//
// Copyright (c) 2003, 2013, Oracle and/or its affiliates. All rights reserved.
// Copyright (c) 2015, 2021, Loongson Technology. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!


#ifndef GENERATED_ADFILES_ADGLOBALS_HPP
#define GENERATED_ADFILES_ADGLOBALS_HPP


// the number of reserved registers + machine registers.
#define REG_COUNT    128

// the number of save_on_entry + always_saved registers.
#define MAX_SAVED_ON_ENTRY_REG_COUNT    16
#define     SAVED_ON_ENTRY_REG_COUNT    0
#define   C_SAVED_ON_ENTRY_REG_COUNT    16

// Enumerate machine register numbers starting after reserved regs.
// in the order of occurrence in the register block.
enum MachRegisterNumbers {
  S7_num,                   // enum   0, regnum   0, reg encode  30
  S7_H_num,                 // enum   1, regnum   1, reg encode  30
  S0_num,                   // enum   2, regnum   2, reg encode  23
  S0_H_num,                 // enum   3, regnum   3, reg encode  23
  S1_num,                   // enum   4, regnum   4, reg encode  24
  S1_H_num,                 // enum   5, regnum   5, reg encode  24
  S2_num,                   // enum   6, regnum   6, reg encode  25
  S2_H_num,                 // enum   7, regnum   7, reg encode  25
  S4_num,                   // enum   8, regnum   8, reg encode  27
  S4_H_num,                 // enum   9, regnum   9, reg encode  27
  S5_num,                   // enum  10, regnum  10, reg encode  28
  S5_H_num,                 // enum  11, regnum  11, reg encode  28
  S6_num,                   // enum  12, regnum  12, reg encode  29
  S6_H_num,                 // enum  13, regnum  13, reg encode  29
  S3_num,                   // enum  14, regnum  14, reg encode  26
  S3_H_num,                 // enum  15, regnum  15, reg encode  26
  T2_num,                   // enum  16, regnum  16, reg encode  14
  T2_H_num,                 // enum  17, regnum  17, reg encode  14
  T3_num,                   // enum  18, regnum  18, reg encode  15
  T3_H_num,                 // enum  19, regnum  19, reg encode  15
  T8_num,                   // enum  20, regnum  20, reg encode  20
  T8_H_num,                 // enum  21, regnum  21, reg encode  20
  T4_num,                   // enum  22, regnum  22, reg encode  16
  T4_H_num,                 // enum  23, regnum  23, reg encode  16
  T1_num,                   // enum  24, regnum  24, reg encode  13
  T1_H_num,                 // enum  25, regnum  25, reg encode  13
  T6_num,                   // enum  26, regnum  26, reg encode  18
  T6_H_num,                 // enum  27, regnum  27, reg encode  18
  A7_num,                   // enum  28, regnum  28, reg encode  11
  A7_H_num,                 // enum  29, regnum  29, reg encode  11
  A6_num,                   // enum  30, regnum  30, reg encode  10
  A6_H_num,                 // enum  31, regnum  31, reg encode  10
  A5_num,                   // enum  32, regnum  32, reg encode   9
  A5_H_num,                 // enum  33, regnum  33, reg encode   9
  A4_num,                   // enum  34, regnum  34, reg encode   8
  A4_H_num,                 // enum  35, regnum  35, reg encode   8
  T5_num,                   // enum  36, regnum  36, reg encode  17
  T5_H_num,                 // enum  37, regnum  37, reg encode  17
  A3_num,                   // enum  38, regnum  38, reg encode   7
  A3_H_num,                 // enum  39, regnum  39, reg encode   7
  A2_num,                   // enum  40, regnum  40, reg encode   6
  A2_H_num,                 // enum  41, regnum  41, reg encode   6
  A1_num,                   // enum  42, regnum  42, reg encode   5
  A1_H_num,                 // enum  43, regnum  43, reg encode   5
  A0_num,                   // enum  44, regnum  44, reg encode   4
  A0_H_num,                 // enum  45, regnum  45, reg encode   4
  T0_num,                   // enum  46, regnum  46, reg encode  12
  T0_H_num,                 // enum  47, regnum  47, reg encode  12
  S8_num,                   // enum  48, regnum  48, reg encode  31
  S8_H_num,                 // enum  49, regnum  49, reg encode  31
  RA_num,                   // enum  50, regnum  50, reg encode   1
  RA_H_num,                 // enum  51, regnum  51, reg encode   1
  SP_num,                   // enum  52, regnum  52, reg encode   3
  SP_H_num,                 // enum  53, regnum  53, reg encode   3
  FP_num,                   // enum  54, regnum  54, reg encode  22
  FP_H_num,                 // enum  55, regnum  55, reg encode  22
  F0_num,                   // enum  56, regnum  56, reg encode   0
  F0_H_num,                 // enum  57, regnum  57, reg encode   0
  F1_num,                   // enum  58, regnum  58, reg encode   1
  F1_H_num,                 // enum  59, regnum  59, reg encode   1
  F2_num,                   // enum  60, regnum  60, reg encode   2
  F2_H_num,                 // enum  61, regnum  61, reg encode   2
  F3_num,                   // enum  62, regnum  62, reg encode   3
  F3_H_num,                 // enum  63, regnum  63, reg encode   3
  F4_num,                   // enum  64, regnum  64, reg encode   4
  F4_H_num,                 // enum  65, regnum  65, reg encode   4
  F5_num,                   // enum  66, regnum  66, reg encode   5
  F5_H_num,                 // enum  67, regnum  67, reg encode   5
  F6_num,                   // enum  68, regnum  68, reg encode   6
  F6_H_num,                 // enum  69, regnum  69, reg encode   6
  F7_num,                   // enum  70, regnum  70, reg encode   7
  F7_H_num,                 // enum  71, regnum  71, reg encode   7
  F8_num,                   // enum  72, regnum  72, reg encode   8
  F8_H_num,                 // enum  73, regnum  73, reg encode   8
  F9_num,                   // enum  74, regnum  74, reg encode   9
  F9_H_num,                 // enum  75, regnum  75, reg encode   9
  F10_num,                  // enum  76, regnum  76, reg encode  10
  F10_H_num,                // enum  77, regnum  77, reg encode  10
  F11_num,                  // enum  78, regnum  78, reg encode  11
  F11_H_num,                // enum  79, regnum  79, reg encode  11
  F20_num,                  // enum  80, regnum  80, reg encode  20
  F20_H_num,                // enum  81, regnum  81, reg encode  20
  F21_num,                  // enum  82, regnum  82, reg encode  21
  F21_H_num,                // enum  83, regnum  83, reg encode  21
  F22_num,                  // enum  84, regnum  84, reg encode  22
  F22_H_num,                // enum  85, regnum  85, reg encode  22
  F23_num,                  // enum  86, regnum  86, reg encode  23
  F23_H_num,                // enum  87, regnum  87, reg encode  23
  F24_num,                  // enum  88, regnum  88, reg encode  24
  F24_H_num,                // enum  89, regnum  89, reg encode  24
  F25_num,                  // enum  90, regnum  90, reg encode  25
  F25_H_num,                // enum  91, regnum  91, reg encode  25
  F26_num,                  // enum  92, regnum  92, reg encode  26
  F26_H_num,                // enum  93, regnum  93, reg encode  26
  F27_num,                  // enum  94, regnum  94, reg encode  27
  F27_H_num,                // enum  95, regnum  95, reg encode  27
  F28_num,                  // enum  96, regnum  96, reg encode  28
  F28_H_num,                // enum  97, regnum  97, reg encode  28
  F19_num,                  // enum  98, regnum  98, reg encode  19
  F19_H_num,                // enum  99, regnum  99, reg encode  19
  F18_num,                  // enum 100, regnum 100, reg encode  18
  F18_H_num,                // enum 101, regnum 101, reg encode  18
  F17_num,                  // enum 102, regnum 102, reg encode  17
  F17_H_num,                // enum 103, regnum 103, reg encode  17
  F16_num,                  // enum 104, regnum 104, reg encode  16
  F16_H_num,                // enum 105, regnum 105, reg encode  16
  F15_num,                  // enum 106, regnum 106, reg encode  15
  F15_H_num,                // enum 107, regnum 107, reg encode  15
  F14_num,                  // enum 108, regnum 108, reg encode  14
  F14_H_num,                // enum 109, regnum 109, reg encode  14
  F13_num,                  // enum 110, regnum 110, reg encode  13
  F13_H_num,                // enum 111, regnum 111, reg encode  13
  F12_num,                  // enum 112, regnum 112, reg encode  12
  F12_H_num,                // enum 113, regnum 113, reg encode  12
  F29_num,                  // enum 114, regnum 114, reg encode  29
  F29_H_num,                // enum 115, regnum 115, reg encode  29
  F30_num,                  // enum 116, regnum 116, reg encode  30
  F30_H_num,                // enum 117, regnum 117, reg encode  30
  F31_num,                  // enum 118, regnum 118, reg encode  31
  F31_H_num,                // enum 119, regnum 119, reg encode  31
  LOONGARCH_FLAG_num,       // enum 120, regnum 120, reg encode   1
  _last_Mach_Reg            // 121
};

// Size of register-mask in ints
#define RM_SIZE 8
// Unroll factor for loops over the data in a RegMask
#define FORALL_BODY BODY(0) BODY(1) BODY(2) BODY(3) BODY(4) BODY(5) BODY(6) BODY(7) 

class RegMask;

#endif // GENERATED_ADFILES_ADGLOBALS_HPP
