//
// Copyright (c) 2003, 2013, Oracle and/or its affiliates. All rights reserved.
// Copyright (c) 2015, 2021, Loongson Technology. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/ad_loongarch_64.hpp"
#include "opto/cfgnode.hpp"
#include "opto/locknode.hpp"


//------------------------- MachOper Generator ---------------
// A switch statement on the dense-packed user-defined type system
// that invokes 'new' on the corresponding class constructor.

MachOper *State::MachOperGenerator(int opcode, Compile* C){

  switch(opcode) {
  case UNIVERSE:
    return new (C) UniverseOper( );
  case LABEL:
    return new (C) labelOper( );
  case SREGI:
    return new (C) sRegIOper( );
  case SREGP:
    return new (C) sRegPOper( );
  case SREGF:
    return new (C) sRegFOper( );
  case SREGD:
    return new (C) sRegDOper( );
  case SREGL:
    return new (C) sRegLOper( );
  case METHOD:
    return new (C) methodOper( );
  case VECD:
    return new (C) vecDOper( );
  case FLAGSREG:
    return new (C) FlagsRegOper( );
  case IMMI:
    return new (C) immIOper(_leaf->get_int() );
  case IMMI8:
    return new (C) immI8Oper(_leaf->get_int() );
  case IMMI_M65536:
    return new (C) immI_M65536Oper(_leaf->get_int() );
  case IMMI_M1:
    return new (C) immI_M1Oper(_leaf->get_int() );
  case IMMI_0:
    return new (C) immI_0Oper(_leaf->get_int() );
  case IMMI_1:
    return new (C) immI_1Oper(_leaf->get_int() );
  case IMMI_16:
    return new (C) immI_16Oper(_leaf->get_int() );
  case IMMI_24:
    return new (C) immI_24Oper(_leaf->get_int() );
  case IMMI_32:
    return new (C) immI_32Oper(_leaf->get_int() );
  case IMMI_255:
    return new (C) immI_255Oper(_leaf->get_int() );
  case IMMI_65535:
    return new (C) immI_65535Oper(_leaf->get_int() );
  case IMMI_MAXI:
    return new (C) immI_MaxIOper(_leaf->get_int() );
  case IMMI_M2047_2048:
    return new (C) immI_M2047_2048Oper(_leaf->get_int() );
  case IMMI_0_3:
    return new (C) immI_0_3Oper(_leaf->get_int() );
  case IMMI_0_31:
    return new (C) immI_0_31Oper(_leaf->get_int() );
  case IMMI_0_4095:
    return new (C) immI_0_4095Oper(_leaf->get_int() );
  case IMMI_0_32767:
    return new (C) immI_0_32767Oper(_leaf->get_int() );
  case IMMI_1_4:
    return new (C) immI_1_4Oper(_leaf->get_int() );
  case IMMI_32_63:
    return new (C) immI_32_63Oper(_leaf->get_int() );
  case IMMI_NONNEG_MASK:
    return new (C) immI_nonneg_maskOper(_leaf->get_int() );
  case IMML:
    return new (C) immLOper(_leaf->get_long() );
  case IMML8:
    return new (C) immL8Oper(_leaf->get_long() );
  case IMML12:
    return new (C) immL12Oper(_leaf->get_long() );
  case IMML32:
    return new (C) immL32Oper(_leaf->get_long() );
  case IMML_M121:
    return new (C) immL_M121Oper(_leaf->get_long() );
  case IMML_M8:
    return new (C) immL_M8Oper(_leaf->get_long() );
  case IMML_M7:
    return new (C) immL_M7Oper(_leaf->get_long() );
  case IMML_M5:
    return new (C) immL_M5Oper(_leaf->get_long() );
  case IMML_M4:
    return new (C) immL_M4Oper(_leaf->get_long() );
  case IMML_0:
    return new (C) immL_0Oper(_leaf->get_long() );
  case IMML_7:
    return new (C) immL_7Oper(_leaf->get_long() );
  case IMML_MAXUI:
    return new (C) immL_MaxUIOper(_leaf->get_long() );
  case IMML_M2047_2048:
    return new (C) immL_M2047_2048Oper(_leaf->get_long() );
  case IMML_0_4095:
    return new (C) immL_0_4095Oper(_leaf->get_long() );
  case IMML_NONNEG_MASK:
    return new (C) immL_nonneg_maskOper(_leaf->get_long() );
  case IMMP:
    return new (C) immPOper(_leaf->bottom_type()->is_ptr() );
  case IMMP_0:
    return new (C) immP_0Oper(_leaf->bottom_type()->is_ptr() );
  case IMMP_NO_OOP_CHEAP:
    return new (C) immP_no_oop_cheapOper(_leaf->bottom_type()->is_ptr() );
  case IMMP_POLL:
    return new (C) immP_pollOper(_leaf->bottom_type()->is_ptr() );
  case IMMN:
    return new (C) immNOper(_leaf->bottom_type()->is_narrowoop() );
  case IMMN_0:
    return new (C) immN_0Oper(_leaf->bottom_type()->is_narrowoop() );
  case IMMNKLASS:
    return new (C) immNKlassOper(_leaf->bottom_type()->is_narrowklass() );
  case IMMF:
    return new (C) immFOper(_leaf->getf() );
  case IMMF_0:
    return new (C) immF_0Oper(_leaf->getf() );
  case IMMD:
    return new (C) immDOper(_leaf->getd() );
  case IMMD_0:
    return new (C) immD_0Oper(_leaf->getd() );
  case MREGI:
    return new (C) mRegIOper( );
  case NO_AX_MREGI:
    return new (C) no_Ax_mRegIOper( );
  case MS0REGI:
    return new (C) mS0RegIOper( );
  case MS1REGI:
    return new (C) mS1RegIOper( );
  case MS2REGI:
    return new (C) mS2RegIOper( );
  case MS3REGI:
    return new (C) mS3RegIOper( );
  case MS4REGI:
    return new (C) mS4RegIOper( );
  case MS5REGI:
    return new (C) mS5RegIOper( );
  case MS6REGI:
    return new (C) mS6RegIOper( );
  case MS7REGI:
    return new (C) mS7RegIOper( );
  case MT0REGI:
    return new (C) mT0RegIOper( );
  case MT1REGI:
    return new (C) mT1RegIOper( );
  case MT2REGI:
    return new (C) mT2RegIOper( );
  case MT3REGI:
    return new (C) mT3RegIOper( );
  case MT8REGI:
    return new (C) mT8RegIOper( );
  case MT4REGI:
    return new (C) mT4RegIOper( );
  case MA0REGI:
    return new (C) mA0RegIOper( );
  case MA1REGI:
    return new (C) mA1RegIOper( );
  case MA2REGI:
    return new (C) mA2RegIOper( );
  case MA3REGI:
    return new (C) mA3RegIOper( );
  case MA4REGI:
    return new (C) mA4RegIOper( );
  case MA5REGI:
    return new (C) mA5RegIOper( );
  case MA6REGI:
    return new (C) mA6RegIOper( );
  case MA7REGI:
    return new (C) mA7RegIOper( );
  case MREGN:
    return new (C) mRegNOper( );
  case T0_REGN:
    return new (C) t0_RegNOper( );
  case T1_REGN:
    return new (C) t1_RegNOper( );
  case T2_REGN:
    return new (C) t2_RegNOper( );
  case T3_REGN:
    return new (C) t3_RegNOper( );
  case T8_REGN:
    return new (C) t8_RegNOper( );
  case A0_REGN:
    return new (C) a0_RegNOper( );
  case A1_REGN:
    return new (C) a1_RegNOper( );
  case A2_REGN:
    return new (C) a2_RegNOper( );
  case A3_REGN:
    return new (C) a3_RegNOper( );
  case A4_REGN:
    return new (C) a4_RegNOper( );
  case A5_REGN:
    return new (C) a5_RegNOper( );
  case A6_REGN:
    return new (C) a6_RegNOper( );
  case A7_REGN:
    return new (C) a7_RegNOper( );
  case S0_REGN:
    return new (C) s0_RegNOper( );
  case S1_REGN:
    return new (C) s1_RegNOper( );
  case S2_REGN:
    return new (C) s2_RegNOper( );
  case S3_REGN:
    return new (C) s3_RegNOper( );
  case S4_REGN:
    return new (C) s4_RegNOper( );
  case S5_REGN:
    return new (C) s5_RegNOper( );
  case S6_REGN:
    return new (C) s6_RegNOper( );
  case S7_REGN:
    return new (C) s7_RegNOper( );
  case MREGP:
    return new (C) mRegPOper( );
  case NO_T8_MREGP:
    return new (C) no_T8_mRegPOper( );
  case NO_AX_MREGP:
    return new (C) no_Ax_mRegPOper( );
  case S0_REGP:
    return new (C) s0_RegPOper( );
  case S1_REGP:
    return new (C) s1_RegPOper( );
  case S2_REGP:
    return new (C) s2_RegPOper( );
  case S3_REGP:
    return new (C) s3_RegPOper( );
  case S4_REGP:
    return new (C) s4_RegPOper( );
  case S5_REGP:
    return new (C) s5_RegPOper( );
  case S6_REGP:
    return new (C) s6_RegPOper( );
  case S7_REGP:
    return new (C) s7_RegPOper( );
  case T0_REGP:
    return new (C) t0_RegPOper( );
  case T1_REGP:
    return new (C) t1_RegPOper( );
  case T2_REGP:
    return new (C) t2_RegPOper( );
  case T3_REGP:
    return new (C) t3_RegPOper( );
  case T8_REGP:
    return new (C) t8_RegPOper( );
  case A0_REGP:
    return new (C) a0_RegPOper( );
  case A1_REGP:
    return new (C) a1_RegPOper( );
  case A2_REGP:
    return new (C) a2_RegPOper( );
  case A3_REGP:
    return new (C) a3_RegPOper( );
  case A4_REGP:
    return new (C) a4_RegPOper( );
  case A5_REGP:
    return new (C) a5_RegPOper( );
  case A6_REGP:
    return new (C) a6_RegPOper( );
  case A7_REGP:
    return new (C) a7_RegPOper( );
  case V0_REGP:
    return new (C) v0_RegPOper( );
  case V1_REGP:
    return new (C) v1_RegPOper( );
  case MREGL:
    return new (C) mRegLOper( );
  case V0REGL:
    return new (C) v0RegLOper( );
  case V1REGL:
    return new (C) v1RegLOper( );
  case A0REGL:
    return new (C) a0RegLOper( );
  case A1REGL:
    return new (C) a1RegLOper( );
  case A2REGL:
    return new (C) a2RegLOper( );
  case A3REGL:
    return new (C) a3RegLOper( );
  case T0REGL:
    return new (C) t0RegLOper( );
  case T1REGL:
    return new (C) t1RegLOper( );
  case T2REGL:
    return new (C) t2RegLOper( );
  case T3REGL:
    return new (C) t3RegLOper( );
  case T8REGL:
    return new (C) t8RegLOper( );
  case A4REGL:
    return new (C) a4RegLOper( );
  case A5REGL:
    return new (C) a5RegLOper( );
  case A6REGL:
    return new (C) a6RegLOper( );
  case A7REGL:
    return new (C) a7RegLOper( );
  case S0REGL:
    return new (C) s0RegLOper( );
  case S1REGL:
    return new (C) s1RegLOper( );
  case S2REGL:
    return new (C) s2RegLOper( );
  case S3REGL:
    return new (C) s3RegLOper( );
  case S4REGL:
    return new (C) s4RegLOper( );
  case S7REGL:
    return new (C) s7RegLOper( );
  case REGF:
    return new (C) regFOper( );
  case REGD:
    return new (C) regDOper( );
  case INDIRECT:
    return new (C) indirectOper( );
  case INDOFFSET8:
    return new (C) indOffset8Oper(_kids[1]->_leaf->get_long() );
  case INDINDEXSCALE:
    return new (C) indIndexScaleOper(_kids[1]->_kids[1]->_leaf->get_int() );
  case BASEINDEXOFFSET8:
    return new (C) baseIndexOffset8Oper(_kids[1]->_leaf->get_long() );
  case BASEINDEXOFFSET8_CONVI2L:
    return new (C) baseIndexOffset8_convI2LOper(_kids[1]->_leaf->get_long() );
  case INDINDEXSCALEOFFSET8:
    return new (C) indIndexScaleOffset8Oper(_kids[0]->_kids[1]->_kids[1]->_leaf->get_int(), _kids[1]->_leaf->get_long() );
  case INDINDEXSCALEOFFSET8_CONVI2L:
    return new (C) indIndexScaleOffset8_convI2LOper(_kids[0]->_kids[1]->_kids[1]->_leaf->get_int(), _kids[1]->_leaf->get_long() );
  case BASEPOSINDEXSCALEOFFSET8:
    return new (C) basePosIndexScaleOffset8Oper(_kids[0]->_kids[1]->_kids[1]->_leaf->get_int(), _kids[1]->_leaf->get_long() );
  case INDINDEXSCALEOFFSETNARROW:
    return new (C) indIndexScaleOffsetNarrowOper(_kids[0]->_kids[1]->_kids[1]->_leaf->get_int(), _kids[1]->_leaf->get_long() );
  case INDPOSINDEXI2LSCALEOFFSET8NARROW:
    return new (C) indPosIndexI2LScaleOffset8NarrowOper(_kids[0]->_kids[1]->_kids[1]->_leaf->get_int(), _kids[1]->_leaf->get_long() );
  case INDOFFSET32:
    return new (C) indOffset32Oper(_kids[1]->_leaf->get_long() );
  case INDINDEX:
    return new (C) indIndexOper( );
  case INDIRECTNARROWKLASS:
    return new (C) indirectNarrowKlassOper( );
  case INDOFFSET8NARROWKLASS:
    return new (C) indOffset8NarrowKlassOper(_kids[1]->_leaf->get_long() );
  case INDOFFSET32NARROWKLASS:
    return new (C) indOffset32NarrowKlassOper(_kids[1]->_leaf->get_long() );
  case INDINDEXOFFSETNARROWKLASS:
    return new (C) indIndexOffsetNarrowKlassOper(_kids[1]->_leaf->get_long() );
  case INDINDEXNARROWKLASS:
    return new (C) indIndexNarrowKlassOper( );
  case INDIRECTNARROW:
    return new (C) indirectNarrowOper( );
  case INDOFFSET8NARROW:
    return new (C) indOffset8NarrowOper(_kids[1]->_leaf->get_long() );
  case INDINDEXOFFSET8NARROW:
    return new (C) indIndexOffset8NarrowOper(_kids[1]->_leaf->get_long() );
  case LOAD_LONG_REGP:
    return new (C) load_long_RegPOper( );
  case LOAD_LONG_INDIRECT:
    return new (C) load_long_indirectOper( );
  case LOAD_LONG_INDOFFSET32:
    return new (C) load_long_indOffset32Oper(_kids[1]->_leaf->get_long() );
  case CMPOP:
    return new (C) cmpOpOper(_leaf->as_Bool()->_test._test );
  case CMPOPU:
    return new (C) cmpOpUOper(_leaf->as_Bool()->_test._test );
  case STACKSLOTP:
    return new (C) stackSlotPOper( );
  case STACKSLOTI:
    return new (C) stackSlotIOper( );
  case STACKSLOTF:
    return new (C) stackSlotFOper( );
  case STACKSLOTD:
    return new (C) stackSlotDOper( );
  case STACKSLOTL:
    return new (C) stackSlotLOper( );
  case _LSHIFTL_MREGL_IMMI_0_3:    return NULL;
  case _ADDP_MREGP_MREGL:    return NULL;
  case _CONVI2L_MREGI_:    return NULL;
  case _ADDP_MREGP__CONVI2L_MREGI_:    return NULL;
  case _ADDP_MREGP__LSHIFTL_MREGL_IMMI_0_3:    return NULL;
  case _LSHIFTL__CONVI2L_MREGI__IMMI_0_3:    return NULL;
  case _ADDP_MREGP__LSHIFTL__CONVI2L_MREGI__IMMI_0_3:    return NULL;
  case _LSHIFTL__CONVI2L_MREGI__IMMI_0_31:    return NULL;
  case _ADDP_MREGP__LSHIFTL__CONVI2L_MREGI__IMMI_0_31:    return NULL;
  case _DECODEN_MREGN_:    return NULL;
  case _ADDP__DECODEN_MREGN___LSHIFTL_MREGL_IMMI_0_3:    return NULL;
  case _ADDP__DECODEN_MREGN___LSHIFTL__CONVI2L_MREGI__IMMI_0_31:    return NULL;
  case _DECODENKLASS_MREGN_:    return NULL;
  case _ADDP__DECODENKLASS_MREGN__MREGL:    return NULL;
  case _ADDP__DECODEN_MREGN__MREGL:    return NULL;
  case _LOADI_MEMORY_:    return NULL;
  case _LSHIFTI__LOADI_MEMORY__IMMI_24:    return NULL;
  case _LSHIFTI__LOADI_MEMORY__IMMI_16:    return NULL;
  case _LOADN_MEMORY_:    return NULL;
  case _LOADNKLASS_MEMORY_:    return NULL;
  case _ENCODEP_MREGP_:    return NULL;
  case _ENCODEPKLASS_MREGP_:    return NULL;
  case _CONVL2I_MREGL_:    return NULL;
  case _LOADB_MEMORY_:    return NULL;
  case _LOADUB_MEMORY_:    return NULL;
  case _LOADS_MEMORY_:    return NULL;
  case _LSHIFTI__LOADS_MEMORY__IMMI_24:    return NULL;
  case _CMPI_MREGI_MREGI:    return NULL;
  case _CMPI_MREGI_IMMI:    return NULL;
  case _CMPP_MREGP_IMMP_0:    return NULL;
  case _CMPP__DECODEN_MREGN__IMMP_0:    return NULL;
  case _CMPP_MREGP_MREGP:    return NULL;
  case _CMPN_MREGN_IMMN_0:    return NULL;
  case _CMPN_MREGN_MREGN:    return NULL;
  case _CMPU_MREGI_MREGI:    return NULL;
  case _CMPU_MREGI_IMMI:    return NULL;
  case _CMPI_MREGI_IMMI_0:    return NULL;
  case _CMPU_MREGI_IMMI_0:    return NULL;
  case _CMPL_MREGL_MREGL:    return NULL;
  case _CMPL_MREGL_IMML_0:    return NULL;
  case _CMPL_MREGL_IMML:    return NULL;
  case _CMPF_REGF_REGF:    return NULL;
  case _CMPD_REGD_REGD:    return NULL;
  case _BINARY_CMPOP__CMPI_MREGI_MREGI:    return NULL;
  case _BINARY_MREGI_MREGI:    return NULL;
  case _BINARY_CMPOPU__CMPP_MREGP_MREGP:    return NULL;
  case _BINARY_CMPOPU__CMPN_MREGN_MREGN:    return NULL;
  case _BINARY_CMPOPU__CMPU_MREGI_MREGI:    return NULL;
  case _BINARY_MREGP_MREGP:    return NULL;
  case _BINARY_CMPOP__CMPF_REGF_REGF:    return NULL;
  case _BINARY_MREGN_MREGN:    return NULL;
  case _BINARY_CMPOP__CMPD_REGD_REGD:    return NULL;
  case _BINARY_CMPOP__CMPL_MREGL_MREGL:    return NULL;
  case _BINARY_MREGL_MREGL:    return NULL;
  case _BINARY_REGD_REGD:    return NULL;
  case _BINARY_REGF_REGF:    return NULL;
  case _BINARY_CMPOP__CMPP_MREGP_MREGP:    return NULL;
  case _BINARY_A4_REGP_MA5REGI:    return NULL;
  case _BINARY_A6_REGP_MA7REGI:    return NULL;
  case _BINARY_A4_REGP_A5_REGP:    return NULL;
  case _LSHIFTI_MREGI_IMMI_1_4:    return NULL;
  case _LSHIFTL__CONVI2L_MREGI__IMMI_1_4:    return NULL;
  case _MULI_MREGI_MREGI:    return NULL;
  case _MULF_REGF_REGF:    return NULL;
  case _MULD_REGD_REGD:    return NULL;
  case _CONVF2D_REGF_:    return NULL;
  case _SQRTD__CONVF2D_REGF__:    return NULL;
  case _XORI_MREGI_IMMI_M1:    return NULL;
  case _ANDL_MREGL_IMML_0_4095:    return NULL;
  case _CASTP2X_MREGP_:    return NULL;
  case _LSHIFTI_MREGI_IMMI_16:    return NULL;
  case _ANDL_MREGL_IMML_7:    return NULL;
  case _CONVL2I__ANDL_MREGL_IMML_7_:    return NULL;
  case _LSHIFTI__CONVL2I__ANDL_MREGL_IMML_7__IMMI_16:    return NULL;
  case _ORI_MREGI_IMMI_0_32767:    return NULL;
  case _LSHIFTI__ORI_MREGI_IMMI_0_32767_IMMI_16:    return NULL;
  case _LSHIFTI_MREGI_IMMI_24:    return NULL;
  case _RSHIFTL_MREGL_IMMI_32_63:    return NULL;
  case _URSHIFTL_MREGL_IMMI_0_31:    return NULL;
  case _CONVL2I__URSHIFTL_MREGL_IMMI_0_31_:    return NULL;
  case _URSHIFTL_MREGL_IMMI_32_63:    return NULL;
  case _URSHIFTI_MREGI_IMMI_0_31:    return NULL;
  case _ANDI_MREGI_IMMI_1:    return NULL;
  case _LSHIFTI__ANDI_MREGI_IMMI_1_IMMI_0_31:    return NULL;
  case _LSHIFTI_MREGI_IMMI_0_31:    return NULL;
  case _LSHIFTL_MREGL_IMMI_32_63:    return NULL;
  case _LSHIFTL_MREGL_IMMI_0_31:    return NULL;
  case _LOADUS_MEMORY_:    return NULL;
  case _BINARY_T2REGL_MREGL:    return NULL;
  case _BINARY_MS2REGI_MREGI:    return NULL;
  case _BINARY_S2REGL_MREGL:    return NULL;
  case _BINARY_S2_REGP_MREGP:    return NULL;
  case _BINARY_T2_REGN_MREGN:    return NULL;
  case _ANDL__CONVI2L_MREGI__IMML_MAXUI:    return NULL;
  case _LSHIFTL__CONVI2L_MREGI__IMMI_32:    return NULL;
  case _CONVI2L__CONVL2I_MREGL__:    return NULL;
  case _CONVI2L__LOADI_MEMORY__:    return NULL;
  
  default:
    fprintf(stderr, "Default MachOper Generator invoked for: \n");
    fprintf(stderr, "   opcode = %d\n", opcode);
    break;
  }
  return NULL;
};


//------------------------- MachNode Generator ---------------
// A switch statement on the dense-packed user-defined type system
// that invokes 'new' on the corresponding class constructor.

MachNode *State::MachNodeGenerator(int opcode, Compile* C){
  switch(opcode) {
  case loadI_rule: {
      loadINode *node = new (C) loadINode();
      return node;
    }
  case loadI_convI2L_rule: {
      loadI_convI2LNode *node = new (C) loadI_convI2LNode();
      return node;
    }
  case loadI2B_rule: {
      loadI2BNode *node = new (C) loadI2BNode();
      return node;
    }
  case loadI2UB_rule: {
      loadI2UBNode *node = new (C) loadI2UBNode();
      return node;
    }
  case loadI2S_rule: {
      loadI2SNode *node = new (C) loadI2SNode();
      return node;
    }
  case loadI2US_rule: {
      loadI2USNode *node = new (C) loadI2USNode();
      return node;
    }
  case loadL_rule: {
      loadLNode *node = new (C) loadLNode();
      return node;
    }
  case loadL_unaligned_rule: {
      loadL_unalignedNode *node = new (C) loadL_unalignedNode();
      return node;
    }
  case storeL_reg_rule: {
      storeL_regNode *node = new (C) storeL_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeL_immL_0_rule: {
      storeL_immL_0Node *node = new (C) storeL_immL_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeL_imm_rule: {
      storeL_immNode *node = new (C) storeL_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadN_rule: {
      loadNNode *node = new (C) loadNNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadN2P_rule: {
      loadN2PNode *node = new (C) loadN2PNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadP_rule: {
      loadPNode *node = new (C) loadPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadKlass_rule: {
      loadKlassNode *node = new (C) loadKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadNKlass_rule: {
      loadNKlassNode *node = new (C) loadNKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadN2PKlass_rule: {
      loadN2PKlassNode *node = new (C) loadN2PKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadConI_rule: {
      loadConINode *node = new (C) loadConINode();
      node->_opnd_array[1] = new (C) immIOper(_leaf->get_int() );
      return node;
    }
  case loadConL_set64_rule: {
      loadConL_set64Node *node = new (C) loadConL_set64Node();
      node->_opnd_array[1] = new (C) immLOper(_leaf->get_long() );
      return node;
    }
  case loadConL12_rule: {
      loadConL12Node *node = new (C) loadConL12Node();
      node->_opnd_array[1] = new (C) immL12Oper(_leaf->get_long() );
      return node;
    }
  case loadConL_immL_0_rule: {
      loadConL_immL_0Node *node = new (C) loadConL_immL_0Node();
      node->_opnd_array[1] = new (C) immL_0Oper(_leaf->get_long() );
      return node;
    }
  case loadRange_rule: {
      loadRangeNode *node = new (C) loadRangeNode();
      return node;
    }
  case storeP_rule: {
      storePNode *node = new (C) storePNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeImmP_immP_0_rule: {
      storeImmP_immP_0Node *node = new (C) storeImmP_immP_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeImmB_rule: {
      storeImmBNode *node = new (C) storeImmBNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeN_rule: {
      storeNNode *node = new (C) storeNNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeP2N_rule: {
      storeP2NNode *node = new (C) storeP2NNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeNKlass_rule: {
      storeNKlassNode *node = new (C) storeNKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeP2NKlass_rule: {
      storeP2NKlassNode *node = new (C) storeP2NKlassNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeImmN_immN_0_rule: {
      storeImmN_immN_0Node *node = new (C) storeImmN_immN_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeB_rule: {
      storeBNode *node = new (C) storeBNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeB_convL2I_rule: {
      storeB_convL2INode *node = new (C) storeB_convL2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadB_rule: {
      loadBNode *node = new (C) loadBNode();
      return node;
    }
  case loadB_convI2L_rule: {
      loadB_convI2LNode *node = new (C) loadB_convI2LNode();
      return node;
    }
  case loadUB_rule: {
      loadUBNode *node = new (C) loadUBNode();
      return node;
    }
  case loadUB_convI2L_rule: {
      loadUB_convI2LNode *node = new (C) loadUB_convI2LNode();
      return node;
    }
  case loadS_rule: {
      loadSNode *node = new (C) loadSNode();
      return node;
    }
  case loadS2B_rule: {
      loadS2BNode *node = new (C) loadS2BNode();
      return node;
    }
  case loadS_convI2L_rule: {
      loadS_convI2LNode *node = new (C) loadS_convI2LNode();
      return node;
    }
  case storeImmI_rule: {
      storeImmINode *node = new (C) storeImmINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeI_rule: {
      storeINode *node = new (C) storeINode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeI_convL2I_rule: {
      storeI_convL2INode *node = new (C) storeI_convL2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadF_rule: {
      loadFNode *node = new (C) loadFNode();
      return node;
    }
  case loadConP_general_rule: {
      loadConP_generalNode *node = new (C) loadConP_generalNode();
      node->_opnd_array[1] = new (C) immPOper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadConP_no_oop_cheap_rule: {
      loadConP_no_oop_cheapNode *node = new (C) loadConP_no_oop_cheapNode();
      node->_opnd_array[1] = new (C) immP_no_oop_cheapOper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadConP_poll_rule: {
      loadConP_pollNode *node = new (C) loadConP_pollNode();
      node->_opnd_array[1] = new (C) immP_pollOper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadConP_immP_0_rule: {
      loadConP_immP_0Node *node = new (C) loadConP_immP_0Node();
      node->_opnd_array[1] = new (C) immP_0Oper(_leaf->bottom_type()->is_ptr() );
      return node;
    }
  case loadConN_immN_0_rule: {
      loadConN_immN_0Node *node = new (C) loadConN_immN_0Node();
      node->_opnd_array[1] = new (C) immN_0Oper(_leaf->bottom_type()->is_narrowoop() );
      return node;
    }
  case loadConN_rule: {
      loadConNNode *node = new (C) loadConNNode();
      node->_opnd_array[1] = new (C) immNOper(_leaf->bottom_type()->is_narrowoop() );
      return node;
    }
  case loadConNKlass_rule: {
      loadConNKlassNode *node = new (C) loadConNKlassNode();
      node->_opnd_array[1] = new (C) immNKlassOper(_leaf->bottom_type()->is_narrowklass() );
      return node;
    }
  case TailCalljmpInd_rule: {
      TailCalljmpIndNode *node = new (C) TailCalljmpIndNode();
      return node;
    }
  case CreateException_rule: {
      CreateExceptionNode *node = new (C) CreateExceptionNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case RethrowException_rule: {
      RethrowExceptionNode *node = new (C) RethrowExceptionNode();
      return node;
    }
  case jmpDir_long_rule: {
      jmpDir_longNode *node = new (C) jmpDir_longNode();
      node->set_opnd_array(1, MachOperGenerator(LABEL, C));
      return node;
    }
  case jmpLoopEnd_long_rule: {
      jmpLoopEnd_longNode *node = new (C) jmpLoopEnd_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpLoopEnd_reg_immI_long_rule: {
      jmpLoopEnd_reg_immI_longNode *node = new (C) jmpLoopEnd_reg_immI_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpCon_flags_long_rule: {
      jmpCon_flags_longNode *node = new (C) jmpCon_flags_longNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConP_0_long_rule: {
      branchConP_0_longNode *node = new (C) branchConP_0_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConN2P_0_long_rule: {
      branchConN2P_0_longNode *node = new (C) branchConN2P_0_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConP_long_rule: {
      branchConP_longNode *node = new (C) branchConP_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpN_null_branch_long_rule: {
      cmpN_null_branch_longNode *node = new (C) cmpN_null_branch_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpN_reg_branch_long_rule: {
      cmpN_reg_branch_longNode *node = new (C) cmpN_reg_branch_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConIU_reg_reg_long_rule: {
      branchConIU_reg_reg_longNode *node = new (C) branchConIU_reg_reg_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConIU_reg_imm_long_rule: {
      branchConIU_reg_imm_longNode *node = new (C) branchConIU_reg_imm_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConI_reg_reg_long_rule: {
      branchConI_reg_reg_longNode *node = new (C) branchConI_reg_reg_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConI_reg_immI_0_long_rule: {
      branchConI_reg_immI_0_longNode *node = new (C) branchConI_reg_immI_0_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConI_reg_imm_long_rule: {
      branchConI_reg_imm_longNode *node = new (C) branchConI_reg_imm_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConIU_reg_immI_0_long_rule: {
      branchConIU_reg_immI_0_longNode *node = new (C) branchConIU_reg_immI_0_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConL_regL_regL_long_rule: {
      branchConL_regL_regL_longNode *node = new (C) branchConL_regL_regL_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConL_regL_immL_0_long_rule: {
      branchConL_regL_immL_0_longNode *node = new (C) branchConL_regL_immL_0_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConL_regL_immL_long_rule: {
      branchConL_regL_immL_longNode *node = new (C) branchConL_regL_immL_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConF_reg_reg_long_rule: {
      branchConF_reg_reg_longNode *node = new (C) branchConF_reg_reg_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConD_reg_reg_long_rule: {
      branchConD_reg_reg_longNode *node = new (C) branchConD_reg_reg_longNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpDir_short_rule: {
      jmpDir_shortNode *node = new (C) jmpDir_shortNode();
      node->set_opnd_array(1, MachOperGenerator(LABEL, C));
      return node;
    }
  case jmpLoopEnd_short_rule: {
      jmpLoopEnd_shortNode *node = new (C) jmpLoopEnd_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpLoopEnd_reg_immI_short_rule: {
      jmpLoopEnd_reg_immI_shortNode *node = new (C) jmpLoopEnd_reg_immI_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case jmpCon_flags_short_rule: {
      jmpCon_flags_shortNode *node = new (C) jmpCon_flags_shortNode();
      node->set_opnd_array(3, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConP_0_short_rule: {
      branchConP_0_shortNode *node = new (C) branchConP_0_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConN2P_0_short_rule: {
      branchConN2P_0_shortNode *node = new (C) branchConN2P_0_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConP_short_rule: {
      branchConP_shortNode *node = new (C) branchConP_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpN_null_branch_short_rule: {
      cmpN_null_branch_shortNode *node = new (C) cmpN_null_branch_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case cmpN_reg_branch_short_rule: {
      cmpN_reg_branch_shortNode *node = new (C) cmpN_reg_branch_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConIU_reg_reg_short_rule: {
      branchConIU_reg_reg_shortNode *node = new (C) branchConIU_reg_reg_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConIU_reg_imm_short_rule: {
      branchConIU_reg_imm_shortNode *node = new (C) branchConIU_reg_imm_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConI_reg_reg_short_rule: {
      branchConI_reg_reg_shortNode *node = new (C) branchConI_reg_reg_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConI_reg_immI_0_short_rule: {
      branchConI_reg_immI_0_shortNode *node = new (C) branchConI_reg_immI_0_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConI_reg_imm_short_rule: {
      branchConI_reg_imm_shortNode *node = new (C) branchConI_reg_imm_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConIU_reg_immI_0_short_rule: {
      branchConIU_reg_immI_0_shortNode *node = new (C) branchConIU_reg_immI_0_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConL_regL_regL_short_rule: {
      branchConL_regL_regL_shortNode *node = new (C) branchConL_regL_regL_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConL_regL_immL_0_short_rule: {
      branchConL_regL_immL_0_shortNode *node = new (C) branchConL_regL_immL_0_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConL_regL_immL_short_rule: {
      branchConL_regL_immL_shortNode *node = new (C) branchConL_regL_immL_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConF_reg_reg_short_rule: {
      branchConF_reg_reg_shortNode *node = new (C) branchConF_reg_reg_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case branchConD_reg_reg_short_rule: {
      branchConD_reg_reg_shortNode *node = new (C) branchConD_reg_reg_shortNode();
      node->set_opnd_array(4, MachOperGenerator(LABEL, C));
      node->_prob = _leaf->as_If()->_prob;
      node->_fcnt = _leaf->as_If()->_fcnt;
      return node;
    }
  case CallRuntimeDirect_rule: {
      CallRuntimeDirectNode *node = new (C) CallRuntimeDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case membar_acquire_rule: {
      membar_acquireNode *node = new (C) membar_acquireNode();
      return node;
    }
  case load_fence_rule: {
      load_fenceNode *node = new (C) load_fenceNode();
      return node;
    }
  case membar_acquire_lock_rule: {
      membar_acquire_lockNode *node = new (C) membar_acquire_lockNode();
      return node;
    }
  case membar_release_rule: {
      membar_releaseNode *node = new (C) membar_releaseNode();
      return node;
    }
  case store_fence_rule: {
      store_fenceNode *node = new (C) store_fenceNode();
      return node;
    }
  case membar_release_lock_rule: {
      membar_release_lockNode *node = new (C) membar_release_lockNode();
      return node;
    }
  case membar_volatile_rule: {
      membar_volatileNode *node = new (C) membar_volatileNode();
      return node;
    }
  case unnecessary_membar_volatile_rule: {
      unnecessary_membar_volatileNode *node = new (C) unnecessary_membar_volatileNode();
      return node;
    }
  case membar_storestore_rule: {
      membar_storestoreNode *node = new (C) membar_storestoreNode();
      return node;
    }
  case castX2P_rule: {
      castX2PNode *node = new (C) castX2PNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castP2X_rule: {
      castP2XNode *node = new (C) castP2XNode();
      return node;
    }
  case MoveF2I_reg_reg_rule: {
      MoveF2I_reg_regNode *node = new (C) MoveF2I_reg_regNode();
      return node;
    }
  case MoveI2F_reg_reg_rule: {
      MoveI2F_reg_regNode *node = new (C) MoveI2F_reg_regNode();
      return node;
    }
  case MoveD2L_reg_reg_rule: {
      MoveD2L_reg_regNode *node = new (C) MoveD2L_reg_regNode();
      return node;
    }
  case MoveL2D_reg_reg_rule: {
      MoveL2D_reg_regNode *node = new (C) MoveL2D_reg_regNode();
      return node;
    }
  case cmovI_cmpI_reg_reg_rule: {
      cmovI_cmpI_reg_regNode *node = new (C) cmovI_cmpI_reg_regNode();
      return node;
    }
  case cmovI_cmpP_reg_reg_rule: {
      cmovI_cmpP_reg_regNode *node = new (C) cmovI_cmpP_reg_regNode();
      return node;
    }
  case cmovI_cmpN_reg_reg_rule: {
      cmovI_cmpN_reg_regNode *node = new (C) cmovI_cmpN_reg_regNode();
      return node;
    }
  case cmovP_cmpU_reg_reg_rule: {
      cmovP_cmpU_reg_regNode *node = new (C) cmovP_cmpU_reg_regNode();
      return node;
    }
  case cmovP_cmpF_reg_reg_rule: {
      cmovP_cmpF_reg_regNode *node = new (C) cmovP_cmpF_reg_regNode();
      node->set_opnd_array(6, MachOperGenerator(REGD, C));
      node->set_opnd_array(7, MachOperGenerator(REGD, C));
      return node;
    }
  case cmovP_cmpN_reg_reg_rule: {
      cmovP_cmpN_reg_regNode *node = new (C) cmovP_cmpN_reg_regNode();
      return node;
    }
  case cmovN_cmpP_reg_reg_rule: {
      cmovN_cmpP_reg_regNode *node = new (C) cmovN_cmpP_reg_regNode();
      return node;
    }
  case cmovP_cmpD_reg_reg_rule: {
      cmovP_cmpD_reg_regNode *node = new (C) cmovP_cmpD_reg_regNode();
      node->set_opnd_array(6, MachOperGenerator(REGD, C));
      node->set_opnd_array(7, MachOperGenerator(REGD, C));
      return node;
    }
  case cmovN_cmpN_reg_reg_rule: {
      cmovN_cmpN_reg_regNode *node = new (C) cmovN_cmpN_reg_regNode();
      return node;
    }
  case cmovI_cmpU_reg_reg_rule: {
      cmovI_cmpU_reg_regNode *node = new (C) cmovI_cmpU_reg_regNode();
      return node;
    }
  case cmovI_cmpL_reg_reg_rule: {
      cmovI_cmpL_reg_regNode *node = new (C) cmovI_cmpL_reg_regNode();
      return node;
    }
  case cmovP_cmpL_reg_reg_rule: {
      cmovP_cmpL_reg_regNode *node = new (C) cmovP_cmpL_reg_regNode();
      return node;
    }
  case cmovI_cmpD_reg_reg_rule: {
      cmovI_cmpD_reg_regNode *node = new (C) cmovI_cmpD_reg_regNode();
      node->set_opnd_array(6, MachOperGenerator(REGD, C));
      node->set_opnd_array(7, MachOperGenerator(REGD, C));
      return node;
    }
  case cmovP_cmpP_reg_reg_rule: {
      cmovP_cmpP_reg_regNode *node = new (C) cmovP_cmpP_reg_regNode();
      return node;
    }
  case cmovP_cmpI_reg_reg_rule: {
      cmovP_cmpI_reg_regNode *node = new (C) cmovP_cmpI_reg_regNode();
      return node;
    }
  case cmovL_cmpP_reg_reg_rule: {
      cmovL_cmpP_reg_regNode *node = new (C) cmovL_cmpP_reg_regNode();
      return node;
    }
  case cmovN_cmpU_reg_reg_rule: {
      cmovN_cmpU_reg_regNode *node = new (C) cmovN_cmpU_reg_regNode();
      return node;
    }
  case cmovN_cmpL_reg_reg_rule: {
      cmovN_cmpL_reg_regNode *node = new (C) cmovN_cmpL_reg_regNode();
      return node;
    }
  case cmovN_cmpI_reg_reg_rule: {
      cmovN_cmpI_reg_regNode *node = new (C) cmovN_cmpI_reg_regNode();
      return node;
    }
  case cmovL_cmpU_reg_reg_rule: {
      cmovL_cmpU_reg_regNode *node = new (C) cmovL_cmpU_reg_regNode();
      return node;
    }
  case cmovL_cmpF_reg_reg_rule: {
      cmovL_cmpF_reg_regNode *node = new (C) cmovL_cmpF_reg_regNode();
      node->set_opnd_array(6, MachOperGenerator(REGD, C));
      node->set_opnd_array(7, MachOperGenerator(REGD, C));
      return node;
    }
  case cmovL_cmpI_reg_reg_rule: {
      cmovL_cmpI_reg_regNode *node = new (C) cmovL_cmpI_reg_regNode();
      return node;
    }
  case cmovL_cmpL_reg_reg_rule: {
      cmovL_cmpL_reg_regNode *node = new (C) cmovL_cmpL_reg_regNode();
      return node;
    }
  case cmovL_cmpN_reg_reg_rule: {
      cmovL_cmpN_reg_regNode *node = new (C) cmovL_cmpN_reg_regNode();
      return node;
    }
  case cmovL_cmpD_reg_reg_rule: {
      cmovL_cmpD_reg_regNode *node = new (C) cmovL_cmpD_reg_regNode();
      node->set_opnd_array(6, MachOperGenerator(REGD, C));
      node->set_opnd_array(7, MachOperGenerator(REGD, C));
      return node;
    }
  case cmovD_cmpD_reg_reg_rule: {
      cmovD_cmpD_reg_regNode *node = new (C) cmovD_cmpD_reg_regNode();
      return node;
    }
  case cmovF_cmpI_reg_reg_rule: {
      cmovF_cmpI_reg_regNode *node = new (C) cmovF_cmpI_reg_regNode();
      node->set_opnd_array(6, MachOperGenerator(REGF, C));
      node->set_opnd_array(7, MachOperGenerator(REGF, C));
      return node;
    }
  case cmovD_cmpI_reg_reg_rule: {
      cmovD_cmpI_reg_regNode *node = new (C) cmovD_cmpI_reg_regNode();
      node->set_opnd_array(6, MachOperGenerator(REGF, C));
      node->set_opnd_array(7, MachOperGenerator(REGF, C));
      return node;
    }
  case cmovD_cmpP_reg_reg_rule: {
      cmovD_cmpP_reg_regNode *node = new (C) cmovD_cmpP_reg_regNode();
      node->set_opnd_array(6, MachOperGenerator(REGF, C));
      node->set_opnd_array(7, MachOperGenerator(REGF, C));
      return node;
    }
  case cmovI_cmpF_reg_reg_rule: {
      cmovI_cmpF_reg_regNode *node = new (C) cmovI_cmpF_reg_regNode();
      node->set_opnd_array(6, MachOperGenerator(REGD, C));
      node->set_opnd_array(7, MachOperGenerator(REGD, C));
      return node;
    }
  case cmovF_cmpF_reg_reg_rule: {
      cmovF_cmpF_reg_regNode *node = new (C) cmovF_cmpF_reg_regNode();
      return node;
    }
  case cmpL3_reg_reg_rule: {
      cmpL3_reg_regNode *node = new (C) cmpL3_reg_regNode();
      return node;
    }
  case cmpF3_reg_reg_rule: {
      cmpF3_reg_regNode *node = new (C) cmpF3_reg_regNode();
      return node;
    }
  case cmpD3_reg_reg_rule: {
      cmpD3_reg_regNode *node = new (C) cmpD3_reg_regNode();
      return node;
    }
  case clear_array_rule: {
      clear_arrayNode *node = new (C) clear_arrayNode();
      return node;
    }
  case string_compare_rule: {
      string_compareNode *node = new (C) string_compareNode();
      return node;
    }
  case string_equals_rule: {
      string_equalsNode *node = new (C) string_equalsNode();
      return node;
    }
  case addI_Reg_Reg_rule: {
      addI_Reg_RegNode *node = new (C) addI_Reg_RegNode();
      return node;
    }
  case addI_Reg_imm_rule: {
      addI_Reg_immNode *node = new (C) addI_Reg_immNode();
      return node;
    }
  case addI_salI_Reg_Reg_immI_1_4_rule: {
      addI_salI_Reg_Reg_immI_1_4Node *node = new (C) addI_salI_Reg_Reg_immI_1_4Node();
      return node;
    }
  case addI_salI_Reg_Reg_immI_1_4_0_rule: {
      addI_salI_Reg_Reg_immI_1_4_0Node *node = new (C) addI_salI_Reg_Reg_immI_1_4_0Node();
      return node;
    }
  case addP_reg_reg_rule: {
      addP_reg_regNode *node = new (C) addP_reg_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addP_reg_reg_convI2L_rule: {
      addP_reg_reg_convI2LNode *node = new (C) addP_reg_reg_convI2LNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addP_reg_imm_rule: {
      addP_reg_immNode *node = new (C) addP_reg_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addP_salL_Reg_RegI2L_immI_1_4_rule: {
      addP_salL_Reg_RegI2L_immI_1_4Node *node = new (C) addP_salL_Reg_RegI2L_immI_1_4Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case addL_Reg_Reg_rule: {
      addL_Reg_RegNode *node = new (C) addL_Reg_RegNode();
      return node;
    }
  case addL_Reg_imm_rule: {
      addL_Reg_immNode *node = new (C) addL_Reg_immNode();
      return node;
    }
  case addL_RegI2L_imm_rule: {
      addL_RegI2L_immNode *node = new (C) addL_RegI2L_immNode();
      return node;
    }
  case addL_RegI2L_Reg_rule: {
      addL_RegI2L_RegNode *node = new (C) addL_RegI2L_RegNode();
      return node;
    }
  case addL_RegI2L_Reg_0_rule: {
      addL_RegI2L_Reg_0Node *node = new (C) addL_RegI2L_Reg_0Node();
      return node;
    }
  case addL_RegI2L_RegI2L_rule: {
      addL_RegI2L_RegI2LNode *node = new (C) addL_RegI2L_RegI2LNode();
      return node;
    }
  case addL_RegI2L_RegI2L_0_rule: {
      addL_RegI2L_RegI2L_0Node *node = new (C) addL_RegI2L_RegI2L_0Node();
      return node;
    }
  case addL_Reg_RegI2L_rule: {
      addL_Reg_RegI2LNode *node = new (C) addL_Reg_RegI2LNode();
      return node;
    }
  case addL_Reg_RegI2L_0_rule: {
      addL_Reg_RegI2L_0Node *node = new (C) addL_Reg_RegI2L_0Node();
      return node;
    }
  case subI_Reg_Reg_rule: {
      subI_Reg_RegNode *node = new (C) subI_Reg_RegNode();
      return node;
    }
  case subI_Reg_immI_M2047_2048_rule: {
      subI_Reg_immI_M2047_2048Node *node = new (C) subI_Reg_immI_M2047_2048Node();
      return node;
    }
  case negI_Reg_rule: {
      negI_RegNode *node = new (C) negI_RegNode();
      return node;
    }
  case negL_Reg_rule: {
      negL_RegNode *node = new (C) negL_RegNode();
      return node;
    }
  case subL_Reg_immL_M2047_2048_rule: {
      subL_Reg_immL_M2047_2048Node *node = new (C) subL_Reg_immL_M2047_2048Node();
      return node;
    }
  case subL_Reg_Reg_rule: {
      subL_Reg_RegNode *node = new (C) subL_Reg_RegNode();
      return node;
    }
  case subL_Reg_RegI2L_rule: {
      subL_Reg_RegI2LNode *node = new (C) subL_Reg_RegI2LNode();
      return node;
    }
  case subL_RegI2L_Reg_rule: {
      subL_RegI2L_RegNode *node = new (C) subL_RegI2L_RegNode();
      return node;
    }
  case subL_RegI2L_RegI2L_rule: {
      subL_RegI2L_RegI2LNode *node = new (C) subL_RegI2L_RegI2LNode();
      return node;
    }
  case modI_Reg_Reg_rule: {
      modI_Reg_RegNode *node = new (C) modI_Reg_RegNode();
      return node;
    }
  case modL_reg_reg_rule: {
      modL_reg_regNode *node = new (C) modL_reg_regNode();
      return node;
    }
  case mulI_Reg_Reg_rule: {
      mulI_Reg_RegNode *node = new (C) mulI_Reg_RegNode();
      return node;
    }
  case maddI_Reg_Reg_rule: {
      maddI_Reg_RegNode *node = new (C) maddI_Reg_RegNode();
      return node;
    }
  case maddI_Reg_Reg_0_rule: {
      maddI_Reg_Reg_0Node *node = new (C) maddI_Reg_Reg_0Node();
      return node;
    }
  case divI_Reg_Reg_rule: {
      divI_Reg_RegNode *node = new (C) divI_Reg_RegNode();
      return node;
    }
  case divF_Reg_Reg_rule: {
      divF_Reg_RegNode *node = new (C) divF_Reg_RegNode();
      return node;
    }
  case divD_Reg_Reg_rule: {
      divD_Reg_RegNode *node = new (C) divD_Reg_RegNode();
      return node;
    }
  case mulL_reg_reg_rule: {
      mulL_reg_regNode *node = new (C) mulL_reg_regNode();
      return node;
    }
  case mulL_reg_regI2L_rule: {
      mulL_reg_regI2LNode *node = new (C) mulL_reg_regI2LNode();
      return node;
    }
  case mulL_reg_regI2L_0_rule: {
      mulL_reg_regI2L_0Node *node = new (C) mulL_reg_regI2L_0Node();
      return node;
    }
  case divL_reg_reg_rule: {
      divL_reg_regNode *node = new (C) divL_reg_regNode();
      return node;
    }
  case addF_reg_reg_rule: {
      addF_reg_regNode *node = new (C) addF_reg_regNode();
      return node;
    }
  case subF_reg_reg_rule: {
      subF_reg_regNode *node = new (C) subF_reg_regNode();
      return node;
    }
  case addD_reg_reg_rule: {
      addD_reg_regNode *node = new (C) addD_reg_regNode();
      return node;
    }
  case subD_reg_reg_rule: {
      subD_reg_regNode *node = new (C) subD_reg_regNode();
      return node;
    }
  case negF_reg_rule: {
      negF_regNode *node = new (C) negF_regNode();
      return node;
    }
  case negD_reg_rule: {
      negD_regNode *node = new (C) negD_regNode();
      return node;
    }
  case mulF_reg_reg_rule: {
      mulF_reg_regNode *node = new (C) mulF_reg_regNode();
      return node;
    }
  case maddF_reg_reg_rule: {
      maddF_reg_regNode *node = new (C) maddF_reg_regNode();
      return node;
    }
  case maddF_reg_reg_0_rule: {
      maddF_reg_reg_0Node *node = new (C) maddF_reg_reg_0Node();
      return node;
    }
  case mulD_reg_reg_rule: {
      mulD_reg_regNode *node = new (C) mulD_reg_regNode();
      return node;
    }
  case maddD_reg_reg_rule: {
      maddD_reg_regNode *node = new (C) maddD_reg_regNode();
      return node;
    }
  case maddD_reg_reg_0_rule: {
      maddD_reg_reg_0Node *node = new (C) maddD_reg_reg_0Node();
      return node;
    }
  case absF_reg_rule: {
      absF_regNode *node = new (C) absF_regNode();
      return node;
    }
  case absD_reg_rule: {
      absD_regNode *node = new (C) absD_regNode();
      return node;
    }
  case sqrtD_reg_rule: {
      sqrtD_regNode *node = new (C) sqrtD_regNode();
      return node;
    }
  case sqrtF_reg_rule: {
      sqrtF_regNode *node = new (C) sqrtF_regNode();
      return node;
    }
  case andI_Reg_immI_rule: {
      andI_Reg_immINode *node = new (C) andI_Reg_immINode();
      return node;
    }
  case andI_Reg_imm_0_4095_rule: {
      andI_Reg_imm_0_4095Node *node = new (C) andI_Reg_imm_0_4095Node();
      return node;
    }
  case andI_Reg_immI_nonneg_mask_rule: {
      andI_Reg_immI_nonneg_maskNode *node = new (C) andI_Reg_immI_nonneg_maskNode();
      return node;
    }
  case andL_Reg_immL_nonneg_mask_rule: {
      andL_Reg_immL_nonneg_maskNode *node = new (C) andL_Reg_immL_nonneg_maskNode();
      return node;
    }
  case xorI_Reg_imm_0_4095_rule: {
      xorI_Reg_imm_0_4095Node *node = new (C) xorI_Reg_imm_0_4095Node();
      return node;
    }
  case xorI_Reg_immI_M1_rule: {
      xorI_Reg_immI_M1Node *node = new (C) xorI_Reg_immI_M1Node();
      return node;
    }
  case xorL2I_Reg_immI_M1_rule: {
      xorL2I_Reg_immI_M1Node *node = new (C) xorL2I_Reg_immI_M1Node();
      return node;
    }
  case xorL_Reg_imm_0_4095_rule: {
      xorL_Reg_imm_0_4095Node *node = new (C) xorL_Reg_imm_0_4095Node();
      return node;
    }
  case lbu_and_lmask_rule: {
      lbu_and_lmaskNode *node = new (C) lbu_and_lmaskNode();
      return node;
    }
  case lbu_and_lmask_0_rule: {
      lbu_and_lmask_0Node *node = new (C) lbu_and_lmask_0Node();
      return node;
    }
  case lbu_and_rmask_rule: {
      lbu_and_rmaskNode *node = new (C) lbu_and_rmaskNode();
      return node;
    }
  case andI_Reg_Reg_rule: {
      andI_Reg_RegNode *node = new (C) andI_Reg_RegNode();
      return node;
    }
  case andnI_Reg_nReg_rule: {
      andnI_Reg_nRegNode *node = new (C) andnI_Reg_nRegNode();
      return node;
    }
  case andnI_Reg_nReg_0_rule: {
      andnI_Reg_nReg_0Node *node = new (C) andnI_Reg_nReg_0Node();
      return node;
    }
  case ornI_Reg_nReg_rule: {
      ornI_Reg_nRegNode *node = new (C) ornI_Reg_nRegNode();
      return node;
    }
  case ornI_Reg_nReg_0_rule: {
      ornI_Reg_nReg_0Node *node = new (C) ornI_Reg_nReg_0Node();
      return node;
    }
  case andnI_nReg_Reg_rule: {
      andnI_nReg_RegNode *node = new (C) andnI_nReg_RegNode();
      return node;
    }
  case andnI_nReg_Reg_0_rule: {
      andnI_nReg_Reg_0Node *node = new (C) andnI_nReg_Reg_0Node();
      return node;
    }
  case ornI_nReg_Reg_rule: {
      ornI_nReg_RegNode *node = new (C) ornI_nReg_RegNode();
      return node;
    }
  case ornI_nReg_Reg_0_rule: {
      ornI_nReg_Reg_0Node *node = new (C) ornI_nReg_Reg_0Node();
      return node;
    }
  case andL_Reg_Reg_rule: {
      andL_Reg_RegNode *node = new (C) andL_Reg_RegNode();
      return node;
    }
  case andL_Reg_Reg_convI2L_rule: {
      andL_Reg_Reg_convI2LNode *node = new (C) andL_Reg_Reg_convI2LNode();
      return node;
    }
  case andL_Reg_Reg_convI2L_0_rule: {
      andL_Reg_Reg_convI2L_0Node *node = new (C) andL_Reg_Reg_convI2L_0Node();
      return node;
    }
  case andL_Reg_imm_0_4095_rule: {
      andL_Reg_imm_0_4095Node *node = new (C) andL_Reg_imm_0_4095Node();
      return node;
    }
  case andL2I_Reg_imm_0_4095_rule: {
      andL2I_Reg_imm_0_4095Node *node = new (C) andL2I_Reg_imm_0_4095Node();
      return node;
    }
  case andL_Reg_immL_M8_rule: {
      andL_Reg_immL_M8Node *node = new (C) andL_Reg_immL_M8Node();
      return node;
    }
  case andL_Reg_immL_M5_rule: {
      andL_Reg_immL_M5Node *node = new (C) andL_Reg_immL_M5Node();
      return node;
    }
  case andL_Reg_immL_M7_rule: {
      andL_Reg_immL_M7Node *node = new (C) andL_Reg_immL_M7Node();
      return node;
    }
  case andL_Reg_immL_M4_rule: {
      andL_Reg_immL_M4Node *node = new (C) andL_Reg_immL_M4Node();
      return node;
    }
  case andL_Reg_immL_M121_rule: {
      andL_Reg_immL_M121Node *node = new (C) andL_Reg_immL_M121Node();
      return node;
    }
  case orL_Reg_Reg_rule: {
      orL_Reg_RegNode *node = new (C) orL_Reg_RegNode();
      return node;
    }
  case orL_Reg_P2XReg_rule: {
      orL_Reg_P2XRegNode *node = new (C) orL_Reg_P2XRegNode();
      return node;
    }
  case orL_Reg_P2XReg_0_rule: {
      orL_Reg_P2XReg_0Node *node = new (C) orL_Reg_P2XReg_0Node();
      return node;
    }
  case xorL_Reg_Reg_rule: {
      xorL_Reg_RegNode *node = new (C) xorL_Reg_RegNode();
      return node;
    }
  case salI_Reg_imm_rule: {
      salI_Reg_immNode *node = new (C) salI_Reg_immNode();
      return node;
    }
  case salL2I_Reg_imm_rule: {
      salL2I_Reg_immNode *node = new (C) salL2I_Reg_immNode();
      return node;
    }
  case salI_Reg_imm_and_M65536_rule: {
      salI_Reg_imm_and_M65536Node *node = new (C) salI_Reg_imm_and_M65536Node();
      return node;
    }
  case land7_2_s_rule: {
      land7_2_sNode *node = new (C) land7_2_sNode();
      return node;
    }
  case ori2s_rule: {
      ori2sNode *node = new (C) ori2sNode();
      return node;
    }
  case i2s_rule: {
      i2sNode *node = new (C) i2sNode();
      return node;
    }
  case i2b_rule: {
      i2bNode *node = new (C) i2bNode();
      return node;
    }
  case salI_RegL2I_imm_rule: {
      salI_RegL2I_immNode *node = new (C) salI_RegL2I_immNode();
      return node;
    }
  case salI_Reg_Reg_rule: {
      salI_Reg_RegNode *node = new (C) salI_Reg_RegNode();
      return node;
    }
  case salL_Reg_imm_rule: {
      salL_Reg_immNode *node = new (C) salL_Reg_immNode();
      return node;
    }
  case salL_RegI2L_imm_rule: {
      salL_RegI2L_immNode *node = new (C) salL_RegI2L_immNode();
      return node;
    }
  case salL_Reg_Reg_rule: {
      salL_Reg_RegNode *node = new (C) salL_Reg_RegNode();
      return node;
    }
  case sarL_Reg_imm_rule: {
      sarL_Reg_immNode *node = new (C) sarL_Reg_immNode();
      return node;
    }
  case sarL2I_Reg_immI_32_63_rule: {
      sarL2I_Reg_immI_32_63Node *node = new (C) sarL2I_Reg_immI_32_63Node();
      return node;
    }
  case sarL_Reg_Reg_rule: {
      sarL_Reg_RegNode *node = new (C) sarL_Reg_RegNode();
      return node;
    }
  case slrL_Reg_Reg_rule: {
      slrL_Reg_RegNode *node = new (C) slrL_Reg_RegNode();
      return node;
    }
  case slrL_Reg_immI_0_31_rule: {
      slrL_Reg_immI_0_31Node *node = new (C) slrL_Reg_immI_0_31Node();
      return node;
    }
  case slrL_Reg_immI_0_31_and_max_int_rule: {
      slrL_Reg_immI_0_31_and_max_intNode *node = new (C) slrL_Reg_immI_0_31_and_max_intNode();
      return node;
    }
  case slrL_P2XReg_immI_0_31_rule: {
      slrL_P2XReg_immI_0_31Node *node = new (C) slrL_P2XReg_immI_0_31Node();
      return node;
    }
  case slrL_Reg_immI_32_63_rule: {
      slrL_Reg_immI_32_63Node *node = new (C) slrL_Reg_immI_32_63Node();
      return node;
    }
  case slrL_Reg_immI_convL2I_rule: {
      slrL_Reg_immI_convL2INode *node = new (C) slrL_Reg_immI_convL2INode();
      return node;
    }
  case slrL_P2XReg_immI_32_63_rule: {
      slrL_P2XReg_immI_32_63Node *node = new (C) slrL_P2XReg_immI_32_63Node();
      return node;
    }
  case xorI_Reg_Reg_rule: {
      xorI_Reg_RegNode *node = new (C) xorI_Reg_RegNode();
      return node;
    }
  case orI_Reg_Reg_rule: {
      orI_Reg_RegNode *node = new (C) orI_Reg_RegNode();
      return node;
    }
  case rotI_shr_logical_Reg_rule: {
      rotI_shr_logical_RegNode *node = new (C) rotI_shr_logical_RegNode();
      return node;
    }
  case rotI_shr_logical_Reg_0_rule: {
      rotI_shr_logical_Reg_0Node *node = new (C) rotI_shr_logical_Reg_0Node();
      return node;
    }
  case orI_Reg_castP2X_rule: {
      orI_Reg_castP2XNode *node = new (C) orI_Reg_castP2XNode();
      return node;
    }
  case orI_Reg_castP2X_0_rule: {
      orI_Reg_castP2X_0Node *node = new (C) orI_Reg_castP2X_0Node();
      return node;
    }
  case shr_logical_Reg_imm_rule: {
      shr_logical_Reg_immNode *node = new (C) shr_logical_Reg_immNode();
      return node;
    }
  case shr_logical_Reg_imm_nonneg_mask_rule: {
      shr_logical_Reg_imm_nonneg_maskNode *node = new (C) shr_logical_Reg_imm_nonneg_maskNode();
      return node;
    }
  case rolI_Reg_immI_0_31_rule: {
      rolI_Reg_immI_0_31Node *node = new (C) rolI_Reg_immI_0_31Node();
      return node;
    }
  case rolI_Reg_immI_0_31_0_rule: {
      rolI_Reg_immI_0_31_0Node *node = new (C) rolI_Reg_immI_0_31_0Node();
      return node;
    }
  case rolL_Reg_immI_0_31_rule: {
      rolL_Reg_immI_0_31Node *node = new (C) rolL_Reg_immI_0_31Node();
      return node;
    }
  case rolL_Reg_immI_0_31_0_rule: {
      rolL_Reg_immI_0_31_0Node *node = new (C) rolL_Reg_immI_0_31_0Node();
      return node;
    }
  case rolL_Reg_immI_32_63_rule: {
      rolL_Reg_immI_32_63Node *node = new (C) rolL_Reg_immI_32_63Node();
      return node;
    }
  case rolL_Reg_immI_32_63_0_rule: {
      rolL_Reg_immI_32_63_0Node *node = new (C) rolL_Reg_immI_32_63_0Node();
      return node;
    }
  case rorI_Reg_immI_0_31_rule: {
      rorI_Reg_immI_0_31Node *node = new (C) rorI_Reg_immI_0_31Node();
      return node;
    }
  case rorI_Reg_immI_0_31_0_rule: {
      rorI_Reg_immI_0_31_0Node *node = new (C) rorI_Reg_immI_0_31_0Node();
      return node;
    }
  case rorL_Reg_immI_0_31_rule: {
      rorL_Reg_immI_0_31Node *node = new (C) rorL_Reg_immI_0_31Node();
      return node;
    }
  case rorL_Reg_immI_0_31_0_rule: {
      rorL_Reg_immI_0_31_0Node *node = new (C) rorL_Reg_immI_0_31_0Node();
      return node;
    }
  case rorL_Reg_immI_32_63_rule: {
      rorL_Reg_immI_32_63Node *node = new (C) rorL_Reg_immI_32_63Node();
      return node;
    }
  case rorL_Reg_immI_32_63_0_rule: {
      rorL_Reg_immI_32_63_0Node *node = new (C) rorL_Reg_immI_32_63_0Node();
      return node;
    }
  case shr_logical_Reg_Reg_rule: {
      shr_logical_Reg_RegNode *node = new (C) shr_logical_Reg_RegNode();
      return node;
    }
  case shr_arith_Reg_imm_rule: {
      shr_arith_Reg_immNode *node = new (C) shr_arith_Reg_immNode();
      return node;
    }
  case shr_arith_Reg_Reg_rule: {
      shr_arith_Reg_RegNode *node = new (C) shr_arith_Reg_RegNode();
      return node;
    }
  case convI2B_rule: {
      convI2BNode *node = new (C) convI2BNode();
      return node;
    }
  case convI2L_reg_rule: {
      convI2L_regNode *node = new (C) convI2L_regNode();
      return node;
    }
  case convL2I_reg_rule: {
      convL2I_regNode *node = new (C) convL2I_regNode();
      return node;
    }
  case convL2I2L_reg_rule: {
      convL2I2L_regNode *node = new (C) convL2I2L_regNode();
      return node;
    }
  case convL2D_reg_rule: {
      convL2D_regNode *node = new (C) convL2D_regNode();
      return node;
    }
  case convD2L_reg_fast_rule: {
      convD2L_reg_fastNode *node = new (C) convD2L_reg_fastNode();
      return node;
    }
  case convD2L_reg_slow_rule: {
      convD2L_reg_slowNode *node = new (C) convD2L_reg_slowNode();
      return node;
    }
  case convF2I_reg_fast_rule: {
      convF2I_reg_fastNode *node = new (C) convF2I_reg_fastNode();
      return node;
    }
  case convF2I_reg_slow_rule: {
      convF2I_reg_slowNode *node = new (C) convF2I_reg_slowNode();
      return node;
    }
  case convF2L_reg_fast_rule: {
      convF2L_reg_fastNode *node = new (C) convF2L_reg_fastNode();
      return node;
    }
  case convF2L_reg_slow_rule: {
      convF2L_reg_slowNode *node = new (C) convF2L_reg_slowNode();
      return node;
    }
  case convL2F_reg_rule: {
      convL2F_regNode *node = new (C) convL2F_regNode();
      return node;
    }
  case convI2F_reg_rule: {
      convI2F_regNode *node = new (C) convI2F_regNode();
      return node;
    }
  case cmpLTMask_immI_0_rule: {
      cmpLTMask_immI_0Node *node = new (C) cmpLTMask_immI_0Node();
      return node;
    }
  case cmpLTMask_rule: {
      cmpLTMaskNode *node = new (C) cmpLTMaskNode();
      return node;
    }
  case convP2B_rule: {
      convP2BNode *node = new (C) convP2BNode();
      return node;
    }
  case convI2D_reg_reg_rule: {
      convI2D_reg_regNode *node = new (C) convI2D_reg_regNode();
      return node;
    }
  case convF2D_reg_reg_rule: {
      convF2D_reg_regNode *node = new (C) convF2D_reg_regNode();
      return node;
    }
  case convD2F_reg_reg_rule: {
      convD2F_reg_regNode *node = new (C) convD2F_reg_regNode();
      return node;
    }
  case convD2I_reg_reg_fast_rule: {
      convD2I_reg_reg_fastNode *node = new (C) convD2I_reg_reg_fastNode();
      return node;
    }
  case convD2I_reg_reg_slow_rule: {
      convD2I_reg_reg_slowNode *node = new (C) convD2I_reg_reg_slowNode();
      return node;
    }
  case encodeHeapOop_rule: {
      encodeHeapOopNode *node = new (C) encodeHeapOopNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case encodeHeapOop_not_null_rule: {
      encodeHeapOop_not_nullNode *node = new (C) encodeHeapOop_not_nullNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeHeapOop_rule: {
      decodeHeapOopNode *node = new (C) decodeHeapOopNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeHeapOop_not_null_rule: {
      decodeHeapOop_not_nullNode *node = new (C) decodeHeapOop_not_nullNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case encodeKlass_not_null_rule: {
      encodeKlass_not_nullNode *node = new (C) encodeKlass_not_nullNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case decodeKlass_not_null_rule: {
      decodeKlass_not_nullNode *node = new (C) decodeKlass_not_nullNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case tlsLoadP_rule: {
      tlsLoadPNode *node = new (C) tlsLoadPNode();
      return node;
    }
  case checkCastPP_rule: {
      checkCastPPNode *node = new (C) checkCastPPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castPP_rule: {
      castPPNode *node = new (C) castPPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case castII_rule: {
      castIINode *node = new (C) castIINode();
      return node;
    }
  case Ret_rule: {
      RetNode *node = new (C) RetNode();
      return node;
    }
  case tailjmpInd_rule: {
      tailjmpIndNode *node = new (C) tailjmpIndNode();
      return node;
    }
  case CallStaticJavaDirect_rule: {
      CallStaticJavaDirectNode *node = new (C) CallStaticJavaDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case CallDynamicJavaDirect_rule: {
      CallDynamicJavaDirectNode *node = new (C) CallDynamicJavaDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case CallLeafNoFPDirect_rule: {
      CallLeafNoFPDirectNode *node = new (C) CallLeafNoFPDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case prefetchr_rule: {
      prefetchrNode *node = new (C) prefetchrNode();
      return node;
    }
  case prefetchw_rule: {
      prefetchwNode *node = new (C) prefetchwNode();
      return node;
    }
  case prefetchAlloc_rule: {
      prefetchAllocNode *node = new (C) prefetchAllocNode();
      return node;
    }
  case CallLeafDirect_rule: {
      CallLeafDirectNode *node = new (C) CallLeafDirectNode();
      node->set_opnd_array(1, MachOperGenerator(METHOD, C));
      return node;
    }
  case loadUS_rule: {
      loadUSNode *node = new (C) loadUSNode();
      return node;
    }
  case loadUS_convI2L_rule: {
      loadUS_convI2LNode *node = new (C) loadUS_convI2LNode();
      return node;
    }
  case storeC_rule: {
      storeCNode *node = new (C) storeCNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeC_0_rule: {
      storeC_0Node *node = new (C) storeC_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadConF_immF_0_rule: {
      loadConF_immF_0Node *node = new (C) loadConF_immF_0Node();
      node->_opnd_array[1] = new (C) immF_0Oper(_leaf->getf() );
      return node;
    }
  case loadConF_rule: {
      loadConFNode *node = new (C) loadConFNode();
      node->_opnd_array[1] = new (C) immFOper(_leaf->getf() );
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadConD_immD_0_rule: {
      loadConD_immD_0Node *node = new (C) loadConD_immD_0Node();
      node->_opnd_array[1] = new (C) immD_0Oper(_leaf->getd() );
      return node;
    }
  case loadConD_rule: {
      loadConDNode *node = new (C) loadConDNode();
      node->_opnd_array[1] = new (C) immDOper(_leaf->getd() );
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeF_reg_rule: {
      storeF_regNode *node = new (C) storeF_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeF_immF_0_rule: {
      storeF_immF_0Node *node = new (C) storeF_immF_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadD_rule: {
      loadDNode *node = new (C) loadDNode();
      return node;
    }
  case loadD_unaligned_rule: {
      loadD_unalignedNode *node = new (C) loadD_unalignedNode();
      return node;
    }
  case storeD_reg_rule: {
      storeD_regNode *node = new (C) storeD_regNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeD_immD_0_rule: {
      storeD_immD_0Node *node = new (C) storeD_immD_0Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case loadSSI_rule: {
      loadSSINode *node = new (C) loadSSINode();
      return node;
    }
  case storeSSI_rule: {
      storeSSINode *node = new (C) storeSSINode();
      return node;
    }
  case loadSSL_rule: {
      loadSSLNode *node = new (C) loadSSLNode();
      return node;
    }
  case storeSSL_rule: {
      storeSSLNode *node = new (C) storeSSLNode();
      return node;
    }
  case loadSSP_rule: {
      loadSSPNode *node = new (C) loadSSPNode();
      return node;
    }
  case storeSSP_rule: {
      storeSSPNode *node = new (C) storeSSPNode();
      return node;
    }
  case loadSSF_rule: {
      loadSSFNode *node = new (C) loadSSFNode();
      return node;
    }
  case storeSSF_rule: {
      storeSSFNode *node = new (C) storeSSFNode();
      return node;
    }
  case loadSSD_rule: {
      loadSSDNode *node = new (C) loadSSDNode();
      return node;
    }
  case storeSSD_rule: {
      storeSSDNode *node = new (C) storeSSDNode();
      return node;
    }
  case cmpFastLock_rule: {
      cmpFastLockNode *node = new (C) cmpFastLockNode();
      node->set_opnd_array(3, MachOperGenerator(MREGI, C));
      node->set_opnd_array(4, MachOperGenerator(MREGP, C));
      node->_counters = _leaf->as_FastLock()->counters();
      node->_rtm_counters = _leaf->as_FastLock()->rtm_counters();
      node->_stack_rtm_counters = _leaf->as_FastLock()->stack_rtm_counters();
      return node;
    }
  case cmpFastUnlock_rule: {
      cmpFastUnlockNode *node = new (C) cmpFastUnlockNode();
      node->set_opnd_array(3, MachOperGenerator(MREGP, C));
      return node;
    }
  case storeImmCM_rule: {
      storeImmCMNode *node = new (C) storeImmCMNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case ShouldNotReachHere_rule: {
      ShouldNotReachHereNode *node = new (C) ShouldNotReachHereNode();
      return node;
    }
  case leaP8Narrow_rule: {
      leaP8NarrowNode *node = new (C) leaP8NarrowNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case leaPPosIdxScaleOff8_rule: {
      leaPPosIdxScaleOff8Node *node = new (C) leaPPosIdxScaleOff8Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case leaPIdxScale_rule: {
      leaPIdxScaleNode *node = new (C) leaPIdxScaleNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case partialSubtypeCheck_rule: {
      partialSubtypeCheckNode *node = new (C) partialSubtypeCheckNode();
      return node;
    }
  case storePConditional_rule: {
      storePConditionalNode *node = new (C) storePConditionalNode();
      return node;
    }
  case storeIConditional_rule: {
      storeIConditionalNode *node = new (C) storeIConditionalNode();
      return node;
    }
  case storeLConditional_rule: {
      storeLConditionalNode *node = new (C) storeLConditionalNode();
      return node;
    }
  case loadPLocked_rule: {
      loadPLockedNode *node = new (C) loadPLockedNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case compareAndSwapI_rule: {
      compareAndSwapINode *node = new (C) compareAndSwapINode();
      return node;
    }
  case compareAndSwapL_rule: {
      compareAndSwapLNode *node = new (C) compareAndSwapLNode();
      return node;
    }
  case compareAndSwapP_rule: {
      compareAndSwapPNode *node = new (C) compareAndSwapPNode();
      return node;
    }
  case compareAndSwapN_rule: {
      compareAndSwapNNode *node = new (C) compareAndSwapNNode();
      return node;
    }
  case minI_Reg_Reg_rule: {
      minI_Reg_RegNode *node = new (C) minI_Reg_RegNode();
      return node;
    }
  case maxI_Reg_Reg_rule: {
      maxI_Reg_RegNode *node = new (C) maxI_Reg_RegNode();
      return node;
    }
  case maxI_Reg_zero_rule: {
      maxI_Reg_zeroNode *node = new (C) maxI_Reg_zeroNode();
      return node;
    }
  case zerox_long_reg_reg_rule: {
      zerox_long_reg_regNode *node = new (C) zerox_long_reg_regNode();
      return node;
    }
  case combine_i2l_rule: {
      combine_i2lNode *node = new (C) combine_i2lNode();
      return node;
    }
  case combine_i2l_0_rule: {
      combine_i2l_0Node *node = new (C) combine_i2l_0Node();
      return node;
    }
  case convI2L_reg_reg_zex_rule: {
      convI2L_reg_reg_zexNode *node = new (C) convI2L_reg_reg_zexNode();
      return node;
    }
  case convL2I2L_reg_reg_zex_rule: {
      convL2I2L_reg_reg_zexNode *node = new (C) convL2I2L_reg_reg_zexNode();
      return node;
    }
  case loadUI2L_rmask_rule: {
      loadUI2L_rmaskNode *node = new (C) loadUI2L_rmaskNode();
      return node;
    }
  case loadUI2L_lmask_rule: {
      loadUI2L_lmaskNode *node = new (C) loadUI2L_lmaskNode();
      return node;
    }
  case loadUI2L_lmask_0_rule: {
      loadUI2L_lmask_0Node *node = new (C) loadUI2L_lmask_0Node();
      return node;
    }
  case safePoint_poll_reg_rule: {
      safePoint_poll_regNode *node = new (C) safePoint_poll_regNode();
      return node;
    }
  case safePoint_poll_rule: {
      safePoint_pollNode *node = new (C) safePoint_pollNode();
      return node;
    }
  case roundFloat_nop_rule: {
      roundFloat_nopNode *node = new (C) roundFloat_nopNode();
      return node;
    }
  case roundDouble_nop_rule: {
      roundDouble_nopNode *node = new (C) roundDouble_nopNode();
      return node;
    }
  case countLeadingZerosI_rule: {
      countLeadingZerosINode *node = new (C) countLeadingZerosINode();
      return node;
    }
  case countLeadingZerosL_rule: {
      countLeadingZerosLNode *node = new (C) countLeadingZerosLNode();
      return node;
    }
  case countTrailingZerosI_rule: {
      countTrailingZerosINode *node = new (C) countTrailingZerosINode();
      return node;
    }
  case countTrailingZerosL_rule: {
      countTrailingZerosLNode *node = new (C) countTrailingZerosLNode();
      return node;
    }
  case loadV8_rule: {
      loadV8Node *node = new (C) loadV8Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case storeV8_rule: {
      storeV8Node *node = new (C) storeV8Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8B_DSP_rule: {
      Repl8B_DSPNode *node = new (C) Repl8B_DSPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8B_rule: {
      Repl8BNode *node = new (C) Repl8BNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8B_imm_DSP_rule: {
      Repl8B_imm_DSPNode *node = new (C) Repl8B_imm_DSPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8B_imm_rule: {
      Repl8B_immNode *node = new (C) Repl8B_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8B_zero_rule: {
      Repl8B_zeroNode *node = new (C) Repl8B_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl8B_M1_rule: {
      Repl8B_M1Node *node = new (C) Repl8B_M1Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4S_DSP_rule: {
      Repl4S_DSPNode *node = new (C) Repl4S_DSPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4S_rule: {
      Repl4SNode *node = new (C) Repl4SNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4S_imm_DSP_rule: {
      Repl4S_imm_DSPNode *node = new (C) Repl4S_imm_DSPNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4S_imm_rule: {
      Repl4S_immNode *node = new (C) Repl4S_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4S_zero_rule: {
      Repl4S_zeroNode *node = new (C) Repl4S_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl4S_M1_rule: {
      Repl4S_M1Node *node = new (C) Repl4S_M1Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2I_rule: {
      Repl2INode *node = new (C) Repl2INode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2I_imm_rule: {
      Repl2I_immNode *node = new (C) Repl2I_immNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2I_zero_rule: {
      Repl2I_zeroNode *node = new (C) Repl2I_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2I_M1_rule: {
      Repl2I_M1Node *node = new (C) Repl2I_M1Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2F_rule: {
      Repl2FNode *node = new (C) Repl2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case Repl2F_zero_rule: {
      Repl2F_zeroNode *node = new (C) Repl2F_zeroNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2F_rule: {
      vadd2FNode *node = new (C) vadd2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vadd2F3_rule: {
      vadd2F3Node *node = new (C) vadd2F3Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vsub2F_rule: {
      vsub2FNode *node = new (C) vsub2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2F_rule: {
      vmul2FNode *node = new (C) vmul2FNode();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  case vmul2F3_rule: {
      vmul2F3Node *node = new (C) vmul2F3Node();
      node->_bottom_type = _leaf->bottom_type();
      return node;
    }
  
  default:
    fprintf(stderr, "Default MachNode Generator invoked for: \n");
    fprintf(stderr, "   opcode = %d\n", opcode);
    break;
  };
  return NULL;
}
// Check consistency of C++ compilation with ADLC options:
// Check adlc -DLINUX=1
#ifndef LINUX
#  error "LINUX must be defined"
#endif // LINUX
// Check adlc -D_GNU_SOURCE=1
#ifndef _GNU_SOURCE
#  error "_GNU_SOURCE must be defined"
#endif // _GNU_SOURCE
// Check adlc -DLOONGARCH64=1
#ifndef LOONGARCH64
#  error "LOONGARCH64 must be defined"
#endif // LOONGARCH64
// Check adlc -D_LP64=1
#ifndef _LP64
#  error "_LP64 must be defined"
#endif // _LP64
