//
// Copyright (c) 2003, 2013, Oracle and/or its affiliates. All rights reserved.
// Copyright (c) 2015, 2021, Loongson Technology. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/adGlobals_loongarch_64.hpp"
#include "adfiles/ad_loongarch_64.hpp"
#include "memory/allocation.inline.hpp"
#include "asm/macroAssembler.inline.hpp"
#include "code/compiledIC.hpp"
#include "code/vmreg.hpp"
#include "gc_interface/collectedHeap.inline.hpp"
#include "oops/compiledICHolder.hpp"
#include "oops/markOop.hpp"
#include "oops/method.hpp"
#include "oops/oop.inline.hpp"
#include "oops/oop.inline2.hpp"
#include "opto/cfgnode.hpp"
#include "opto/locknode.hpp"
#include "opto/opcodes.hpp"
#include "opto/regalloc.hpp"
#include "opto/regmask.hpp"
#include "opto/runtime.hpp"
#include "runtime/biasedLocking.hpp"
#include "runtime/sharedRuntime.hpp"
#include "runtime/stubRoutines.hpp"
#include "utilities/growableArray.hpp"
#include "nativeInst_loongarch.hpp"
#include "vmreg_loongarch.inline.hpp"

//SourceForm

#line 542 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"


#define   NO_INDEX    0
#define   RELOC_IMM64    Assembler::imm_operand
#define   RELOC_DISP32   Assembler::disp32_operand

#define V0_num    A0_num
#define V0_H_num  A0_H_num

#define __ _masm.

#define A0 RA0
#define A1 RA1
#define A2 RA2
#define A3 RA3
#define A4 RA4
#define A5 RA5
#define A6 RA6
#define A7 RA7
#define T0 RT0
#define T1 RT1
#define T2 RT2
#define T3 RT3
#define T4 RT4
#define T5 RT5
#define T6 RT6
#define T7 RT7
#define T8 RT8

// Emit exception handler code.
// Stuff framesize into a register and call a VM stub routine.
int HandlerImpl::emit_exception_handler(CodeBuffer& cbuf) {
  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a handler.
  MacroAssembler _masm(&cbuf);
  address base = __ start_a_stub(size_exception_handler());
  if (base == NULL) {
    ciEnv::current()->record_failure("CodeCache is full");
    return 0;  // CodeBuffer::expand failed
  }

  int offset = __ offset();

  __ block_comment("; emit_exception_handler");

  cbuf.set_insts_mark();
  __ relocate(relocInfo::runtime_call_type);
  __ patchable_jump((address)OptoRuntime::exception_blob()->entry_point());
  __ align(16);
  assert(__ offset() - offset <= (int) size_exception_handler(), "overflow");
  __ end_a_stub();
  return offset;
}

// Emit deopt handler code.
int HandlerImpl::emit_deopt_handler(CodeBuffer& cbuf) {
  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a handler.
  MacroAssembler _masm(&cbuf);
  address base = __ start_a_stub(size_deopt_handler());
  if (base == NULL) {
    ciEnv::current()->record_failure("CodeCache is full");
    return 0;  // CodeBuffer::expand failed
  }

  int offset = __ offset();

  __ block_comment("; emit_deopt_handler");

  cbuf.set_insts_mark();
  __ relocate(relocInfo::runtime_call_type);
  __ patchable_call(SharedRuntime::deopt_blob()->unpack());
  __ align(16);
  assert(__ offset() - offset <= (int) size_deopt_handler(), "overflow");
  __ end_a_stub();
  return offset;
}


const bool Matcher::match_rule_supported(int opcode) {
  if (!has_match_rule(opcode))
    return false;

  switch (opcode) {
    //Op_CountLeadingZerosI Op_CountLeadingZerosL can be deleted, all MIPS CPUs support clz & dclz.
    case Op_CountLeadingZerosI:
    case Op_CountLeadingZerosL:
      if (!UseCountLeadingZerosInstructionLOONGARCH64)
        return false;
      break;
    case Op_CountTrailingZerosI:
    case Op_CountTrailingZerosL:
      if (!UseCountTrailingZerosInstructionLOONGARCH64)
        return false;
      break;
  }

  return true;  // Per default match rules are supported.
}

//FIXME
// emit call stub, compiled java to interpreter
void emit_java_to_interp(CodeBuffer &cbuf ) {
  // Stub is fixed up when the corresponding call is converted from calling
  // compiled code to calling interpreted code.
  // mov S3,0
  // jmp pc()

  address mark = cbuf.insts_mark(); // get mark within main instrs section

  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a stub.
  MacroAssembler _masm(&cbuf);

  address base = __ start_a_stub(Compile::MAX_stubs_size);
  if (base == NULL) { // CodeBuffer::expand failed
    ciEnv::current()->record_failure("CodeCache is full");
  }

  // static stub relocation stores the instruction address of the call
  // static stub relocation also tags the methodOop in the code-stream.
  __ relocate(static_stub_Relocation::spec(mark), 0);
  __ patchable_set52(S3, (long)0);
  // This is recognized as unresolved by relocs/nativeInst/ic code

  cbuf.set_insts_mark();
  __ patchable_jump(__ pc());
  __ align(16);
  __ end_a_stub();
  // Update current stubs pointer and restore code_end.
}

// size of call stub, compiled java to interpretor
uint size_java_to_interp() {
  int size = NativeMovConstReg::instruction_size + NativeGeneralJump::instruction_size;
  return round_to(size, 16);
}

// relocation entries for call stub, compiled java to interpreter
uint reloc_java_to_interp() {
  return 16; // in emit_java_to_interp +  in Java_Static_Call
}

bool Matcher::is_short_branch_offset(int rule, int br_size, int offset) {
  // TODO: LA
  int offs = offset - br_size + 4;
  // To be conservative on MIPS
  // branch node should be end with:
  //   branch inst
  const int safety_zone = 3 * BytesPerInstWord;
  return Assembler::is_simm16((offs<0 ? offs-safety_zone : offs+safety_zone) >> 2);
}


// No additional cost for CMOVL.
const int Matcher::long_cmove_cost() { return 0; }

// No CMOVF/CMOVD with SSE2
const int Matcher::float_cmove_cost() { return ConditionalMoveLimit; }

// Does the CPU require late expand (see block.cpp for description of late expand)?
const bool Matcher::require_postalloc_expand = false;

// Should the Matcher clone shifts on addressing modes, expecting them
// to be subsumed into complex addressing expressions or compute them
// into registers?  True for Intel but false for most RISCs
const bool Matcher::clone_shift_expressions = false;

// Do we need to mask the count passed to shift instructions or does
// the cpu only look at the lower 5/6 bits anyway?
const bool Matcher::need_masked_shift_count = false;

bool Matcher::narrow_oop_use_complex_address() {
  NOT_LP64(ShouldNotCallThis());
  assert(UseCompressedOops, "only for compressed oops code");
  return false;
}

bool Matcher::narrow_klass_use_complex_address() {
  NOT_LP64(ShouldNotCallThis());
  assert(UseCompressedClassPointers, "only for compressed klass code");
  return false;
}

// This is UltraSparc specific, true just means we have fast l2f conversion
const bool Matcher::convL2FSupported(void) {
  return true;
}

// Max vector size in bytes. 0 if not supported.
const int Matcher::vector_width_in_bytes(BasicType bt) {
  if (MaxVectorSize == 0)
    return 0;
  assert(MaxVectorSize == 8, "");
  return 8;
}

// Vector ideal reg
const uint Matcher::vector_ideal_reg(int size) {
  assert(MaxVectorSize == 8, "");
  switch(size) {
    case  8: return Op_VecD;
  }
  ShouldNotReachHere();
  return 0;
}

// Only lowest bits of xmm reg are used for vector shift count.
const uint Matcher::vector_shift_count_ideal_reg(int size) {
  fatal("vector shift is not supported");
  return Node::NotAMachineReg;
}

// Limits on vector size (number of elements) loaded into vector.
const int Matcher::max_vector_size(const BasicType bt) {
  assert(is_java_primitive(bt), "only primitive type vectors");
  return vector_width_in_bytes(bt)/type2aelembytes(bt);
}

const int Matcher::min_vector_size(const BasicType bt) {
  return max_vector_size(bt); // Same as max.
}

// MIPS supports misaligned vectors store/load? FIXME
const bool Matcher::misaligned_vectors_ok() {
  return false;
  //return !AlignVector; // can be changed by flag
}

// Register for DIVI projection of divmodI
RegMask Matcher::divI_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for MODI projection of divmodI
RegMask Matcher::modI_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for DIVL projection of divmodL
RegMask Matcher::divL_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

int Matcher::regnum_to_fpu_offset(int regnum) {
  return regnum - 32; // The FP registers are in the second chunk
}


const bool Matcher::isSimpleConstant64(jlong value) {
  // Will one (StoreL ConL) be cheaper than two (StoreI ConI)?.
  return true;
}


// Return whether or not this register is ever used as an argument.  This
// function is used on startup to build the trampoline stubs in generateOptoStub.
// Registers not mentioned will be killed by the VM call in the trampoline, and
// arguments in those registers not be available to the callee.
bool Matcher::can_be_java_arg( int reg ) {
  // Refer to: [sharedRuntime_mips_64.cpp] SharedRuntime::java_calling_convention()
  if (    reg == T0_num || reg == T0_H_num
       || reg == A0_num || reg == A0_H_num
       || reg == A1_num || reg == A1_H_num
       || reg == A2_num || reg == A2_H_num
       || reg == A3_num || reg == A3_H_num
       || reg == A4_num || reg == A4_H_num
       || reg == A5_num || reg == A5_H_num
       || reg == A6_num || reg == A6_H_num
       || reg == A7_num || reg == A7_H_num )
    return true;

  if (    reg == F0_num || reg == F0_H_num
       || reg == F1_num || reg == F1_H_num
       || reg == F2_num || reg == F2_H_num
       || reg == F3_num || reg == F3_H_num
       || reg == F4_num || reg == F4_H_num
       || reg == F5_num || reg == F5_H_num
       || reg == F6_num || reg == F6_H_num
       || reg == F7_num || reg == F7_H_num )
    return true;

  return false;
}

bool Matcher::is_spillable_arg( int reg ) {
  return can_be_java_arg(reg);
}

bool Matcher::use_asm_for_ldiv_by_con( jlong divisor ) {
  return false;
}

// Register for MODL projection of divmodL
RegMask Matcher::modL_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

const RegMask Matcher::method_handle_invoke_SP_save_mask() {
  return FP_REG_mask();
}

// MIPS doesn't support AES intrinsics
const bool Matcher::pass_original_key_for_aes() {
  return false;
}

int CallStaticJavaDirectNode::compute_padding(int current_offset) const {
  return round_to(current_offset, alignment_required()) - current_offset;
}

int CallDynamicJavaDirectNode::compute_padding(int current_offset) const {
  return round_to(current_offset, alignment_required()) - current_offset;
}

int CallLeafNoFPDirectNode::compute_padding(int current_offset) const {
  return round_to(current_offset, alignment_required()) - current_offset;
}

int CallLeafDirectNode::compute_padding(int current_offset) const {
  return round_to(current_offset, alignment_required()) - current_offset;
}

int CallRuntimeDirectNode::compute_padding(int current_offset) const {
  return round_to(current_offset, alignment_required()) - current_offset;
}

// If CPU can load and store mis-aligned doubles directly then no fixup is
// needed.  Else we split the double into 2 integer pieces and move it
// piece-by-piece.  Only happens when passing doubles into C code as the
// Java calling convention forces doubles to be aligned.
const bool Matcher::misaligned_doubles_ok = false;
// Do floats take an entire double register or just half?
//const bool Matcher::float_in_double = true;
bool Matcher::float_in_double() { return false; }
// Threshold size for cleararray.
const int Matcher::init_array_short_size = 8 * BytesPerLong;
// Do ints take an entire long register or just half?
const bool Matcher::int_in_long = true;
// Is it better to copy float constants, or load them directly from memory?
// Intel can load a float constant from a direct address, requiring no
// extra registers.  Most RISCs will have to materialize an address into a
// register first, so they would do better to copy the constant from stack.
const bool Matcher::rematerialize_float_constants = false;
// Advertise here if the CPU requires explicit rounding operations
// to implement the UseStrictFP mode.
const bool Matcher::strict_fp_requires_explicit_rounding = false;
// false => size gets scaled to BytesPerLong, ok.
const bool Matcher::init_array_count_is_in_bytes = false;

// Indicate if the safepoint node needs the polling page as an input.
// Since MIPS doesn't have absolute addressing, it needs.
bool SafePointNode::needs_polling_address_input() {
  return false;
}

// !!!!! Special hack to get all type of calls to specify the byte offset
//       from the start of the call to the point where the return address
//       will point.
int MachCallStaticJavaNode::ret_addr_offset() {
  // pcaddu18i
  // jirl
  return NativeCall::instruction_size;
}

int MachCallDynamicJavaNode::ret_addr_offset() {
  // lu12i_w IC_Klass,
  // ori IC_Klass,
  // lu32i_d IC_Klass
  // lu52i_d IC_Klass

  // pcaddu18i
  // jirl
  return NativeMovConstReg::instruction_size + NativeCall::instruction_size;
}

//=============================================================================

// Figure out which register class each belongs in: rc_int, rc_float, rc_stack
enum RC { rc_bad, rc_int, rc_float, rc_stack };
static enum RC rc_class( OptoReg::Name reg ) {
  if( !OptoReg::is_valid(reg)  ) return rc_bad;
  if (OptoReg::is_stack(reg)) return rc_stack;
  VMReg r = OptoReg::as_VMReg(reg);
  if (r->is_Register()) return rc_int;
  assert(r->is_FloatRegister(), "must be");
  return rc_float;
}

uint MachSpillCopyNode::implementation( CodeBuffer *cbuf, PhaseRegAlloc *ra_, bool do_size, outputStream* st ) const {
  // Get registers to move
  OptoReg::Name src_second = ra_->get_reg_second(in(1));
  OptoReg::Name src_first = ra_->get_reg_first(in(1));
  OptoReg::Name dst_second = ra_->get_reg_second(this );
  OptoReg::Name dst_first = ra_->get_reg_first(this );

  enum RC src_second_rc = rc_class(src_second);
  enum RC src_first_rc = rc_class(src_first);
  enum RC dst_second_rc = rc_class(dst_second);
  enum RC dst_first_rc = rc_class(dst_first);

  assert(OptoReg::is_valid(src_first) && OptoReg::is_valid(dst_first), "must move at least 1 register" );

  // Generate spill code!

  if( src_first == dst_first && src_second == dst_second )
    return 0;            // Self copy, no move

  if (src_first_rc == rc_stack) {
    // mem ->
    if (dst_first_rc == rc_stack) {
      // mem -> mem
      assert(src_second != dst_first, "overlap");
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        int src_offset = ra_->reg2offset(src_first);
        int dst_offset = ra_->reg2offset(dst_first);
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ ld_d(AT, Address(SP, src_offset));
          __ st_d(AT, Address(SP, dst_offset));
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("ld_d    AT, [SP + #%d]\t# 64-bit mem-mem spill 1\n\t"
                    "st_d    AT, [SP + #%d]",
                    src_offset, dst_offset);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        // No pushl/popl, so:
        int src_offset = ra_->reg2offset(src_first);
        int dst_offset = ra_->reg2offset(dst_first);
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ ld_w(AT, Address(SP, src_offset));
          __ st_w(AT, Address(SP, dst_offset));
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("ld_w    AT, [SP + #%d] spill 2\n\t"
                    "st_w    AT, [SP + #%d]\n\t",
                    src_offset, dst_offset);
#endif
        }
      }
      return 0;
    } else if (dst_first_rc == rc_int) {
      // mem -> gpr
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        int offset = ra_->reg2offset(src_first);
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ ld_d(as_Register(Matcher::_regEncode[dst_first]), Address(SP, offset));
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("ld_d    %s, [SP + #%d]\t# spill 3",
                    Matcher::regName[dst_first],
                    offset);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        int offset = ra_->reg2offset(src_first);
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          if (this->ideal_reg() == Op_RegI)
            __ ld_w(as_Register(Matcher::_regEncode[dst_first]), Address(SP, offset));
          else {
            if (Assembler::is_simm12(offset)) {
              __ ld_wu(as_Register(Matcher::_regEncode[dst_first]), Address(SP, offset));
            } else {
              __ move(AT, offset);
              __ ldx_wu(as_Register(Matcher::_regEncode[dst_first]), SP, AT);
            }
          }
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          if (this->ideal_reg() == Op_RegI)
            st->print("ld_w    %s, [SP + #%d]\t# spill 4",
                      Matcher::regName[dst_first],
                      offset);
          else
            st->print("ld_wu    %s, [SP + #%d]\t# spill 5",
                      Matcher::regName[dst_first],
                      offset);
#endif
        }
      }
      return 0;
    } else if (dst_first_rc == rc_float) {
      // mem-> xmm
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        int offset = ra_->reg2offset(src_first);
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ fld_d( as_FloatRegister(Matcher::_regEncode[dst_first]), Address(SP, offset));
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("fld_d  %s, [SP + #%d]\t# spill 6",
                    Matcher::regName[dst_first],
                    offset);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        int offset = ra_->reg2offset(src_first);
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ fld_s( as_FloatRegister(Matcher::_regEncode[dst_first]), Address(SP, offset));
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("fld_s   %s, [SP + #%d]\t# spill 7",
                    Matcher::regName[dst_first],
                    offset);
#endif
        }
      }
    }
    return 0;
  } else if (src_first_rc == rc_int) {
    // gpr ->
    if (dst_first_rc == rc_stack) {
      // gpr -> mem
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        int offset = ra_->reg2offset(dst_first);
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ st_d(as_Register(Matcher::_regEncode[src_first]), Address(SP, offset));
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("st_d    %s, [SP + #%d] # spill 8",
                    Matcher::regName[src_first],
                    offset);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        int offset = ra_->reg2offset(dst_first);
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ st_w(as_Register(Matcher::_regEncode[src_first]), Address(SP, offset));
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("st_w    %s, [SP + #%d]\t# spill 9",
                    Matcher::regName[src_first], offset);
#endif
        }
      }
      return 0;
    } else if (dst_first_rc == rc_int) {
      // gpr -> gpr
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ move(as_Register(Matcher::_regEncode[dst_first]),
                  as_Register(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("move(64bit)    %s <-- %s\t# spill 10",
                    Matcher::regName[dst_first],
                    Matcher::regName[src_first]);
#endif
        }
        return 0;
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          if (this->ideal_reg() == Op_RegI)
              __ move_u32(as_Register(Matcher::_regEncode[dst_first]), as_Register(Matcher::_regEncode[src_first]));
          else
              __ add_d(as_Register(Matcher::_regEncode[dst_first]), as_Register(Matcher::_regEncode[src_first]), R0);
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("move(32-bit)    %s <-- %s\t# spill 11",
                    Matcher::regName[dst_first],
                    Matcher::regName[src_first]);
#endif
        }
        return 0;
      }
    } else if (dst_first_rc == rc_float) {
      // gpr -> xmm
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ movgr2fr_d(as_FloatRegister(Matcher::_regEncode[dst_first]), as_Register(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("movgr2fr_d   %s, %s\t# spill 12",
                    Matcher::regName[dst_first],
                    Matcher::regName[src_first]);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ movgr2fr_w(as_FloatRegister(Matcher::_regEncode[dst_first]), as_Register(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("movgr2fr_w   %s, %s\t# spill 13",
                    Matcher::regName[dst_first],
                    Matcher::regName[src_first]);
#endif
        }
      }
      return 0;
    }
  } else if (src_first_rc == rc_float) {
    // xmm ->
    if (dst_first_rc == rc_stack) {
      // xmm -> mem
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        int offset = ra_->reg2offset(dst_first);
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ fst_d( as_FloatRegister(Matcher::_regEncode[src_first]), Address(SP, offset) );
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("fst_d   %s, [SP + #%d]\t# spill 14",
                    Matcher::regName[src_first],
                    offset);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        int offset = ra_->reg2offset(dst_first);
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ fst_s(as_FloatRegister(Matcher::_regEncode[src_first]), Address(SP, offset));
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("fst_s   %s, [SP + #%d]\t# spill 15",
                    Matcher::regName[src_first],
                    offset);
#endif
        }
      }
      return 0;
    } else if (dst_first_rc == rc_int) {
      // xmm -> gpr
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ movfr2gr_d( as_Register(Matcher::_regEncode[dst_first]), as_FloatRegister(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("dmfc1   %s, %s\t# spill 16",
                    Matcher::regName[dst_first],
                    Matcher::regName[src_first]);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ movfr2gr_s( as_Register(Matcher::_regEncode[dst_first]), as_FloatRegister(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("movfr2gr_s   %s, %s\t# spill 17",
                    Matcher::regName[dst_first],
                    Matcher::regName[src_first]);
#endif
        }
      }
      return 0;
    } else if (dst_first_rc == rc_float) {
      // xmm -> xmm
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ fmov_d( as_FloatRegister(Matcher::_regEncode[dst_first]), as_FloatRegister(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("mov_d  %s <-- %s\t# spill 18",
                    Matcher::regName[dst_first],
                    Matcher::regName[src_first]);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ fmov_s( as_FloatRegister(Matcher::_regEncode[dst_first]), as_FloatRegister(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("\n\t");
          st->print("mov_s  %s <-- %s\t# spill 19",
                    Matcher::regName[dst_first],
                    Matcher::regName[src_first]);
#endif
        }
      }
      return 0;
    }
  }

  assert(0," foo ");
  Unimplemented();
  return 0;
}

#ifndef PRODUCT
void MachSpillCopyNode::format( PhaseRegAlloc *ra_, outputStream* st ) const {
  implementation( NULL, ra_, false, st );
}
#endif

void MachSpillCopyNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  implementation( &cbuf, ra_, false, NULL );
}

uint MachSpillCopyNode::size(PhaseRegAlloc *ra_) const {
  return MachNode::size(ra_);
}

//=============================================================================
#

#ifndef PRODUCT
void MachBreakpointNode::format( PhaseRegAlloc *, outputStream* st ) const {
  st->print("INT3");
}
#endif

void MachBreakpointNode::emit(CodeBuffer &cbuf, PhaseRegAlloc* ra_) const {
  MacroAssembler _masm(&cbuf);
  __ int3();
}

uint MachBreakpointNode::size(PhaseRegAlloc* ra_) const {
  return MachNode::size(ra_);
}


//=============================================================================
#ifndef PRODUCT
void MachEpilogNode::format( PhaseRegAlloc *ra_, outputStream* st ) const {
  Compile *C = ra_->C;
  int framesize = C->frame_size_in_bytes();

  assert((framesize & (StackAlignmentInBytes-1)) == 0, "frame size not aligned");

  st->print_cr("addi_d   SP, SP, %d # Rlease stack @ MachEpilogNode", framesize);
  st->print("\t");
  st->print_cr("ld_d    RA, SP, %d # Restore RA @ MachEpilogNode", -wordSize);
  st->print("\t");
  st->print_cr("ld_d    FP, SP, %d # Restore FP @ MachEpilogNode", -wordSize*2);
  if( do_polling() && C->is_method_compilation() ) {
    st->print("\t");
    st->print_cr("Poll Safepoint # MachEpilogNode");
  }
}
#endif

void MachEpilogNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  Compile *C = ra_->C;
  MacroAssembler _masm(&cbuf);
  int framesize = C->frame_size_in_bytes();

  assert((framesize & (StackAlignmentInBytes-1)) == 0, "frame size not aligned");

  __ ld_d(RA, Address(SP, framesize - wordSize));
  __ ld_d(FP, Address(SP, framesize - wordSize * 2));
  if (Assembler::is_simm12(framesize)) {
    __ addi_d(SP, SP, framesize);
  } else {
    __ move(AT, framesize);
    __ add_d(SP, SP, AT);
  }

  if( do_polling() && C->is_method_compilation() ) {
    __ set64(AT, (long)os::get_polling_page());
    __ relocate(relocInfo::poll_return_type);
    __ ld_w(AT, AT, 0);
  }
}

uint MachEpilogNode::size(PhaseRegAlloc *ra_) const {
  return MachNode::size(ra_); // too many variables; just compute it the hard way  fujie debug
}

int MachEpilogNode::reloc() const {
  return 0; // a large enough number
}

const Pipeline * MachEpilogNode::pipeline() const {
  return MachNode::pipeline_class();
}

int MachEpilogNode::safepoint_offset() const { return 0; }

//=============================================================================

#ifndef PRODUCT
void BoxLockNode::format( PhaseRegAlloc *ra_, outputStream* st ) const {
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  int reg = ra_->get_reg_first(this);
  st->print("ADDI_D %s, SP, %d   @BoxLockNode",Matcher::regName[reg],offset);
}
#endif


uint BoxLockNode::size(PhaseRegAlloc *ra_) const {
  return 4;
}

void BoxLockNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  MacroAssembler _masm(&cbuf);
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  int reg = ra_->get_encode(this);

  __ addi_d(as_Register(reg), SP, offset);
}


//static int sizeof_FFree_Float_Stack_All = -1;

int MachCallRuntimeNode::ret_addr_offset() {
  // pcaddu18i
  // jirl
  assert(NativeCall::instruction_size == 2 * BytesPerInstWord,
         "in MachCallRuntimeNode::ret_addr_offset()");
  return NativeCall::instruction_size;
}


//=============================================================================
#ifndef PRODUCT
void MachNopNode::format( PhaseRegAlloc *, outputStream* st ) const {
  st->print("NOP \t# %d bytes pad for loops and calls", 4 * _count);
}
#endif

void MachNopNode::emit(CodeBuffer &cbuf, PhaseRegAlloc * ) const {
  MacroAssembler _masm(&cbuf);
  int i = 0;
  for(i = 0; i < _count; i++)
     __ nop();
}

uint MachNopNode::size(PhaseRegAlloc *) const {
  return 4 * _count;
}
const Pipeline* MachNopNode::pipeline() const {
  return MachNode::pipeline_class();
}

//=============================================================================

//=============================================================================
#ifndef PRODUCT
void MachUEPNode::format( PhaseRegAlloc *ra_, outputStream* st ) const {
  st->print_cr("load_klass(T4, T0)");
  st->print_cr("\tbeq(T4, iCache, L)");
  st->print_cr("\tjmp(SharedRuntime::get_ic_miss_stub(), relocInfo::runtime_call_type)");
  st->print_cr("    L:");
}
#endif


void MachUEPNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  MacroAssembler _masm(&cbuf);
  int  ic_reg = Matcher::inline_cache_reg_encode();
  Label L;
  Register receiver = T0;
  Register   iCache = as_Register(ic_reg);

  __ load_klass(T4, receiver);
  __ beq(T4, iCache, L);
  __ jmp((address)SharedRuntime::get_ic_miss_stub(), relocInfo::runtime_call_type);
  __ bind(L);
}

uint MachUEPNode::size(PhaseRegAlloc *ra_) const {
  return MachNode::size(ra_);
}



//=============================================================================

const RegMask& MachConstantBaseNode::_out_RegMask = P_REG_mask();

int Compile::ConstantTable::calculate_table_base_offset() const {
  return 0;  // absolute addressing, no offset
}

bool MachConstantBaseNode::requires_postalloc_expand() const { return false; }
void MachConstantBaseNode::postalloc_expand(GrowableArray <Node *> *nodes, PhaseRegAlloc *ra_) {
  ShouldNotReachHere();
}

void MachConstantBaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  Compile* C = ra_->C;
  Compile::ConstantTable& constant_table = C->constant_table();
  MacroAssembler _masm(&cbuf);

  Register Rtoc = as_Register(ra_->get_encode(this));
  CodeSection* consts_section = cbuf.consts();
  int consts_size = consts_section->align_at_start(consts_section->size());
  assert(constant_table.size() == consts_size, "must be equal");

  if (consts_section->size()) {
    assert((CodeBuffer::SECT_CONSTS + 1) == CodeBuffer::SECT_INSTS,
           "insts must be immediately follow consts");
    // Materialize the constant table base.
    address baseaddr = cbuf.insts()->start() - consts_size + -(constant_table.table_base_offset());
    jint offs = (baseaddr - __ pc()) >> 2;
    guarantee(Assembler::is_simm(offs, 20), "Not signed 20-bit offset");
    __ pcaddi(Rtoc, offs);
  }
}

uint MachConstantBaseNode::size(PhaseRegAlloc* ra_) const {
  // pcaddi
  return 1 * BytesPerInstWord;
}

#ifndef PRODUCT
void MachConstantBaseNode::format(PhaseRegAlloc* ra_, outputStream* st) const {
  Register r = as_Register(ra_->get_encode(this));
  st->print("pcaddi    %s, &constanttable (constant table base) @ MachConstantBaseNode", r->name());
}
#endif


//=============================================================================
#ifndef PRODUCT
void MachPrologNode::format( PhaseRegAlloc *ra_, outputStream* st ) const {
  Compile* C = ra_->C;

  int framesize = C->frame_size_in_bytes();
  int bangsize = C->bang_size_in_bytes();
  assert((framesize & (StackAlignmentInBytes-1)) == 0, "frame size not aligned");

  // Calls to C2R adapters often do not accept exceptional returns.
  // We require that their callers must bang for them.  But be careful, because
  // some VM calls (such as call site linkage) can use several kilobytes of
  // stack.  But the stack safety zone should account for that.
  // See bugs 4446381, 4468289, 4497237.
  if (C->need_stack_bang(bangsize)) {
    st->print_cr("# stack bang"); st->print("\t");
  }
  st->print("st_d       RA, %d(SP)  @ MachPrologNode\n\t", -wordSize);
  st->print("st_d       FP, %d(SP)  @ MachPrologNode\n\t", -wordSize*2);
  st->print("addi_d   FP, SP, -%d \n\t", wordSize*2);
  st->print("addi_d   SP, SP, -%d \t",framesize);
}
#endif


void MachPrologNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  Compile* C = ra_->C;
  MacroAssembler _masm(&cbuf);

  int framesize = C->frame_size_in_bytes();
  int bangsize = C->bang_size_in_bytes();

  assert((framesize & (StackAlignmentInBytes-1)) == 0, "frame size not aligned");

#ifdef ASSERT
  address start = __ pc();
#endif

  if (C->need_stack_bang(bangsize)) {
    __ generate_stack_overflow_check(bangsize);
  }

  if (Assembler::is_simm12(-framesize)) {
    __ addi_d(SP, SP, -framesize);
  } else {
    __ move(AT, -framesize);
    __ add_d(SP, SP, AT);
  }
  __ st_d(RA, Address(SP, framesize - wordSize));
  __ st_d(FP, Address(SP, framesize - wordSize * 2));
  if (Assembler::is_simm12(framesize - wordSize * 2)) {
    __ addi_d(FP, SP, framesize - wordSize * 2);
  } else {
    __ move(AT, framesize - wordSize * 2);
    __ add_d(FP, SP, AT);
  }

  assert((__ pc() - start) >= 1 * BytesPerInstWord, "No enough room for patch_verified_entry");

  C->set_frame_complete(cbuf.insts_size());
  if (C->has_mach_constant_base_node()) {
    // NOTE: We set the table base offset here because users might be
    // emitted before MachConstantBaseNode.
    Compile::ConstantTable& constant_table = C->constant_table();
    constant_table.set_table_base_offset(constant_table.calculate_table_base_offset());
  }
}


uint MachPrologNode::size(PhaseRegAlloc *ra_) const {
  return MachNode::size(ra_); // too many variables; just compute it the hard way
}

int MachPrologNode::reloc() const {
  return 0; // a large enough number
}


#line 1120 "../generated/adfiles/ad_loongarch_64.cpp"


#ifndef PRODUCT
void Compile::adlc_verification() {

  // Following assertions generated from definition section
  assert( DEFAULT_COST == 100, "Expect (100) to equal 100");
  assert( HUGE_COST == 1000000, "Expect (1000000) to equal 1000000");
  assert( MEMORY_REF_COST == 200, "Expect (DEFAULT_COST * 2) to equal 200");
  assert( BRANCH_COST == 300, "Expect (DEFAULT_COST * 3) to equal 300");
  assert( CALL_COST == 500, "Expect (DEFAULT_COST * 5) to equal 500");
}
#endif

// Map from machine-independent register number to register_save_policy
const        char register_save_policy[] = {
  'C', // S7
  'C', // S7_H
  'C', // S0
  'C', // S0_H
  'C', // S1
  'C', // S1_H
  'C', // S2
  'C', // S2_H
  'C', // S4
  'C', // S4_H
  'C', // S5
  'C', // S5_H
  'C', // S6
  'C', // S6_H
  'C', // S3
  'C', // S3_H
  'C', // T2
  'C', // T2_H
  'C', // T3
  'C', // T3_H
  'C', // T8
  'C', // T8_H
  'C', // T4
  'C', // T4_H
  'C', // T1
  'C', // T1_H
  'C', // T6
  'C', // T6_H
  'C', // A7
  'C', // A7_H
  'C', // A6
  'C', // A6_H
  'C', // A5
  'C', // A5_H
  'C', // A4
  'C', // A4_H
  'C', // T5
  'C', // T5_H
  'C', // A3
  'C', // A3_H
  'C', // A2
  'C', // A2_H
  'C', // A1
  'C', // A1_H
  'C', // A0
  'C', // A0_H
  'C', // T0
  'C', // T0_H
  'N', // S8
  'N', // S8_H
  'N', // RA
  'N', // RA_H
  'N', // SP
  'N', // SP_H
  'N', // FP
  'N', // FP_H
  'C', // F0
  'C', // F0_H
  'C', // F1
  'C', // F1_H
  'C', // F2
  'C', // F2_H
  'C', // F3
  'C', // F3_H
  'C', // F4
  'C', // F4_H
  'C', // F5
  'C', // F5_H
  'C', // F6
  'C', // F6_H
  'C', // F7
  'C', // F7_H
  'C', // F8
  'C', // F8_H
  'C', // F9
  'C', // F9_H
  'C', // F10
  'C', // F10_H
  'C', // F11
  'C', // F11_H
  'C', // F20
  'C', // F20_H
  'C', // F21
  'C', // F21_H
  'C', // F22
  'C', // F22_H
  'C', // F23
  'C', // F23_H
  'C', // F24
  'C', // F24_H
  'C', // F25
  'C', // F25_H
  'C', // F26
  'C', // F26_H
  'C', // F27
  'C', // F27_H
  'C', // F28
  'C', // F28_H
  'C', // F19
  'C', // F19_H
  'C', // F18
  'C', // F18_H
  'C', // F17
  'C', // F17_H
  'C', // F16
  'C', // F16_H
  'C', // F15
  'C', // F15_H
  'C', // F14
  'C', // F14_H
  'C', // F13
  'C', // F13_H
  'C', // F12
  'C', // F12_H
  'C', // F29
  'C', // F29_H
  'C', // F30
  'C', // F30_H
  'C', // F31
  'C', // F31_H
  'C' // no trailing comma // LOONGARCH_FLAG
};

// Map from machine-independent register number to c_reg_save_policy
const        char c_reg_save_policy[] = {
  'E', // S7
  'E', // S7_H
  'E', // S0
  'E', // S0_H
  'E', // S1
  'E', // S1_H
  'E', // S2
  'E', // S2_H
  'E', // S4
  'E', // S4_H
  'E', // S5
  'E', // S5_H
  'E', // S6
  'E', // S6_H
  'E', // S3
  'E', // S3_H
  'C', // T2
  'C', // T2_H
  'C', // T3
  'C', // T3_H
  'C', // T8
  'C', // T8_H
  'C', // T4
  'C', // T4_H
  'C', // T1
  'C', // T1_H
  'C', // T6
  'C', // T6_H
  'C', // A7
  'C', // A7_H
  'C', // A6
  'C', // A6_H
  'C', // A5
  'C', // A5_H
  'C', // A4
  'C', // A4_H
  'C', // T5
  'C', // T5_H
  'C', // A3
  'C', // A3_H
  'C', // A2
  'C', // A2_H
  'C', // A1
  'C', // A1_H
  'C', // A0
  'C', // A0_H
  'C', // T0
  'C', // T0_H
  'N', // S8
  'N', // S8_H
  'N', // RA
  'N', // RA_H
  'N', // SP
  'N', // SP_H
  'N', // FP
  'N', // FP_H
  'C', // F0
  'C', // F0_H
  'C', // F1
  'C', // F1_H
  'C', // F2
  'C', // F2_H
  'C', // F3
  'C', // F3_H
  'C', // F4
  'C', // F4_H
  'C', // F5
  'C', // F5_H
  'C', // F6
  'C', // F6_H
  'C', // F7
  'C', // F7_H
  'C', // F8
  'C', // F8_H
  'C', // F9
  'C', // F9_H
  'C', // F10
  'C', // F10_H
  'C', // F11
  'C', // F11_H
  'C', // F20
  'C', // F20_H
  'C', // F21
  'C', // F21_H
  'C', // F22
  'C', // F22_H
  'C', // F23
  'C', // F23_H
  'C', // F24
  'C', // F24_H
  'C', // F25
  'C', // F25_H
  'C', // F26
  'C', // F26_H
  'C', // F27
  'C', // F27_H
  'C', // F28
  'C', // F28_H
  'C', // F19
  'C', // F19_H
  'C', // F18
  'C', // F18_H
  'C', // F17
  'C', // F17_H
  'C', // F16
  'C', // F16_H
  'C', // F15
  'C', // F15_H
  'C', // F14
  'C', // F14_H
  'C', // F13
  'C', // F13_H
  'C', // F12
  'C', // F12_H
  'C', // F29
  'C', // F29_H
  'C', // F30
  'C', // F30_H
  'C', // F31
  'C', // F31_H
  'C' // no trailing comma // LOONGARCH_FLAG
};

// Map from machine-independent register number to register_save_type
const        int register_save_type[] = {
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegFlags // no trailing comma
};


const        int   reduceOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  vecD_rule,
  /*    9 */  FlagsReg_rule,
  /*   10 */  immI_rule,
  /*   11 */  immI8_rule,
  /*   12 */  immI_M65536_rule,
  /*   13 */  immI_M1_rule,
  /*   14 */  immI_0_rule,
  /*   15 */  immI_1_rule,
  /*   16 */  immI_16_rule,
  /*   17 */  immI_24_rule,
  /*   18 */  immI_32_rule,
  /*   19 */  immI_255_rule,
  /*   20 */  immI_65535_rule,
  /*   21 */  immI_MaxI_rule,
  /*   22 */  immI_M2047_2048_rule,
  /*   23 */  immI_0_3_rule,
  /*   24 */  immI_0_31_rule,
  /*   25 */  immI_0_4095_rule,
  /*   26 */  immI_0_32767_rule,
  /*   27 */  immI_1_4_rule,
  /*   28 */  immI_32_63_rule,
  /*   29 */  immI_nonneg_mask_rule,
  /*   30 */  immL_rule,
  /*   31 */  immL8_rule,
  /*   32 */  immL12_rule,
  /*   33 */  immL32_rule,
  /*   34 */  immL_M121_rule,
  /*   35 */  immL_M8_rule,
  /*   36 */  immL_M7_rule,
  /*   37 */  immL_M5_rule,
  /*   38 */  immL_M4_rule,
  /*   39 */  immL_0_rule,
  /*   40 */  immL_7_rule,
  /*   41 */  immL_MaxUI_rule,
  /*   42 */  immL_M2047_2048_rule,
  /*   43 */  immL_0_4095_rule,
  /*   44 */  immL_nonneg_mask_rule,
  /*   45 */  immP_rule,
  /*   46 */  immP_0_rule,
  /*   47 */  immP_no_oop_cheap_rule,
  /*   48 */  immP_poll_rule,
  /*   49 */  immN_rule,
  /*   50 */  immN_0_rule,
  /*   51 */  immNKlass_rule,
  /*   52 */  immF_rule,
  /*   53 */  immF_0_rule,
  /*   54 */  immD_rule,
  /*   55 */  immD_0_rule,
  /*   56 */  mRegI_rule,
  /*   57 */  no_Ax_mRegI_rule,
  /*   58 */  mS0RegI_rule,
  /*   59 */  mS1RegI_rule,
  /*   60 */  mS2RegI_rule,
  /*   61 */  mS3RegI_rule,
  /*   62 */  mS4RegI_rule,
  /*   63 */  mS5RegI_rule,
  /*   64 */  mS6RegI_rule,
  /*   65 */  mS7RegI_rule,
  /*   66 */  mT0RegI_rule,
  /*   67 */  mT1RegI_rule,
  /*   68 */  mT2RegI_rule,
  /*   69 */  mT3RegI_rule,
  /*   70 */  mT8RegI_rule,
  /*   71 */  mT4RegI_rule,
  /*   72 */  mA0RegI_rule,
  /*   73 */  mA1RegI_rule,
  /*   74 */  mA2RegI_rule,
  /*   75 */  mA3RegI_rule,
  /*   76 */  mA4RegI_rule,
  /*   77 */  mA5RegI_rule,
  /*   78 */  mA6RegI_rule,
  /*   79 */  mA7RegI_rule,
  /*   80 */  mRegN_rule,
  /*   81 */  t0_RegN_rule,
  /*   82 */  t1_RegN_rule,
  /*   83 */  t2_RegN_rule,
  /*   84 */  t3_RegN_rule,
  /*   85 */  t8_RegN_rule,
  /*   86 */  a0_RegN_rule,
  /*   87 */  a1_RegN_rule,
  /*   88 */  a2_RegN_rule,
  /*   89 */  a3_RegN_rule,
  /*   90 */  a4_RegN_rule,
  /*   91 */  a5_RegN_rule,
  /*   92 */  a6_RegN_rule,
  /*   93 */  a7_RegN_rule,
  /*   94 */  s0_RegN_rule,
  /*   95 */  s1_RegN_rule,
  /*   96 */  s2_RegN_rule,
  /*   97 */  s3_RegN_rule,
  /*   98 */  s4_RegN_rule,
  /*   99 */  s5_RegN_rule,
  /*  100 */  s6_RegN_rule,
  /*  101 */  s7_RegN_rule,
  /*  102 */  mRegP_rule,
  /*  103 */  no_T8_mRegP_rule,
  /*  104 */  no_Ax_mRegP_rule,
  /*  105 */  s0_RegP_rule,
  /*  106 */  s1_RegP_rule,
  /*  107 */  s2_RegP_rule,
  /*  108 */  s3_RegP_rule,
  /*  109 */  s4_RegP_rule,
  /*  110 */  s5_RegP_rule,
  /*  111 */  s6_RegP_rule,
  /*  112 */  s7_RegP_rule,
  /*  113 */  t0_RegP_rule,
  /*  114 */  t1_RegP_rule,
  /*  115 */  t2_RegP_rule,
  /*  116 */  t3_RegP_rule,
  /*  117 */  t8_RegP_rule,
  /*  118 */  a0_RegP_rule,
  /*  119 */  a1_RegP_rule,
  /*  120 */  a2_RegP_rule,
  /*  121 */  a3_RegP_rule,
  /*  122 */  a4_RegP_rule,
  /*  123 */  a5_RegP_rule,
  /*  124 */  a6_RegP_rule,
  /*  125 */  a7_RegP_rule,
  /*  126 */  v0_RegP_rule,
  /*  127 */  v1_RegP_rule,
  /*  128 */  mRegL_rule,
  /*  129 */  v0RegL_rule,
  /*  130 */  v1RegL_rule,
  /*  131 */  a0RegL_rule,
  /*  132 */  a1RegL_rule,
  /*  133 */  a2RegL_rule,
  /*  134 */  a3RegL_rule,
  /*  135 */  t0RegL_rule,
  /*  136 */  t1RegL_rule,
  /*  137 */  t2RegL_rule,
  /*  138 */  t3RegL_rule,
  /*  139 */  t8RegL_rule,
  /*  140 */  a4RegL_rule,
  /*  141 */  a5RegL_rule,
  /*  142 */  a6RegL_rule,
  /*  143 */  a7RegL_rule,
  /*  144 */  s0RegL_rule,
  /*  145 */  s1RegL_rule,
  /*  146 */  s2RegL_rule,
  /*  147 */  s3RegL_rule,
  /*  148 */  s4RegL_rule,
  /*  149 */  s7RegL_rule,
  /*  150 */  regF_rule,
  /*  151 */  regD_rule,
  /*  152 */  indirect_rule,
  /*  153 */  indOffset8_rule,
  /*  154 */  indIndexScale_rule,
  /*  155 */  baseIndexOffset8_rule,
  /*  156 */  baseIndexOffset8_convI2L_rule,
  /*  157 */  indIndexScaleOffset8_rule,
  /*  158 */  indIndexScaleOffset8_convI2L_rule,
  /*  159 */  basePosIndexScaleOffset8_rule,
  /*  160 */  indIndexScaleOffsetNarrow_rule,
  /*  161 */  indPosIndexI2LScaleOffset8Narrow_rule,
  /*  162 */  indOffset32_rule,
  /*  163 */  indIndex_rule,
  /*  164 */  indirectNarrowKlass_rule,
  /*  165 */  indOffset8NarrowKlass_rule,
  /*  166 */  indOffset32NarrowKlass_rule,
  /*  167 */  indIndexOffsetNarrowKlass_rule,
  /*  168 */  indIndexNarrowKlass_rule,
  /*  169 */  indirectNarrow_rule,
  /*  170 */  indOffset8Narrow_rule,
  /*  171 */  indIndexOffset8Narrow_rule,
  /*  172 */  load_long_RegP_rule,
  /*  173 */  load_long_indirect_rule,
  /*  174 */  load_long_indOffset32_rule,
  /*  175 */  cmpOp_rule,
  /*  176 */  cmpOpU_rule,
  /*  177 */  stackSlotP_rule,
  /*  178 */  stackSlotI_rule,
  /*  179 */  stackSlotF_rule,
  /*  180 */  stackSlotD_rule,
  /*  181 */  stackSlotL_rule,
  // last operand
  /*  182 */  memory_rule,
  // last operand class
  /*  183 */  _LShiftL_mRegL_immI_0_3_rule,
  /*  184 */  _AddP_mRegP_mRegL_rule,
  /*  185 */  _ConvI2L_mRegI__rule,
  /*  186 */  _AddP_mRegP__ConvI2L_mRegI__rule,
  /*  187 */  _AddP_mRegP__LShiftL_mRegL_immI_0_3_rule,
  /*  188 */  _LShiftL__ConvI2L_mRegI__immI_0_3_rule,
  /*  189 */  _AddP_mRegP__LShiftL__ConvI2L_mRegI__immI_0_3_rule,
  /*  190 */  _LShiftL__ConvI2L_mRegI__immI_0_31_rule,
  /*  191 */  _AddP_mRegP__LShiftL__ConvI2L_mRegI__immI_0_31_rule,
  /*  192 */  _DecodeN_mRegN__rule,
  /*  193 */  _AddP__DecodeN_mRegN___LShiftL_mRegL_immI_0_3_rule,
  /*  194 */  _AddP__DecodeN_mRegN___LShiftL__ConvI2L_mRegI__immI_0_31_rule,
  /*  195 */  _DecodeNKlass_mRegN__rule,
  /*  196 */  _AddP__DecodeNKlass_mRegN__mRegL_rule,
  /*  197 */  _AddP__DecodeN_mRegN__mRegL_rule,
  /*  198 */  _LoadI_memory__rule,
  /*  199 */  _LShiftI__LoadI_memory__immI_24_rule,
  /*  200 */  _LShiftI__LoadI_memory__immI_16_rule,
  /*  201 */  _LoadN_memory__rule,
  /*  202 */  _LoadNKlass_memory__rule,
  /*  203 */  _EncodeP_mRegP__rule,
  /*  204 */  _EncodePKlass_mRegP__rule,
  /*  205 */  _ConvL2I_mRegL__rule,
  /*  206 */  _LoadB_memory__rule,
  /*  207 */  _LoadUB_memory__rule,
  /*  208 */  _LoadS_memory__rule,
  /*  209 */  _LShiftI__LoadS_memory__immI_24_rule,
  /*  210 */  _CmpI_mRegI_mRegI_rule,
  /*  211 */  _CmpI_mRegI_immI_rule,
  /*  212 */  _CmpP_mRegP_immP_0_rule,
  /*  213 */  _CmpP__DecodeN_mRegN__immP_0_rule,
  /*  214 */  _CmpP_mRegP_mRegP_rule,
  /*  215 */  _CmpN_mRegN_immN_0_rule,
  /*  216 */  _CmpN_mRegN_mRegN_rule,
  /*  217 */  _CmpU_mRegI_mRegI_rule,
  /*  218 */  _CmpU_mRegI_immI_rule,
  /*  219 */  _CmpI_mRegI_immI_0_rule,
  /*  220 */  _CmpU_mRegI_immI_0_rule,
  /*  221 */  _CmpL_mRegL_mRegL_rule,
  /*  222 */  _CmpL_mRegL_immL_0_rule,
  /*  223 */  _CmpL_mRegL_immL_rule,
  /*  224 */  _CmpF_regF_regF_rule,
  /*  225 */  _CmpD_regD_regD_rule,
  /*  226 */  _Binary_cmpOp__CmpI_mRegI_mRegI_rule,
  /*  227 */  _Binary_mRegI_mRegI_rule,
  /*  228 */  _Binary_cmpOpU__CmpP_mRegP_mRegP_rule,
  /*  229 */  _Binary_cmpOpU__CmpN_mRegN_mRegN_rule,
  /*  230 */  _Binary_cmpOpU__CmpU_mRegI_mRegI_rule,
  /*  231 */  _Binary_mRegP_mRegP_rule,
  /*  232 */  _Binary_cmpOp__CmpF_regF_regF_rule,
  /*  233 */  _Binary_mRegN_mRegN_rule,
  /*  234 */  _Binary_cmpOp__CmpD_regD_regD_rule,
  /*  235 */  _Binary_cmpOp__CmpL_mRegL_mRegL_rule,
  /*  236 */  _Binary_mRegL_mRegL_rule,
  /*  237 */  _Binary_regD_regD_rule,
  /*  238 */  _Binary_regF_regF_rule,
  /*  239 */  _Binary_cmpOp__CmpP_mRegP_mRegP_rule,
  /*  240 */  _Binary_a4_RegP_mA5RegI_rule,
  /*  241 */  _Binary_a6_RegP_mA7RegI_rule,
  /*  242 */  _Binary_a4_RegP_a5_RegP_rule,
  /*  243 */  _LShiftI_mRegI_immI_1_4_rule,
  /*  244 */  _LShiftL__ConvI2L_mRegI__immI_1_4_rule,
  /*  245 */  _MulI_mRegI_mRegI_rule,
  /*  246 */  _MulF_regF_regF_rule,
  /*  247 */  _MulD_regD_regD_rule,
  /*  248 */  _ConvF2D_regF__rule,
  /*  249 */  _SqrtD__ConvF2D_regF___rule,
  /*  250 */  _XorI_mRegI_immI_M1_rule,
  /*  251 */  _AndL_mRegL_immL_0_4095_rule,
  /*  252 */  _CastP2X_mRegP__rule,
  /*  253 */  _LShiftI_mRegI_immI_16_rule,
  /*  254 */  _AndL_mRegL_immL_7_rule,
  /*  255 */  _ConvL2I__AndL_mRegL_immL_7__rule,
  /*  256 */  _LShiftI__ConvL2I__AndL_mRegL_immL_7__immI_16_rule,
  /*  257 */  _OrI_mRegI_immI_0_32767_rule,
  /*  258 */  _LShiftI__OrI_mRegI_immI_0_32767_immI_16_rule,
  /*  259 */  _LShiftI_mRegI_immI_24_rule,
  /*  260 */  _RShiftL_mRegL_immI_32_63_rule,
  /*  261 */  _URShiftL_mRegL_immI_0_31_rule,
  /*  262 */  _ConvL2I__URShiftL_mRegL_immI_0_31__rule,
  /*  263 */  _URShiftL_mRegL_immI_32_63_rule,
  /*  264 */  _URShiftI_mRegI_immI_0_31_rule,
  /*  265 */  _AndI_mRegI_immI_1_rule,
  /*  266 */  _LShiftI__AndI_mRegI_immI_1_immI_0_31_rule,
  /*  267 */  _LShiftI_mRegI_immI_0_31_rule,
  /*  268 */  _LShiftL_mRegL_immI_32_63_rule,
  /*  269 */  _LShiftL_mRegL_immI_0_31_rule,
  /*  270 */  _LoadUS_memory__rule,
  /*  271 */  _Binary_t2RegL_mRegL_rule,
  /*  272 */  _Binary_mS2RegI_mRegI_rule,
  /*  273 */  _Binary_s2RegL_mRegL_rule,
  /*  274 */  _Binary_s2_RegP_mRegP_rule,
  /*  275 */  _Binary_t2_RegN_mRegN_rule,
  /*  276 */  _AndL__ConvI2L_mRegI__immL_MaxUI_rule,
  /*  277 */  _LShiftL__ConvI2L_mRegI__immI_32_rule,
  /*  278 */  _ConvI2L__ConvL2I_mRegL___rule,
  /*  279 */  _ConvI2L__LoadI_memory___rule,
  // last internally defined operand
  /*  280 */  stackSlotI_rule,
  /*  281 */  stackSlotL_rule,
  /*  282 */  stackSlotP_rule,
  /*  283 */  stackSlotF_rule,
  /*  284 */  stackSlotD_rule,
  /*  285 */  mRegI_rule,
  /*  286 */  mRegL_rule,
  /*  287 */  mRegL_rule,
  /*  288 */  mRegL_rule,
  /*  289 */  mRegP_rule,
  /*  290 */  mRegP_rule,
  /*  291 */  mRegP_rule,
  /*  292 */  mRegP_rule,
  /*  293 */  mRegN_rule,
  /*  294 */  mRegN_rule,
  /*  295 */  mRegN_rule,
  /*  296 */  regF_rule,
  /*  297 */  regF_rule,
  /*  298 */  regD_rule,
  /*  299 */  regD_rule,
  /*  300 */  mRegI_rule,
  /*  301 */  mRegL_rule,
  /*  302 */  mRegP_rule,
  /*  303 */  regF_rule,
  /*  304 */  regD_rule,
  /*  305 */  mRegP_rule,
  /*  306 */  mRegP_rule,
  /*  307 */  mRegP_rule,
  /*  308 */  mRegP_rule,
  /*  309 */  mRegL_rule,
  /*  310 */  mRegI_rule,
  /*  311 */  regF_rule,
  /*  312 */  mRegL_rule,
  /*  313 */  regD_rule,
  /*  314 */  regF_rule,
  /*  315 */  regD_rule,
  /*  316 */  regF_rule,
  /*  317 */  regD_rule,
  /*  318 */  mRegI_rule,
  /*  319 */  mRegI_rule,
  /*  320 */  mRegP_rule,
  /*  321 */  mRegP_rule,
  /*  322 */  mRegI_rule,
  /*  323 */  FlagsReg_rule,
  /*  324 */  FlagsReg_rule,
  /*  325 */  FlagsReg_rule,
  /*  326 */  FlagsReg_rule,
  /*  327 */  FlagsReg_rule,
  /*  328 */  regF_rule,
  /*  329 */  regD_rule,
  /*  330 */  mRegI_rule,
  /*  331 */  mRegI_rule,
  /*  332 */  mRegI_rule,
  /*  333 */  mRegI_rule,
  /*  334 */  mRegI_rule,
  /*  335 */  mRegL_rule,
  /*  336 */  mRegI_rule,
  /*  337 */  mRegI_rule,
  /*  338 */  mRegI_rule,
  /*  339 */  mRegI_rule,
  /*  340 */  mRegL_rule,
  /*  341 */  mRegL_rule,
  /*  342 */  Universe_rule,
  /*  343 */  Universe_rule,
  /*  344 */  Universe_rule,
  /*  345 */  mRegN_rule,
  /*  346 */  mRegP_rule,
  /*  347 */  mRegP_rule,
  /*  348 */  mRegP_rule,
  /*  349 */  mRegN_rule,
  /*  350 */  mRegP_rule,
  /*  351 */  mRegI_rule,
  /*  352 */  Universe_rule,
  /*  353 */  Universe_rule,
  /*  354 */  Universe_rule,
  /*  355 */  Universe_rule,
  /*  356 */  Universe_rule,
  /*  357 */  Universe_rule,
  /*  358 */  Universe_rule,
  /*  359 */  Universe_rule,
  /*  360 */  Universe_rule,
  /*  361 */  Universe_rule,
  /*  362 */  mRegI_rule,
  /*  363 */  mRegL_rule,
  /*  364 */  mRegI_rule,
  /*  365 */  mRegL_rule,
  /*  366 */  mRegI_rule,
  /*  367 */  mRegI_rule,
  /*  368 */  mRegL_rule,
  /*  369 */  Universe_rule,
  /*  370 */  Universe_rule,
  /*  371 */  Universe_rule,
  /*  372 */  regF_rule,
  /*  373 */  Universe_rule,
  /*  374 */  a0_RegP_rule,
  /*  375 */  Universe_rule,
  /*  376 */  Universe_rule,
  /*  377 */  Universe_rule,
  /*  378 */  Universe_rule,
  /*  379 */  Universe_rule,
  /*  380 */  Universe_rule,
  /*  381 */  Universe_rule,
  /*  382 */  Universe_rule,
  /*  383 */  Universe_rule,
  /*  384 */  Universe_rule,
  /*  385 */  Universe_rule,
  /*  386 */  Universe_rule,
  /*  387 */  Universe_rule,
  /*  388 */  Universe_rule,
  /*  389 */  Universe_rule,
  /*  390 */  Universe_rule,
  /*  391 */  Universe_rule,
  /*  392 */  Universe_rule,
  /*  393 */  Universe_rule,
  /*  394 */  Universe_rule,
  /*  395 */  Universe_rule,
  /*  396 */  Universe_rule,
  /*  397 */  Universe_rule,
  /*  398 */  Universe_rule,
  /*  399 */  Universe_rule,
  /*  400 */  Universe_rule,
  /*  401 */  Universe_rule,
  /*  402 */  Universe_rule,
  /*  403 */  Universe_rule,
  /*  404 */  Universe_rule,
  /*  405 */  Universe_rule,
  /*  406 */  Universe_rule,
  /*  407 */  Universe_rule,
  /*  408 */  Universe_rule,
  /*  409 */  Universe_rule,
  /*  410 */  Universe_rule,
  /*  411 */  Universe_rule,
  /*  412 */  Universe_rule,
  /*  413 */  Universe_rule,
  /*  414 */  Universe_rule,
  /*  415 */  Universe_rule,
  /*  416 */  Universe_rule,
  /*  417 */  Universe_rule,
  /*  418 */  Universe_rule,
  /*  419 */  Universe_rule,
  /*  420 */  Universe_rule,
  /*  421 */  Universe_rule,
  /*  422 */  Universe_rule,
  /*  423 */  Universe_rule,
  /*  424 */  Universe_rule,
  /*  425 */  Universe_rule,
  /*  426 */  mRegI_rule,
  /*  427 */  mRegI_rule,
  /*  428 */  mRegI_rule,
  /*  429 */  mRegP_rule,
  /*  430 */  mRegP_rule,
  /*  431 */  mRegP_rule,
  /*  432 */  mRegN_rule,
  /*  433 */  mRegP_rule,
  /*  434 */  mRegN_rule,
  /*  435 */  mRegI_rule,
  /*  436 */  mRegI_rule,
  /*  437 */  mRegP_rule,
  /*  438 */  mRegI_rule,
  /*  439 */  mRegP_rule,
  /*  440 */  mRegP_rule,
  /*  441 */  mRegL_rule,
  /*  442 */  mRegN_rule,
  /*  443 */  mRegN_rule,
  /*  444 */  mRegN_rule,
  /*  445 */  mRegL_rule,
  /*  446 */  mRegL_rule,
  /*  447 */  mRegL_rule,
  /*  448 */  mRegL_rule,
  /*  449 */  mRegL_rule,
  /*  450 */  mRegL_rule,
  /*  451 */  regD_rule,
  /*  452 */  regF_rule,
  /*  453 */  regD_rule,
  /*  454 */  regD_rule,
  /*  455 */  mRegI_rule,
  /*  456 */  regF_rule,
  /*  457 */  mRegI_rule,
  /*  458 */  mRegI_rule,
  /*  459 */  mRegI_rule,
  /*  460 */  Universe_rule,
  /*  461 */  no_Ax_mRegI_rule,
  /*  462 */  no_Ax_mRegI_rule,
  /*  463 */  mRegI_rule,
  /*  464 */  mRegI_rule,
  /*  465 */  mRegI_rule,
  /*  466 */  mRegI_rule,
  /*  467 */  mRegP_rule,
  /*  468 */  mRegP_rule,
  /*  469 */  mRegP_rule,
  /*  470 */  mRegP_rule,
  /*  471 */  mRegL_rule,
  /*  472 */  mRegL_rule,
  /*  473 */  mRegL_rule,
  /*  474 */  mRegL_rule,
  /*  475 */  mRegL_rule,
  /*  476 */  mRegL_rule,
  /*  477 */  mRegL_rule,
  /*  478 */  mRegL_rule,
  /*  479 */  mRegL_rule,
  /*  480 */  mRegI_rule,
  /*  481 */  mRegI_rule,
  /*  482 */  mRegI_rule,
  /*  483 */  mRegL_rule,
  /*  484 */  mRegL_rule,
  /*  485 */  mRegL_rule,
  /*  486 */  mRegL_rule,
  /*  487 */  mRegL_rule,
  /*  488 */  mRegL_rule,
  /*  489 */  mRegI_rule,
  /*  490 */  mRegL_rule,
  /*  491 */  mRegI_rule,
  /*  492 */  mRegI_rule,
  /*  493 */  mRegI_rule,
  /*  494 */  mRegI_rule,
  /*  495 */  regF_rule,
  /*  496 */  regD_rule,
  /*  497 */  mRegL_rule,
  /*  498 */  mRegL_rule,
  /*  499 */  mRegL_rule,
  /*  500 */  mRegL_rule,
  /*  501 */  regF_rule,
  /*  502 */  regF_rule,
  /*  503 */  regD_rule,
  /*  504 */  regD_rule,
  /*  505 */  regF_rule,
  /*  506 */  regF_rule,
  /*  507 */  regF_rule,
  /*  508 */  regD_rule,
  /*  509 */  regD_rule,
  /*  510 */  regD_rule,
  /*  511 */  regD_rule,
  /*  512 */  regF_rule,
  /*  513 */  mRegI_rule,
  /*  514 */  mRegI_rule,
  /*  515 */  mRegI_rule,
  /*  516 */  mRegL_rule,
  /*  517 */  mRegI_rule,
  /*  518 */  mRegI_rule,
  /*  519 */  mRegI_rule,
  /*  520 */  mRegL_rule,
  /*  521 */  mRegI_rule,
  /*  522 */  mRegI_rule,
  /*  523 */  mRegI_rule,
  /*  524 */  mRegI_rule,
  /*  525 */  mRegI_rule,
  /*  526 */  mRegI_rule,
  /*  527 */  mRegI_rule,
  /*  528 */  mRegI_rule,
  /*  529 */  mRegI_rule,
  /*  530 */  mRegI_rule,
  /*  531 */  mRegI_rule,
  /*  532 */  mRegI_rule,
  /*  533 */  mRegL_rule,
  /*  534 */  mRegL_rule,
  /*  535 */  mRegL_rule,
  /*  536 */  mRegL_rule,
  /*  537 */  mRegI_rule,
  /*  538 */  mRegL_rule,
  /*  539 */  mRegL_rule,
  /*  540 */  mRegL_rule,
  /*  541 */  mRegL_rule,
  /*  542 */  mRegL_rule,
  /*  543 */  mRegL_rule,
  /*  544 */  mRegL_rule,
  /*  545 */  mRegL_rule,
  /*  546 */  mRegL_rule,
  /*  547 */  mRegI_rule,
  /*  548 */  mRegI_rule,
  /*  549 */  mRegI_rule,
  /*  550 */  mRegI_rule,
  /*  551 */  mRegI_rule,
  /*  552 */  mRegI_rule,
  /*  553 */  mRegI_rule,
  /*  554 */  mRegI_rule,
  /*  555 */  mRegI_rule,
  /*  556 */  mRegL_rule,
  /*  557 */  mRegL_rule,
  /*  558 */  mRegL_rule,
  /*  559 */  mRegL_rule,
  /*  560 */  mRegI_rule,
  /*  561 */  mRegL_rule,
  /*  562 */  mRegL_rule,
  /*  563 */  mRegL_rule,
  /*  564 */  mRegI_rule,
  /*  565 */  mRegL_rule,
  /*  566 */  mRegL_rule,
  /*  567 */  mRegI_rule,
  /*  568 */  mRegL_rule,
  /*  569 */  mRegI_rule,
  /*  570 */  mRegI_rule,
  /*  571 */  mRegI_rule,
  /*  572 */  mRegI_rule,
  /*  573 */  mRegL_rule,
  /*  574 */  mRegL_rule,
  /*  575 */  mRegI_rule,
  /*  576 */  mRegI_rule,
  /*  577 */  mRegI_rule,
  /*  578 */  mRegI_rule,
  /*  579 */  mRegL_rule,
  /*  580 */  mRegL_rule,
  /*  581 */  mRegL_rule,
  /*  582 */  mRegL_rule,
  /*  583 */  mRegI_rule,
  /*  584 */  mRegI_rule,
  /*  585 */  mRegL_rule,
  /*  586 */  mRegL_rule,
  /*  587 */  mRegL_rule,
  /*  588 */  mRegL_rule,
  /*  589 */  mRegI_rule,
  /*  590 */  mRegI_rule,
  /*  591 */  mRegI_rule,
  /*  592 */  mRegL_rule,
  /*  593 */  mRegI_rule,
  /*  594 */  mRegL_rule,
  /*  595 */  regD_rule,
  /*  596 */  mRegL_rule,
  /*  597 */  mRegL_rule,
  /*  598 */  mRegI_rule,
  /*  599 */  mRegI_rule,
  /*  600 */  mRegL_rule,
  /*  601 */  mRegL_rule,
  /*  602 */  regF_rule,
  /*  603 */  regF_rule,
  /*  604 */  mRegI_rule,
  /*  605 */  mRegI_rule,
  /*  606 */  regD_rule,
  /*  607 */  regD_rule,
  /*  608 */  regF_rule,
  /*  609 */  mRegI_rule,
  /*  610 */  mRegI_rule,
  /*  611 */  mRegN_rule,
  /*  612 */  mRegN_rule,
  /*  613 */  mRegP_rule,
  /*  614 */  mRegP_rule,
  /*  615 */  mRegN_rule,
  /*  616 */  mRegP_rule,
  /*  617 */  mRegP_rule,
  /*  618 */  Universe_rule,
  /*  619 */  Universe_rule,
  /*  620 */  Universe_rule,
  /*  621 */  Universe_rule,
  /*  622 */  Universe_rule,
  /*  623 */  Universe_rule,
  /*  624 */  Universe_rule,
  /*  625 */  Universe_rule,
  /*  626 */  Universe_rule,
  /*  627 */  mRegI_rule,
  /*  628 */  mRegL_rule,
  /*  629 */  Universe_rule,
  /*  630 */  Universe_rule,
  /*  631 */  Universe_rule,
  /*  632 */  Universe_rule,
  /*  633 */  regD_rule,
  /*  634 */  regD_rule,
  /*  635 */  Universe_rule,
  /*  636 */  Universe_rule,
  /*  637 */  Universe_rule,
  /*  638 */  Universe_rule,
  /*  639 */  mRegP_rule,
  /*  640 */  mRegP_rule,
  /*  641 */  mRegI_rule,
  /*  642 */  mRegI_rule,
  /*  643 */  mRegI_rule,
  /*  644 */  mRegI_rule,
  /*  645 */  mRegI_rule,
  /*  646 */  mRegI_rule,
  /*  647 */  mRegI_rule,
  /*  648 */  mRegL_rule,
  /*  649 */  mRegL_rule,
  /*  650 */  mRegL_rule,
  /*  651 */  mRegL_rule,
  /*  652 */  mRegL_rule,
  /*  653 */  mRegL_rule,
  /*  654 */  mRegL_rule,
  /*  655 */  mRegL_rule,
  /*  656 */  Universe_rule,
  /*  657 */  Universe_rule,
  /*  658 */  vecD_rule,
  /*  659 */  Universe_rule,
  /*  660 */  vecD_rule,
  /*  661 */  vecD_rule,
  /*  662 */  vecD_rule,
  /*  663 */  vecD_rule,
  /*  664 */  vecD_rule,
  /*  665 */  vecD_rule,
  /*  666 */  vecD_rule,
  /*  667 */  vecD_rule,
  /*  668 */  vecD_rule,
  /*  669 */  vecD_rule,
  /*  670 */  vecD_rule,
  /*  671 */  vecD_rule,
  /*  672 */  vecD_rule,
  /*  673 */  vecD_rule,
  /*  674 */  vecD_rule,
  /*  675 */  vecD_rule,
  /*  676 */  vecD_rule,
  /*  677 */  vecD_rule,
  /*  678 */  vecD_rule,
  /*  679 */  vecD_rule,
  /*  680 */  vecD_rule,
  /*  681 */  vecD_rule,
  /*  682 */  vecD_rule,
  // last instruction
  0 // no trailing comma
};

const        int   leftOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  0,
  /*    9 */  0,
  /*   10 */  0,
  /*   11 */  0,
  /*   12 */  0,
  /*   13 */  0,
  /*   14 */  0,
  /*   15 */  0,
  /*   16 */  0,
  /*   17 */  0,
  /*   18 */  0,
  /*   19 */  0,
  /*   20 */  0,
  /*   21 */  0,
  /*   22 */  0,
  /*   23 */  0,
  /*   24 */  0,
  /*   25 */  0,
  /*   26 */  0,
  /*   27 */  0,
  /*   28 */  0,
  /*   29 */  0,
  /*   30 */  0,
  /*   31 */  0,
  /*   32 */  0,
  /*   33 */  0,
  /*   34 */  0,
  /*   35 */  0,
  /*   36 */  0,
  /*   37 */  0,
  /*   38 */  0,
  /*   39 */  0,
  /*   40 */  0,
  /*   41 */  0,
  /*   42 */  0,
  /*   43 */  0,
  /*   44 */  0,
  /*   45 */  0,
  /*   46 */  0,
  /*   47 */  0,
  /*   48 */  0,
  /*   49 */  0,
  /*   50 */  0,
  /*   51 */  0,
  /*   52 */  0,
  /*   53 */  0,
  /*   54 */  0,
  /*   55 */  0,
  /*   56 */  0,
  /*   57 */  0,
  /*   58 */  0,
  /*   59 */  0,
  /*   60 */  0,
  /*   61 */  0,
  /*   62 */  0,
  /*   63 */  0,
  /*   64 */  0,
  /*   65 */  0,
  /*   66 */  0,
  /*   67 */  0,
  /*   68 */  0,
  /*   69 */  0,
  /*   70 */  0,
  /*   71 */  0,
  /*   72 */  0,
  /*   73 */  0,
  /*   74 */  0,
  /*   75 */  0,
  /*   76 */  0,
  /*   77 */  0,
  /*   78 */  0,
  /*   79 */  0,
  /*   80 */  0,
  /*   81 */  0,
  /*   82 */  0,
  /*   83 */  0,
  /*   84 */  0,
  /*   85 */  0,
  /*   86 */  0,
  /*   87 */  0,
  /*   88 */  0,
  /*   89 */  0,
  /*   90 */  0,
  /*   91 */  0,
  /*   92 */  0,
  /*   93 */  0,
  /*   94 */  0,
  /*   95 */  0,
  /*   96 */  0,
  /*   97 */  0,
  /*   98 */  0,
  /*   99 */  0,
  /*  100 */  0,
  /*  101 */  0,
  /*  102 */  0,
  /*  103 */  0,
  /*  104 */  0,
  /*  105 */  0,
  /*  106 */  0,
  /*  107 */  0,
  /*  108 */  0,
  /*  109 */  0,
  /*  110 */  0,
  /*  111 */  0,
  /*  112 */  0,
  /*  113 */  0,
  /*  114 */  0,
  /*  115 */  0,
  /*  116 */  0,
  /*  117 */  0,
  /*  118 */  0,
  /*  119 */  0,
  /*  120 */  0,
  /*  121 */  0,
  /*  122 */  0,
  /*  123 */  0,
  /*  124 */  0,
  /*  125 */  0,
  /*  126 */  0,
  /*  127 */  0,
  /*  128 */  0,
  /*  129 */  0,
  /*  130 */  0,
  /*  131 */  0,
  /*  132 */  0,
  /*  133 */  0,
  /*  134 */  0,
  /*  135 */  0,
  /*  136 */  0,
  /*  137 */  0,
  /*  138 */  0,
  /*  139 */  0,
  /*  140 */  0,
  /*  141 */  0,
  /*  142 */  0,
  /*  143 */  0,
  /*  144 */  0,
  /*  145 */  0,
  /*  146 */  0,
  /*  147 */  0,
  /*  148 */  0,
  /*  149 */  0,
  /*  150 */  0,
  /*  151 */  0,
  /*  152 */  0,
  /*  153 */  mRegP_rule,
  /*  154 */  mRegP_rule,
  /*  155 */  _AddP_mRegP_mRegL_rule,
  /*  156 */  _AddP_mRegP__ConvI2L_mRegI__rule,
  /*  157 */  _AddP_mRegP__LShiftL_mRegL_immI_0_3_rule,
  /*  158 */  _AddP_mRegP__LShiftL__ConvI2L_mRegI__immI_0_3_rule,
  /*  159 */  _AddP_mRegP__LShiftL__ConvI2L_mRegI__immI_0_31_rule,
  /*  160 */  _AddP__DecodeN_mRegN___LShiftL_mRegL_immI_0_3_rule,
  /*  161 */  _AddP__DecodeN_mRegN___LShiftL__ConvI2L_mRegI__immI_0_31_rule,
  /*  162 */  mRegP_rule,
  /*  163 */  mRegP_rule,
  /*  164 */  mRegN_rule,
  /*  165 */  _DecodeNKlass_mRegN__rule,
  /*  166 */  _DecodeNKlass_mRegN__rule,
  /*  167 */  _AddP__DecodeNKlass_mRegN__mRegL_rule,
  /*  168 */  _DecodeNKlass_mRegN__rule,
  /*  169 */  mRegN_rule,
  /*  170 */  _DecodeN_mRegN__rule,
  /*  171 */  _AddP__DecodeN_mRegN__mRegL_rule,
  /*  172 */  0,
  /*  173 */  0,
  /*  174 */  load_long_RegP_rule,
  /*  175 */  0,
  /*  176 */  0,
  /*  177 */  0,
  /*  178 */  0,
  /*  179 */  0,
  /*  180 */  0,
  /*  181 */  0,
  // last operand
  /*  182 */  0,
  // last operand class
  /*  183 */  mRegL_rule,
  /*  184 */  mRegP_rule,
  /*  185 */  mRegI_rule,
  /*  186 */  mRegP_rule,
  /*  187 */  mRegP_rule,
  /*  188 */  _ConvI2L_mRegI__rule,
  /*  189 */  mRegP_rule,
  /*  190 */  _ConvI2L_mRegI__rule,
  /*  191 */  mRegP_rule,
  /*  192 */  mRegN_rule,
  /*  193 */  _DecodeN_mRegN__rule,
  /*  194 */  _DecodeN_mRegN__rule,
  /*  195 */  mRegN_rule,
  /*  196 */  _DecodeNKlass_mRegN__rule,
  /*  197 */  _DecodeN_mRegN__rule,
  /*  198 */  memory_rule,
  /*  199 */  _LoadI_memory__rule,
  /*  200 */  _LoadI_memory__rule,
  /*  201 */  memory_rule,
  /*  202 */  memory_rule,
  /*  203 */  mRegP_rule,
  /*  204 */  mRegP_rule,
  /*  205 */  mRegL_rule,
  /*  206 */  memory_rule,
  /*  207 */  memory_rule,
  /*  208 */  memory_rule,
  /*  209 */  _LoadS_memory__rule,
  /*  210 */  mRegI_rule,
  /*  211 */  mRegI_rule,
  /*  212 */  mRegP_rule,
  /*  213 */  _DecodeN_mRegN__rule,
  /*  214 */  mRegP_rule,
  /*  215 */  mRegN_rule,
  /*  216 */  mRegN_rule,
  /*  217 */  mRegI_rule,
  /*  218 */  mRegI_rule,
  /*  219 */  mRegI_rule,
  /*  220 */  mRegI_rule,
  /*  221 */  mRegL_rule,
  /*  222 */  mRegL_rule,
  /*  223 */  mRegL_rule,
  /*  224 */  regF_rule,
  /*  225 */  regD_rule,
  /*  226 */  cmpOp_rule,
  /*  227 */  mRegI_rule,
  /*  228 */  cmpOpU_rule,
  /*  229 */  cmpOpU_rule,
  /*  230 */  cmpOpU_rule,
  /*  231 */  mRegP_rule,
  /*  232 */  cmpOp_rule,
  /*  233 */  mRegN_rule,
  /*  234 */  cmpOp_rule,
  /*  235 */  cmpOp_rule,
  /*  236 */  mRegL_rule,
  /*  237 */  regD_rule,
  /*  238 */  regF_rule,
  /*  239 */  cmpOp_rule,
  /*  240 */  a4_RegP_rule,
  /*  241 */  a6_RegP_rule,
  /*  242 */  a4_RegP_rule,
  /*  243 */  mRegI_rule,
  /*  244 */  _ConvI2L_mRegI__rule,
  /*  245 */  mRegI_rule,
  /*  246 */  regF_rule,
  /*  247 */  regD_rule,
  /*  248 */  regF_rule,
  /*  249 */  _ConvF2D_regF__rule,
  /*  250 */  mRegI_rule,
  /*  251 */  mRegL_rule,
  /*  252 */  mRegP_rule,
  /*  253 */  mRegI_rule,
  /*  254 */  mRegL_rule,
  /*  255 */  _AndL_mRegL_immL_7_rule,
  /*  256 */  _ConvL2I__AndL_mRegL_immL_7__rule,
  /*  257 */  mRegI_rule,
  /*  258 */  _OrI_mRegI_immI_0_32767_rule,
  /*  259 */  mRegI_rule,
  /*  260 */  mRegL_rule,
  /*  261 */  mRegL_rule,
  /*  262 */  _URShiftL_mRegL_immI_0_31_rule,
  /*  263 */  mRegL_rule,
  /*  264 */  mRegI_rule,
  /*  265 */  mRegI_rule,
  /*  266 */  _AndI_mRegI_immI_1_rule,
  /*  267 */  mRegI_rule,
  /*  268 */  mRegL_rule,
  /*  269 */  mRegL_rule,
  /*  270 */  memory_rule,
  /*  271 */  t2RegL_rule,
  /*  272 */  mS2RegI_rule,
  /*  273 */  s2RegL_rule,
  /*  274 */  s2_RegP_rule,
  /*  275 */  t2_RegN_rule,
  /*  276 */  _ConvI2L_mRegI__rule,
  /*  277 */  _ConvI2L_mRegI__rule,
  /*  278 */  _ConvL2I_mRegL__rule,
  /*  279 */  _LoadI_memory__rule,
  // last internally defined operand
  /*  280 */  mRegI_rule,
  /*  281 */  mRegL_rule,
  /*  282 */  mRegP_rule,
  /*  283 */  regF_rule,
  /*  284 */  regD_rule,
  /*  285 */  immI_rule,
  /*  286 */  immL_rule,
  /*  287 */  immL12_rule,
  /*  288 */  immL_0_rule,
  /*  289 */  immP_rule,
  /*  290 */  immP_no_oop_cheap_rule,
  /*  291 */  immP_poll_rule,
  /*  292 */  immP_0_rule,
  /*  293 */  immN_0_rule,
  /*  294 */  immN_rule,
  /*  295 */  immNKlass_rule,
  /*  296 */  immF_0_rule,
  /*  297 */  immF_rule,
  /*  298 */  immD_0_rule,
  /*  299 */  immD_rule,
  /*  300 */  stackSlotI_rule,
  /*  301 */  stackSlotL_rule,
  /*  302 */  stackSlotP_rule,
  /*  303 */  stackSlotF_rule,
  /*  304 */  stackSlotD_rule,
  /*  305 */  indOffset8Narrow_rule,
  /*  306 */  basePosIndexScaleOffset8_rule,
  /*  307 */  indIndexScale_rule,
  /*  308 */  mRegL_rule,
  /*  309 */  mRegP_rule,
  /*  310 */  regF_rule,
  /*  311 */  mRegI_rule,
  /*  312 */  regD_rule,
  /*  313 */  mRegL_rule,
  /*  314 */  regF_rule,
  /*  315 */  regD_rule,
  /*  316 */  regF_rule,
  /*  317 */  regD_rule,
  /*  318 */  mRegI_rule,
  /*  319 */  mRegP_rule,
  /*  320 */  mRegP_rule,
  /*  321 */  mRegP_rule,
  /*  322 */  mRegI_rule,
  /*  323 */  mRegP_rule,
  /*  324 */  mRegP_rule,
  /*  325 */  memory_rule,
  /*  326 */  memory_rule,
  /*  327 */  memory_rule,
  /*  328 */  regF_rule,
  /*  329 */  regD_rule,
  /*  330 */  mRegI_rule,
  /*  331 */  mRegL_rule,
  /*  332 */  mRegI_rule,
  /*  333 */  mRegL_rule,
  /*  334 */  memory_rule,
  /*  335 */  _LoadI_memory__rule,
  /*  336 */  _LShiftI__LoadI_memory__immI_24_rule,
  /*  337 */  _LoadI_memory__rule,
  /*  338 */  _LShiftI__LoadI_memory__immI_16_rule,
  /*  339 */  _LoadI_memory__rule,
  /*  340 */  memory_rule,
  /*  341 */  memory_rule,
  /*  342 */  memory_rule,
  /*  343 */  memory_rule,
  /*  344 */  memory_rule,
  /*  345 */  memory_rule,
  /*  346 */  _LoadN_memory__rule,
  /*  347 */  memory_rule,
  /*  348 */  memory_rule,
  /*  349 */  memory_rule,
  /*  350 */  _LoadNKlass_memory__rule,
  /*  351 */  memory_rule,
  /*  352 */  memory_rule,
  /*  353 */  memory_rule,
  /*  354 */  memory_rule,
  /*  355 */  memory_rule,
  /*  356 */  memory_rule,
  /*  357 */  memory_rule,
  /*  358 */  memory_rule,
  /*  359 */  memory_rule,
  /*  360 */  memory_rule,
  /*  361 */  memory_rule,
  /*  362 */  memory_rule,
  /*  363 */  _LoadB_memory__rule,
  /*  364 */  memory_rule,
  /*  365 */  _LoadUB_memory__rule,
  /*  366 */  memory_rule,
  /*  367 */  _LShiftI__LoadS_memory__immI_24_rule,
  /*  368 */  _LoadS_memory__rule,
  /*  369 */  memory_rule,
  /*  370 */  memory_rule,
  /*  371 */  memory_rule,
  /*  372 */  memory_rule,
  /*  373 */  mRegP_rule,
  /*  374 */  0,
  /*  375 */  0,
  /*  376 */  0,
  /*  377 */  cmpOp_rule,
  /*  378 */  cmpOp_rule,
  /*  379 */  cmpOp_rule,
  /*  380 */  cmpOpU_rule,
  /*  381 */  cmpOpU_rule,
  /*  382 */  cmpOpU_rule,
  /*  383 */  cmpOp_rule,
  /*  384 */  cmpOp_rule,
  /*  385 */  cmpOpU_rule,
  /*  386 */  cmpOpU_rule,
  /*  387 */  cmpOp_rule,
  /*  388 */  cmpOp_rule,
  /*  389 */  cmpOp_rule,
  /*  390 */  cmpOpU_rule,
  /*  391 */  cmpOp_rule,
  /*  392 */  cmpOp_rule,
  /*  393 */  cmpOp_rule,
  /*  394 */  cmpOp_rule,
  /*  395 */  cmpOp_rule,
  /*  396 */  0,
  /*  397 */  cmpOp_rule,
  /*  398 */  cmpOp_rule,
  /*  399 */  cmpOp_rule,
  /*  400 */  cmpOpU_rule,
  /*  401 */  cmpOpU_rule,
  /*  402 */  cmpOpU_rule,
  /*  403 */  cmpOp_rule,
  /*  404 */  cmpOp_rule,
  /*  405 */  cmpOpU_rule,
  /*  406 */  cmpOpU_rule,
  /*  407 */  cmpOp_rule,
  /*  408 */  cmpOp_rule,
  /*  409 */  cmpOp_rule,
  /*  410 */  cmpOpU_rule,
  /*  411 */  cmpOp_rule,
  /*  412 */  cmpOp_rule,
  /*  413 */  cmpOp_rule,
  /*  414 */  cmpOp_rule,
  /*  415 */  cmpOp_rule,
  /*  416 */  0,
  /*  417 */  0,
  /*  418 */  0,
  /*  419 */  0,
  /*  420 */  0,
  /*  421 */  0,
  /*  422 */  0,
  /*  423 */  0,
  /*  424 */  0,
  /*  425 */  0,
  /*  426 */  _Binary_cmpOp__CmpI_mRegI_mRegI_rule,
  /*  427 */  _Binary_cmpOpU__CmpP_mRegP_mRegP_rule,
  /*  428 */  _Binary_cmpOpU__CmpN_mRegN_mRegN_rule,
  /*  429 */  _Binary_cmpOpU__CmpU_mRegI_mRegI_rule,
  /*  430 */  _Binary_cmpOp__CmpF_regF_regF_rule,
  /*  431 */  _Binary_cmpOpU__CmpN_mRegN_mRegN_rule,
  /*  432 */  _Binary_cmpOpU__CmpP_mRegP_mRegP_rule,
  /*  433 */  _Binary_cmpOp__CmpD_regD_regD_rule,
  /*  434 */  _Binary_cmpOpU__CmpN_mRegN_mRegN_rule,
  /*  435 */  _Binary_cmpOpU__CmpU_mRegI_mRegI_rule,
  /*  436 */  _Binary_cmpOp__CmpL_mRegL_mRegL_rule,
  /*  437 */  _Binary_cmpOp__CmpL_mRegL_mRegL_rule,
  /*  438 */  _Binary_cmpOp__CmpD_regD_regD_rule,
  /*  439 */  _Binary_cmpOpU__CmpP_mRegP_mRegP_rule,
  /*  440 */  _Binary_cmpOp__CmpI_mRegI_mRegI_rule,
  /*  441 */  _Binary_cmpOpU__CmpP_mRegP_mRegP_rule,
  /*  442 */  _Binary_cmpOpU__CmpU_mRegI_mRegI_rule,
  /*  443 */  _Binary_cmpOp__CmpL_mRegL_mRegL_rule,
  /*  444 */  _Binary_cmpOp__CmpI_mRegI_mRegI_rule,
  /*  445 */  _Binary_cmpOpU__CmpU_mRegI_mRegI_rule,
  /*  446 */  _Binary_cmpOp__CmpF_regF_regF_rule,
  /*  447 */  _Binary_cmpOp__CmpI_mRegI_mRegI_rule,
  /*  448 */  _Binary_cmpOp__CmpL_mRegL_mRegL_rule,
  /*  449 */  _Binary_cmpOpU__CmpN_mRegN_mRegN_rule,
  /*  450 */  _Binary_cmpOp__CmpD_regD_regD_rule,
  /*  451 */  _Binary_cmpOp__CmpD_regD_regD_rule,
  /*  452 */  _Binary_cmpOp__CmpI_mRegI_mRegI_rule,
  /*  453 */  _Binary_cmpOp__CmpI_mRegI_mRegI_rule,
  /*  454 */  _Binary_cmpOp__CmpP_mRegP_mRegP_rule,
  /*  455 */  _Binary_cmpOp__CmpF_regF_regF_rule,
  /*  456 */  _Binary_cmpOp__CmpF_regF_regF_rule,
  /*  457 */  mRegL_rule,
  /*  458 */  regF_rule,
  /*  459 */  regD_rule,
  /*  460 */  mRegL_rule,
  /*  461 */  _Binary_a4_RegP_mA5RegI_rule,
  /*  462 */  _Binary_a4_RegP_a5_RegP_rule,
  /*  463 */  mRegI_rule,
  /*  464 */  mRegI_rule,
  /*  465 */  mRegI_rule,
  /*  466 */  _LShiftI_mRegI_immI_1_4_rule,
  /*  467 */  mRegP_rule,
  /*  468 */  mRegP_rule,
  /*  469 */  mRegP_rule,
  /*  470 */  mRegP_rule,
  /*  471 */  mRegL_rule,
  /*  472 */  mRegL_rule,
  /*  473 */  _ConvI2L_mRegI__rule,
  /*  474 */  _ConvI2L_mRegI__rule,
  /*  475 */  mRegL_rule,
  /*  476 */  _ConvI2L_mRegI__rule,
  /*  477 */  _ConvI2L_mRegI__rule,
  /*  478 */  mRegL_rule,
  /*  479 */  _ConvI2L_mRegI__rule,
  /*  480 */  mRegI_rule,
  /*  481 */  mRegI_rule,
  /*  482 */  immI_0_rule,
  /*  483 */  immL_0_rule,
  /*  484 */  mRegL_rule,
  /*  485 */  mRegL_rule,
  /*  486 */  mRegL_rule,
  /*  487 */  _ConvI2L_mRegI__rule,
  /*  488 */  _ConvI2L_mRegI__rule,
  /*  489 */  mRegI_rule,
  /*  490 */  mRegL_rule,
  /*  491 */  mRegI_rule,
  /*  492 */  _MulI_mRegI_mRegI_rule,
  /*  493 */  mRegI_rule,
  /*  494 */  mRegI_rule,
  /*  495 */  regF_rule,
  /*  496 */  regD_rule,
  /*  497 */  mRegL_rule,
  /*  498 */  mRegL_rule,
  /*  499 */  _ConvI2L_mRegI__rule,
  /*  500 */  mRegL_rule,
  /*  501 */  regF_rule,
  /*  502 */  regF_rule,
  /*  503 */  regD_rule,
  /*  504 */  regD_rule,
  /*  505 */  regF_rule,
  /*  506 */  _MulF_regF_regF_rule,
  /*  507 */  regF_rule,
  /*  508 */  regD_rule,
  /*  509 */  _MulD_regD_regD_rule,
  /*  510 */  regD_rule,
  /*  511 */  regD_rule,
  /*  512 */  _SqrtD__ConvF2D_regF___rule,
  /*  513 */  mRegI_rule,
  /*  514 */  mRegI_rule,
  /*  515 */  mRegI_rule,
  /*  516 */  mRegL_rule,
  /*  517 */  mRegI_rule,
  /*  518 */  mRegI_rule,
  /*  519 */  _ConvL2I_mRegL__rule,
  /*  520 */  mRegL_rule,
  /*  521 */  immI_255_rule,
  /*  522 */  _LoadB_memory__rule,
  /*  523 */  _LoadB_memory__rule,
  /*  524 */  mRegI_rule,
  /*  525 */  mRegI_rule,
  /*  526 */  _XorI_mRegI_immI_M1_rule,
  /*  527 */  mRegI_rule,
  /*  528 */  _XorI_mRegI_immI_M1_rule,
  /*  529 */  _XorI_mRegI_immI_M1_rule,
  /*  530 */  mRegI_rule,
  /*  531 */  _XorI_mRegI_immI_M1_rule,
  /*  532 */  mRegI_rule,
  /*  533 */  mRegL_rule,
  /*  534 */  mRegL_rule,
  /*  535 */  _ConvI2L_mRegI__rule,
  /*  536 */  mRegL_rule,
  /*  537 */  _AndL_mRegL_immL_0_4095_rule,
  /*  538 */  mRegL_rule,
  /*  539 */  mRegL_rule,
  /*  540 */  mRegL_rule,
  /*  541 */  mRegL_rule,
  /*  542 */  mRegL_rule,
  /*  543 */  mRegL_rule,
  /*  544 */  _CastP2X_mRegP__rule,
  /*  545 */  mRegL_rule,
  /*  546 */  mRegL_rule,
  /*  547 */  mRegI_rule,
  /*  548 */  _ConvL2I_mRegL__rule,
  /*  549 */  _LShiftI_mRegI_immI_16_rule,
  /*  550 */  _LShiftI__ConvL2I__AndL_mRegL_immL_7__immI_16_rule,
  /*  551 */  _LShiftI__OrI_mRegI_immI_0_32767_immI_16_rule,
  /*  552 */  _LShiftI_mRegI_immI_16_rule,
  /*  553 */  _LShiftI_mRegI_immI_24_rule,
  /*  554 */  _ConvL2I_mRegL__rule,
  /*  555 */  mRegI_rule,
  /*  556 */  mRegL_rule,
  /*  557 */  _ConvI2L_mRegI__rule,
  /*  558 */  mRegL_rule,
  /*  559 */  mRegL_rule,
  /*  560 */  _RShiftL_mRegL_immI_32_63_rule,
  /*  561 */  mRegL_rule,
  /*  562 */  mRegL_rule,
  /*  563 */  mRegL_rule,
  /*  564 */  _ConvL2I__URShiftL_mRegL_immI_0_31__rule,
  /*  565 */  _CastP2X_mRegP__rule,
  /*  566 */  mRegL_rule,
  /*  567 */  _URShiftL_mRegL_immI_32_63_rule,
  /*  568 */  _CastP2X_mRegP__rule,
  /*  569 */  mRegI_rule,
  /*  570 */  mRegI_rule,
  /*  571 */  _URShiftI_mRegI_immI_0_31_rule,
  /*  572 */  _LShiftI__AndI_mRegI_immI_1_immI_0_31_rule,
  /*  573 */  mRegL_rule,
  /*  574 */  _CastP2X_mRegP__rule,
  /*  575 */  mRegI_rule,
  /*  576 */  _URShiftI_mRegI_immI_0_31_rule,
  /*  577 */  _LShiftI_mRegI_immI_0_31_rule,
  /*  578 */  _URShiftI_mRegI_immI_0_31_rule,
  /*  579 */  _LShiftL_mRegL_immI_32_63_rule,
  /*  580 */  _URShiftL_mRegL_immI_0_31_rule,
  /*  581 */  _LShiftL_mRegL_immI_0_31_rule,
  /*  582 */  _URShiftL_mRegL_immI_32_63_rule,
  /*  583 */  _URShiftI_mRegI_immI_0_31_rule,
  /*  584 */  _LShiftI_mRegI_immI_0_31_rule,
  /*  585 */  _URShiftL_mRegL_immI_0_31_rule,
  /*  586 */  _LShiftL_mRegL_immI_32_63_rule,
  /*  587 */  _URShiftL_mRegL_immI_32_63_rule,
  /*  588 */  _LShiftL_mRegL_immI_0_31_rule,
  /*  589 */  mRegI_rule,
  /*  590 */  mRegI_rule,
  /*  591 */  mRegI_rule,
  /*  592 */  mRegI_rule,
  /*  593 */  mRegL_rule,
  /*  594 */  _ConvL2I_mRegL__rule,
  /*  595 */  mRegL_rule,
  /*  596 */  regD_rule,
  /*  597 */  regD_rule,
  /*  598 */  regF_rule,
  /*  599 */  regF_rule,
  /*  600 */  regF_rule,
  /*  601 */  regF_rule,
  /*  602 */  mRegL_rule,
  /*  603 */  mRegI_rule,
  /*  604 */  mRegI_rule,
  /*  605 */  mRegI_rule,
  /*  606 */  mRegI_rule,
  /*  607 */  regF_rule,
  /*  608 */  regD_rule,
  /*  609 */  regD_rule,
  /*  610 */  regD_rule,
  /*  611 */  mRegP_rule,
  /*  612 */  mRegP_rule,
  /*  613 */  mRegN_rule,
  /*  614 */  mRegN_rule,
  /*  615 */  mRegP_rule,
  /*  616 */  mRegN_rule,
  /*  617 */  0,
  /*  618 */  0,
  /*  619 */  no_Ax_mRegP_rule,
  /*  620 */  0,
  /*  621 */  0,
  /*  622 */  0,
  /*  623 */  memory_rule,
  /*  624 */  memory_rule,
  /*  625 */  memory_rule,
  /*  626 */  0,
  /*  627 */  memory_rule,
  /*  628 */  _LoadUS_memory__rule,
  /*  629 */  memory_rule,
  /*  630 */  memory_rule,
  /*  631 */  memory_rule,
  /*  632 */  memory_rule,
  /*  633 */  memory_rule,
  /*  634 */  memory_rule,
  /*  635 */  memory_rule,
  /*  636 */  memory_rule,
  /*  637 */  memory_rule,
  /*  638 */  0,
  /*  639 */  no_T8_mRegP_rule,
  /*  640 */  memory_rule,
  /*  641 */  mRegP_rule,
  /*  642 */  mRegP_rule,
  /*  643 */  mRegP_rule,
  /*  644 */  mRegP_rule,
  /*  645 */  mRegI_rule,
  /*  646 */  mRegI_rule,
  /*  647 */  mRegI_rule,
  /*  648 */  mRegL_rule,
  /*  649 */  _AndL__ConvI2L_mRegI__immL_MaxUI_rule,
  /*  650 */  _LShiftL__ConvI2L_mRegI__immI_32_rule,
  /*  651 */  _ConvI2L_mRegI__rule,
  /*  652 */  _ConvI2L__ConvL2I_mRegL___rule,
  /*  653 */  _ConvI2L__LoadI_memory___rule,
  /*  654 */  immL_MaxUI_rule,
  /*  655 */  _ConvI2L__LoadI_memory___rule,
  /*  656 */  mRegP_rule,
  /*  657 */  0,
  /*  658 */  memory_rule,
  /*  659 */  memory_rule,
  /*  660 */  mRegI_rule,
  /*  661 */  mRegI_rule,
  /*  662 */  immI_rule,
  /*  663 */  immI_rule,
  /*  664 */  immI_0_rule,
  /*  665 */  immI_M1_rule,
  /*  666 */  mRegI_rule,
  /*  667 */  mRegI_rule,
  /*  668 */  immI_rule,
  /*  669 */  immI_rule,
  /*  670 */  immI_0_rule,
  /*  671 */  immI_M1_rule,
  /*  672 */  mRegI_rule,
  /*  673 */  immI_rule,
  /*  674 */  immI_0_rule,
  /*  675 */  immI_M1_rule,
  /*  676 */  regF_rule,
  /*  677 */  immF_0_rule,
  /*  678 */  vecD_rule,
  /*  679 */  vecD_rule,
  /*  680 */  vecD_rule,
  /*  681 */  vecD_rule,
  /*  682 */  vecD_rule,
  // last instruction
  0 // no trailing comma
};

const        int   rightOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  0,
  /*    9 */  0,
  /*   10 */  0,
  /*   11 */  0,
  /*   12 */  0,
  /*   13 */  0,
  /*   14 */  0,
  /*   15 */  0,
  /*   16 */  0,
  /*   17 */  0,
  /*   18 */  0,
  /*   19 */  0,
  /*   20 */  0,
  /*   21 */  0,
  /*   22 */  0,
  /*   23 */  0,
  /*   24 */  0,
  /*   25 */  0,
  /*   26 */  0,
  /*   27 */  0,
  /*   28 */  0,
  /*   29 */  0,
  /*   30 */  0,
  /*   31 */  0,
  /*   32 */  0,
  /*   33 */  0,
  /*   34 */  0,
  /*   35 */  0,
  /*   36 */  0,
  /*   37 */  0,
  /*   38 */  0,
  /*   39 */  0,
  /*   40 */  0,
  /*   41 */  0,
  /*   42 */  0,
  /*   43 */  0,
  /*   44 */  0,
  /*   45 */  0,
  /*   46 */  0,
  /*   47 */  0,
  /*   48 */  0,
  /*   49 */  0,
  /*   50 */  0,
  /*   51 */  0,
  /*   52 */  0,
  /*   53 */  0,
  /*   54 */  0,
  /*   55 */  0,
  /*   56 */  0,
  /*   57 */  0,
  /*   58 */  0,
  /*   59 */  0,
  /*   60 */  0,
  /*   61 */  0,
  /*   62 */  0,
  /*   63 */  0,
  /*   64 */  0,
  /*   65 */  0,
  /*   66 */  0,
  /*   67 */  0,
  /*   68 */  0,
  /*   69 */  0,
  /*   70 */  0,
  /*   71 */  0,
  /*   72 */  0,
  /*   73 */  0,
  /*   74 */  0,
  /*   75 */  0,
  /*   76 */  0,
  /*   77 */  0,
  /*   78 */  0,
  /*   79 */  0,
  /*   80 */  0,
  /*   81 */  0,
  /*   82 */  0,
  /*   83 */  0,
  /*   84 */  0,
  /*   85 */  0,
  /*   86 */  0,
  /*   87 */  0,
  /*   88 */  0,
  /*   89 */  0,
  /*   90 */  0,
  /*   91 */  0,
  /*   92 */  0,
  /*   93 */  0,
  /*   94 */  0,
  /*   95 */  0,
  /*   96 */  0,
  /*   97 */  0,
  /*   98 */  0,
  /*   99 */  0,
  /*  100 */  0,
  /*  101 */  0,
  /*  102 */  0,
  /*  103 */  0,
  /*  104 */  0,
  /*  105 */  0,
  /*  106 */  0,
  /*  107 */  0,
  /*  108 */  0,
  /*  109 */  0,
  /*  110 */  0,
  /*  111 */  0,
  /*  112 */  0,
  /*  113 */  0,
  /*  114 */  0,
  /*  115 */  0,
  /*  116 */  0,
  /*  117 */  0,
  /*  118 */  0,
  /*  119 */  0,
  /*  120 */  0,
  /*  121 */  0,
  /*  122 */  0,
  /*  123 */  0,
  /*  124 */  0,
  /*  125 */  0,
  /*  126 */  0,
  /*  127 */  0,
  /*  128 */  0,
  /*  129 */  0,
  /*  130 */  0,
  /*  131 */  0,
  /*  132 */  0,
  /*  133 */  0,
  /*  134 */  0,
  /*  135 */  0,
  /*  136 */  0,
  /*  137 */  0,
  /*  138 */  0,
  /*  139 */  0,
  /*  140 */  0,
  /*  141 */  0,
  /*  142 */  0,
  /*  143 */  0,
  /*  144 */  0,
  /*  145 */  0,
  /*  146 */  0,
  /*  147 */  0,
  /*  148 */  0,
  /*  149 */  0,
  /*  150 */  0,
  /*  151 */  0,
  /*  152 */  0,
  /*  153 */  immL8_rule,
  /*  154 */  _LShiftL_mRegL_immI_0_3_rule,
  /*  155 */  immL8_rule,
  /*  156 */  immL8_rule,
  /*  157 */  immL8_rule,
  /*  158 */  immL8_rule,
  /*  159 */  immL8_rule,
  /*  160 */  immL8_rule,
  /*  161 */  immL8_rule,
  /*  162 */  immL32_rule,
  /*  163 */  mRegL_rule,
  /*  164 */  0,
  /*  165 */  immL8_rule,
  /*  166 */  immL32_rule,
  /*  167 */  immL32_rule,
  /*  168 */  mRegL_rule,
  /*  169 */  0,
  /*  170 */  immL8_rule,
  /*  171 */  immL8_rule,
  /*  172 */  0,
  /*  173 */  0,
  /*  174 */  immL32_rule,
  /*  175 */  0,
  /*  176 */  0,
  /*  177 */  0,
  /*  178 */  0,
  /*  179 */  0,
  /*  180 */  0,
  /*  181 */  0,
  // last operand
  /*  182 */  0,
  // last operand class
  /*  183 */  immI_0_3_rule,
  /*  184 */  mRegL_rule,
  /*  185 */  0,
  /*  186 */  _ConvI2L_mRegI__rule,
  /*  187 */  _LShiftL_mRegL_immI_0_3_rule,
  /*  188 */  immI_0_3_rule,
  /*  189 */  _LShiftL__ConvI2L_mRegI__immI_0_3_rule,
  /*  190 */  immI_0_31_rule,
  /*  191 */  _LShiftL__ConvI2L_mRegI__immI_0_31_rule,
  /*  192 */  0,
  /*  193 */  _LShiftL_mRegL_immI_0_3_rule,
  /*  194 */  _LShiftL__ConvI2L_mRegI__immI_0_31_rule,
  /*  195 */  0,
  /*  196 */  mRegL_rule,
  /*  197 */  mRegL_rule,
  /*  198 */  0,
  /*  199 */  immI_24_rule,
  /*  200 */  immI_16_rule,
  /*  201 */  0,
  /*  202 */  0,
  /*  203 */  0,
  /*  204 */  0,
  /*  205 */  0,
  /*  206 */  0,
  /*  207 */  0,
  /*  208 */  0,
  /*  209 */  immI_24_rule,
  /*  210 */  mRegI_rule,
  /*  211 */  immI_rule,
  /*  212 */  immP_0_rule,
  /*  213 */  immP_0_rule,
  /*  214 */  mRegP_rule,
  /*  215 */  immN_0_rule,
  /*  216 */  mRegN_rule,
  /*  217 */  mRegI_rule,
  /*  218 */  immI_rule,
  /*  219 */  immI_0_rule,
  /*  220 */  immI_0_rule,
  /*  221 */  mRegL_rule,
  /*  222 */  immL_0_rule,
  /*  223 */  immL_rule,
  /*  224 */  regF_rule,
  /*  225 */  regD_rule,
  /*  226 */  _CmpI_mRegI_mRegI_rule,
  /*  227 */  mRegI_rule,
  /*  228 */  _CmpP_mRegP_mRegP_rule,
  /*  229 */  _CmpN_mRegN_mRegN_rule,
  /*  230 */  _CmpU_mRegI_mRegI_rule,
  /*  231 */  mRegP_rule,
  /*  232 */  _CmpF_regF_regF_rule,
  /*  233 */  mRegN_rule,
  /*  234 */  _CmpD_regD_regD_rule,
  /*  235 */  _CmpL_mRegL_mRegL_rule,
  /*  236 */  mRegL_rule,
  /*  237 */  regD_rule,
  /*  238 */  regF_rule,
  /*  239 */  _CmpP_mRegP_mRegP_rule,
  /*  240 */  mA5RegI_rule,
  /*  241 */  mA7RegI_rule,
  /*  242 */  a5_RegP_rule,
  /*  243 */  immI_1_4_rule,
  /*  244 */  immI_1_4_rule,
  /*  245 */  mRegI_rule,
  /*  246 */  regF_rule,
  /*  247 */  regD_rule,
  /*  248 */  0,
  /*  249 */  0,
  /*  250 */  immI_M1_rule,
  /*  251 */  immL_0_4095_rule,
  /*  252 */  0,
  /*  253 */  immI_16_rule,
  /*  254 */  immL_7_rule,
  /*  255 */  0,
  /*  256 */  immI_16_rule,
  /*  257 */  immI_0_32767_rule,
  /*  258 */  immI_16_rule,
  /*  259 */  immI_24_rule,
  /*  260 */  immI_32_63_rule,
  /*  261 */  immI_0_31_rule,
  /*  262 */  0,
  /*  263 */  immI_32_63_rule,
  /*  264 */  immI_0_31_rule,
  /*  265 */  immI_1_rule,
  /*  266 */  immI_0_31_rule,
  /*  267 */  immI_0_31_rule,
  /*  268 */  immI_32_63_rule,
  /*  269 */  immI_0_31_rule,
  /*  270 */  0,
  /*  271 */  mRegL_rule,
  /*  272 */  mRegI_rule,
  /*  273 */  mRegL_rule,
  /*  274 */  mRegP_rule,
  /*  275 */  mRegN_rule,
  /*  276 */  immL_MaxUI_rule,
  /*  277 */  immI_32_rule,
  /*  278 */  0,
  /*  279 */  0,
  // last internally defined operand
  /*  280 */  0,
  /*  281 */  0,
  /*  282 */  0,
  /*  283 */  0,
  /*  284 */  0,
  /*  285 */  0,
  /*  286 */  0,
  /*  287 */  0,
  /*  288 */  0,
  /*  289 */  0,
  /*  290 */  0,
  /*  291 */  0,
  /*  292 */  0,
  /*  293 */  0,
  /*  294 */  0,
  /*  295 */  0,
  /*  296 */  0,
  /*  297 */  0,
  /*  298 */  0,
  /*  299 */  0,
  /*  300 */  0,
  /*  301 */  0,
  /*  302 */  0,
  /*  303 */  0,
  /*  304 */  0,
  /*  305 */  0,
  /*  306 */  0,
  /*  307 */  0,
  /*  308 */  0,
  /*  309 */  0,
  /*  310 */  0,
  /*  311 */  0,
  /*  312 */  0,
  /*  313 */  0,
  /*  314 */  0,
  /*  315 */  0,
  /*  316 */  0,
  /*  317 */  0,
  /*  318 */  0,
  /*  319 */  0,
  /*  320 */  0,
  /*  321 */  0,
  /*  322 */  0,
  /*  323 */  s0_RegP_rule,
  /*  324 */  s0_RegP_rule,
  /*  325 */  _Binary_mRegP_mRegP_rule,
  /*  326 */  _Binary_mRegI_mRegI_rule,
  /*  327 */  _Binary_t2RegL_mRegL_rule,
  /*  328 */  0,
  /*  329 */  0,
  /*  330 */  0,
  /*  331 */  0,
  /*  332 */  0,
  /*  333 */  0,
  /*  334 */  0,
  /*  335 */  0,
  /*  336 */  immI_24_rule,
  /*  337 */  immI_255_rule,
  /*  338 */  immI_16_rule,
  /*  339 */  immI_65535_rule,
  /*  340 */  0,
  /*  341 */  0,
  /*  342 */  mRegL_rule,
  /*  343 */  immL_0_rule,
  /*  344 */  immL_rule,
  /*  345 */  0,
  /*  346 */  0,
  /*  347 */  0,
  /*  348 */  0,
  /*  349 */  0,
  /*  350 */  0,
  /*  351 */  0,
  /*  352 */  mRegP_rule,
  /*  353 */  immP_0_rule,
  /*  354 */  immI8_rule,
  /*  355 */  mRegN_rule,
  /*  356 */  _EncodeP_mRegP__rule,
  /*  357 */  mRegN_rule,
  /*  358 */  _EncodePKlass_mRegP__rule,
  /*  359 */  immN_0_rule,
  /*  360 */  mRegI_rule,
  /*  361 */  _ConvL2I_mRegL__rule,
  /*  362 */  0,
  /*  363 */  0,
  /*  364 */  0,
  /*  365 */  0,
  /*  366 */  0,
  /*  367 */  immI_24_rule,
  /*  368 */  0,
  /*  369 */  immI_rule,
  /*  370 */  mRegI_rule,
  /*  371 */  _ConvL2I_mRegL__rule,
  /*  372 */  0,
  /*  373 */  mRegP_rule,
  /*  374 */  0,
  /*  375 */  0,
  /*  376 */  0,
  /*  377 */  _CmpI_mRegI_mRegI_rule,
  /*  378 */  _CmpI_mRegI_immI_rule,
  /*  379 */  FlagsReg_rule,
  /*  380 */  _CmpP_mRegP_immP_0_rule,
  /*  381 */  _CmpP__DecodeN_mRegN__immP_0_rule,
  /*  382 */  _CmpP_mRegP_mRegP_rule,
  /*  383 */  _CmpN_mRegN_immN_0_rule,
  /*  384 */  _CmpN_mRegN_mRegN_rule,
  /*  385 */  _CmpU_mRegI_mRegI_rule,
  /*  386 */  _CmpU_mRegI_immI_rule,
  /*  387 */  _CmpI_mRegI_mRegI_rule,
  /*  388 */  _CmpI_mRegI_immI_0_rule,
  /*  389 */  _CmpI_mRegI_immI_rule,
  /*  390 */  _CmpU_mRegI_immI_0_rule,
  /*  391 */  _CmpL_mRegL_mRegL_rule,
  /*  392 */  _CmpL_mRegL_immL_0_rule,
  /*  393 */  _CmpL_mRegL_immL_rule,
  /*  394 */  _CmpF_regF_regF_rule,
  /*  395 */  _CmpD_regD_regD_rule,
  /*  396 */  0,
  /*  397 */  _CmpI_mRegI_mRegI_rule,
  /*  398 */  _CmpI_mRegI_immI_rule,
  /*  399 */  FlagsReg_rule,
  /*  400 */  _CmpP_mRegP_immP_0_rule,
  /*  401 */  _CmpP__DecodeN_mRegN__immP_0_rule,
  /*  402 */  _CmpP_mRegP_mRegP_rule,
  /*  403 */  _CmpN_mRegN_immN_0_rule,
  /*  404 */  _CmpN_mRegN_mRegN_rule,
  /*  405 */  _CmpU_mRegI_mRegI_rule,
  /*  406 */  _CmpU_mRegI_immI_rule,
  /*  407 */  _CmpI_mRegI_mRegI_rule,
  /*  408 */  _CmpI_mRegI_immI_0_rule,
  /*  409 */  _CmpI_mRegI_immI_rule,
  /*  410 */  _CmpU_mRegI_immI_0_rule,
  /*  411 */  _CmpL_mRegL_mRegL_rule,
  /*  412 */  _CmpL_mRegL_immL_0_rule,
  /*  413 */  _CmpL_mRegL_immL_rule,
  /*  414 */  _CmpF_regF_regF_rule,
  /*  415 */  _CmpD_regD_regD_rule,
  /*  416 */  0,
  /*  417 */  0,
  /*  418 */  0,
  /*  419 */  0,
  /*  420 */  0,
  /*  421 */  0,
  /*  422 */  0,
  /*  423 */  0,
  /*  424 */  0,
  /*  425 */  0,
  /*  426 */  _Binary_mRegI_mRegI_rule,
  /*  427 */  _Binary_mRegI_mRegI_rule,
  /*  428 */  _Binary_mRegI_mRegI_rule,
  /*  429 */  _Binary_mRegP_mRegP_rule,
  /*  430 */  _Binary_mRegP_mRegP_rule,
  /*  431 */  _Binary_mRegP_mRegP_rule,
  /*  432 */  _Binary_mRegN_mRegN_rule,
  /*  433 */  _Binary_mRegP_mRegP_rule,
  /*  434 */  _Binary_mRegN_mRegN_rule,
  /*  435 */  _Binary_mRegI_mRegI_rule,
  /*  436 */  _Binary_mRegI_mRegI_rule,
  /*  437 */  _Binary_mRegP_mRegP_rule,
  /*  438 */  _Binary_mRegI_mRegI_rule,
  /*  439 */  _Binary_mRegP_mRegP_rule,
  /*  440 */  _Binary_mRegP_mRegP_rule,
  /*  441 */  _Binary_mRegL_mRegL_rule,
  /*  442 */  _Binary_mRegN_mRegN_rule,
  /*  443 */  _Binary_mRegN_mRegN_rule,
  /*  444 */  _Binary_mRegN_mRegN_rule,
  /*  445 */  _Binary_mRegL_mRegL_rule,
  /*  446 */  _Binary_mRegL_mRegL_rule,
  /*  447 */  _Binary_mRegL_mRegL_rule,
  /*  448 */  _Binary_mRegL_mRegL_rule,
  /*  449 */  _Binary_mRegL_mRegL_rule,
  /*  450 */  _Binary_mRegL_mRegL_rule,
  /*  451 */  _Binary_regD_regD_rule,
  /*  452 */  _Binary_regF_regF_rule,
  /*  453 */  _Binary_regD_regD_rule,
  /*  454 */  _Binary_regD_regD_rule,
  /*  455 */  _Binary_mRegI_mRegI_rule,
  /*  456 */  _Binary_regF_regF_rule,
  /*  457 */  mRegL_rule,
  /*  458 */  regF_rule,
  /*  459 */  regD_rule,
  /*  460 */  mRegP_rule,
  /*  461 */  _Binary_a6_RegP_mA7RegI_rule,
  /*  462 */  mA6RegI_rule,
  /*  463 */  mRegI_rule,
  /*  464 */  immI_rule,
  /*  465 */  _LShiftI_mRegI_immI_1_4_rule,
  /*  466 */  mRegI_rule,
  /*  467 */  mRegL_rule,
  /*  468 */  _ConvI2L_mRegI__rule,
  /*  469 */  immL_rule,
  /*  470 */  _LShiftL__ConvI2L_mRegI__immI_1_4_rule,
  /*  471 */  mRegL_rule,
  /*  472 */  immL12_rule,
  /*  473 */  immL12_rule,
  /*  474 */  mRegL_rule,
  /*  475 */  _ConvI2L_mRegI__rule,
  /*  476 */  _ConvI2L_mRegI__rule,
  /*  477 */  _ConvI2L_mRegI__rule,
  /*  478 */  _ConvI2L_mRegI__rule,
  /*  479 */  mRegL_rule,
  /*  480 */  mRegI_rule,
  /*  481 */  immI_M2047_2048_rule,
  /*  482 */  mRegI_rule,
  /*  483 */  mRegL_rule,
  /*  484 */  immL_M2047_2048_rule,
  /*  485 */  mRegL_rule,
  /*  486 */  _ConvI2L_mRegI__rule,
  /*  487 */  mRegL_rule,
  /*  488 */  _ConvI2L_mRegI__rule,
  /*  489 */  mRegI_rule,
  /*  490 */  mRegL_rule,
  /*  491 */  mRegI_rule,
  /*  492 */  mRegI_rule,
  /*  493 */  _MulI_mRegI_mRegI_rule,
  /*  494 */  mRegI_rule,
  /*  495 */  regF_rule,
  /*  496 */  regD_rule,
  /*  497 */  mRegL_rule,
  /*  498 */  _ConvI2L_mRegI__rule,
  /*  499 */  mRegL_rule,
  /*  500 */  mRegL_rule,
  /*  501 */  regF_rule,
  /*  502 */  regF_rule,
  /*  503 */  regD_rule,
  /*  504 */  regD_rule,
  /*  505 */  regF_rule,
  /*  506 */  regF_rule,
  /*  507 */  _MulF_regF_regF_rule,
  /*  508 */  regD_rule,
  /*  509 */  regD_rule,
  /*  510 */  _MulD_regD_regD_rule,
  /*  511 */  0,
  /*  512 */  0,
  /*  513 */  immI_rule,
  /*  514 */  immI_0_4095_rule,
  /*  515 */  immI_nonneg_mask_rule,
  /*  516 */  immL_nonneg_mask_rule,
  /*  517 */  immI_0_4095_rule,
  /*  518 */  immI_M1_rule,
  /*  519 */  immI_M1_rule,
  /*  520 */  immL_0_4095_rule,
  /*  521 */  _LoadB_memory__rule,
  /*  522 */  immI_255_rule,
  /*  523 */  immI_255_rule,
  /*  524 */  mRegI_rule,
  /*  525 */  _XorI_mRegI_immI_M1_rule,
  /*  526 */  mRegI_rule,
  /*  527 */  _XorI_mRegI_immI_M1_rule,
  /*  528 */  mRegI_rule,
  /*  529 */  mRegI_rule,
  /*  530 */  _XorI_mRegI_immI_M1_rule,
  /*  531 */  mRegI_rule,
  /*  532 */  _XorI_mRegI_immI_M1_rule,
  /*  533 */  mRegL_rule,
  /*  534 */  _ConvI2L_mRegI__rule,
  /*  535 */  mRegL_rule,
  /*  536 */  immL_0_4095_rule,
  /*  537 */  0,
  /*  538 */  immL_M8_rule,
  /*  539 */  immL_M5_rule,
  /*  540 */  immL_M7_rule,
  /*  541 */  immL_M4_rule,
  /*  542 */  immL_M121_rule,
  /*  543 */  mRegL_rule,
  /*  544 */  mRegL_rule,
  /*  545 */  _CastP2X_mRegP__rule,
  /*  546 */  mRegL_rule,
  /*  547 */  immI8_rule,
  /*  548 */  immI8_rule,
  /*  549 */  immI_M65536_rule,
  /*  550 */  immI_16_rule,
  /*  551 */  immI_16_rule,
  /*  552 */  immI_16_rule,
  /*  553 */  immI_24_rule,
  /*  554 */  immI8_rule,
  /*  555 */  mRegI_rule,
  /*  556 */  immI8_rule,
  /*  557 */  immI8_rule,
  /*  558 */  mRegI_rule,
  /*  559 */  immI8_rule,
  /*  560 */  0,
  /*  561 */  mRegI_rule,
  /*  562 */  mRegI_rule,
  /*  563 */  immI_0_31_rule,
  /*  564 */  immI_MaxI_rule,
  /*  565 */  immI_0_31_rule,
  /*  566 */  immI_32_63_rule,
  /*  567 */  0,
  /*  568 */  immI_32_63_rule,
  /*  569 */  mRegI_rule,
  /*  570 */  mRegI_rule,
  /*  571 */  _LShiftI__AndI_mRegI_immI_1_immI_0_31_rule,
  /*  572 */  _URShiftI_mRegI_immI_0_31_rule,
  /*  573 */  _CastP2X_mRegP__rule,
  /*  574 */  mRegL_rule,
  /*  575 */  immI8_rule,
  /*  576 */  immI_nonneg_mask_rule,
  /*  577 */  _URShiftI_mRegI_immI_0_31_rule,
  /*  578 */  _LShiftI_mRegI_immI_0_31_rule,
  /*  579 */  _URShiftL_mRegL_immI_0_31_rule,
  /*  580 */  _LShiftL_mRegL_immI_32_63_rule,
  /*  581 */  _URShiftL_mRegL_immI_32_63_rule,
  /*  582 */  _LShiftL_mRegL_immI_0_31_rule,
  /*  583 */  _LShiftI_mRegI_immI_0_31_rule,
  /*  584 */  _URShiftI_mRegI_immI_0_31_rule,
  /*  585 */  _LShiftL_mRegL_immI_32_63_rule,
  /*  586 */  _URShiftL_mRegL_immI_0_31_rule,
  /*  587 */  _LShiftL_mRegL_immI_0_31_rule,
  /*  588 */  _URShiftL_mRegL_immI_32_63_rule,
  /*  589 */  mRegI_rule,
  /*  590 */  immI8_rule,
  /*  591 */  mRegI_rule,
  /*  592 */  0,
  /*  593 */  0,
  /*  594 */  0,
  /*  595 */  0,
  /*  596 */  0,
  /*  597 */  0,
  /*  598 */  0,
  /*  599 */  0,
  /*  600 */  0,
  /*  601 */  0,
  /*  602 */  0,
  /*  603 */  0,
  /*  604 */  immI_0_rule,
  /*  605 */  mRegI_rule,
  /*  606 */  0,
  /*  607 */  0,
  /*  608 */  0,
  /*  609 */  0,
  /*  610 */  0,
  /*  611 */  0,
  /*  612 */  0,
  /*  613 */  0,
  /*  614 */  0,
  /*  615 */  0,
  /*  616 */  0,
  /*  617 */  0,
  /*  618 */  0,
  /*  619 */  mRegP_rule,
  /*  620 */  0,
  /*  621 */  0,
  /*  622 */  0,
  /*  623 */  0,
  /*  624 */  0,
  /*  625 */  0,
  /*  626 */  0,
  /*  627 */  0,
  /*  628 */  0,
  /*  629 */  mRegI_rule,
  /*  630 */  immI_0_rule,
  /*  631 */  regF_rule,
  /*  632 */  immF_0_rule,
  /*  633 */  0,
  /*  634 */  0,
  /*  635 */  regD_rule,
  /*  636 */  immD_0_rule,
  /*  637 */  immI8_rule,
  /*  638 */  0,
  /*  639 */  no_T8_mRegP_rule,
  /*  640 */  0,
  /*  641 */  _Binary_mS2RegI_mRegI_rule,
  /*  642 */  _Binary_s2RegL_mRegL_rule,
  /*  643 */  _Binary_s2_RegP_mRegP_rule,
  /*  644 */  _Binary_t2_RegN_mRegN_rule,
  /*  645 */  mRegI_rule,
  /*  646 */  mRegI_rule,
  /*  647 */  immI_0_rule,
  /*  648 */  immL_MaxUI_rule,
  /*  649 */  _LShiftL__ConvI2L_mRegI__immI_32_rule,
  /*  650 */  _AndL__ConvI2L_mRegI__immL_MaxUI_rule,
  /*  651 */  immL_MaxUI_rule,
  /*  652 */  immL_MaxUI_rule,
  /*  653 */  immL_MaxUI_rule,
  /*  654 */  _ConvI2L__LoadI_memory___rule,
  /*  655 */  immL_MaxUI_rule,
  /*  656 */  0,
  /*  657 */  0,
  /*  658 */  0,
  /*  659 */  vecD_rule,
  /*  660 */  0,
  /*  661 */  0,
  /*  662 */  0,
  /*  663 */  0,
  /*  664 */  0,
  /*  665 */  0,
  /*  666 */  0,
  /*  667 */  0,
  /*  668 */  0,
  /*  669 */  0,
  /*  670 */  0,
  /*  671 */  0,
  /*  672 */  0,
  /*  673 */  0,
  /*  674 */  0,
  /*  675 */  0,
  /*  676 */  0,
  /*  677 */  0,
  /*  678 */  vecD_rule,
  /*  679 */  vecD_rule,
  /*  680 */  vecD_rule,
  /*  681 */  vecD_rule,
  /*  682 */  vecD_rule,
  // last instruction
  0 // no trailing comma
};

const char        *ruleName[] = {
  /*    0 */  "UNIVERSE",
  /*    1 */  "LABEL",
  /*    2 */  "SREGI",
  /*    3 */  "SREGP",
  /*    4 */  "SREGF",
  /*    5 */  "SREGD",
  /*    6 */  "SREGL",
  /*    7 */  "METHOD",
  /*    8 */  "VECD",
  /*    9 */  "FLAGSREG",
  /*   10 */  "IMMI",
  /*   11 */  "IMMI8",
  /*   12 */  "IMMI_M65536",
  /*   13 */  "IMMI_M1",
  /*   14 */  "IMMI_0",
  /*   15 */  "IMMI_1",
  /*   16 */  "IMMI_16",
  /*   17 */  "IMMI_24",
  /*   18 */  "IMMI_32",
  /*   19 */  "IMMI_255",
  /*   20 */  "IMMI_65535",
  /*   21 */  "IMMI_MAXI",
  /*   22 */  "IMMI_M2047_2048",
  /*   23 */  "IMMI_0_3",
  /*   24 */  "IMMI_0_31",
  /*   25 */  "IMMI_0_4095",
  /*   26 */  "IMMI_0_32767",
  /*   27 */  "IMMI_1_4",
  /*   28 */  "IMMI_32_63",
  /*   29 */  "IMMI_NONNEG_MASK",
  /*   30 */  "IMML",
  /*   31 */  "IMML8",
  /*   32 */  "IMML12",
  /*   33 */  "IMML32",
  /*   34 */  "IMML_M121",
  /*   35 */  "IMML_M8",
  /*   36 */  "IMML_M7",
  /*   37 */  "IMML_M5",
  /*   38 */  "IMML_M4",
  /*   39 */  "IMML_0",
  /*   40 */  "IMML_7",
  /*   41 */  "IMML_MAXUI",
  /*   42 */  "IMML_M2047_2048",
  /*   43 */  "IMML_0_4095",
  /*   44 */  "IMML_NONNEG_MASK",
  /*   45 */  "IMMP",
  /*   46 */  "IMMP_0",
  /*   47 */  "IMMP_NO_OOP_CHEAP",
  /*   48 */  "IMMP_POLL",
  /*   49 */  "IMMN",
  /*   50 */  "IMMN_0",
  /*   51 */  "IMMNKLASS",
  /*   52 */  "IMMF",
  /*   53 */  "IMMF_0",
  /*   54 */  "IMMD",
  /*   55 */  "IMMD_0",
  /*   56 */  "MREGI",
  /*   57 */  "NO_AX_MREGI",
  /*   58 */  "MS0REGI",
  /*   59 */  "MS1REGI",
  /*   60 */  "MS2REGI",
  /*   61 */  "MS3REGI",
  /*   62 */  "MS4REGI",
  /*   63 */  "MS5REGI",
  /*   64 */  "MS6REGI",
  /*   65 */  "MS7REGI",
  /*   66 */  "MT0REGI",
  /*   67 */  "MT1REGI",
  /*   68 */  "MT2REGI",
  /*   69 */  "MT3REGI",
  /*   70 */  "MT8REGI",
  /*   71 */  "MT4REGI",
  /*   72 */  "MA0REGI",
  /*   73 */  "MA1REGI",
  /*   74 */  "MA2REGI",
  /*   75 */  "MA3REGI",
  /*   76 */  "MA4REGI",
  /*   77 */  "MA5REGI",
  /*   78 */  "MA6REGI",
  /*   79 */  "MA7REGI",
  /*   80 */  "MREGN",
  /*   81 */  "T0_REGN",
  /*   82 */  "T1_REGN",
  /*   83 */  "T2_REGN",
  /*   84 */  "T3_REGN",
  /*   85 */  "T8_REGN",
  /*   86 */  "A0_REGN",
  /*   87 */  "A1_REGN",
  /*   88 */  "A2_REGN",
  /*   89 */  "A3_REGN",
  /*   90 */  "A4_REGN",
  /*   91 */  "A5_REGN",
  /*   92 */  "A6_REGN",
  /*   93 */  "A7_REGN",
  /*   94 */  "S0_REGN",
  /*   95 */  "S1_REGN",
  /*   96 */  "S2_REGN",
  /*   97 */  "S3_REGN",
  /*   98 */  "S4_REGN",
  /*   99 */  "S5_REGN",
  /*  100 */  "S6_REGN",
  /*  101 */  "S7_REGN",
  /*  102 */  "MREGP",
  /*  103 */  "NO_T8_MREGP",
  /*  104 */  "NO_AX_MREGP",
  /*  105 */  "S0_REGP",
  /*  106 */  "S1_REGP",
  /*  107 */  "S2_REGP",
  /*  108 */  "S3_REGP",
  /*  109 */  "S4_REGP",
  /*  110 */  "S5_REGP",
  /*  111 */  "S6_REGP",
  /*  112 */  "S7_REGP",
  /*  113 */  "T0_REGP",
  /*  114 */  "T1_REGP",
  /*  115 */  "T2_REGP",
  /*  116 */  "T3_REGP",
  /*  117 */  "T8_REGP",
  /*  118 */  "A0_REGP",
  /*  119 */  "A1_REGP",
  /*  120 */  "A2_REGP",
  /*  121 */  "A3_REGP",
  /*  122 */  "A4_REGP",
  /*  123 */  "A5_REGP",
  /*  124 */  "A6_REGP",
  /*  125 */  "A7_REGP",
  /*  126 */  "V0_REGP",
  /*  127 */  "V1_REGP",
  /*  128 */  "MREGL",
  /*  129 */  "V0REGL",
  /*  130 */  "V1REGL",
  /*  131 */  "A0REGL",
  /*  132 */  "A1REGL",
  /*  133 */  "A2REGL",
  /*  134 */  "A3REGL",
  /*  135 */  "T0REGL",
  /*  136 */  "T1REGL",
  /*  137 */  "T2REGL",
  /*  138 */  "T3REGL",
  /*  139 */  "T8REGL",
  /*  140 */  "A4REGL",
  /*  141 */  "A5REGL",
  /*  142 */  "A6REGL",
  /*  143 */  "A7REGL",
  /*  144 */  "S0REGL",
  /*  145 */  "S1REGL",
  /*  146 */  "S2REGL",
  /*  147 */  "S3REGL",
  /*  148 */  "S4REGL",
  /*  149 */  "S7REGL",
  /*  150 */  "REGF",
  /*  151 */  "REGD",
  /*  152 */  "INDIRECT",
  /*  153 */  "INDOFFSET8",
  /*  154 */  "INDINDEXSCALE",
  /*  155 */  "BASEINDEXOFFSET8",
  /*  156 */  "BASEINDEXOFFSET8_CONVI2L",
  /*  157 */  "INDINDEXSCALEOFFSET8",
  /*  158 */  "INDINDEXSCALEOFFSET8_CONVI2L",
  /*  159 */  "BASEPOSINDEXSCALEOFFSET8",
  /*  160 */  "INDINDEXSCALEOFFSETNARROW",
  /*  161 */  "INDPOSINDEXI2LSCALEOFFSET8NARROW",
  /*  162 */  "INDOFFSET32",
  /*  163 */  "INDINDEX",
  /*  164 */  "INDIRECTNARROWKLASS",
  /*  165 */  "INDOFFSET8NARROWKLASS",
  /*  166 */  "INDOFFSET32NARROWKLASS",
  /*  167 */  "INDINDEXOFFSETNARROWKLASS",
  /*  168 */  "INDINDEXNARROWKLASS",
  /*  169 */  "INDIRECTNARROW",
  /*  170 */  "INDOFFSET8NARROW",
  /*  171 */  "INDINDEXOFFSET8NARROW",
  /*  172 */  "LOAD_LONG_REGP",
  /*  173 */  "LOAD_LONG_INDIRECT",
  /*  174 */  "LOAD_LONG_INDOFFSET32",
  /*  175 */  "CMPOP",
  /*  176 */  "CMPOPU",
  /*  177 */  "STACKSLOTP",
  /*  178 */  "STACKSLOTI",
  /*  179 */  "STACKSLOTF",
  /*  180 */  "STACKSLOTD",
  /*  181 */  "STACKSLOTL",
  // last operand
  /*  182 */  "MEMORY",
  // last operand class
  /*  183 */  "_LShiftL_mRegL_immI_0_3",
  /*  184 */  "_AddP_mRegP_mRegL",
  /*  185 */  "_ConvI2L_mRegI_",
  /*  186 */  "_AddP_mRegP__ConvI2L_mRegI_",
  /*  187 */  "_AddP_mRegP__LShiftL_mRegL_immI_0_3",
  /*  188 */  "_LShiftL__ConvI2L_mRegI__immI_0_3",
  /*  189 */  "_AddP_mRegP__LShiftL__ConvI2L_mRegI__immI_0_3",
  /*  190 */  "_LShiftL__ConvI2L_mRegI__immI_0_31",
  /*  191 */  "_AddP_mRegP__LShiftL__ConvI2L_mRegI__immI_0_31",
  /*  192 */  "_DecodeN_mRegN_",
  /*  193 */  "_AddP__DecodeN_mRegN___LShiftL_mRegL_immI_0_3",
  /*  194 */  "_AddP__DecodeN_mRegN___LShiftL__ConvI2L_mRegI__immI_0_31",
  /*  195 */  "_DecodeNKlass_mRegN_",
  /*  196 */  "_AddP__DecodeNKlass_mRegN__mRegL",
  /*  197 */  "_AddP__DecodeN_mRegN__mRegL",
  /*  198 */  "_LoadI_memory_",
  /*  199 */  "_LShiftI__LoadI_memory__immI_24",
  /*  200 */  "_LShiftI__LoadI_memory__immI_16",
  /*  201 */  "_LoadN_memory_",
  /*  202 */  "_LoadNKlass_memory_",
  /*  203 */  "_EncodeP_mRegP_",
  /*  204 */  "_EncodePKlass_mRegP_",
  /*  205 */  "_ConvL2I_mRegL_",
  /*  206 */  "_LoadB_memory_",
  /*  207 */  "_LoadUB_memory_",
  /*  208 */  "_LoadS_memory_",
  /*  209 */  "_LShiftI__LoadS_memory__immI_24",
  /*  210 */  "_CmpI_mRegI_mRegI",
  /*  211 */  "_CmpI_mRegI_immI",
  /*  212 */  "_CmpP_mRegP_immP_0",
  /*  213 */  "_CmpP__DecodeN_mRegN__immP_0",
  /*  214 */  "_CmpP_mRegP_mRegP",
  /*  215 */  "_CmpN_mRegN_immN_0",
  /*  216 */  "_CmpN_mRegN_mRegN",
  /*  217 */  "_CmpU_mRegI_mRegI",
  /*  218 */  "_CmpU_mRegI_immI",
  /*  219 */  "_CmpI_mRegI_immI_0",
  /*  220 */  "_CmpU_mRegI_immI_0",
  /*  221 */  "_CmpL_mRegL_mRegL",
  /*  222 */  "_CmpL_mRegL_immL_0",
  /*  223 */  "_CmpL_mRegL_immL",
  /*  224 */  "_CmpF_regF_regF",
  /*  225 */  "_CmpD_regD_regD",
  /*  226 */  "_Binary_cmpOp__CmpI_mRegI_mRegI",
  /*  227 */  "_Binary_mRegI_mRegI",
  /*  228 */  "_Binary_cmpOpU__CmpP_mRegP_mRegP",
  /*  229 */  "_Binary_cmpOpU__CmpN_mRegN_mRegN",
  /*  230 */  "_Binary_cmpOpU__CmpU_mRegI_mRegI",
  /*  231 */  "_Binary_mRegP_mRegP",
  /*  232 */  "_Binary_cmpOp__CmpF_regF_regF",
  /*  233 */  "_Binary_mRegN_mRegN",
  /*  234 */  "_Binary_cmpOp__CmpD_regD_regD",
  /*  235 */  "_Binary_cmpOp__CmpL_mRegL_mRegL",
  /*  236 */  "_Binary_mRegL_mRegL",
  /*  237 */  "_Binary_regD_regD",
  /*  238 */  "_Binary_regF_regF",
  /*  239 */  "_Binary_cmpOp__CmpP_mRegP_mRegP",
  /*  240 */  "_Binary_a4_RegP_mA5RegI",
  /*  241 */  "_Binary_a6_RegP_mA7RegI",
  /*  242 */  "_Binary_a4_RegP_a5_RegP",
  /*  243 */  "_LShiftI_mRegI_immI_1_4",
  /*  244 */  "_LShiftL__ConvI2L_mRegI__immI_1_4",
  /*  245 */  "_MulI_mRegI_mRegI",
  /*  246 */  "_MulF_regF_regF",
  /*  247 */  "_MulD_regD_regD",
  /*  248 */  "_ConvF2D_regF_",
  /*  249 */  "_SqrtD__ConvF2D_regF__",
  /*  250 */  "_XorI_mRegI_immI_M1",
  /*  251 */  "_AndL_mRegL_immL_0_4095",
  /*  252 */  "_CastP2X_mRegP_",
  /*  253 */  "_LShiftI_mRegI_immI_16",
  /*  254 */  "_AndL_mRegL_immL_7",
  /*  255 */  "_ConvL2I__AndL_mRegL_immL_7_",
  /*  256 */  "_LShiftI__ConvL2I__AndL_mRegL_immL_7__immI_16",
  /*  257 */  "_OrI_mRegI_immI_0_32767",
  /*  258 */  "_LShiftI__OrI_mRegI_immI_0_32767_immI_16",
  /*  259 */  "_LShiftI_mRegI_immI_24",
  /*  260 */  "_RShiftL_mRegL_immI_32_63",
  /*  261 */  "_URShiftL_mRegL_immI_0_31",
  /*  262 */  "_ConvL2I__URShiftL_mRegL_immI_0_31_",
  /*  263 */  "_URShiftL_mRegL_immI_32_63",
  /*  264 */  "_URShiftI_mRegI_immI_0_31",
  /*  265 */  "_AndI_mRegI_immI_1",
  /*  266 */  "_LShiftI__AndI_mRegI_immI_1_immI_0_31",
  /*  267 */  "_LShiftI_mRegI_immI_0_31",
  /*  268 */  "_LShiftL_mRegL_immI_32_63",
  /*  269 */  "_LShiftL_mRegL_immI_0_31",
  /*  270 */  "_LoadUS_memory_",
  /*  271 */  "_Binary_t2RegL_mRegL",
  /*  272 */  "_Binary_mS2RegI_mRegI",
  /*  273 */  "_Binary_s2RegL_mRegL",
  /*  274 */  "_Binary_s2_RegP_mRegP",
  /*  275 */  "_Binary_t2_RegN_mRegN",
  /*  276 */  "_AndL__ConvI2L_mRegI__immL_MaxUI",
  /*  277 */  "_LShiftL__ConvI2L_mRegI__immI_32",
  /*  278 */  "_ConvI2L__ConvL2I_mRegL__",
  /*  279 */  "_ConvI2L__LoadI_memory__",
  // last internally defined operand
  /*  280 */  "storeSSI",
  /*  281 */  "storeSSL",
  /*  282 */  "storeSSP",
  /*  283 */  "storeSSF",
  /*  284 */  "storeSSD",
  /*  285 */  "loadConI",
  /*  286 */  "loadConL_set64",
  /*  287 */  "loadConL12",
  /*  288 */  "loadConL_immL_0",
  /*  289 */  "loadConP_general",
  /*  290 */  "loadConP_no_oop_cheap",
  /*  291 */  "loadConP_poll",
  /*  292 */  "loadConP_immP_0",
  /*  293 */  "loadConN_immN_0",
  /*  294 */  "loadConN",
  /*  295 */  "loadConNKlass",
  /*  296 */  "loadConF_immF_0",
  /*  297 */  "loadConF",
  /*  298 */  "loadConD_immD_0",
  /*  299 */  "loadConD",
  /*  300 */  "loadSSI",
  /*  301 */  "loadSSL",
  /*  302 */  "loadSSP",
  /*  303 */  "loadSSF",
  /*  304 */  "loadSSD",
  /*  305 */  "leaP8Narrow",
  /*  306 */  "leaPPosIdxScaleOff8",
  /*  307 */  "leaPIdxScale",
  /*  308 */  "castX2P",
  /*  309 */  "castP2X",
  /*  310 */  "MoveF2I_reg_reg",
  /*  311 */  "MoveI2F_reg_reg",
  /*  312 */  "MoveD2L_reg_reg",
  /*  313 */  "MoveL2D_reg_reg",
  /*  314 */  "negF_reg",
  /*  315 */  "negD_reg",
  /*  316 */  "absF_reg",
  /*  317 */  "absD_reg",
  /*  318 */  "convI2B",
  /*  319 */  "convP2B",
  /*  320 */  "checkCastPP",
  /*  321 */  "castPP",
  /*  322 */  "castII",
  /*  323 */  "cmpFastLock",
  /*  324 */  "cmpFastUnlock",
  /*  325 */  "storePConditional",
  /*  326 */  "storeIConditional",
  /*  327 */  "storeLConditional",
  /*  328 */  "roundFloat_nop",
  /*  329 */  "roundDouble_nop",
  /*  330 */  "countLeadingZerosI",
  /*  331 */  "countLeadingZerosL",
  /*  332 */  "countTrailingZerosI",
  /*  333 */  "countTrailingZerosL",
  /*  334 */  "loadI",
  /*  335 */  "loadI_convI2L",
  /*  336 */  "loadI2B",
  /*  337 */  "loadI2UB",
  /*  338 */  "loadI2S",
  /*  339 */  "loadI2US",
  /*  340 */  "loadL",
  /*  341 */  "loadL_unaligned",
  /*  342 */  "storeL_reg",
  /*  343 */  "storeL_immL_0",
  /*  344 */  "storeL_imm",
  /*  345 */  "loadN",
  /*  346 */  "loadN2P",
  /*  347 */  "loadP",
  /*  348 */  "loadKlass",
  /*  349 */  "loadNKlass",
  /*  350 */  "loadN2PKlass",
  /*  351 */  "loadRange",
  /*  352 */  "storeP",
  /*  353 */  "storeImmP_immP_0",
  /*  354 */  "storeImmB",
  /*  355 */  "storeN",
  /*  356 */  "storeP2N",
  /*  357 */  "storeNKlass",
  /*  358 */  "storeP2NKlass",
  /*  359 */  "storeImmN_immN_0",
  /*  360 */  "storeB",
  /*  361 */  "storeB_convL2I",
  /*  362 */  "loadB",
  /*  363 */  "loadB_convI2L",
  /*  364 */  "loadUB",
  /*  365 */  "loadUB_convI2L",
  /*  366 */  "loadS",
  /*  367 */  "loadS2B",
  /*  368 */  "loadS_convI2L",
  /*  369 */  "storeImmI",
  /*  370 */  "storeI",
  /*  371 */  "storeI_convL2I",
  /*  372 */  "loadF",
  /*  373 */  "TailCalljmpInd",
  /*  374 */  "CreateException",
  /*  375 */  "RethrowException",
  /*  376 */  "jmpDir_long",
  /*  377 */  "jmpLoopEnd_long",
  /*  378 */  "jmpLoopEnd_reg_immI_long",
  /*  379 */  "jmpCon_flags_long",
  /*  380 */  "branchConP_0_long",
  /*  381 */  "branchConN2P_0_long",
  /*  382 */  "branchConP_long",
  /*  383 */  "cmpN_null_branch_long",
  /*  384 */  "cmpN_reg_branch_long",
  /*  385 */  "branchConIU_reg_reg_long",
  /*  386 */  "branchConIU_reg_imm_long",
  /*  387 */  "branchConI_reg_reg_long",
  /*  388 */  "branchConI_reg_immI_0_long",
  /*  389 */  "branchConI_reg_imm_long",
  /*  390 */  "branchConIU_reg_immI_0_long",
  /*  391 */  "branchConL_regL_regL_long",
  /*  392 */  "branchConL_regL_immL_0_long",
  /*  393 */  "branchConL_regL_immL_long",
  /*  394 */  "branchConF_reg_reg_long",
  /*  395 */  "branchConD_reg_reg_long",
  /*  396 */  "jmpDir_short",
  /*  397 */  "jmpLoopEnd_short",
  /*  398 */  "jmpLoopEnd_reg_immI_short",
  /*  399 */  "jmpCon_flags_short",
  /*  400 */  "branchConP_0_short",
  /*  401 */  "branchConN2P_0_short",
  /*  402 */  "branchConP_short",
  /*  403 */  "cmpN_null_branch_short",
  /*  404 */  "cmpN_reg_branch_short",
  /*  405 */  "branchConIU_reg_reg_short",
  /*  406 */  "branchConIU_reg_imm_short",
  /*  407 */  "branchConI_reg_reg_short",
  /*  408 */  "branchConI_reg_immI_0_short",
  /*  409 */  "branchConI_reg_imm_short",
  /*  410 */  "branchConIU_reg_immI_0_short",
  /*  411 */  "branchConL_regL_regL_short",
  /*  412 */  "branchConL_regL_immL_0_short",
  /*  413 */  "branchConL_regL_immL_short",
  /*  414 */  "branchConF_reg_reg_short",
  /*  415 */  "branchConD_reg_reg_short",
  /*  416 */  "CallRuntimeDirect",
  /*  417 */  "membar_acquire",
  /*  418 */  "load_fence",
  /*  419 */  "membar_acquire_lock",
  /*  420 */  "membar_release",
  /*  421 */  "store_fence",
  /*  422 */  "membar_release_lock",
  /*  423 */  "membar_volatile",
  /*  424 */  "unnecessary_membar_volatile",
  /*  425 */  "membar_storestore",
  /*  426 */  "cmovI_cmpI_reg_reg",
  /*  427 */  "cmovI_cmpP_reg_reg",
  /*  428 */  "cmovI_cmpN_reg_reg",
  /*  429 */  "cmovP_cmpU_reg_reg",
  /*  430 */  "cmovP_cmpF_reg_reg",
  /*  431 */  "cmovP_cmpN_reg_reg",
  /*  432 */  "cmovN_cmpP_reg_reg",
  /*  433 */  "cmovP_cmpD_reg_reg",
  /*  434 */  "cmovN_cmpN_reg_reg",
  /*  435 */  "cmovI_cmpU_reg_reg",
  /*  436 */  "cmovI_cmpL_reg_reg",
  /*  437 */  "cmovP_cmpL_reg_reg",
  /*  438 */  "cmovI_cmpD_reg_reg",
  /*  439 */  "cmovP_cmpP_reg_reg",
  /*  440 */  "cmovP_cmpI_reg_reg",
  /*  441 */  "cmovL_cmpP_reg_reg",
  /*  442 */  "cmovN_cmpU_reg_reg",
  /*  443 */  "cmovN_cmpL_reg_reg",
  /*  444 */  "cmovN_cmpI_reg_reg",
  /*  445 */  "cmovL_cmpU_reg_reg",
  /*  446 */  "cmovL_cmpF_reg_reg",
  /*  447 */  "cmovL_cmpI_reg_reg",
  /*  448 */  "cmovL_cmpL_reg_reg",
  /*  449 */  "cmovL_cmpN_reg_reg",
  /*  450 */  "cmovL_cmpD_reg_reg",
  /*  451 */  "cmovD_cmpD_reg_reg",
  /*  452 */  "cmovF_cmpI_reg_reg",
  /*  453 */  "cmovD_cmpI_reg_reg",
  /*  454 */  "cmovD_cmpP_reg_reg",
  /*  455 */  "cmovI_cmpF_reg_reg",
  /*  456 */  "cmovF_cmpF_reg_reg",
  /*  457 */  "cmpL3_reg_reg",
  /*  458 */  "cmpF3_reg_reg",
  /*  459 */  "cmpD3_reg_reg",
  /*  460 */  "clear_array",
  /*  461 */  "string_compare",
  /*  462 */  "string_equals",
  /*  463 */  "addI_Reg_Reg",
  /*  464 */  "addI_Reg_imm",
  /*  465 */  "addI_salI_Reg_Reg_immI_1_4",
  /*  466 */  "addI_salI_Reg_Reg_immI_1_4_0",
  /*  467 */  "addP_reg_reg",
  /*  468 */  "addP_reg_reg_convI2L",
  /*  469 */  "addP_reg_imm",
  /*  470 */  "addP_salL_Reg_RegI2L_immI_1_4",
  /*  471 */  "addL_Reg_Reg",
  /*  472 */  "addL_Reg_imm",
  /*  473 */  "addL_RegI2L_imm",
  /*  474 */  "addL_RegI2L_Reg",
  /*  475 */  "addL_RegI2L_Reg_0",
  /*  476 */  "addL_RegI2L_RegI2L",
  /*  477 */  "addL_RegI2L_RegI2L_0",
  /*  478 */  "addL_Reg_RegI2L",
  /*  479 */  "addL_Reg_RegI2L_0",
  /*  480 */  "subI_Reg_Reg",
  /*  481 */  "subI_Reg_immI_M2047_2048",
  /*  482 */  "negI_Reg",
  /*  483 */  "negL_Reg",
  /*  484 */  "subL_Reg_immL_M2047_2048",
  /*  485 */  "subL_Reg_Reg",
  /*  486 */  "subL_Reg_RegI2L",
  /*  487 */  "subL_RegI2L_Reg",
  /*  488 */  "subL_RegI2L_RegI2L",
  /*  489 */  "modI_Reg_Reg",
  /*  490 */  "modL_reg_reg",
  /*  491 */  "mulI_Reg_Reg",
  /*  492 */  "maddI_Reg_Reg",
  /*  493 */  "maddI_Reg_Reg_0",
  /*  494 */  "divI_Reg_Reg",
  /*  495 */  "divF_Reg_Reg",
  /*  496 */  "divD_Reg_Reg",
  /*  497 */  "mulL_reg_reg",
  /*  498 */  "mulL_reg_regI2L",
  /*  499 */  "mulL_reg_regI2L_0",
  /*  500 */  "divL_reg_reg",
  /*  501 */  "addF_reg_reg",
  /*  502 */  "subF_reg_reg",
  /*  503 */  "addD_reg_reg",
  /*  504 */  "subD_reg_reg",
  /*  505 */  "mulF_reg_reg",
  /*  506 */  "maddF_reg_reg",
  /*  507 */  "maddF_reg_reg_0",
  /*  508 */  "mulD_reg_reg",
  /*  509 */  "maddD_reg_reg",
  /*  510 */  "maddD_reg_reg_0",
  /*  511 */  "sqrtD_reg",
  /*  512 */  "sqrtF_reg",
  /*  513 */  "andI_Reg_immI",
  /*  514 */  "andI_Reg_imm_0_4095",
  /*  515 */  "andI_Reg_immI_nonneg_mask",
  /*  516 */  "andL_Reg_immL_nonneg_mask",
  /*  517 */  "xorI_Reg_imm_0_4095",
  /*  518 */  "xorI_Reg_immI_M1",
  /*  519 */  "xorL2I_Reg_immI_M1",
  /*  520 */  "xorL_Reg_imm_0_4095",
  /*  521 */  "lbu_and_lmask",
  /*  522 */  "lbu_and_lmask_0",
  /*  523 */  "lbu_and_rmask",
  /*  524 */  "andI_Reg_Reg",
  /*  525 */  "andnI_Reg_nReg",
  /*  526 */  "andnI_Reg_nReg_0",
  /*  527 */  "ornI_Reg_nReg",
  /*  528 */  "ornI_Reg_nReg_0",
  /*  529 */  "andnI_nReg_Reg",
  /*  530 */  "andnI_nReg_Reg_0",
  /*  531 */  "ornI_nReg_Reg",
  /*  532 */  "ornI_nReg_Reg_0",
  /*  533 */  "andL_Reg_Reg",
  /*  534 */  "andL_Reg_Reg_convI2L",
  /*  535 */  "andL_Reg_Reg_convI2L_0",
  /*  536 */  "andL_Reg_imm_0_4095",
  /*  537 */  "andL2I_Reg_imm_0_4095",
  /*  538 */  "andL_Reg_immL_M8",
  /*  539 */  "andL_Reg_immL_M5",
  /*  540 */  "andL_Reg_immL_M7",
  /*  541 */  "andL_Reg_immL_M4",
  /*  542 */  "andL_Reg_immL_M121",
  /*  543 */  "orL_Reg_Reg",
  /*  544 */  "orL_Reg_P2XReg",
  /*  545 */  "orL_Reg_P2XReg_0",
  /*  546 */  "xorL_Reg_Reg",
  /*  547 */  "salI_Reg_imm",
  /*  548 */  "salL2I_Reg_imm",
  /*  549 */  "salI_Reg_imm_and_M65536",
  /*  550 */  "land7_2_s",
  /*  551 */  "ori2s",
  /*  552 */  "i2s",
  /*  553 */  "i2b",
  /*  554 */  "salI_RegL2I_imm",
  /*  555 */  "salI_Reg_Reg",
  /*  556 */  "salL_Reg_imm",
  /*  557 */  "salL_RegI2L_imm",
  /*  558 */  "salL_Reg_Reg",
  /*  559 */  "sarL_Reg_imm",
  /*  560 */  "sarL2I_Reg_immI_32_63",
  /*  561 */  "sarL_Reg_Reg",
  /*  562 */  "slrL_Reg_Reg",
  /*  563 */  "slrL_Reg_immI_0_31",
  /*  564 */  "slrL_Reg_immI_0_31_and_max_int",
  /*  565 */  "slrL_P2XReg_immI_0_31",
  /*  566 */  "slrL_Reg_immI_32_63",
  /*  567 */  "slrL_Reg_immI_convL2I",
  /*  568 */  "slrL_P2XReg_immI_32_63",
  /*  569 */  "xorI_Reg_Reg",
  /*  570 */  "orI_Reg_Reg",
  /*  571 */  "rotI_shr_logical_Reg",
  /*  572 */  "rotI_shr_logical_Reg_0",
  /*  573 */  "orI_Reg_castP2X",
  /*  574 */  "orI_Reg_castP2X_0",
  /*  575 */  "shr_logical_Reg_imm",
  /*  576 */  "shr_logical_Reg_imm_nonneg_mask",
  /*  577 */  "rolI_Reg_immI_0_31",
  /*  578 */  "rolI_Reg_immI_0_31_0",
  /*  579 */  "rolL_Reg_immI_0_31",
  /*  580 */  "rolL_Reg_immI_0_31_0",
  /*  581 */  "rolL_Reg_immI_32_63",
  /*  582 */  "rolL_Reg_immI_32_63_0",
  /*  583 */  "rorI_Reg_immI_0_31",
  /*  584 */  "rorI_Reg_immI_0_31_0",
  /*  585 */  "rorL_Reg_immI_0_31",
  /*  586 */  "rorL_Reg_immI_0_31_0",
  /*  587 */  "rorL_Reg_immI_32_63",
  /*  588 */  "rorL_Reg_immI_32_63_0",
  /*  589 */  "shr_logical_Reg_Reg",
  /*  590 */  "shr_arith_Reg_imm",
  /*  591 */  "shr_arith_Reg_Reg",
  /*  592 */  "convI2L_reg",
  /*  593 */  "convL2I_reg",
  /*  594 */  "convL2I2L_reg",
  /*  595 */  "convL2D_reg",
  /*  596 */  "convD2L_reg_fast",
  /*  597 */  "convD2L_reg_slow",
  /*  598 */  "convF2I_reg_fast",
  /*  599 */  "convF2I_reg_slow",
  /*  600 */  "convF2L_reg_fast",
  /*  601 */  "convF2L_reg_slow",
  /*  602 */  "convL2F_reg",
  /*  603 */  "convI2F_reg",
  /*  604 */  "cmpLTMask_immI_0",
  /*  605 */  "cmpLTMask",
  /*  606 */  "convI2D_reg_reg",
  /*  607 */  "convF2D_reg_reg",
  /*  608 */  "convD2F_reg_reg",
  /*  609 */  "convD2I_reg_reg_fast",
  /*  610 */  "convD2I_reg_reg_slow",
  /*  611 */  "encodeHeapOop",
  /*  612 */  "encodeHeapOop_not_null",
  /*  613 */  "decodeHeapOop",
  /*  614 */  "decodeHeapOop_not_null",
  /*  615 */  "encodeKlass_not_null",
  /*  616 */  "decodeKlass_not_null",
  /*  617 */  "tlsLoadP",
  /*  618 */  "Ret",
  /*  619 */  "tailjmpInd",
  /*  620 */  "CallStaticJavaDirect",
  /*  621 */  "CallDynamicJavaDirect",
  /*  622 */  "CallLeafNoFPDirect",
  /*  623 */  "prefetchr",
  /*  624 */  "prefetchw",
  /*  625 */  "prefetchAlloc",
  /*  626 */  "CallLeafDirect",
  /*  627 */  "loadUS",
  /*  628 */  "loadUS_convI2L",
  /*  629 */  "storeC",
  /*  630 */  "storeC_0",
  /*  631 */  "storeF_reg",
  /*  632 */  "storeF_immF_0",
  /*  633 */  "loadD",
  /*  634 */  "loadD_unaligned",
  /*  635 */  "storeD_reg",
  /*  636 */  "storeD_immD_0",
  /*  637 */  "storeImmCM",
  /*  638 */  "ShouldNotReachHere",
  /*  639 */  "partialSubtypeCheck",
  /*  640 */  "loadPLocked",
  /*  641 */  "compareAndSwapI",
  /*  642 */  "compareAndSwapL",
  /*  643 */  "compareAndSwapP",
  /*  644 */  "compareAndSwapN",
  /*  645 */  "minI_Reg_Reg",
  /*  646 */  "maxI_Reg_Reg",
  /*  647 */  "maxI_Reg_zero",
  /*  648 */  "zerox_long_reg_reg",
  /*  649 */  "combine_i2l",
  /*  650 */  "combine_i2l_0",
  /*  651 */  "convI2L_reg_reg_zex",
  /*  652 */  "convL2I2L_reg_reg_zex",
  /*  653 */  "loadUI2L_rmask",
  /*  654 */  "loadUI2L_lmask",
  /*  655 */  "loadUI2L_lmask_0",
  /*  656 */  "safePoint_poll_reg",
  /*  657 */  "safePoint_poll",
  /*  658 */  "loadV8",
  /*  659 */  "storeV8",
  /*  660 */  "Repl8B_DSP",
  /*  661 */  "Repl8B",
  /*  662 */  "Repl8B_imm_DSP",
  /*  663 */  "Repl8B_imm",
  /*  664 */  "Repl8B_zero",
  /*  665 */  "Repl8B_M1",
  /*  666 */  "Repl4S_DSP",
  /*  667 */  "Repl4S",
  /*  668 */  "Repl4S_imm_DSP",
  /*  669 */  "Repl4S_imm",
  /*  670 */  "Repl4S_zero",
  /*  671 */  "Repl4S_M1",
  /*  672 */  "Repl2I",
  /*  673 */  "Repl2I_imm",
  /*  674 */  "Repl2I_zero",
  /*  675 */  "Repl2I_M1",
  /*  676 */  "Repl2F",
  /*  677 */  "Repl2F_zero",
  /*  678 */  "vadd2F",
  /*  679 */  "vadd2F3",
  /*  680 */  "vsub2F",
  /*  681 */  "vmul2F",
  /*  682 */  "vmul2F3",
  // last instruction
  "invalid rule name" // no trailing comma
};

const        bool  swallowed[] = {
  /*    0 */  false,
  /*    1 */  false,
  /*    2 */  false,
  /*    3 */  false,
  /*    4 */  false,
  /*    5 */  false,
  /*    6 */  false,
  /*    7 */  false,
  /*    8 */  false,
  /*    9 */  false,
  /*   10 */  true,
  /*   11 */  true,
  /*   12 */  true,
  /*   13 */  true,
  /*   14 */  true,
  /*   15 */  true,
  /*   16 */  true,
  /*   17 */  true,
  /*   18 */  true,
  /*   19 */  true,
  /*   20 */  true,
  /*   21 */  true,
  /*   22 */  true,
  /*   23 */  true,
  /*   24 */  true,
  /*   25 */  true,
  /*   26 */  true,
  /*   27 */  true,
  /*   28 */  true,
  /*   29 */  true,
  /*   30 */  true,
  /*   31 */  true,
  /*   32 */  true,
  /*   33 */  true,
  /*   34 */  true,
  /*   35 */  true,
  /*   36 */  true,
  /*   37 */  true,
  /*   38 */  true,
  /*   39 */  true,
  /*   40 */  true,
  /*   41 */  true,
  /*   42 */  true,
  /*   43 */  true,
  /*   44 */  true,
  /*   45 */  true,
  /*   46 */  true,
  /*   47 */  true,
  /*   48 */  true,
  /*   49 */  true,
  /*   50 */  true,
  /*   51 */  true,
  /*   52 */  true,
  /*   53 */  true,
  /*   54 */  true,
  /*   55 */  true,
  /*   56 */  false,
  /*   57 */  false,
  /*   58 */  false,
  /*   59 */  false,
  /*   60 */  false,
  /*   61 */  false,
  /*   62 */  false,
  /*   63 */  false,
  /*   64 */  false,
  /*   65 */  false,
  /*   66 */  false,
  /*   67 */  false,
  /*   68 */  false,
  /*   69 */  false,
  /*   70 */  false,
  /*   71 */  false,
  /*   72 */  false,
  /*   73 */  false,
  /*   74 */  false,
  /*   75 */  false,
  /*   76 */  false,
  /*   77 */  false,
  /*   78 */  false,
  /*   79 */  false,
  /*   80 */  false,
  /*   81 */  false,
  /*   82 */  false,
  /*   83 */  false,
  /*   84 */  false,
  /*   85 */  false,
  /*   86 */  false,
  /*   87 */  false,
  /*   88 */  false,
  /*   89 */  false,
  /*   90 */  false,
  /*   91 */  false,
  /*   92 */  false,
  /*   93 */  false,
  /*   94 */  false,
  /*   95 */  false,
  /*   96 */  false,
  /*   97 */  false,
  /*   98 */  false,
  /*   99 */  false,
  /*  100 */  false,
  /*  101 */  false,
  /*  102 */  false,
  /*  103 */  false,
  /*  104 */  false,
  /*  105 */  false,
  /*  106 */  false,
  /*  107 */  false,
  /*  108 */  false,
  /*  109 */  false,
  /*  110 */  false,
  /*  111 */  false,
  /*  112 */  false,
  /*  113 */  false,
  /*  114 */  false,
  /*  115 */  false,
  /*  116 */  false,
  /*  117 */  false,
  /*  118 */  false,
  /*  119 */  false,
  /*  120 */  false,
  /*  121 */  false,
  /*  122 */  false,
  /*  123 */  false,
  /*  124 */  false,
  /*  125 */  false,
  /*  126 */  false,
  /*  127 */  false,
  /*  128 */  false,
  /*  129 */  false,
  /*  130 */  false,
  /*  131 */  false,
  /*  132 */  false,
  /*  133 */  false,
  /*  134 */  false,
  /*  135 */  false,
  /*  136 */  false,
  /*  137 */  false,
  /*  138 */  false,
  /*  139 */  false,
  /*  140 */  false,
  /*  141 */  false,
  /*  142 */  false,
  /*  143 */  false,
  /*  144 */  false,
  /*  145 */  false,
  /*  146 */  false,
  /*  147 */  false,
  /*  148 */  false,
  /*  149 */  false,
  /*  150 */  false,
  /*  151 */  false,
  /*  152 */  false,
  /*  153 */  false,
  /*  154 */  false,
  /*  155 */  false,
  /*  156 */  false,
  /*  157 */  false,
  /*  158 */  false,
  /*  159 */  false,
  /*  160 */  false,
  /*  161 */  false,
  /*  162 */  false,
  /*  163 */  false,
  /*  164 */  false,
  /*  165 */  false,
  /*  166 */  false,
  /*  167 */  false,
  /*  168 */  false,
  /*  169 */  false,
  /*  170 */  false,
  /*  171 */  false,
  /*  172 */  false,
  /*  173 */  false,
  /*  174 */  false,
  /*  175 */  true,
  /*  176 */  true,
  /*  177 */  false,
  /*  178 */  false,
  /*  179 */  false,
  /*  180 */  false,
  /*  181 */  false,
  // last operand
  /*  182 */  false,
  // last operand class
  /*  183 */  false,
  /*  184 */  false,
  /*  185 */  false,
  /*  186 */  false,
  /*  187 */  false,
  /*  188 */  false,
  /*  189 */  false,
  /*  190 */  false,
  /*  191 */  false,
  /*  192 */  false,
  /*  193 */  false,
  /*  194 */  false,
  /*  195 */  false,
  /*  196 */  false,
  /*  197 */  false,
  /*  198 */  false,
  /*  199 */  false,
  /*  200 */  false,
  /*  201 */  false,
  /*  202 */  false,
  /*  203 */  false,
  /*  204 */  false,
  /*  205 */  false,
  /*  206 */  false,
  /*  207 */  false,
  /*  208 */  false,
  /*  209 */  false,
  /*  210 */  false,
  /*  211 */  false,
  /*  212 */  false,
  /*  213 */  false,
  /*  214 */  false,
  /*  215 */  false,
  /*  216 */  false,
  /*  217 */  false,
  /*  218 */  false,
  /*  219 */  false,
  /*  220 */  false,
  /*  221 */  false,
  /*  222 */  false,
  /*  223 */  false,
  /*  224 */  false,
  /*  225 */  false,
  /*  226 */  false,
  /*  227 */  false,
  /*  228 */  false,
  /*  229 */  false,
  /*  230 */  false,
  /*  231 */  false,
  /*  232 */  false,
  /*  233 */  false,
  /*  234 */  false,
  /*  235 */  false,
  /*  236 */  false,
  /*  237 */  false,
  /*  238 */  false,
  /*  239 */  false,
  /*  240 */  false,
  /*  241 */  false,
  /*  242 */  false,
  /*  243 */  false,
  /*  244 */  false,
  /*  245 */  false,
  /*  246 */  false,
  /*  247 */  false,
  /*  248 */  false,
  /*  249 */  false,
  /*  250 */  false,
  /*  251 */  false,
  /*  252 */  false,
  /*  253 */  false,
  /*  254 */  false,
  /*  255 */  false,
  /*  256 */  false,
  /*  257 */  false,
  /*  258 */  false,
  /*  259 */  false,
  /*  260 */  false,
  /*  261 */  false,
  /*  262 */  false,
  /*  263 */  false,
  /*  264 */  false,
  /*  265 */  false,
  /*  266 */  false,
  /*  267 */  false,
  /*  268 */  false,
  /*  269 */  false,
  /*  270 */  false,
  /*  271 */  false,
  /*  272 */  false,
  /*  273 */  false,
  /*  274 */  false,
  /*  275 */  false,
  /*  276 */  false,
  /*  277 */  false,
  /*  278 */  false,
  /*  279 */  false,
  // last internally defined operand
  /*  280 */  false,
  /*  281 */  false,
  /*  282 */  false,
  /*  283 */  false,
  /*  284 */  false,
  /*  285 */  false,
  /*  286 */  false,
  /*  287 */  false,
  /*  288 */  false,
  /*  289 */  false,
  /*  290 */  false,
  /*  291 */  false,
  /*  292 */  false,
  /*  293 */  false,
  /*  294 */  false,
  /*  295 */  false,
  /*  296 */  false,
  /*  297 */  false,
  /*  298 */  false,
  /*  299 */  false,
  /*  300 */  false,
  /*  301 */  false,
  /*  302 */  false,
  /*  303 */  false,
  /*  304 */  false,
  /*  305 */  false,
  /*  306 */  false,
  /*  307 */  false,
  /*  308 */  false,
  /*  309 */  false,
  /*  310 */  false,
  /*  311 */  false,
  /*  312 */  false,
  /*  313 */  false,
  /*  314 */  false,
  /*  315 */  false,
  /*  316 */  false,
  /*  317 */  false,
  /*  318 */  false,
  /*  319 */  false,
  /*  320 */  false,
  /*  321 */  false,
  /*  322 */  false,
  /*  323 */  false,
  /*  324 */  false,
  /*  325 */  false,
  /*  326 */  false,
  /*  327 */  false,
  /*  328 */  false,
  /*  329 */  false,
  /*  330 */  false,
  /*  331 */  false,
  /*  332 */  false,
  /*  333 */  false,
  /*  334 */  false,
  /*  335 */  false,
  /*  336 */  false,
  /*  337 */  false,
  /*  338 */  false,
  /*  339 */  false,
  /*  340 */  false,
  /*  341 */  false,
  /*  342 */  false,
  /*  343 */  false,
  /*  344 */  false,
  /*  345 */  false,
  /*  346 */  false,
  /*  347 */  false,
  /*  348 */  false,
  /*  349 */  false,
  /*  350 */  false,
  /*  351 */  false,
  /*  352 */  false,
  /*  353 */  false,
  /*  354 */  false,
  /*  355 */  false,
  /*  356 */  false,
  /*  357 */  false,
  /*  358 */  false,
  /*  359 */  false,
  /*  360 */  false,
  /*  361 */  false,
  /*  362 */  false,
  /*  363 */  false,
  /*  364 */  false,
  /*  365 */  false,
  /*  366 */  false,
  /*  367 */  false,
  /*  368 */  false,
  /*  369 */  false,
  /*  370 */  false,
  /*  371 */  false,
  /*  372 */  false,
  /*  373 */  false,
  /*  374 */  false,
  /*  375 */  false,
  /*  376 */  false,
  /*  377 */  false,
  /*  378 */  false,
  /*  379 */  false,
  /*  380 */  false,
  /*  381 */  false,
  /*  382 */  false,
  /*  383 */  false,
  /*  384 */  false,
  /*  385 */  false,
  /*  386 */  false,
  /*  387 */  false,
  /*  388 */  false,
  /*  389 */  false,
  /*  390 */  false,
  /*  391 */  false,
  /*  392 */  false,
  /*  393 */  false,
  /*  394 */  false,
  /*  395 */  false,
  /*  396 */  false,
  /*  397 */  false,
  /*  398 */  false,
  /*  399 */  false,
  /*  400 */  false,
  /*  401 */  false,
  /*  402 */  false,
  /*  403 */  false,
  /*  404 */  false,
  /*  405 */  false,
  /*  406 */  false,
  /*  407 */  false,
  /*  408 */  false,
  /*  409 */  false,
  /*  410 */  false,
  /*  411 */  false,
  /*  412 */  false,
  /*  413 */  false,
  /*  414 */  false,
  /*  415 */  false,
  /*  416 */  false,
  /*  417 */  false,
  /*  418 */  false,
  /*  419 */  false,
  /*  420 */  false,
  /*  421 */  false,
  /*  422 */  false,
  /*  423 */  false,
  /*  424 */  false,
  /*  425 */  false,
  /*  426 */  false,
  /*  427 */  false,
  /*  428 */  false,
  /*  429 */  false,
  /*  430 */  false,
  /*  431 */  false,
  /*  432 */  false,
  /*  433 */  false,
  /*  434 */  false,
  /*  435 */  false,
  /*  436 */  false,
  /*  437 */  false,
  /*  438 */  false,
  /*  439 */  false,
  /*  440 */  false,
  /*  441 */  false,
  /*  442 */  false,
  /*  443 */  false,
  /*  444 */  false,
  /*  445 */  false,
  /*  446 */  false,
  /*  447 */  false,
  /*  448 */  false,
  /*  449 */  false,
  /*  450 */  false,
  /*  451 */  false,
  /*  452 */  false,
  /*  453 */  false,
  /*  454 */  false,
  /*  455 */  false,
  /*  456 */  false,
  /*  457 */  false,
  /*  458 */  false,
  /*  459 */  false,
  /*  460 */  false,
  /*  461 */  false,
  /*  462 */  false,
  /*  463 */  false,
  /*  464 */  false,
  /*  465 */  false,
  /*  466 */  false,
  /*  467 */  false,
  /*  468 */  false,
  /*  469 */  false,
  /*  470 */  false,
  /*  471 */  false,
  /*  472 */  false,
  /*  473 */  false,
  /*  474 */  false,
  /*  475 */  false,
  /*  476 */  false,
  /*  477 */  false,
  /*  478 */  false,
  /*  479 */  false,
  /*  480 */  false,
  /*  481 */  false,
  /*  482 */  false,
  /*  483 */  false,
  /*  484 */  false,
  /*  485 */  false,
  /*  486 */  false,
  /*  487 */  false,
  /*  488 */  false,
  /*  489 */  false,
  /*  490 */  false,
  /*  491 */  false,
  /*  492 */  false,
  /*  493 */  false,
  /*  494 */  false,
  /*  495 */  false,
  /*  496 */  false,
  /*  497 */  false,
  /*  498 */  false,
  /*  499 */  false,
  /*  500 */  false,
  /*  501 */  false,
  /*  502 */  false,
  /*  503 */  false,
  /*  504 */  false,
  /*  505 */  false,
  /*  506 */  false,
  /*  507 */  false,
  /*  508 */  false,
  /*  509 */  false,
  /*  510 */  false,
  /*  511 */  false,
  /*  512 */  false,
  /*  513 */  false,
  /*  514 */  false,
  /*  515 */  false,
  /*  516 */  false,
  /*  517 */  false,
  /*  518 */  false,
  /*  519 */  false,
  /*  520 */  false,
  /*  521 */  false,
  /*  522 */  false,
  /*  523 */  false,
  /*  524 */  false,
  /*  525 */  false,
  /*  526 */  false,
  /*  527 */  false,
  /*  528 */  false,
  /*  529 */  false,
  /*  530 */  false,
  /*  531 */  false,
  /*  532 */  false,
  /*  533 */  false,
  /*  534 */  false,
  /*  535 */  false,
  /*  536 */  false,
  /*  537 */  false,
  /*  538 */  false,
  /*  539 */  false,
  /*  540 */  false,
  /*  541 */  false,
  /*  542 */  false,
  /*  543 */  false,
  /*  544 */  false,
  /*  545 */  false,
  /*  546 */  false,
  /*  547 */  false,
  /*  548 */  false,
  /*  549 */  false,
  /*  550 */  false,
  /*  551 */  false,
  /*  552 */  false,
  /*  553 */  false,
  /*  554 */  false,
  /*  555 */  false,
  /*  556 */  false,
  /*  557 */  false,
  /*  558 */  false,
  /*  559 */  false,
  /*  560 */  false,
  /*  561 */  false,
  /*  562 */  false,
  /*  563 */  false,
  /*  564 */  false,
  /*  565 */  false,
  /*  566 */  false,
  /*  567 */  false,
  /*  568 */  false,
  /*  569 */  false,
  /*  570 */  false,
  /*  571 */  false,
  /*  572 */  false,
  /*  573 */  false,
  /*  574 */  false,
  /*  575 */  false,
  /*  576 */  false,
  /*  577 */  false,
  /*  578 */  false,
  /*  579 */  false,
  /*  580 */  false,
  /*  581 */  false,
  /*  582 */  false,
  /*  583 */  false,
  /*  584 */  false,
  /*  585 */  false,
  /*  586 */  false,
  /*  587 */  false,
  /*  588 */  false,
  /*  589 */  false,
  /*  590 */  false,
  /*  591 */  false,
  /*  592 */  false,
  /*  593 */  false,
  /*  594 */  false,
  /*  595 */  false,
  /*  596 */  false,
  /*  597 */  false,
  /*  598 */  false,
  /*  599 */  false,
  /*  600 */  false,
  /*  601 */  false,
  /*  602 */  false,
  /*  603 */  false,
  /*  604 */  false,
  /*  605 */  false,
  /*  606 */  false,
  /*  607 */  false,
  /*  608 */  false,
  /*  609 */  false,
  /*  610 */  false,
  /*  611 */  false,
  /*  612 */  false,
  /*  613 */  false,
  /*  614 */  false,
  /*  615 */  false,
  /*  616 */  false,
  /*  617 */  false,
  /*  618 */  false,
  /*  619 */  false,
  /*  620 */  false,
  /*  621 */  false,
  /*  622 */  false,
  /*  623 */  false,
  /*  624 */  false,
  /*  625 */  false,
  /*  626 */  false,
  /*  627 */  false,
  /*  628 */  false,
  /*  629 */  false,
  /*  630 */  false,
  /*  631 */  false,
  /*  632 */  false,
  /*  633 */  false,
  /*  634 */  false,
  /*  635 */  false,
  /*  636 */  false,
  /*  637 */  false,
  /*  638 */  false,
  /*  639 */  false,
  /*  640 */  false,
  /*  641 */  false,
  /*  642 */  false,
  /*  643 */  false,
  /*  644 */  false,
  /*  645 */  false,
  /*  646 */  false,
  /*  647 */  false,
  /*  648 */  false,
  /*  649 */  false,
  /*  650 */  false,
  /*  651 */  false,
  /*  652 */  false,
  /*  653 */  false,
  /*  654 */  false,
  /*  655 */  false,
  /*  656 */  false,
  /*  657 */  false,
  /*  658 */  false,
  /*  659 */  false,
  /*  660 */  false,
  /*  661 */  false,
  /*  662 */  false,
  /*  663 */  false,
  /*  664 */  false,
  /*  665 */  false,
  /*  666 */  false,
  /*  667 */  false,
  /*  668 */  false,
  /*  669 */  false,
  /*  670 */  false,
  /*  671 */  false,
  /*  672 */  false,
  /*  673 */  false,
  /*  674 */  false,
  /*  675 */  false,
  /*  676 */  false,
  /*  677 */  false,
  /*  678 */  false,
  /*  679 */  false,
  /*  680 */  false,
  /*  681 */  false,
  /*  682 */  false,
  // last instruction
  false // no trailing comma
};

// Mapping from machine-independent opcode to boolean
const        char must_clone[] = {
  0, // Node: 0
  0, // Set: 1
  0, // RegN: 2
  0, // RegI: 3
  0, // RegP: 4
  0, // RegF: 5
  0, // RegD: 6
  0, // RegL: 7
  0, // RegFlags: 8
  0, // VecS: 9
  0, // VecD: 10
  0, // VecX: 11
  0, // VecY: 12
  0, // _last_machine_leaf: 13
  0, // AbsD: 14
  0, // AbsF: 15
  0, // AbsI: 16
  0, // AddD: 17
  0, // AddF: 18
  0, // AddI: 19
  0, // AddL: 20
  0, // AddP: 21
  0, // Allocate: 22
  0, // AllocateArray: 23
  0, // AndI: 24
  0, // AndL: 25
  0, // AryEq: 26
  0, // AtanD: 27
  1, // Binary: 28
  1, // Bool: 29
  0, // BoxLock: 30
  0, // ReverseBytesI: 31
  0, // ReverseBytesL: 32
  0, // ReverseBytesUS: 33
  0, // ReverseBytesS: 34
  0, // CProj: 35
  0, // CallDynamicJava: 36
  0, // CallJava: 37
  0, // CallLeaf: 38
  0, // CallLeafNoFP: 39
  0, // CallRuntime: 40
  0, // CallStaticJava: 41
  0, // CastII: 42
  0, // CastX2P: 43
  0, // CastP2X: 44
  0, // CastPP: 45
  0, // Catch: 46
  0, // CatchProj: 47
  0, // CheckCastPP: 48
  0, // ClearArray: 49
  0, // ConstraintCast: 50
  0, // CMoveD: 51
  0, // CMoveF: 52
  0, // CMoveI: 53
  0, // CMoveL: 54
  0, // CMoveP: 55
  0, // CMoveN: 56
  1, // CmpN: 57
  1, // CmpD: 58
  0, // CmpD3: 59
  1, // CmpF: 60
  0, // CmpF3: 61
  1, // CmpI: 62
  1, // CmpL: 63
  0, // CmpL3: 64
  0, // CmpLTMask: 65
  1, // CmpP: 66
  1, // CmpU: 67
  1, // CmpUL: 68
  0, // CompareAndSwapI: 69
  0, // CompareAndSwapL: 70
  0, // CompareAndSwapP: 71
  0, // CompareAndSwapN: 72
  0, // GetAndAddI: 73
  0, // GetAndAddL: 74
  0, // GetAndSetI: 75
  0, // GetAndSetL: 76
  0, // GetAndSetP: 77
  0, // GetAndSetN: 78
  0, // Con: 79
  0, // ConN: 80
  0, // ConNKlass: 81
  0, // ConD: 82
  0, // ConF: 83
  0, // ConI: 84
  0, // ConL: 85
  0, // ConP: 86
  0, // Conv2B: 87
  0, // ConvD2F: 88
  0, // ConvD2I: 89
  0, // ConvD2L: 90
  0, // ConvF2D: 91
  0, // ConvF2I: 92
  0, // ConvF2L: 93
  0, // ConvI2D: 94
  0, // ConvI2F: 95
  0, // ConvI2L: 96
  0, // ConvL2D: 97
  0, // ConvL2F: 98
  0, // ConvL2I: 99
  0, // CosD: 100
  0, // CountedLoop: 101
  0, // CountedLoopEnd: 102
  0, // CountLeadingZerosI: 103
  0, // CountLeadingZerosL: 104
  0, // CountTrailingZerosI: 105
  0, // CountTrailingZerosL: 106
  0, // CreateEx: 107
  0, // DecodeN: 108
  0, // DecodeNKlass: 109
  0, // DivD: 110
  0, // DivF: 111
  0, // DivI: 112
  0, // DivL: 113
  0, // DivMod: 114
  0, // DivModI: 115
  0, // DivModL: 116
  0, // EncodeISOArray: 117
  0, // EncodeP: 118
  0, // EncodePKlass: 119
  0, // ExpD: 120
  1, // FastLock: 121
  1, // FastUnlock: 122
  0, // Goto: 123
  0, // Halt: 124
  0, // If: 125
  0, // IfFalse: 126
  0, // IfTrue: 127
  0, // Initialize: 128
  0, // JProj: 129
  0, // Jump: 130
  0, // JumpProj: 131
  0, // LShiftI: 132
  0, // LShiftL: 133
  0, // LoadB: 134
  0, // LoadUB: 135
  0, // LoadUS: 136
  0, // LoadD: 137
  0, // LoadD_unaligned: 138
  0, // LoadF: 139
  0, // LoadI: 140
  0, // LoadKlass: 141
  0, // LoadNKlass: 142
  0, // LoadL: 143
  0, // LoadL_unaligned: 144
  0, // LoadPLocked: 145
  0, // LoadP: 146
  0, // LoadN: 147
  0, // LoadRange: 148
  0, // LoadS: 149
  0, // Lock: 150
  0, // LogD: 151
  0, // Log10D: 152
  0, // Loop: 153
  0, // LoopLimit: 154
  0, // Mach: 155
  0, // MachProj: 156
  0, // MaxI: 157
  0, // MemBarAcquire: 158
  0, // LoadFence: 159
  0, // MemBarAcquireLock: 160
  0, // MemBarCPUOrder: 161
  0, // MemBarRelease: 162
  0, // StoreFence: 163
  0, // MemBarReleaseLock: 164
  0, // MemBarVolatile: 165
  0, // MemBarStoreStore: 166
  0, // MergeMem: 167
  0, // MinI: 168
  0, // ModD: 169
  0, // ModF: 170
  0, // ModI: 171
  0, // ModL: 172
  0, // MoveI2F: 173
  0, // MoveF2I: 174
  0, // MoveL2D: 175
  0, // MoveD2L: 176
  0, // MulD: 177
  0, // MulF: 178
  0, // MulHiL: 179
  0, // MulI: 180
  0, // MulL: 181
  0, // Multi: 182
  0, // NegD: 183
  0, // NegF: 184
  0, // NeverBranch: 185
  0, // Opaque1: 186
  0, // Opaque2: 187
  0, // Opaque3: 188
  0, // ProfileBoolean: 189
  0, // OrI: 190
  0, // OrL: 191
  1, // OverflowAddI: 192
  1, // OverflowSubI: 193
  1, // OverflowMulI: 194
  1, // OverflowAddL: 195
  1, // OverflowSubL: 196
  1, // OverflowMulL: 197
  0, // PCTable: 198
  0, // Parm: 199
  0, // PartialSubtypeCheck: 200
  0, // Phi: 201
  0, // PopCountI: 202
  0, // PopCountL: 203
  0, // PowD: 204
  0, // PrefetchAllocation: 205
  0, // PrefetchRead: 206
  0, // PrefetchWrite: 207
  0, // Proj: 208
  0, // RShiftI: 209
  0, // RShiftL: 210
  0, // Region: 211
  0, // Rethrow: 212
  0, // Return: 213
  0, // Root: 214
  0, // RoundDouble: 215
  0, // RoundFloat: 216
  0, // SafePoint: 217
  0, // SafePointScalarObject: 218
  0, // SCMemProj: 219
  0, // SinD: 220
  0, // SqrtD: 221
  0, // Start: 222
  0, // StartOSR: 223
  0, // StoreB: 224
  0, // StoreC: 225
  0, // StoreCM: 226
  0, // StorePConditional: 227
  0, // StoreIConditional: 228
  0, // StoreLConditional: 229
  0, // StoreD: 230
  0, // StoreF: 231
  0, // StoreI: 232
  0, // StoreL: 233
  0, // StoreP: 234
  0, // StoreN: 235
  0, // StoreNKlass: 236
  0, // StrComp: 237
  0, // StrEquals: 238
  0, // StrIndexOf: 239
  0, // SubD: 240
  0, // SubF: 241
  0, // SubI: 242
  0, // SubL: 243
  0, // TailCall: 244
  0, // TailJump: 245
  0, // TanD: 246
  0, // ThreadLocal: 247
  0, // Unlock: 248
  0, // URShiftI: 249
  0, // URShiftL: 250
  0, // XorI: 251
  0, // XorL: 252
  0, // Vector: 253
  0, // AddVB: 254
  0, // AddVS: 255
  0, // AddVI: 256
  0, // AddVL: 257
  0, // AddVF: 258
  0, // AddVD: 259
  0, // SubVB: 260
  0, // SubVS: 261
  0, // SubVI: 262
  0, // SubVL: 263
  0, // SubVF: 264
  0, // SubVD: 265
  0, // MulVS: 266
  0, // MulVI: 267
  0, // MulVF: 268
  0, // MulVD: 269
  0, // DivVF: 270
  0, // DivVD: 271
  0, // LShiftCntV: 272
  0, // RShiftCntV: 273
  0, // LShiftVB: 274
  0, // LShiftVS: 275
  0, // LShiftVI: 276
  0, // LShiftVL: 277
  0, // RShiftVB: 278
  0, // RShiftVS: 279
  0, // RShiftVI: 280
  0, // RShiftVL: 281
  0, // URShiftVB: 282
  0, // URShiftVS: 283
  0, // URShiftVI: 284
  0, // URShiftVL: 285
  0, // AndV: 286
  0, // OrV: 287
  0, // XorV: 288
  0, // LoadVector: 289
  0, // StoreVector: 290
  0, // Pack: 291
  0, // PackB: 292
  0, // PackS: 293
  0, // PackI: 294
  0, // PackL: 295
  0, // PackF: 296
  0, // PackD: 297
  0, // Pack2L: 298
  0, // Pack2D: 299
  0, // ReplicateB: 300
  0, // ReplicateS: 301
  0, // ReplicateI: 302
  0, // ReplicateL: 303
  0, // ReplicateF: 304
  0, // ReplicateD: 305
  0, // Extract: 306
  0, // ExtractB: 307
  0, // ExtractUB: 308
  0, // ExtractC: 309
  0, // ExtractS: 310
  0, // ExtractI: 311
  0, // ExtractL: 312
  0, // ExtractF: 313
  0 // no trailing comma // ExtractD: 314
};
//  The following instructions can cisc-spill
//  i2s can cisc-spill operand 1 to loadI2S
//  i2b can cisc-spill operand 1 to loadI2B
//  convI2L_reg can cisc-spill operand 1 to loadI_convI2L
//  convI2L_reg_reg_zex can cisc-spill operand 1 to loadUI2L_rmask



// An array of character pointers to machine register names.
const char *Matcher::regName[REG_COUNT] = {
  "S7",
  "S7_H",
  "S0",
  "S0_H",
  "S1",
  "S1_H",
  "S2",
  "S2_H",
  "S4",
  "S4_H",
  "S5",
  "S5_H",
  "S6",
  "S6_H",
  "S3",
  "S3_H",
  "T2",
  "T2_H",
  "T3",
  "T3_H",
  "T8",
  "T8_H",
  "T4",
  "T4_H",
  "T1",
  "T1_H",
  "T6",
  "T6_H",
  "A7",
  "A7_H",
  "A6",
  "A6_H",
  "A5",
  "A5_H",
  "A4",
  "A4_H",
  "T5",
  "T5_H",
  "A3",
  "A3_H",
  "A2",
  "A2_H",
  "A1",
  "A1_H",
  "A0",
  "A0_H",
  "T0",
  "T0_H",
  "S8",
  "S8_H",
  "RA",
  "RA_H",
  "SP",
  "SP_H",
  "FP",
  "FP_H",
  "F0",
  "F0_H",
  "F1",
  "F1_H",
  "F2",
  "F2_H",
  "F3",
  "F3_H",
  "F4",
  "F4_H",
  "F5",
  "F5_H",
  "F6",
  "F6_H",
  "F7",
  "F7_H",
  "F8",
  "F8_H",
  "F9",
  "F9_H",
  "F10",
  "F10_H",
  "F11",
  "F11_H",
  "F20",
  "F20_H",
  "F21",
  "F21_H",
  "F22",
  "F22_H",
  "F23",
  "F23_H",
  "F24",
  "F24_H",
  "F25",
  "F25_H",
  "F26",
  "F26_H",
  "F27",
  "F27_H",
  "F28",
  "F28_H",
  "F19",
  "F19_H",
  "F18",
  "F18_H",
  "F17",
  "F17_H",
  "F16",
  "F16_H",
  "F15",
  "F15_H",
  "F14",
  "F14_H",
  "F13",
  "F13_H",
  "F12",
  "F12_H",
  "F29",
  "F29_H",
  "F30",
  "F30_H",
  "F31",
  "F31_H",
  "LOONGARCH_FLAG" // no trailing comma
};

// An array of character pointers to machine register names.
const VMReg OptoReg::opto2vm[REG_COUNT] = {
	S7->as_VMReg(),
	S7->as_VMReg()->next(),
	S0->as_VMReg(),
	S0->as_VMReg()->next(),
	S1->as_VMReg(),
	S1->as_VMReg()->next(),
	S2->as_VMReg(),
	S2->as_VMReg()->next(),
	S4->as_VMReg(),
	S4->as_VMReg()->next(),
	S5->as_VMReg(),
	S5->as_VMReg()->next(),
	S6->as_VMReg(),
	S6->as_VMReg()->next(),
	S3->as_VMReg(),
	S3->as_VMReg()->next(),
	T2->as_VMReg(),
	T2->as_VMReg()->next(),
	T3->as_VMReg(),
	T3->as_VMReg()->next(),
	T8->as_VMReg(),
	T8->as_VMReg()->next(),
	T4->as_VMReg(),
	T4->as_VMReg()->next(),
	T1->as_VMReg(),
	T1->as_VMReg()->next(),
	T6->as_VMReg(),
	T6->as_VMReg()->next(),
	A7->as_VMReg(),
	A7->as_VMReg()->next(),
	A6->as_VMReg(),
	A6->as_VMReg()->next(),
	A5->as_VMReg(),
	A5->as_VMReg()->next(),
	A4->as_VMReg(),
	A4->as_VMReg()->next(),
	T5->as_VMReg(),
	T5->as_VMReg()->next(),
	A3->as_VMReg(),
	A3->as_VMReg()->next(),
	A2->as_VMReg(),
	A2->as_VMReg()->next(),
	A1->as_VMReg(),
	A1->as_VMReg()->next(),
	A0->as_VMReg(),
	A0->as_VMReg()->next(),
	T0->as_VMReg(),
	T0->as_VMReg()->next(),
	S8->as_VMReg(),
	S8->as_VMReg()->next(),
	RA->as_VMReg(),
	RA->as_VMReg()->next(),
	SP->as_VMReg(),
	SP->as_VMReg()->next(),
	FP->as_VMReg(),
	FP->as_VMReg()->next(),
	F0->as_VMReg(),
	F0->as_VMReg()->next(),
	F1->as_VMReg(),
	F1->as_VMReg()->next(),
	F2->as_VMReg(),
	F2->as_VMReg()->next(),
	F3->as_VMReg(),
	F3->as_VMReg()->next(),
	F4->as_VMReg(),
	F4->as_VMReg()->next(),
	F5->as_VMReg(),
	F5->as_VMReg()->next(),
	F6->as_VMReg(),
	F6->as_VMReg()->next(),
	F7->as_VMReg(),
	F7->as_VMReg()->next(),
	F8->as_VMReg(),
	F8->as_VMReg()->next(),
	F9->as_VMReg(),
	F9->as_VMReg()->next(),
	F10->as_VMReg(),
	F10->as_VMReg()->next(),
	F11->as_VMReg(),
	F11->as_VMReg()->next(),
	F20->as_VMReg(),
	F20->as_VMReg()->next(),
	F21->as_VMReg(),
	F21->as_VMReg()->next(),
	F22->as_VMReg(),
	F22->as_VMReg()->next(),
	F23->as_VMReg(),
	F23->as_VMReg()->next(),
	F24->as_VMReg(),
	F24->as_VMReg()->next(),
	F25->as_VMReg(),
	F25->as_VMReg()->next(),
	F26->as_VMReg(),
	F26->as_VMReg()->next(),
	F27->as_VMReg(),
	F27->as_VMReg()->next(),
	F28->as_VMReg(),
	F28->as_VMReg()->next(),
	F19->as_VMReg(),
	F19->as_VMReg()->next(),
	F18->as_VMReg(),
	F18->as_VMReg()->next(),
	F17->as_VMReg(),
	F17->as_VMReg()->next(),
	F16->as_VMReg(),
	F16->as_VMReg()->next(),
	F15->as_VMReg(),
	F15->as_VMReg()->next(),
	F14->as_VMReg(),
	F14->as_VMReg()->next(),
	F13->as_VMReg(),
	F13->as_VMReg()->next(),
	F12->as_VMReg(),
	F12->as_VMReg()->next(),
	F29->as_VMReg(),
	F29->as_VMReg()->next(),
	F30->as_VMReg(),
	F30->as_VMReg()->next(),
	F31->as_VMReg(),
	F31->as_VMReg()->next(),
	as_Register(1)->as_VMReg() // no trailing comma
	};

 OptoReg::Name OptoReg::vm2opto[ConcreteRegisterImpl::number_of_registers];

// An array of the machine register encode values
const unsigned char Matcher::_regEncode[REG_COUNT] = {
  (unsigned char)'\x1E',  // S7
  (unsigned char)'\x1E',  // S7_H
  (unsigned char)'\x17',  // S0
  (unsigned char)'\x17',  // S0_H
  (unsigned char)'\x18',  // S1
  (unsigned char)'\x18',  // S1_H
  (unsigned char)'\x19',  // S2
  (unsigned char)'\x19',  // S2_H
  (unsigned char)'\x1B',  // S4
  (unsigned char)'\x1B',  // S4_H
  (unsigned char)'\x1C',  // S5
  (unsigned char)'\x1C',  // S5_H
  (unsigned char)'\x1D',  // S6
  (unsigned char)'\x1D',  // S6_H
  (unsigned char)'\x1A',  // S3
  (unsigned char)'\x1A',  // S3_H
  (unsigned char)'\xE',  // T2
  (unsigned char)'\xE',  // T2_H
  (unsigned char)'\xF',  // T3
  (unsigned char)'\xF',  // T3_H
  (unsigned char)'\x14',  // T8
  (unsigned char)'\x14',  // T8_H
  (unsigned char)'\x10',  // T4
  (unsigned char)'\x10',  // T4_H
  (unsigned char)'\xD',  // T1
  (unsigned char)'\xD',  // T1_H
  (unsigned char)'\x12',  // T6
  (unsigned char)'\x12',  // T6_H
  (unsigned char)'\xB',  // A7
  (unsigned char)'\xB',  // A7_H
  (unsigned char)'\xA',  // A6
  (unsigned char)'\xA',  // A6_H
  (unsigned char)'\x9',  // A5
  (unsigned char)'\x9',  // A5_H
  (unsigned char)'\x8',  // A4
  (unsigned char)'\x8',  // A4_H
  (unsigned char)'\x11',  // T5
  (unsigned char)'\x11',  // T5_H
  (unsigned char)'\x7',  // A3
  (unsigned char)'\x7',  // A3_H
  (unsigned char)'\x6',  // A2
  (unsigned char)'\x6',  // A2_H
  (unsigned char)'\x5',  // A1
  (unsigned char)'\x5',  // A1_H
  (unsigned char)'\x4',  // A0
  (unsigned char)'\x4',  // A0_H
  (unsigned char)'\xC',  // T0
  (unsigned char)'\xC',  // T0_H
  (unsigned char)'\x1F',  // S8
  (unsigned char)'\x1F',  // S8_H
  (unsigned char)'\x1',  // RA
  (unsigned char)'\x1',  // RA_H
  (unsigned char)'\x3',  // SP
  (unsigned char)'\x3',  // SP_H
  (unsigned char)'\x16',  // FP
  (unsigned char)'\x16',  // FP_H
  (unsigned char)'\x0',  // F0
  (unsigned char)'\x0',  // F0_H
  (unsigned char)'\x1',  // F1
  (unsigned char)'\x1',  // F1_H
  (unsigned char)'\x2',  // F2
  (unsigned char)'\x2',  // F2_H
  (unsigned char)'\x3',  // F3
  (unsigned char)'\x3',  // F3_H
  (unsigned char)'\x4',  // F4
  (unsigned char)'\x4',  // F4_H
  (unsigned char)'\x5',  // F5
  (unsigned char)'\x5',  // F5_H
  (unsigned char)'\x6',  // F6
  (unsigned char)'\x6',  // F6_H
  (unsigned char)'\x7',  // F7
  (unsigned char)'\x7',  // F7_H
  (unsigned char)'\x8',  // F8
  (unsigned char)'\x8',  // F8_H
  (unsigned char)'\x9',  // F9
  (unsigned char)'\x9',  // F9_H
  (unsigned char)'\xA',  // F10
  (unsigned char)'\xA',  // F10_H
  (unsigned char)'\xB',  // F11
  (unsigned char)'\xB',  // F11_H
  (unsigned char)'\x14',  // F20
  (unsigned char)'\x14',  // F20_H
  (unsigned char)'\x15',  // F21
  (unsigned char)'\x15',  // F21_H
  (unsigned char)'\x16',  // F22
  (unsigned char)'\x16',  // F22_H
  (unsigned char)'\x17',  // F23
  (unsigned char)'\x17',  // F23_H
  (unsigned char)'\x18',  // F24
  (unsigned char)'\x18',  // F24_H
  (unsigned char)'\x19',  // F25
  (unsigned char)'\x19',  // F25_H
  (unsigned char)'\x1A',  // F26
  (unsigned char)'\x1A',  // F26_H
  (unsigned char)'\x1B',  // F27
  (unsigned char)'\x1B',  // F27_H
  (unsigned char)'\x1C',  // F28
  (unsigned char)'\x1C',  // F28_H
  (unsigned char)'\x13',  // F19
  (unsigned char)'\x13',  // F19_H
  (unsigned char)'\x12',  // F18
  (unsigned char)'\x12',  // F18_H
  (unsigned char)'\x11',  // F17
  (unsigned char)'\x11',  // F17_H
  (unsigned char)'\x10',  // F16
  (unsigned char)'\x10',  // F16_H
  (unsigned char)'\xF',  // F15
  (unsigned char)'\xF',  // F15_H
  (unsigned char)'\xE',  // F14
  (unsigned char)'\xE',  // F14_H
  (unsigned char)'\xD',  // F13
  (unsigned char)'\xD',  // F13_H
  (unsigned char)'\xC',  // F12
  (unsigned char)'\xC',  // F12_H
  (unsigned char)'\x1D',  // F29
  (unsigned char)'\x1D',  // F29_H
  (unsigned char)'\x1E',  // F30
  (unsigned char)'\x1E',  // F30_H
  (unsigned char)'\x1F',  // F31
  (unsigned char)'\x1F',  // F31_H
  (unsigned char)'\x1' // no trailing comma  // LOONGARCH_FLAG
};


//------------------Define classes derived from MachOper---------------------
MachOper  *labelOper::clone(Compile* C) const {
  return  new (C) labelOper(_label, _block_num);
}
uint labelOper::opcode() const { return LABEL; }

const RegMask *sRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

MachOper  *methodOper::clone(Compile* C) const {
  return  new (C) methodOper(_method);
}
uint methodOper::opcode() const { return METHOD; }

const RegMask *vecDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &DBL_REG_mask();
}

const RegMask *FlagsRegOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &LOONGARCH_FLAGS_mask();
}

const RegMask *mRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *no_Ax_mRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_AX_INT_REG_mask();
}

const RegMask *mS0RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S0_REG_mask();
}

const RegMask *mS1RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S1_REG_mask();
}

const RegMask *mS2RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S2_REG_mask();
}

const RegMask *mS3RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S3_REG_mask();
}

const RegMask *mS4RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S4_REG_mask();
}

const RegMask *mS5RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S5_REG_mask();
}

const RegMask *mS6RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S6_REG_mask();
}

const RegMask *mS7RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S7_REG_mask();
}

const RegMask *mT0RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T0_REG_mask();
}

const RegMask *mT1RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T1_REG_mask();
}

const RegMask *mT2RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T2_REG_mask();
}

const RegMask *mT3RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T3_REG_mask();
}

const RegMask *mT8RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T8_REG_mask();
}

const RegMask *mT4RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T4_REG_mask();
}

const RegMask *mA0RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A0_REG_mask();
}

const RegMask *mA1RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A1_REG_mask();
}

const RegMask *mA2RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A2_REG_mask();
}

const RegMask *mA3RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A3_REG_mask();
}

const RegMask *mA4RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A4_REG_mask();
}

const RegMask *mA5RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A5_REG_mask();
}

const RegMask *mA6RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A6_REG_mask();
}

const RegMask *mA7RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A7_REG_mask();
}

const RegMask *mRegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *t0_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T0_REG_mask();
}

const RegMask *t1_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T1_REG_mask();
}

const RegMask *t2_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T2_REG_mask();
}

const RegMask *t3_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T3_REG_mask();
}

const RegMask *t8_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T8_REG_mask();
}

const RegMask *a0_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A0_REG_mask();
}

const RegMask *a1_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A1_REG_mask();
}

const RegMask *a2_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A2_REG_mask();
}

const RegMask *a3_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A3_REG_mask();
}

const RegMask *a4_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A4_REG_mask();
}

const RegMask *a5_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A5_REG_mask();
}

const RegMask *a6_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A6_REG_mask();
}

const RegMask *a7_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A7_REG_mask();
}

const RegMask *s0_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S0_REG_mask();
}

const RegMask *s1_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S1_REG_mask();
}

const RegMask *s2_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S2_REG_mask();
}

const RegMask *s3_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S3_REG_mask();
}

const RegMask *s4_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S4_REG_mask();
}

const RegMask *s5_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S5_REG_mask();
}

const RegMask *s6_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S6_REG_mask();
}

const RegMask *s7_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S7_REG_mask();
}

const RegMask *mRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &P_REG_mask();
}

const RegMask *no_T8_mRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_T8_P_REG_mask();
}

const RegMask *no_Ax_mRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_AX_P_REG_mask();
}

const RegMask *s0_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S0_LONG_REG_mask();
}

const RegMask *s1_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S1_LONG_REG_mask();
}

const RegMask *s2_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S2_LONG_REG_mask();
}

const RegMask *s3_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S3_LONG_REG_mask();
}

const RegMask *s4_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S4_LONG_REG_mask();
}

const RegMask *s5_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S5_LONG_REG_mask();
}

const RegMask *s6_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S6_LONG_REG_mask();
}

const RegMask *s7_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S7_LONG_REG_mask();
}

const RegMask *t0_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T0_LONG_REG_mask();
}

const RegMask *t1_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T1_LONG_REG_mask();
}

const RegMask *t2_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T2_LONG_REG_mask();
}

const RegMask *t3_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T3_LONG_REG_mask();
}

const RegMask *t8_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T8_LONG_REG_mask();
}

const RegMask *a0_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A0_LONG_REG_mask();
}

const RegMask *a1_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A1_LONG_REG_mask();
}

const RegMask *a2_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A2_LONG_REG_mask();
}

const RegMask *a3_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A3_LONG_REG_mask();
}

const RegMask *a4_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A4_LONG_REG_mask();
}

const RegMask *a5_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A5_LONG_REG_mask();
}

const RegMask *a6_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A6_LONG_REG_mask();
}

const RegMask *a7_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A7_LONG_REG_mask();
}

const RegMask *v0_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V0_LONG_REG_mask();
}

const RegMask *v1_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V1_LONG_REG_mask();
}

const RegMask *mRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &LONG_REG_mask();
}

const RegMask *v0RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V0_LONG_REG_mask();
}

const RegMask *v1RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V1_LONG_REG_mask();
}

const RegMask *a0RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A0_LONG_REG_mask();
}

const RegMask *a1RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A1_LONG_REG_mask();
}

const RegMask *a2RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A2_LONG_REG_mask();
}

const RegMask *a3RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A3_LONG_REG_mask();
}

const RegMask *t0RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T0_LONG_REG_mask();
}

const RegMask *t1RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T1_LONG_REG_mask();
}

const RegMask *t2RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T2_LONG_REG_mask();
}

const RegMask *t3RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T3_LONG_REG_mask();
}

const RegMask *t8RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &T8_LONG_REG_mask();
}

const RegMask *a4RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A4_LONG_REG_mask();
}

const RegMask *a5RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A5_LONG_REG_mask();
}

const RegMask *a6RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A6_LONG_REG_mask();
}

const RegMask *a7RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &A7_LONG_REG_mask();
}

const RegMask *s0RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S0_LONG_REG_mask();
}

const RegMask *s1RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S1_LONG_REG_mask();
}

const RegMask *s2RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S2_LONG_REG_mask();
}

const RegMask *s3RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S3_LONG_REG_mask();
}

const RegMask *s4RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S4_LONG_REG_mask();
}

const RegMask *s7RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &S7_LONG_REG_mask();
}

const RegMask *regFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FLT_REG_mask();
}

const RegMask *regDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &DBL_REG_mask();
}

const RegMask *indirectOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &P_REG_mask();
}

const RegMask *indOffset8Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &P_REG_mask();
}

const RegMask *indIndexScaleOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &P_REG_mask();
  case 1: return &LONG_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *baseIndexOffset8Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &P_REG_mask();
  case 1: return &LONG_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *baseIndexOffset8_convI2LOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &P_REG_mask();
  case 1: return &INT_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexScaleOffset8Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &P_REG_mask();
  case 1: return &LONG_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexScaleOffset8_convI2LOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &P_REG_mask();
  case 1: return &INT_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *basePosIndexScaleOffset8Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &P_REG_mask();
  case 1: return &INT_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexScaleOffsetNarrowOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &INT_REG_mask();
  case 1: return &LONG_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indPosIndexI2LScaleOffset8NarrowOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  return &INT_REG_mask();
}

const RegMask *indOffset32Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &P_REG_mask();
}

const RegMask *indIndexOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &P_REG_mask();
  case 1: return &LONG_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indirectNarrowKlassOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *indOffset8NarrowKlassOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *indOffset32NarrowKlassOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *indIndexOffsetNarrowKlassOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &INT_REG_mask();
  case 1: return &LONG_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexNarrowKlassOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &INT_REG_mask();
  case 1: return &LONG_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indirectNarrowOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *indOffset8NarrowOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *indIndexOffset8NarrowOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &INT_REG_mask();
  case 1: return &LONG_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *load_long_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &P_REG_mask();
}

const RegMask *load_long_indirectOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &P_REG_mask();
}

const RegMask *load_long_indOffset32Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &P_REG_mask();
}

const RegMask *stackSlotPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

//------------------Define members for classes derived from MachNode----------
// Build short branch version of this instruction
MachNode *jmpDir_longNode::short_branch_version(Compile* C) {
  jmpDir_shortNode *node = new (C) jmpDir_shortNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpLoopEnd_longNode::short_branch_version(Compile* C) {
  jmpLoopEnd_shortNode *node = new (C) jmpLoopEnd_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpLoopEnd_reg_immI_longNode::short_branch_version(Compile* C) {
  jmpLoopEnd_reg_immI_shortNode *node = new (C) jmpLoopEnd_reg_immI_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpCon_flags_longNode::short_branch_version(Compile* C) {
  jmpCon_flags_shortNode *node = new (C) jmpCon_flags_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConP_0_longNode::short_branch_version(Compile* C) {
  branchConP_0_shortNode *node = new (C) branchConP_0_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConN2P_0_longNode::short_branch_version(Compile* C) {
  branchConN2P_0_shortNode *node = new (C) branchConN2P_0_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConP_longNode::short_branch_version(Compile* C) {
  branchConP_shortNode *node = new (C) branchConP_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *cmpN_null_branch_longNode::short_branch_version(Compile* C) {
  cmpN_null_branch_shortNode *node = new (C) cmpN_null_branch_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *cmpN_reg_branch_longNode::short_branch_version(Compile* C) {
  cmpN_reg_branch_shortNode *node = new (C) cmpN_reg_branch_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConIU_reg_reg_longNode::short_branch_version(Compile* C) {
  branchConIU_reg_reg_shortNode *node = new (C) branchConIU_reg_reg_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConIU_reg_imm_longNode::short_branch_version(Compile* C) {
  branchConIU_reg_imm_shortNode *node = new (C) branchConIU_reg_imm_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConI_reg_reg_longNode::short_branch_version(Compile* C) {
  branchConI_reg_reg_shortNode *node = new (C) branchConI_reg_reg_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConI_reg_immI_0_longNode::short_branch_version(Compile* C) {
  branchConI_reg_immI_0_shortNode *node = new (C) branchConI_reg_immI_0_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConI_reg_imm_longNode::short_branch_version(Compile* C) {
  branchConI_reg_imm_shortNode *node = new (C) branchConI_reg_imm_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConIU_reg_immI_0_longNode::short_branch_version(Compile* C) {
  branchConIU_reg_immI_0_shortNode *node = new (C) branchConIU_reg_immI_0_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConL_regL_regL_longNode::short_branch_version(Compile* C) {
  branchConL_regL_regL_shortNode *node = new (C) branchConL_regL_regL_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConL_regL_immL_0_longNode::short_branch_version(Compile* C) {
  branchConL_regL_immL_0_shortNode *node = new (C) branchConL_regL_immL_0_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConL_regL_immL_longNode::short_branch_version(Compile* C) {
  branchConL_regL_immL_shortNode *node = new (C) branchConL_regL_immL_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConF_reg_reg_longNode::short_branch_version(Compile* C) {
  branchConF_reg_reg_shortNode *node = new (C) branchConF_reg_reg_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConD_reg_reg_longNode::short_branch_version(Compile* C) {
  branchConD_reg_reg_shortNode *node = new (C) branchConD_reg_reg_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  return node;
}


void i2sNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *i2sNode::cisc_version( int offset, Compile* C ) {
  loadI2SNode *node = new (C) loadI2SNode();
  node->_num_opnds = 3;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void i2bNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *i2bNode::cisc_version( int offset, Compile* C ) {
  loadI2BNode *node = new (C) loadI2BNode();
  node->_num_opnds = 3;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void convI2L_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *convI2L_regNode::cisc_version( int offset, Compile* C ) {
  loadI_convI2LNode *node = new (C) loadI_convI2LNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


void convI2L_reg_reg_zexNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *convI2L_reg_reg_zexNode::cisc_version( int offset, Compile* C ) {
  loadUI2L_rmaskNode *node = new (C) loadUI2L_rmaskNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node, C);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new (C) indOffset32Oper(offset));

  return node;
}


// Copy _idx, inputs and operands to new node
void MachNode::fill_new_machnode( MachNode* node, Compile* C) const {
  // New node must use same node index
  node->set_idx( _idx );
  // Copy machine-independent inputs
  for( uint j = 0; j < req(); j++ ) {
    node->add_req(in(j));
  }
  // Copy my operands, except for cisc position
  int nopnds = num_opnds();
  assert( node->num_opnds() == (uint)nopnds, "Must have same number of operands");
  MachOper **to = node->_opnds;
  for( int i = 0; i < nopnds; i++ ) {
    if( i != cisc_operand() ) 
      to[i] = _opnds[i]->clone(C);
  }
}

void jmpDir_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpDir_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpLoopEnd_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpLoopEnd_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpLoopEnd_reg_immI_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpLoopEnd_reg_immI_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpCon_flags_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpCon_flags_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConP_0_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConP_0_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConN2P_0_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConN2P_0_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConP_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConP_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpN_null_branch_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpN_null_branch_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpN_reg_branch_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpN_reg_branch_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConIU_reg_reg_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConIU_reg_reg_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConIU_reg_imm_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConIU_reg_imm_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConI_reg_reg_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConI_reg_reg_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConI_reg_immI_0_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConI_reg_immI_0_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConI_reg_imm_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConI_reg_imm_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConIU_reg_immI_0_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConIU_reg_immI_0_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConL_regL_regL_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConL_regL_regL_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConL_regL_immL_0_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConL_regL_immL_0_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConL_regL_immL_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConL_regL_immL_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConF_reg_reg_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConF_reg_reg_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConD_reg_reg_longNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConD_reg_reg_longNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpDir_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpDir_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpLoopEnd_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpLoopEnd_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpLoopEnd_reg_immI_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpLoopEnd_reg_immI_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpCon_flags_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpCon_flags_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConP_0_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConP_0_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConN2P_0_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConN2P_0_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConP_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConP_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpN_null_branch_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpN_null_branch_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpN_reg_branch_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpN_reg_branch_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConIU_reg_reg_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConIU_reg_reg_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConIU_reg_imm_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConIU_reg_imm_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConI_reg_reg_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConI_reg_reg_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConI_reg_immI_0_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConI_reg_immI_0_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConI_reg_imm_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConI_reg_imm_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConIU_reg_immI_0_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConIU_reg_immI_0_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConL_regL_regL_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConL_regL_regL_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConL_regL_immL_0_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConL_regL_immL_0_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConL_regL_immL_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConL_regL_immL_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConF_reg_reg_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConF_reg_reg_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConD_reg_reg_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConD_reg_reg_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void CallRuntimeDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallStaticJavaDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallDynamicJavaDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafNoFPDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

int loadINode::reloc() const {
  return 1;
}

int loadI_convI2LNode::reloc() const {
  return 1;
}

int loadI2BNode::reloc() const {
  return 1;
}

int loadI2UBNode::reloc() const {
  return 1;
}

int loadI2SNode::reloc() const {
  return 1;
}

int loadI2USNode::reloc() const {
  return 1;
}

int loadLNode::reloc() const {
  return 1;
}

int loadL_unalignedNode::reloc() const {
  return 1;
}

int storeL_regNode::reloc() const {
  return 2;
}

int storeL_immL_0Node::reloc() const {
  return 2;
}

int storeL_immNode::reloc() const {
  return 2;
}

int loadNNode::reloc() const {
  return 1;
}

int loadN2PNode::reloc() const {
  return 1;
}

int loadPNode::reloc() const {
  return 1;
}

int loadKlassNode::reloc() const {
  return 1;
}

int loadNKlassNode::reloc() const {
  return 1;
}

int loadN2PKlassNode::reloc() const {
  return 1;
}

int loadRangeNode::reloc() const {
  return 1;
}

int storePNode::reloc() const {
  return 2;
}

int storeImmP_immP_0Node::reloc() const {
  return 3;
}

int storeImmBNode::reloc() const {
  return 2;
}

int storeNNode::reloc() const {
  return 2;
}

int storeP2NNode::reloc() const {
  return 2;
}

int storeNKlassNode::reloc() const {
  return 2;
}

int storeP2NKlassNode::reloc() const {
  return 2;
}

int storeImmN_immN_0Node::reloc() const {
  return 2;
}

int storeBNode::reloc() const {
  return 2;
}

int storeB_convL2INode::reloc() const {
  return 2;
}

int loadBNode::reloc() const {
  return 1;
}

int loadB_convI2LNode::reloc() const {
  return 1;
}

int loadUBNode::reloc() const {
  return 1;
}

int loadUB_convI2LNode::reloc() const {
  return 1;
}

int loadSNode::reloc() const {
  return 1;
}

int loadS2BNode::reloc() const {
  return 1;
}

int loadS_convI2LNode::reloc() const {
  return 1;
}

int storeImmINode::reloc() const {
  return 2;
}

int storeINode::reloc() const {
  return 2;
}

int storeI_convL2INode::reloc() const {
  return 2;
}

int loadFNode::reloc() const {
  return 1;
}

int loadConP_generalNode::reloc() const {
  return 1;
}

int loadConP_no_oop_cheapNode::reloc() const {
  return 1;
}

int loadConP_pollNode::reloc() const {
  return 1;
}

int loadConP_immP_0Node::reloc() const {
  return 1;
}

int TailCalljmpIndNode::reloc() const {
  return 1;
}

int RethrowExceptionNode::reloc() const {
  return 1;
}

int branchConP_0_longNode::reloc() const {
  return 1;
}

int branchConN2P_0_longNode::reloc() const {
  return 1;
}

int branchConP_0_shortNode::reloc() const {
  return 1;
}

int branchConN2P_0_shortNode::reloc() const {
  return 1;
}

int CallRuntimeDirectNode::reloc() const {
  return 1;
}

int lbu_and_lmaskNode::reloc() const {
  return 1;
}

int lbu_and_lmask_0Node::reloc() const {
  return 1;
}

int lbu_and_rmaskNode::reloc() const {
  return 1;
}

int RetNode::reloc() const {
  return 1;
}

int tailjmpIndNode::reloc() const {
  return 1;
}

int CallStaticJavaDirectNode::reloc() const {
  return 1;
}

int CallDynamicJavaDirectNode::reloc() const {
  return 1;
}

int CallLeafNoFPDirectNode::reloc() const {
  return 1;
}

int prefetchrNode::reloc() const {
  return 1;
}

int prefetchwNode::reloc() const {
  return 1;
}

int prefetchAllocNode::reloc() const {
  return 1;
}

int CallLeafDirectNode::reloc() const {
  return 1;
}

int loadUSNode::reloc() const {
  return 1;
}

int loadUS_convI2LNode::reloc() const {
  return 1;
}

int storeCNode::reloc() const {
  return 2;
}

int storeC_0Node::reloc() const {
  return 2;
}

int loadConF_immF_0Node::reloc() const {
  return 2;
}

int loadConFNode::reloc() const {
  return 2;
}

int loadConD_immD_0Node::reloc() const {
  return 2;
}

int loadConDNode::reloc() const {
  return 2;
}

int storeF_regNode::reloc() const {
  return 2;
}

int storeF_immF_0Node::reloc() const {
  return 3;
}

int loadDNode::reloc() const {
  return 1;
}

int loadD_unalignedNode::reloc() const {
  return 1;
}

int storeD_regNode::reloc() const {
  return 2;
}

int storeD_immD_0Node::reloc() const {
  return 3;
}

int storeImmCMNode::reloc() const {
  return 2;
}

int storePConditionalNode::reloc() const {
  return 1;
}

int storeIConditionalNode::reloc() const {
  return 1;
}

int storeLConditionalNode::reloc() const {
  return 1;
}

int loadPLockedNode::reloc() const {
  return 1;
}

int loadUI2L_rmaskNode::reloc() const {
  return 1;
}

int loadUI2L_lmaskNode::reloc() const {
  return 1;
}

int loadUI2L_lmask_0Node::reloc() const {
  return 1;
}

int safePoint_poll_regNode::reloc() const {
  return 1;
}

int safePoint_pollNode::reloc() const {
  return 1;
}

int loadV8Node::reloc() const {
  return 1;
}

int storeV8Node::reloc() const {
  return 2;
}

int Repl2F_zeroNode::reloc() const {
  return 1;
}


void loadINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1982 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if( Assembler::is_simm12(disp) ) {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ ld_w(as_Register(dst), AT, disp);
      } else {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ move(T4, disp);
        __ ldx_w(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_w(as_Register(dst), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ ldx_w(as_Register(dst), as_Register(base), T4);
      }
    }
  
#line 7518 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadI_convI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1982 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if( Assembler::is_simm12(disp) ) {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ ld_w(as_Register(dst), AT, disp);
      } else {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ move(T4, disp);
        __ ldx_w(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_w(as_Register(dst), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ ldx_w(as_Register(dst), as_Register(base), T4);
      }
    }
  
#line 7564 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadI2BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// twentyfour
  {

#line 1629 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if( Assembler::is_simm12(disp) ) {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ ld_b(as_Register(dst), AT, disp);
      } else {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ move(T4, disp);
        __ ldx_b(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_b(as_Register(dst), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ add_d(AT, as_Register(base), T4);
        __ ld_b(as_Register(dst), AT, 0);
      }
    }
  
#line 7612 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadI2UBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 1666 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ ld_bu(as_Register(dst), AT, disp);
      } else {
        __ move(T4, disp);
        __ ldx_bu(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_bu(as_Register(dst), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ ldx_bu(as_Register(dst), as_Register(base), T4);
      }
    }
  
#line 7654 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadI2SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// sixteen
  {

#line 1851 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        if( Assembler::is_simm12(disp) ) {
          __ ld_h(as_Register(dst), AT, disp);
        } else {
          __ move(T4, disp);
          __ ldx_h(as_Register(dst), AT, T4);
        }
    } else { // index is 0
        if( Assembler::is_simm12(disp) ) {
          __ ld_h(as_Register(dst), as_Register(base), disp);
        } else {
          __ move(T4, disp);
          __ ldx_h(as_Register(dst), as_Register(base), T4);
        }
    }
  
#line 7696 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadI2USNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 1882 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ ld_hu(as_Register(dst), AT, disp);
      } else {
        __ move(T4, disp);
        __ ldx_hu(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_hu(as_Register(dst), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ ldx_hu(as_Register(dst), as_Register(base), T4);
      }
    }
  
#line 7738 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);
    Register  dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ ld_d(dst_reg, AT, disp);
      } else {
        __ move(T4, disp);
        __ ldx_d(dst_reg, AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_d(dst_reg, as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ ldx_d(dst_reg, as_Register(base), T4);
      }
    }
  
#line 7779 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadL_unalignedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);
    Register  dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ ld_d(dst_reg, AT, disp);
      } else {
        __ move(T4, disp);
        __ ldx_d(dst_reg, AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_d(dst_reg, as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ ldx_d(dst_reg, as_Register(base), T4);
      }
    }
  
#line 7820 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2363 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);
    Register  src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ st_d(src_reg, AT, disp);
      } else {
        __ move(T4, disp);
        __ stx_d(src_reg, AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ st_d(src_reg, as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ stx_d(src_reg, as_Register(base), T4);
      }
    }
  
#line 7862 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeL_immL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2393 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ st_d(R0, AT, disp);
      } else {
        __ move(T4, disp);
        __ stx_d(R0, AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ st_d(R0, as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ stx_d(R0, as_Register(base), T4);
      }
    }
  
#line 7903 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeL_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2422 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);
    long  imm = opnd_array(2)->constantL();

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ set64(T4, imm);
        __ st_d(T4, AT, disp);
      } else {
        __ move(T4, disp);
        __ add_d(AT, AT, T4);
        __ set64(T4, imm);
        __ st_d(T4, AT, 0);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ move(AT, as_Register(base));
        __ set64(T4, imm);
        __ st_d(T4, AT, disp);
      } else {
        __ move(T4, disp);
        __ add_d(AT, as_Register(base), T4);
        __ set64(T4, imm);
        __ st_d(T4, AT, 0);
      }
    }
  
#line 7952 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2106 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    assert(disp_reloc == relocInfo::none, "cannot have disp");

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ ld_wu(as_Register(dst), AT, disp);
      } else {
        __ set64(T4, disp);
        __ ldx_wu(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_wu(as_Register(dst), as_Register(base), disp);
      } else {
        __ set64(T4, disp);
        __ ldx_wu(as_Register(dst), as_Register(base), T4);
      }
    }
  
#line 7995 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadN2PNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2106 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    assert(disp_reloc == relocInfo::none, "cannot have disp");

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ ld_wu(as_Register(dst), AT, disp);
      } else {
        __ set64(T4, disp);
        __ ldx_wu(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_wu(as_Register(dst), as_Register(base), disp);
      } else {
        __ set64(T4, disp);
        __ ldx_wu(as_Register(dst), as_Register(base), T4);
      }
    }
  
#line 8038 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2139 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    assert(disp_reloc == relocInfo::none, "cannot have disp");

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ ld_d(as_Register(dst), AT, disp);
      } else {
        __ set64(T4, disp);
        __ ldx_d(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_d(as_Register(dst), as_Register(base), disp);
      } else {
        __ set64(T4, disp);
        __ ldx_d(as_Register(dst), as_Register(base), T4);
      }
    }
  
#line 8081 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2139 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    assert(disp_reloc == relocInfo::none, "cannot have disp");

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ ld_d(as_Register(dst), AT, disp);
      } else {
        __ set64(T4, disp);
        __ ldx_d(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_d(as_Register(dst), as_Register(base), disp);
      } else {
        __ set64(T4, disp);
        __ ldx_d(as_Register(dst), as_Register(base), T4);
      }
    }
  
#line 8124 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadNKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2106 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    assert(disp_reloc == relocInfo::none, "cannot have disp");

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ ld_wu(as_Register(dst), AT, disp);
      } else {
        __ set64(T4, disp);
        __ ldx_wu(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_wu(as_Register(dst), as_Register(base), disp);
      } else {
        __ set64(T4, disp);
        __ ldx_wu(as_Register(dst), as_Register(base), T4);
      }
    }
  
#line 8167 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadN2PKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2106 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    assert(disp_reloc == relocInfo::none, "cannot have disp");

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ ld_wu(as_Register(dst), AT, disp);
      } else {
        __ set64(T4, disp);
        __ ldx_wu(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_wu(as_Register(dst), as_Register(base), disp);
      } else {
        __ set64(T4, disp);
        __ ldx_wu(as_Register(dst), as_Register(base), T4);
      }
    }
  
#line 8210 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadConINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5305 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    int    value = opnd_array(1)->constant();
    __ move(dst, value);
  
#line 8228 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadConL_set64Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5318 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ set64(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->constantL());
  
#line 8244 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadConL12Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5329 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    int      value   = opnd_array(1)->constantL();
    __ addi_d(dst_reg, R0, value);
  
#line 8262 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadConL_immL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5342 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ add_d(dst_reg, R0, R0);
  
#line 8279 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadRangeNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1982 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if( Assembler::is_simm12(disp) ) {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ ld_w(as_Register(dst), AT, disp);
      } else {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ move(T4, disp);
        __ ldx_w(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_w(as_Register(dst), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ ldx_w(as_Register(dst), as_Register(base), T4);
      }
    }
  
#line 8325 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2206 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  src = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ st_d(as_Register(src), AT, disp);
      } else {
        __ move(T4, disp);
        __ stx_d(as_Register(src), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ st_d(as_Register(src), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ stx_d(as_Register(src), as_Register(base), T4);
      }
    }
  
#line 8367 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeImmP_immP_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2266 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if (scale == 0) {
        if ( Assembler::is_simm12(disp) ) {
          __ add_d(AT, as_Register(base), as_Register(index));
          __ st_d(R0, AT, disp);
        } else {
          __ add_d(AT, as_Register(base), as_Register(index));
          __ move(T4, disp);
          __ stx_d(R0, AT, T4);
        }
      } else {
        if( Assembler::is_simm12(disp) ) {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
          __ st_d(R0, AT, disp);
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
          __ move(T4, disp);
          __ stx_d(R0, AT, T4);
        }
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ st_d(R0, as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ stx_d(R0, as_Register(base), T4);
      }
    }
  
#line 8416 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeImmBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1740 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);
    int value = opnd_array(2)->constant();

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        if (value == 0) {
          __ st_b(R0, AT, disp);
        } else {
          __ move(T4, value);
          __ st_b(T4, AT, disp);
        }
      } else {
        if (value == 0) {
          __ move(T4, disp);
          __ stx_b(R0, AT, T4);
        } else {
          __ move(T4, disp);
          __ add_d(AT, AT, T4);
          __ move(T4, value);
          __ st_b(T4, AT, 0);
        }
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        if (value == 0) {
          __ st_b(R0, as_Register(base), disp);
        } else {
          __ move(AT, value);
          __ st_b(AT, as_Register(base), disp);
        }
      } else {
        if (value == 0) {
          __ move(T4, disp);
          __ stx_b(R0, as_Register(base), T4);
        } else {
          __ move(T4, disp);
          __ add_d(AT, as_Register(base), T4);
          __ move(T4, value);
          __ st_b(T4, AT, 0);
        }
      }
    }
  
#line 8482 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2236 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  src = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ st_w(as_Register(src), AT, disp);
      } else {
        __ move(T4, disp);
        __ stx_w(as_Register(src), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ st_w(as_Register(src), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ stx_w(as_Register(src), as_Register(base), T4);
      }
    }
  
#line 8524 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeP2NNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2236 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  src = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ st_w(as_Register(src), AT, disp);
      } else {
        __ move(T4, disp);
        __ stx_w(as_Register(src), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ st_w(as_Register(src), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ stx_w(as_Register(src), as_Register(base), T4);
      }
    }
  
#line 8566 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeNKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2236 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  src = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ st_w(as_Register(src), AT, disp);
      } else {
        __ move(T4, disp);
        __ stx_w(as_Register(src), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ st_w(as_Register(src), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ stx_w(as_Register(src), as_Register(base), T4);
      }
    }
  
#line 8608 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeP2NKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2236 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  src = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ st_w(as_Register(src), AT, disp);
      } else {
        __ move(T4, disp);
        __ stx_w(as_Register(src), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ st_w(as_Register(src), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ stx_w(as_Register(src), as_Register(base), T4);
      }
    }
  
#line 8650 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeImmN_immN_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2303 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if(index!=0){
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }

      if( Assembler::is_simm12(disp) ) {
        __ st_w(R0, AT, disp);
      } else {
        __ move(T4, disp);
        __ stx_w(R0, AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ st_w(R0, as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ stx_w(R0, as_Register(base), T4);
      }
    }
  
#line 8692 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1696 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  src = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if (scale == 0) {
        if( Assembler::is_simm(disp, 8) ) {
          __ add_d(AT, as_Register(base), as_Register(index));
          __ st_b(as_Register(src), AT, disp);
        } else if( Assembler::is_simm12(disp) ) {
          __ add_d(AT, as_Register(base), as_Register(index));
          __ st_b(as_Register(src), AT, disp);
        } else {
          __ add_d(AT, as_Register(base), as_Register(index));
          __ move(T4, disp);
          __ stx_b(as_Register(src), AT, T4);
        }
      } else {
        if( Assembler::is_simm(disp, 8) ) {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
          __ st_b(as_Register(src), AT, disp);
        } else if( Assembler::is_simm12(disp) ) {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
          __ st_b(as_Register(src), AT, disp);
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
          __ move(T4, disp);
          __ stx_b(as_Register(src), AT, T4);
        }
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ st_b(as_Register(src), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ stx_b(as_Register(src), as_Register(base), T4);
      }
    }
  
#line 8748 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeB_convL2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1696 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  src = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if (scale == 0) {
        if( Assembler::is_simm(disp, 8) ) {
          __ add_d(AT, as_Register(base), as_Register(index));
          __ st_b(as_Register(src), AT, disp);
        } else if( Assembler::is_simm12(disp) ) {
          __ add_d(AT, as_Register(base), as_Register(index));
          __ st_b(as_Register(src), AT, disp);
        } else {
          __ add_d(AT, as_Register(base), as_Register(index));
          __ move(T4, disp);
          __ stx_b(as_Register(src), AT, T4);
        }
      } else {
        if( Assembler::is_simm(disp, 8) ) {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
          __ st_b(as_Register(src), AT, disp);
        } else if( Assembler::is_simm12(disp) ) {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
          __ st_b(as_Register(src), AT, disp);
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
          __ move(T4, disp);
          __ stx_b(as_Register(src), AT, T4);
        }
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ st_b(as_Register(src), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ stx_b(as_Register(src), as_Register(base), T4);
      }
    }
  
#line 8804 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1629 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if( Assembler::is_simm12(disp) ) {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ ld_b(as_Register(dst), AT, disp);
      } else {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ move(T4, disp);
        __ ldx_b(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_b(as_Register(dst), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ add_d(AT, as_Register(base), T4);
        __ ld_b(as_Register(dst), AT, 0);
      }
    }
  
#line 8851 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadB_convI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1629 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if( Assembler::is_simm12(disp) ) {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ ld_b(as_Register(dst), AT, disp);
      } else {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ move(T4, disp);
        __ ldx_b(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_b(as_Register(dst), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ add_d(AT, as_Register(base), T4);
        __ ld_b(as_Register(dst), AT, 0);
      }
    }
  
#line 8898 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadUBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1666 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ ld_bu(as_Register(dst), AT, disp);
      } else {
        __ move(T4, disp);
        __ ldx_bu(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_bu(as_Register(dst), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ ldx_bu(as_Register(dst), as_Register(base), T4);
      }
    }
  
#line 8939 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadUB_convI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1666 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ ld_bu(as_Register(dst), AT, disp);
      } else {
        __ move(T4, disp);
        __ ldx_bu(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_bu(as_Register(dst), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ ldx_bu(as_Register(dst), as_Register(base), T4);
      }
    }
  
#line 8980 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1851 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        if( Assembler::is_simm12(disp) ) {
          __ ld_h(as_Register(dst), AT, disp);
        } else {
          __ move(T4, disp);
          __ ldx_h(as_Register(dst), AT, T4);
        }
    } else { // index is 0
        if( Assembler::is_simm12(disp) ) {
          __ ld_h(as_Register(dst), as_Register(base), disp);
        } else {
          __ move(T4, disp);
          __ ldx_h(as_Register(dst), as_Register(base), T4);
        }
    }
  
#line 9021 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadS2BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// twentyfour
  {

#line 1629 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if( Assembler::is_simm12(disp) ) {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ ld_b(as_Register(dst), AT, disp);
      } else {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ move(T4, disp);
        __ ldx_b(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_b(as_Register(dst), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ add_d(AT, as_Register(base), T4);
        __ ld_b(as_Register(dst), AT, 0);
      }
    }
  
#line 9069 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadS_convI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1851 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        if( Assembler::is_simm12(disp) ) {
          __ ld_h(as_Register(dst), AT, disp);
        } else {
          __ move(T4, disp);
          __ ldx_h(as_Register(dst), AT, T4);
        }
    } else { // index is 0
        if( Assembler::is_simm12(disp) ) {
          __ ld_h(as_Register(dst), as_Register(base), disp);
        } else {
          __ move(T4, disp);
          __ ldx_h(as_Register(dst), as_Register(base), T4);
        }
    }
  
#line 9110 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeImmINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2052 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);
    int value = opnd_array(2)->constant();

    if( index != 0 ) {
      if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
      if( Assembler::is_simm12(disp) ) {
        if (value == 0) {
          __ st_w(R0, AT, disp);
        } else {
          __ move(T4, value);
          __ st_w(T4, AT, disp);
        }
      } else {
        if (value == 0) {
          __ move(T4, disp);
          __ stx_w(R0, AT, T4);
        } else {
          __ move(T4, disp);
          __ add_d(AT, AT, T4);
          __ move(T4, value);
          __ st_w(T4, AT, 0);
        }
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        if (value == 0) {
          __ st_w(R0, as_Register(base), disp);
        } else {
          __ move(AT, value);
          __ st_w(AT, as_Register(base), disp);
        }
      } else {
        if (value == 0) {
          __ move(T4, disp);
          __ stx_w(R0, as_Register(base), T4);
        } else {
          __ move(T4, disp);
          __ add_d(AT, as_Register(base), T4);
          __ move(T4, value);
          __ st_w(T4, AT, 0);
        }
      }
    }
  
#line 9176 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2017 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  src = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if( Assembler::is_simm12(disp) ) {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ st_w(as_Register(src), AT, disp);
      } else {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ move(T4, disp);
        __ stx_w(as_Register(src), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ st_w(as_Register(src), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ stx_w(as_Register(src), as_Register(base), T4);
      }
    }
  
#line 9223 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeI_convL2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2017 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  src = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if( Assembler::is_simm12(disp) ) {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ st_w(as_Register(src), AT, disp);
      } else {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ move(T4, disp);
        __ stx_w(as_Register(src), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ st_w(as_Register(src), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ stx_w(as_Register(src), as_Register(base), T4);
      }
    }
  
#line 9270 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2459 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);
    FloatRegister dst = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;

    if( index != 0 ) {
      if( Assembler::is_simm12(disp) ) {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ fld_s(dst, AT, disp);
      } else {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ move(T4, disp);
        __ fldx_s(dst, AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ fld_s(dst, as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ fldx_s(dst, as_Register(base), T4);
      }
    }
  
#line 9316 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadConP_generalNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5573 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    long* value = (long*)opnd_array(1)->constant();

    if(opnd_array(1)->constant_reloc() == relocInfo::metadata_type){
      int klass_index = __ oop_recorder()->find_index((Klass*)value);
      RelocationHolder rspec = metadata_Relocation::spec(klass_index);

      __ relocate(rspec);
      __ patchable_set52(dst, (long)value);
    } else if(opnd_array(1)->constant_reloc() == relocInfo::oop_type){
      int oop_index = __ oop_recorder()->find_index((jobject)value);
      RelocationHolder rspec = oop_Relocation::spec(oop_index);

      __ relocate(rspec);
      __ patchable_set52(dst, (long)value);
    } else if (opnd_array(1)->constant_reloc() == relocInfo::none) {
        __ set64(dst, (long)value);
    }
  
#line 9349 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadConP_no_oop_cheapNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5604 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ set64(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->constant());
  
#line 9365 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadConP_pollNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5618 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    intptr_t value = (intptr_t)opnd_array(1)->constant();

    __ set64(dst, (jlong)value);
  
#line 9384 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadConP_immP_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5634 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

     Register dst_reg = opnd_array(0)->as_Register(ra_,this)/* dst */;
     __ add_d(dst_reg, R0, R0);
  
#line 9401 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadConN_immN_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5644 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ move(opnd_array(0)->as_Register(ra_,this)/* dst */, R0);
  
#line 9417 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadConNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5655 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ set_narrow_oop(dst, (jobject)opnd_array(1)->constant());
  
#line 9434 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadConNKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 5667 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ set_narrow_klass(dst, (Klass*)opnd_array(1)->constant());
  
#line 9451 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void TailCalljmpIndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// method_oop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 5684 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register target = opnd_array(1)->as_Register(ra_,this,idx1)/* jump_target */;
    Register    oop = opnd_array(2)->as_Register(ra_,this,idx2)/* method_oop */;

    // RA will be used in generate_forward_exception()
    __ push(RA);

    __ move(S3, oop);
    __ jr(target);
  
#line 9475 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void CreateExceptionNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 5707 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    // X86 leaves this function empty
    __ block_comment("CreateException is empty in MIPS");
  
#line 9492 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void RethrowExceptionNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 5825 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ block_comment("@ RethrowException");

    cbuf.set_insts_mark();
    cbuf.relocate(cbuf.insts_mark(), runtime_call_Relocation::spec());

    // call OptoRuntime::rethrow_stub to get the exception handler in parent method
    __ patchable_jump((address)OptoRuntime::rethrow_stub());
  
#line 9514 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void jmpDir_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 5848 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Label* L = opnd_array(1)->label();
    __ jmp_far(*L);
  
#line 9531 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void jmpLoopEnd_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 5864 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;
    Label*     L = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        __ beq_long(op1, op2, *L);
        break;
      case 0x02: //not_equal
        __ bne_long(op1, op2, *L);
        break;
      case 0x03: //above
        __ blt_long(op2, op1, *L, true /* signed */);
        break;
      case 0x04: //above_equal
        __ bge_long(op1, op2, *L, true /* signed */);
        break;
      case 0x05: //below
        __ blt_long(op1, op2, *L, true /* signed */);
        break;
      case 0x06: //below_equal
        __ bge_long(op2, op1, *L, true /* signed */);
        break;
      default:
        Unimplemented();
    }
  
#line 9576 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void jmpLoopEnd_reg_immI_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 5903 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register op2 = AT;
    Label*     L = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    __ move(op2, opnd_array(3)->constant());

    switch(flag) {
      case 0x01: //equal
        __ beq_long(op1, op2, *L);
        break;
      case 0x02: //not_equal
        __ bne_long(op1, op2, *L);
        break;
      case 0x03: //above
        __ blt_long(op2, op1, *L, true /* signed */);
        break;
      case 0x04: //above_equal
        __ bge_long(op1, op2, *L, true /* signed */);
        break;
      case 0x05: //below
        __ blt_long(op1, op2, *L, true /* signed */);
        break;
      case 0x06: //below_equal
        __ bge_long(op2, op1, *L, true /* signed */);
        break;
      default:
        Unimplemented();
    }
  
#line 9623 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void jmpCon_flags_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 5947 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Label*    L =  opnd_array(3)->label();
    switch(opnd_array(1)->ccode()) {
      case 0x01: //equal
        __ bne_long(AT, R0, *L);
        break;
      case 0x02: //not equal
        __ beq_long(AT, R0, *L);
        break;
      default:
        Unimplemented();
    }
  
#line 9651 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConP_0_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 5973 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */;
    Register op2 = R0;
    Label*    L  = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        __ beq_long(op1, op2, *L);
        break;
      case 0x02: //not_equal
        __ bne_long(op1, op2, *L);
        break;
      default:
        Unimplemented();
    }
  
#line 9684 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConN2P_0_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6003 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */;
    Register op2 = R0;
    Label*    L  = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    switch(flag)
    {
      case 0x01: //equal
        __ beq_long(op1, op2, *L);
        break;
      case 0x02: //not_equal
        __ bne_long(op1, op2, *L);
        break;
      default:
        Unimplemented();
    }
  
#line 9718 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConP_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6035 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* op2 */;
    Label*    L  = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        __ beq_long(op1, op2, *L);
        break;
      case 0x02: //not_equal
        __ bne_long(op1, op2, *L);
        break;
      case 0x03: //above
        __ blt_long(op2, op1, *L, false /* unsigned */);
        break;
      case 0x04: //above_equal
        __ bge_long(op1, op2, *L, false /* unsigned */);
        break;
      case 0x05: //below
        __ blt_long(op1, op2, *L, false /* unsigned */);
        break;
      case 0x06: //below_equal
        __ bge_long(op2, op1, *L, false /* unsigned */);
       break;
      default:
          Unimplemented();
    }
  
#line 9763 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmpN_null_branch_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// null
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6076 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */;
    Register op2 = R0;
    Label*    L  = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
    case 0x01: //equal
      __ beq_long(op1, op2, *L);
      break;
    case 0x02: //not_equal
      __ bne_long(op1, op2, *L);
      break;
    default:
          Unimplemented();
    }
  
#line 9796 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmpN_reg_branch_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6105 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1_reg = opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */;
    Register op2_reg = opnd_array(3)->as_Register(ra_,this,idx3)/* op2 */;
    Label*    L  = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
    case 0x01: //equal
      __ beq_long(op1_reg, op2_reg, *L);
      break;
    case 0x02: //not_equal
      __ bne_long(op1_reg, op2_reg, *L);
      break;
    case 0x03: //above
      __ blt_long(op2_reg, op1_reg, *L, false /* unsigned */);
      break;
    case 0x04: //above_equal
      __ bge_long(op1_reg, op2_reg, *L, false /* unsigned */);
      break;
    case 0x05: //below
      __ blt_long(op1_reg, op2_reg, *L, false /* unsigned */);
      break;
    case 0x06: //below_equal
      __ bge_long(op2_reg, op1_reg, *L, false /* unsigned */);
      break;
    default:
      Unimplemented();
    }
  
#line 9841 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConIU_reg_reg_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6143 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;
    Label*     L = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        __ beq_long(op1, op2, *L);
        break;
      case 0x02: //not_equal
        __ bne_long(op1, op2, *L);
        break;
      case 0x03: //above
        __ blt_long(op2, op1, *L, false /* unsigned */);
        break;
      case 0x04: //above_equal
        __ bge_long(op1, op2, *L, false /* unsigned */);
        break;
      case 0x05: //below
        __ blt_long(op1, op2, *L, false /* unsigned */);
        break;
      case 0x06: //below_equal
        __ bge_long(op2, op1, *L, false /* unsigned */);
        break;
      default:
        Unimplemented();
    }
  
#line 9886 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConIU_reg_imm_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6183 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    int      val = opnd_array(3)->constant();
    Label*     L = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    __ move(AT, val);
    switch(flag) {
      case 0x01: //equal
        __ beq_long(op1, AT, *L);
        break;
      case 0x02: //not_equal
        __ bne_long(op1, AT, *L);
        break;
      case 0x03: //above
        __ blt_long(AT, op1, *L, false /* unsigned */);
        break;
      case 0x04: //above_equal
        __ bge_long(op1, AT, *L, false /* unsigned */);
        break;
      case 0x05: //below
        __ blt_long(op1, AT, *L, false /* unsigned */);
        break;
      case 0x06: //below_equal
        __ bge_long(AT, op1, *L, false /* unsigned */);
       break;
      default:
        Unimplemented();
    }
  
#line 9932 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConI_reg_reg_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6223 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;
    Label*     L = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        __ beq_long(op1, op2, *L);
        break;
      case 0x02: //not_equal
        __ bne_long(op1, op2, *L);
        break;
      case 0x03: //above
        __ blt_long(op2, op1, *L, true /* signed */);
        break;
      case 0x04: //above_equal
        __ bge_long(op1, op2, *L, true /* signed */);
        break;
      case 0x05: //below
        __ blt_long(op1, op2, *L, true /* signed */);
        break;
      case 0x06: //below_equal
        __ bge_long(op2, op1, *L, true /* signed */);
        break;
      default:
        Unimplemented();
    }
  
#line 9977 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConI_reg_immI_0_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6263 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Label*     L =  opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        __ beq_long(op1, R0, *L);
        break;
      case 0x02: //not_equal
        __ bne_long(op1, R0, *L);
        break;
      case 0x03: //greater
        __ blt_long(R0, op1, *L, true /* signed */);
        break;
      case 0x04: //greater_equal
        __ bge_long(op1, R0, *L, true /* signed */);
        break;
      case 0x05: //less
        __ blt_long(op1, R0, *L, true /* signed */);
        break;
      case 0x06: //less_equal
        __ bge_long(R0, op1, *L, true /* signed */);
        break;
      default:
        Unimplemented();
    }
  
#line 10021 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConI_reg_imm_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6302 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    int      val = opnd_array(3)->constant();
    Label*     L =  opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    __ move(AT, val);
    switch(flag) {
      case 0x01: //equal
        __ beq_long(op1, AT, *L);
        break;
      case 0x02: //not_equal
        __ bne_long(op1, AT, *L);
        break;
      case 0x03: //greater
        __ blt_long(AT, op1, *L, true /* signed */);
        break;
      case 0x04: //greater_equal
        __ bge_long(op1, AT, *L, true /* signed */);
        break;
      case 0x05: //less
        __ blt_long(op1, AT, *L, true /* signed */);
        break;
      case 0x06: //less_equal
        __ bge_long(AT, op1, *L, true /* signed */);
        break;
      default:
          Unimplemented();
    }
  
#line 10067 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConIU_reg_immI_0_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6342 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Label*     L = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        __ beq_long(op1, R0, *L);
        break;
      case 0x02: //not_equal
        __ bne_long(op1, R0, *L);
        break;
      case 0x03: //above
        __ bne_long(R0, op1, *L);
        break;
      case 0x04: //above_equal
        __ beq_long(R0, R0, *L);
        break;
      case 0x05: //below
        return;
        break;
      case 0x06: //below_equal
        __ beq_long(op1, R0, *L);
        break;
      default:
        Unimplemented();
    }
  
#line 10111 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConL_regL_regL_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6382 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register opr1_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
    Register opr2_reg = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */);

    Label*   target = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        __ beq_long(opr1_reg, opr2_reg, *target);
        break;

      case 0x02: //not_equal
        __ bne_long(opr1_reg, opr2_reg, *target);
        break;

      case 0x03: //greater
        __ blt_long(opr2_reg, opr1_reg, *target, true /* signed */);
        break;

      case 0x04: //greater_equal
        __ bge_long(opr1_reg, opr2_reg, *target, true /* signed */);
        break;

      case 0x05: //less
        __ blt_long(opr1_reg, opr2_reg, *target, true /* signed */);
        break;

      case 0x06: //less_equal
        __ bge_long(opr2_reg, opr1_reg, *target, true /* signed */);
        break;

      default:
        Unimplemented();
    }
  
#line 10163 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConL_regL_immL_0_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6430 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register opr1_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
    Register opr2_reg = R0;

    Label*   target = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        __ beq_long(opr1_reg, opr2_reg, *target);
        break;

      case 0x02: //not_equal
        __ bne_long(opr1_reg, opr2_reg, *target);
        break;

      case 0x03: //greater
        __ blt_long(opr2_reg, opr1_reg, *target, true /* signed */);
        break;

      case 0x04: //greater_equal
        __ bge_long(opr1_reg, opr2_reg, *target, true /* signed */);
        break;

      case 0x05: //less
        __ blt_long(opr1_reg, opr2_reg, *target, true /* signed */);
        break;

      case 0x06: //less_equal
        __ bge_long(opr2_reg, opr1_reg, *target, true /* signed */);
        break;

      default:
        Unimplemented();
    }
  
#line 10215 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConL_regL_immL_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6478 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register opr1_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
    Register opr2_reg = AT;

    Label*   target = opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    __ set64(opr2_reg, opnd_array(3)->constantL());

    switch(flag) {
      case 0x01: //equal
        __ beq_long(opr1_reg, opr2_reg, *target);
        break;

      case 0x02: //not_equal
        __ bne_long(opr1_reg, opr2_reg, *target);
        break;

      case 0x03: //greater
        __ blt_long(opr2_reg, opr1_reg, *target, true /* signed */);
        break;

      case 0x04: //greater_equal
        __ bge_long(opr1_reg, opr2_reg, *target, true /* signed */);
        break;

      case 0x05: //less
        __ blt_long(opr1_reg, opr2_reg, *target, true /* signed */);
        break;

      case 0x06: //less_equal
        __ bge_long(opr2_reg, opr1_reg, *target, true /* signed */);
        break;

      default:
        Unimplemented();
    }
  
#line 10269 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConF_reg_reg_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6529 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister reg_op1 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */;
    FloatRegister reg_op2 = opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */;
    Label*     L =  opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        __ fcmp_ceq_s(FCC0, reg_op1, reg_op2);
        __ bc1t_long(*L);
        break;
      case 0x02: //not_equal
        __ fcmp_ceq_s(FCC0, reg_op1, reg_op2);
        __ bc1f_long(*L);
        break;
      case 0x03: //greater
        __ fcmp_cule_s(FCC0, reg_op1, reg_op2);
        __ bc1f_long(*L);
        break;
      case 0x04: //greater_equal
        __ fcmp_cult_s(FCC0, reg_op1, reg_op2);
        __ bc1f_long(*L);
        break;
      case 0x05: //less
        __ fcmp_cult_s(FCC0, reg_op1, reg_op2);
        __ bc1t_long(*L);
        break;
      case 0x06: //less_equal
        __ fcmp_cule_s(FCC0, reg_op1, reg_op2);
        __ bc1t_long(*L);
        break;
      default:
        Unimplemented();
    }
  
#line 10320 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConD_reg_reg_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6574 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister reg_op1 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */;
    FloatRegister reg_op2 = opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */;
    Label*     L =  opnd_array(4)->label();
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        __ fcmp_ceq_d(FCC0, reg_op1, reg_op2);
        __ bc1t_long(*L);
        break;
      case 0x02: //not_equal
        // c_ueq_d cannot distinguish NaN from equal. Double.isNaN(Double) is implemented by 'f != f', so the use of c_ueq_d causes bugs.
        __ fcmp_ceq_d(FCC0, reg_op1, reg_op2);
        __ bc1f_long(*L);
        break;
      case 0x03: //greater
        __ fcmp_cule_d(FCC0, reg_op1, reg_op2);
        __ bc1f_long(*L);
        break;
      case 0x04: //greater_equal
        __ fcmp_cult_d(FCC0, reg_op1, reg_op2);
        __ bc1f_long(*L);
        break;
      case 0x05: //less
        __ fcmp_cult_d(FCC0, reg_op1, reg_op2);
        __ bc1t_long(*L);
        break;
      case 0x06: //less_equal
        __ fcmp_cule_d(FCC0, reg_op1, reg_op2);
        __ bc1t_long(*L);
        break;
      default:
        Unimplemented();
    }
  
#line 10372 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void jmpDir_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6627 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Label &L = *(opnd_array(1)->label());
    if(&L)
       __ b(L);
    else
       __ b(int(0));
  
#line 10392 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void jmpLoopEnd_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6647 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;
    Label     &L = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        if (&L)
          __ beq(op1, op2, L);
        else
          __ beq(op1, op2, (int)0);
        break;
      case 0x02: //not_equal
        if (&L)
          __ bne(op1, op2, L);
        else
          __ bne(op1, op2, (int)0);
        break;
      case 0x03: //above
        if (&L)
          __ blt(op2, op1, L);
        else
          __ blt(op2, op1, (int)0);
        break;
      case 0x04: //above_equal
        if (&L)
          __ bge(op1, op2, L);
        else
          __ bge(op1, op2, (int)0);
        break;
      case 0x05: //below
        if (&L)
          __ blt(op1, op2, L);
        else
          __ blt(op1, op2, (int)0);
        break;
      case 0x06: //below_equal
        if (&L)
          __ bge(op2, op1, L);
        else
          __ bge(op2, op1, (int)0);
        break;
      default:
        Unimplemented();
    }
  
#line 10455 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void jmpLoopEnd_reg_immI_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6705 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register op2 = AT;
    Label     &L = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    __ move(op2, opnd_array(3)->constant());

    switch(flag) {
      case 0x01: //equal
        if (&L)
          __ beq(op1, op2, L);
        else
          __ beq(op1, op2, (int)0);
        break;
      case 0x02: //not_equal
        if (&L)
          __ bne(op1, op2, L);
        else
          __ bne(op1, op2, (int)0);
        break;
      case 0x03: //above
        if (&L)
          __ blt(op2, op1, L);
        else
          __ blt(op2, op1, (int)0);
        break;
      case 0x04: //above_equal
        if (&L)
          __ bge(op1, op2, L);
        else
          __ bge(op1, op2, (int)0);
        break;
      case 0x05: //below
        if (&L)
          __ blt(op1, op2, L);
        else
          __ blt(op1, op2, (int)0);
        break;
      case 0x06: //below_equal
        if (&L)
          __ bge(op2, op1, L);
        else
          __ bge(op2, op1, (int)0);
        break;
      default:
        Unimplemented();
    }
  
#line 10520 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void jmpCon_flags_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6768 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Label    &L =  *(opnd_array(3)->label());
    switch(opnd_array(1)->ccode()) {
      case 0x01: //equal
        if (&L)
          __ bne(AT, R0, L);
        else
          __ bne(AT, R0, (int)0);
        break;
      case 0x02: //not equal
        if (&L)
          __ beq(AT, R0, L);
        else
          __ beq(AT, R0, (int)0);
        break;
      default:
        Unimplemented();
    }
  
#line 10554 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConP_0_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6801 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */;
    Register op2 = R0;
    Label    &L  = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        if (&L)
          __ beq(op1, op2, L);
        else
          __ beq(op1, op2, (int)0);
        break;
      case 0x02: //not_equal
        if (&L)
          __ bne(op1, op2, L);
        else
          __ bne(op1, op2, (int)0);
        break;
      default:
        Unimplemented();
    }
  
#line 10593 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConN2P_0_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6838 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */;
    Register op2 = R0;
    Label    &L  = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    switch(flag)
    {
      case 0x01: //equal
        if (&L)
          __ beq(op1, op2, L);
        else
          __ beq(op1, op2, (int)0);
        break;
      case 0x02: //not_equal
        if (&L)
          __ bne(op1, op2, L);
        else
          __ bne(op1, op2, (int)0);
        break;
      default:
        Unimplemented();
    }
  
#line 10633 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConP_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6877 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* op2 */;
    Label    &L  = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        if (&L)
          __ beq(op1, op2, L);
        else
          __ beq(op1, op2, (int)0);
        break;
      case 0x02: //not_equal
        if (&L)
          __ bne(op1, op2, L);
        else
          __ bne(op1, op2, (int)0);
        break;
      case 0x03: //above
        if (&L)
          __ bltu(op2, op1, L);
        else
          __ bltu(op2, op1, (int)0);
        break;
      case 0x04: //above_equal
        if (&L)
          __ bgeu(op1, op2, L);
        else
          __ bgeu(op1, op2, (int)0);
        break;
      case 0x05: //below
        if (&L)
          __ bltu(op1, op2, L);
        else
          __ bltu(op1, op2, (int)0);
        break;
      case 0x06: //below_equal
        if (&L)
          __ bgeu(op2, op1, L);
        else
          __ bgeu(op2, op1, (int)0);
       break;
      default:
          Unimplemented();
    }
  
#line 10696 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmpN_null_branch_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// null
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6937 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */;
    Register op2 = R0;
    Label    &L  = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
    case 0x01: //equal
      if (&L)
        __ beq(op1, op2, L);
      else
        __ beq(op1, op2, (int)0);
      break;
    case 0x02: //not_equal
      if (&L)
        __ bne(op1, op2, L);
      else
        __ bne(op1, op2, (int)0);
      break;
    default:
          Unimplemented();
    }
  
#line 10735 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmpN_reg_branch_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6973 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1_reg = opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */;
    Register op2_reg = opnd_array(3)->as_Register(ra_,this,idx3)/* op2 */;
    Label    &L  = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
    case 0x01: //equal
      if (&L)
        __ beq(op1_reg, op2_reg, L);
      else
        __ beq(op1_reg, op2_reg, (int)0);
      break;
    case 0x02: //not_equal
      if (&L)
        __ bne(op1_reg, op2_reg, L);
      else
        __ bne(op1_reg, op2_reg, (int)0);
      break;
    case 0x03: //above
      if (&L)
        __ bltu(op2_reg, op1_reg, L);
      else
        __ bltu(op2_reg, op1_reg, (int)0);
      break;
    case 0x04: //above_equal
      if (&L)
        __ bgeu(op1_reg, op2_reg, L);
      else
        __ bgeu(op1_reg, op2_reg, (int)0);
      break;
    case 0x05: //below
      if (&L)
        __ bltu(op1_reg, op2_reg, L);
      else
        __ bltu(op1_reg, op2_reg, (int)0);
      break;
    case 0x06: //below_equal
      if (&L)
        __ bgeu(op2_reg, op1_reg, L);
      else
        __ bgeu(op2_reg, op1_reg, (int)0);
      break;
    default:
      Unimplemented();
    }
  
#line 10798 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConIU_reg_reg_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 7030 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;
    Label     &L = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        if (&L)
          __ beq(op1, op2, L);
        else
          __ beq(op1, op2, (int)0);
        break;
      case 0x02: //not_equal
        if (&L)
          __ bne(op1, op2, L);
        else
          __ bne(op1, op2, (int)0);
        break;
      case 0x03: //above
        if (&L)
          __ bltu(op2, op1, L);
        else
          __ bltu(op2, op1, (int)0);
        break;
      case 0x04: //above_equal
        if (&L)
          __ bgeu(op1, op2, L);
        else
          __ bgeu(op1, op2, (int)0);
        break;
      case 0x05: //below
        if (&L)
           __ bltu(op1, op2, L);
        else
           __ bltu(op1, op2, (int)0);
        break;
      case 0x06: //below_equal
        if (&L)
          __ bgeu(op2, op1, L);
        else
          __ bgeu(op2, op1, (int)0);
        break;
      default:
        Unimplemented();
    }
  
#line 10861 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConIU_reg_imm_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 7089 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    int      val = opnd_array(3)->constant();
    Label     &L = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    __ move(AT, val);
    switch(flag) {
      case 0x01: //equal
        if (&L)
          __ beq(op1, AT, L);
        else
          __ beq(op1, AT, (int)0);
        break;
      case 0x02: //not_equal
        if (&L)
          __ bne(op1, AT, L);
        else
          __ bne(op1, AT, (int)0);
        break;
      case 0x03: //above
        if (&L)
          __ bltu(AT, op1, L);
        else
          __ bltu(AT, op1, (int)0);
        break;
      case 0x04: //above_equal
        if (&L)
          __ bgeu(op1, AT, L);
        else
          __ bgeu(op1, AT, (int)0);
        break;
      case 0x05: //below
        if (&L)
           __ bltu(op1, AT, L);
        else
           __ bltu(op1, AT, (int)0);
        break;
      case 0x06: //below_equal
        if (&L)
          __ bgeu(AT, op1, L);
        else
          __ bgeu(AT, op1, (int)0);
       break;
      default:
        Unimplemented();
    }
  
#line 10925 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConI_reg_reg_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 7148 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;
    Label     &L = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        if (&L)
          __ beq(op1, op2, L);
        else
          __ beq(op1, op2, (int)0);
        break;
      case 0x02: //not_equal
        if (&L)
          __ bne(op1, op2, L);
        else
          __ bne(op1, op2, (int)0);
        break;
      case 0x03: //above
        if (&L)
          __ blt(op2, op1, L);
        else
          __ blt(op2, op1, (int)0);
        break;
      case 0x04: //above_equal
        if (&L)
          __ bge(op1, op2, L);
        else
          __ bge(op1, op2, (int)0);
        break;
      case 0x05: //below
        if (&L)
          __ blt(op1, op2, L);
        else
          __ blt(op1, op2, (int)0);
        break;
      case 0x06: //below_equal
        if (&L)
          __ bge(op2, op1, L);
        else
          __ bge(op2, op1, (int)0);
       break;
      default:
        Unimplemented();
    }
  
#line 10988 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConI_reg_immI_0_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 7207 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Label     &L =  *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        if (&L)
          __ beq(op1, R0, L);
        else
          __ beq(op1, R0, (int)0);
        break;
      case 0x02: //not_equal
        if (&L)
          __ bne(op1, R0, L);
        else
          __ bne(op1, R0, (int)0);
        break;
      case 0x03: //greater
        if (&L)
          __ blt(R0, op1, L);
        else
          __ blt(R0, op1, (int)0);
        break;
      case 0x04: //greater_equal
        if (&L)
          __ bge(op1, R0, L);
        else
          __ bge(op1, R0, (int)0);
        break;
      case 0x05: //less
        if (&L)
          __ blt(op1, R0, L);
        else
          __ blt(op1, R0, (int)0);
        break;
      case 0x06: //less_equal
        if (&L)
          __ bge(R0, op1, L);
        else
          __ bge(R0, op1, (int)0);
       break;
      default:
        Unimplemented();
    }
  
#line 11050 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConI_reg_imm_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 7266 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    int      val = opnd_array(3)->constant();
    Label     &L =  *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    __ move(AT, val);
    switch(flag) {
      case 0x01: //equal
        if (&L)
          __ beq(op1, AT, L);
        else
          __ beq(op1, AT, (int)0);
        break;
      case 0x02: //not_equal
        if (&L)
          __ bne(op1, AT, L);
        else
          __ bne(op1, AT, (int)0);
        break;
      case 0x03: //greater
        if (&L)
          __ blt(AT, op1, L);
        else
          __ blt(AT, op1, (int)0);
        break;
      case 0x04: //greater_equal
        if (&L)
          __ bge(op1, AT, L);
        else
          __ bge(op1, AT, (int)0);
        break;
      case 0x05: //less
        if (&L)
          __ blt(op1, AT, L);
        else
          __ blt(op1, AT, (int)0);
        break;
      case 0x06: //less_equal
        if (&L)
          __ bge(AT, op1, L);
        else
          __ bge(AT, op1, (int)0);
       break;
      default:
          Unimplemented();
    }
  
#line 11114 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConIU_reg_immI_0_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 7325 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Label     &L = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        if (&L)
          __ beq(op1, R0, L);
        else
          __ beq(op1, R0, (int)0);
        break;
      case 0x02: //not_equal
        if (&L)
          __ bne(op1, R0, L);
        else
          __ bne(op1, R0, (int)0);
        break;
      case 0x03: //above
        if (&L)
          __ bne(R0, op1, L);
        else
          __ bne(R0, op1, (int)0);
        break;
      case 0x04: //above_equal
        if (&L)
          __ beq(R0, R0, L);
        else
          __ beq(R0, R0, (int)0);
        break;
      case 0x05: //below
        return;
        break;
      case 0x06: //below_equal
        if (&L)
          __ beq(op1, R0, L);
        else
          __ beq(op1, R0, (int)0);
        break;
      default:
        Unimplemented();
    }
    
#line 11173 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConL_regL_regL_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 7381 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register opr1_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
    Register opr2_reg = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */);

    Label   &target = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        if (&target)
          __ beq(opr1_reg, opr2_reg, target);
        else
          __ beq(opr1_reg, opr2_reg, (int)0);
        break;
      case 0x02: //not_equal
        if(&target)
          __ bne(opr1_reg, opr2_reg, target);
        else
          __ bne(opr1_reg, opr2_reg, (int)0);
        break;
      case 0x03: //greater
        if (&target)
          __ blt(opr2_reg, opr1_reg, target);
        else
          __ blt(opr2_reg, opr1_reg, (int)0);
        break;
      case 0x04: //greater_equal
        if (&target)
          __ bge(opr1_reg, opr2_reg, target);
        else
          __ bge(opr1_reg, opr2_reg, (int)0);
        break;
      case 0x05: //less
        if (&target)
          __ blt(opr1_reg, opr2_reg, target);
        else
          __ blt(opr1_reg, opr2_reg, (int)0);
        break;
      case 0x06: //less_equal
        if (&target)
          __ bge(opr2_reg, opr1_reg, target);
        else
          __ bge(opr2_reg, opr1_reg, (int)0);
        break;
      default:
        Unimplemented();
    }
  
#line 11237 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConL_regL_immL_0_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 7443 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register opr1_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
    Label   &target = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        if (&target)
           __ beq(opr1_reg, R0, target);
        else
           __ beq(opr1_reg, R0, int(0));
        break;

      case 0x02: //not_equal
        if (&target)
           __ bne(opr1_reg, R0, target);
        else
           __ bne(opr1_reg, R0, (int)0);
        break;

      case 0x03: //greater
        if (&target)
           __ blt(R0, opr1_reg, target);
        else
           __ blt(R0, opr1_reg, (int)0);
       break;

      case 0x04: //greater_equal
        if (&target)
           __ bge(opr1_reg, R0, target);
        else
           __ bge(opr1_reg, R0, (int)0);
        break;

      case 0x05: //less
        if (&target)
           __ blt(opr1_reg, R0, target);
        else
           __ blt(opr1_reg, R0, (int)0);
        break;

      case 0x06: //less_equal
        if (&target)
           __ bge(R0, opr1_reg, target);
        else
           __ bge(R0, opr1_reg, int(0));
        break;

      default:
          Unimplemented();
    }
  
#line 11305 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConL_regL_immL_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 7508 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register opr1_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
    Register opr2_reg = AT;

    Label   &target = *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    __ set64(opr2_reg, opnd_array(3)->constantL());

    switch(flag) {
      case 0x01: //equal
        if (&target)
          __ beq(opr1_reg, opr2_reg, target);
        else
          __ beq(opr1_reg, opr2_reg, (int)0);
        break;

      case 0x02: //not_equal
        if(&target)
          __ bne(opr1_reg, opr2_reg, target);
        else
          __ bne(opr1_reg, opr2_reg, (int)0);
        break;

      case 0x03: //greater
        if (&target)
          __ blt(opr2_reg, opr1_reg, target);
        else
          __ blt(opr2_reg, opr1_reg, (int)0);
        break;

      case 0x04: //greater_equal
        if (&target)
          __ bge(opr1_reg, opr2_reg, target);
        else
          __ bge(opr1_reg, opr2_reg, (int)0);
        break;

      case 0x05: //less
        if (&target)
          __ blt(opr1_reg, opr2_reg, target);
        else
          __ blt(opr1_reg, opr2_reg, (int)0);
        break;

      case 0x06: //less_equal
        if (&target)
          __ bge(opr2_reg, opr1_reg, target);
        else
          __ bge(opr2_reg, opr1_reg, (int)0);
        break;

      default:
        Unimplemented();
    }
  
#line 11377 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConF_reg_reg_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 7578 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister reg_op1 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */;
    FloatRegister reg_op2 = opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */;
    Label     &L =  *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        __ fcmp_ceq_s(FCC0, reg_op1, reg_op2);
        if (&L)
          __ bcnez(FCC0, L);
        else
          __ bcnez(FCC0, (int)0);
        break;
      case 0x02: //not_equal
        __ fcmp_ceq_s(FCC0, reg_op1, reg_op2);
        if (&L)
          __ bceqz(FCC0, L);
        else
          __ bceqz(FCC0, (int)0);
        break;
      case 0x03: //greater
        __ fcmp_cule_s(FCC0, reg_op1, reg_op2);
        if(&L)
          __ bceqz(FCC0, L);
        else
          __ bceqz(FCC0, (int)0);
        break;
      case 0x04: //greater_equal
        __ fcmp_cult_s(FCC0, reg_op1, reg_op2);
        if(&L)
          __ bceqz(FCC0, L);
        else
          __ bceqz(FCC0, (int)0);
        break;
      case 0x05: //less
        __ fcmp_cult_s(FCC0, reg_op1, reg_op2);
        if(&L)
          __ bcnez(FCC0, L);
        else
          __ bcnez(FCC0, (int)0);
        break;
      case 0x06: //less_equal
        __ fcmp_cule_s(FCC0, reg_op1, reg_op2);
        if(&L)
          __ bcnez(FCC0, L);
        else
          __ bcnez(FCC0, (int)0);
        break;
      default:
        Unimplemented();
    }
  
#line 11446 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void branchConD_reg_reg_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 7642 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister reg_op1 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */;
    FloatRegister reg_op2 = opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */;
    Label     &L =  *(opnd_array(4)->label());
    int     flag = opnd_array(1)->ccode();

    switch(flag) {
      case 0x01: //equal
        __ fcmp_ceq_d(FCC0, reg_op1, reg_op2);
        if (&L)
          __ bcnez(FCC0, L);
        else
          __ bcnez(FCC0, (int)0);
        break;
      case 0x02: //not_equal
        // c_ueq_d cannot distinguish NaN from equal. Double.isNaN(Double) is implemented by 'f != f', so the use of c_ueq_d causes bugs.
        __ fcmp_ceq_d(FCC0, reg_op1, reg_op2);
        if (&L)
          __ bceqz(FCC0, L);
        else
          __ bceqz(FCC0, (int)0);
        break;
      case 0x03: //greater
        __ fcmp_cule_d(FCC0, reg_op1, reg_op2);
        if(&L)
          __ bceqz(FCC0, L);
        else
          __ bceqz(FCC0, (int)0);
        break;
      case 0x04: //greater_equal
        __ fcmp_cult_d(FCC0, reg_op1, reg_op2);
        if(&L)
          __ bceqz(FCC0, L);
        else
          __ bceqz(FCC0, (int)0);
        break;
      case 0x05: //less
        __ fcmp_cult_d(FCC0, reg_op1, reg_op2);
        if(&L)
          __ bcnez(FCC0, L);
        else
          __ bcnez(FCC0, (int)0);
        break;
      case 0x06: //less_equal
        __ fcmp_cule_d(FCC0, reg_op1, reg_op2);
        if(&L)
          __ bcnez(FCC0, L);
        else
          __ bcnez(FCC0, (int)0);
        break;
      default:
        Unimplemented();
    }
  
#line 11516 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void CallRuntimeDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2599 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    // This is the instruction starting address for relocation info.
    __ block_comment("Java_To_Runtime");
    cbuf.set_insts_mark();
    __ relocate(relocInfo::runtime_call_type);

    __ patchable_call((address)opnd_array(1)->method());
  
#line 11537 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void membar_acquireNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 7726 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ dbar(0);
  
#line 11553 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void load_fenceNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 7737 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ dbar(0);
  
#line 11569 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void membar_acquire_lockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint membar_acquire_lockNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_releaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 7760 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    // Attention: DO NOT DELETE THIS GUY!
    __ dbar(0);
  
#line 11599 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void store_fenceNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 7774 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ dbar(0);
  
#line 11615 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void membar_release_lockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint membar_release_lockNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 7798 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    if( !os::is_MP() ) return;     // Not needed on single CPU
    __ dbar(0);

  
#line 11646 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void unnecessary_membar_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint unnecessary_membar_volatileNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_storestoreNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 7822 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ dbar(0);
  
#line 11675 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void castX2PNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7832 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;

  if(src != dst)
    __ move(dst, src);
  
#line 11695 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void castP2XNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7847 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;

  if(src != dst)
    __ move(dst, src);
  
#line 11715 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void MoveF2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7862 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    FloatRegister src = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */);

    __ movfr2gr_s(dst, src);
  
#line 11734 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void MoveI2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7876 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    FloatRegister dst = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ movgr2fr_w(dst, src);
  
#line 11753 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void MoveD2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7890 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    FloatRegister src = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */);

    __ movfr2gr_d(dst, src);
  
#line 11772 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void MoveL2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7904 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister dst = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);

    __ movgr2fr_d(dst, src);
  
#line 11791 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovI_cmpI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7923 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, true /* is_signed */);
  
#line 11817 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovI_cmpP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7943 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 11843 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovI_cmpN_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7963 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 11869 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovP_cmpU_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7983 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 11895 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovP_cmpF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {
    MacroAssembler _masm(&cbuf);

#line 8005 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister reg_op1 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp1 */;
    FloatRegister reg_op2 = opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp2 */;
    FloatRegister tmp1 = opnd_array(6)->as_FloatRegister(ra_,this,idx6)/* tmp3 */;
    FloatRegister tmp2 = opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* tmp4 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(reg_op1, reg_op2, dst, src, tmp1, tmp2, (MacroAssembler::CMCompare) flag, true /* is_float */);
  
#line 11925 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovP_cmpN_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 8026 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 11951 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovN_cmpP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 8046 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 11977 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovP_cmpD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {
    MacroAssembler _masm(&cbuf);

#line 8067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister reg_op1 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp1 */);
    FloatRegister reg_op2 = as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp2 */);
    FloatRegister tmp1 = opnd_array(6)->as_FloatRegister(ra_,this,idx6)/* tmp3 */;
    FloatRegister tmp2 = opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* tmp4 */;
    Register dst = as_Register(opnd_array(4)->reg(ra_,this,idx4)/* dst */);
    Register src = as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src */);
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(reg_op1, reg_op2, dst, src, tmp1, tmp2, (MacroAssembler::CMCompare) flag, false /* is_float */);
  
#line 12007 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovN_cmpN_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 8090 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 12033 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovI_cmpU_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 8111 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 12059 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovI_cmpL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 8131 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register opr1 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* tmp1 */);
    Register opr2 = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* tmp2 */);
    Register dst  = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src  = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag  = opnd_array(1)->ccode();

    __ cmp_cmov(opr1, opr2, dst, src, (MacroAssembler::CMCompare) flag, true /* is_signed */);
  
#line 12085 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovP_cmpL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 8151 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register opr1 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* tmp1 */);
    Register opr2 = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* tmp2 */);
    Register dst  = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src  = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag  = opnd_array(1)->ccode();

    __ cmp_cmov(opr1, opr2, dst, src, (MacroAssembler::CMCompare) flag, true /* is_signed */);
  
#line 12111 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovI_cmpD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {
    MacroAssembler _masm(&cbuf);

#line 8172 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister reg_op1 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp1 */);
    FloatRegister reg_op2 = as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp2 */);
    FloatRegister tmp1 = opnd_array(6)->as_FloatRegister(ra_,this,idx6)/* tmp3 */;
    FloatRegister tmp2 = opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* tmp4 */;
    Register dst = as_Register(opnd_array(4)->reg(ra_,this,idx4)/* dst */);
    Register src = as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src */);
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(reg_op1, reg_op2, dst, src, tmp1, tmp2, (MacroAssembler::CMCompare) flag, false /* is_float */);
  
#line 12141 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovP_cmpP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 8195 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 12167 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovP_cmpI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 8215 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, true /* is_signed */);
  
#line 12193 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovL_cmpP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 8235 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();
    Label L;

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 12220 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovN_cmpU_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 8256 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 12246 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovN_cmpL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 8276 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register opr1 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* tmp1 */);
    Register opr2 = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* tmp2 */);
    Register dst  = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src  = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag  = opnd_array(1)->ccode();

    __ cmp_cmov(opr1, opr2, dst, src, (MacroAssembler::CMCompare) flag, true /* is_signed */);
  
#line 12272 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovN_cmpI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 8296 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, true /* is_signed */);
  
#line 12298 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovL_cmpU_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 8316 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 12324 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovL_cmpF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {
    MacroAssembler _masm(&cbuf);

#line 8338 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister reg_op1 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp1 */;
    FloatRegister reg_op2 = opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp2 */;
    FloatRegister tmp1 = opnd_array(6)->as_FloatRegister(ra_,this,idx6)/* tmp3 */;
    FloatRegister tmp2 = opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* tmp4 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(reg_op1, reg_op2, dst, src, tmp1, tmp2, (MacroAssembler::CMCompare) flag, true /* is_float */);
  
#line 12354 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovL_cmpI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 8360 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = as_Register(opnd_array(4)->reg(ra_,this,idx4)/* dst */);
    Register src = as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src */);
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, true /* is_signed */);
  
#line 12380 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovL_cmpL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 8380 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register opr1 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* tmp1 */);
    Register opr2 = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* tmp2 */);
    Register dst  = as_Register(opnd_array(4)->reg(ra_,this,idx4)/* dst */);
    Register src  = as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src */);
    int     flag  = opnd_array(1)->ccode();

    __ cmp_cmov(opr1, opr2, dst, src, (MacroAssembler::CMCompare) flag, true /* is_signed */);
  
#line 12406 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovL_cmpN_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 8400 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_signed */);
  
#line 12432 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovL_cmpD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {
    MacroAssembler _masm(&cbuf);

#line 8422 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister reg_op1 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp1 */);
    FloatRegister reg_op2 = as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp2 */);
    FloatRegister tmp1 = opnd_array(6)->as_FloatRegister(ra_,this,idx6)/* tmp3 */;
    FloatRegister tmp2 = opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* tmp4 */;
    Register dst = as_Register(opnd_array(4)->reg(ra_,this,idx4)/* dst */);
    Register src = as_Register(opnd_array(5)->reg(ra_,this,idx5)/* src */);
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(reg_op1, reg_op2, dst, src, tmp1, tmp2, (MacroAssembler::CMCompare) flag, false /* is_float */);
  
#line 12462 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovD_cmpD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 8444 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister reg_op1 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* tmp1 */);
    FloatRegister reg_op2 = as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* tmp2 */);
    FloatRegister dst = as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* dst */);
    FloatRegister src = as_FloatRegister(opnd_array(5)->reg(ra_,this,idx5)/* src */);
    int flag = opnd_array(1)->ccode();

    __ cmp_cmov(reg_op1, reg_op2, dst, src, (MacroAssembler::CMCompare) flag, false /* is_float */);
  
#line 12488 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovF_cmpI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {
    MacroAssembler _masm(&cbuf);

#line 8466 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    FloatRegister dst = as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* dst */);
    FloatRegister src = as_FloatRegister(opnd_array(5)->reg(ra_,this,idx5)/* src */);
    FloatRegister tmp1 = as_FloatRegister(opnd_array(6)->reg(ra_,this,idx6)/* tmp3 */);
    FloatRegister tmp2 = as_FloatRegister(opnd_array(7)->reg(ra_,this,idx7)/* tmp4 */);
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, tmp1, tmp2, (MacroAssembler::CMCompare) flag);
  
#line 12518 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovD_cmpI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {
    MacroAssembler _masm(&cbuf);

#line 8490 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    FloatRegister dst = as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* dst */);
    FloatRegister src = as_FloatRegister(opnd_array(5)->reg(ra_,this,idx5)/* src */);
    FloatRegister tmp1 = as_FloatRegister(opnd_array(6)->reg(ra_,this,idx6)/* tmp3 */);
    FloatRegister tmp2 = as_FloatRegister(opnd_array(7)->reg(ra_,this,idx7)/* tmp4 */);
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(op1, op2, dst, src, tmp1, tmp2, (MacroAssembler::CMCompare) flag);
  
#line 12548 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovD_cmpP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {
    MacroAssembler _masm(&cbuf);

#line 8514 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register op1 = opnd_array(2)->as_Register(ra_,this,idx2)/* tmp1 */;
    Register op2 = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp2 */;
    FloatRegister dst = as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* dst */);
    FloatRegister src = as_FloatRegister(opnd_array(5)->reg(ra_,this,idx5)/* src */);
    FloatRegister tmp1 = as_FloatRegister(opnd_array(6)->reg(ra_,this,idx6)/* tmp3 */);
    FloatRegister tmp2 = as_FloatRegister(opnd_array(7)->reg(ra_,this,idx7)/* tmp4 */);
    int     flag = opnd_array(1)->ccode();

    // Use signed comparison here, because the most significant bit of the
    // user-space virtual address must be 0.
    __ cmp_cmov(op1, op2, dst, src, tmp1, tmp2, (MacroAssembler::CMCompare) flag);
  
#line 12580 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovI_cmpF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {
    MacroAssembler _masm(&cbuf);

#line 8541 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister reg_op1 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp1 */;
    FloatRegister reg_op2 = opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp2 */;
    FloatRegister tmp1 = opnd_array(6)->as_FloatRegister(ra_,this,idx6)/* tmp3 */;
    FloatRegister tmp2 = opnd_array(7)->as_FloatRegister(ra_,this,idx7)/* tmp4 */;
    Register dst = opnd_array(4)->as_Register(ra_,this,idx4)/* dst */;
    Register src = opnd_array(5)->as_Register(ra_,this,idx5)/* src */;
    int     flag = opnd_array(1)->ccode();

    __ cmp_cmov(reg_op1, reg_op2, dst, src, tmp1, tmp2, (MacroAssembler::CMCompare) flag, true /* is_float */);
  
#line 12610 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmovF_cmpF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 8563 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister reg_op1 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* tmp1 */;
    FloatRegister reg_op2 = opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* tmp2 */;
    FloatRegister dst = opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* dst */;
    FloatRegister src = opnd_array(5)->as_FloatRegister(ra_,this,idx5)/* src */;
    int flag = opnd_array(1)->ccode();

    __ cmp_cmov(reg_op1, reg_op2, dst, src, (MacroAssembler::CMCompare) flag, true /* is_float */);
  
#line 12636 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmpL3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8581 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register opr1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register opr2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    Register dst  = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);

    __ slt(AT, opr1, opr2);
    __ slt(dst, opr2, opr1);
    __ sub_d(dst, dst, AT);
  
#line 12659 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmpF3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8603 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister src1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    FloatRegister src2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fcmp_clt_s(FCC0, src2, src1);
    __ fcmp_cult_s(FCC1, src1, src2);
    __ movcf2gr(dst, FCC0);
    __ movcf2gr(AT, FCC1);
    __ sub_d(dst, dst, AT);

  
#line 12685 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmpD3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8622 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister src1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    FloatRegister src2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fcmp_clt_d(FCC0, src2, src1);
    __ fcmp_cult_d(FCC1, src1, src2);
    __ movcf2gr(dst, FCC0);
    __ movcf2gr(AT, FCC1);
    __ sub_d(dst, dst, AT);
  
#line 12710 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void clear_arrayNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cnt
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  {
    MacroAssembler _masm(&cbuf);

#line 8639 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    //Assume cnt is the number of bytes in an array to be cleared,
    //and base points to the starting address of the array.
    Register base = opnd_array(2)->as_Register(ra_,this,idx2)/* base */;
    Register num  = opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */;
    Label Loop, done;

    __ add_d(AT, base, R0);
    __ beq(num, R0, done);

    __ move(T4, num);  /* T4 = words */

    __ bind(Loop);
    __ st_d(R0, AT, 0);
    __ addi_d(T4, T4, -1);
    __ addi_d(AT, AT, wordSize);
    __ bne(T4, R0, Loop);

    __ bind(done);
  
#line 12744 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void string_compareNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  {
    MacroAssembler _masm(&cbuf);

#line 8667 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    // Get the first character position in both strings
    //         [8] char array, [12] offset, [16] count
    Register str1   = opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */;
    Register str2   = opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */;
    Register cnt1   = opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */;
    Register cnt2   = opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */;
    Register result = opnd_array(0)->as_Register(ra_,this)/* result */;

    Label L, Loop, haveResult, done;

   // compute the and difference of lengths (in result)
   __ sub_d(result, cnt1, cnt2); // result holds the difference of two lengths

   // compute the shorter length (in cnt1)
   __ bge(cnt2, cnt1, Loop);
   __ move(cnt1, cnt2);

   // Now the shorter length is in cnt1 and cnt2 can be used as a tmp register
   __ bind(Loop);                        // Loop begin
   __ ld_hu(AT, str1, 0);
   __ beq(cnt1, R0, done);

   // compare current character
   __ ld_hu(cnt2, str2, 0);
   __ addi_d(str1, str1, 2);
   __ bne(AT, cnt2, haveResult);
   __ addi_d(str2, str2, 2);
   __ addi_d(cnt1, cnt1, -1);  // Loop end
   __ b(Loop);

   __ bind(haveResult);
   __ sub_d(result, AT, cnt2);

   __ bind(done);
  
#line 12796 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void string_equalsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// str2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cnt
  {
    MacroAssembler _masm(&cbuf);

#line 8713 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    // Get the first character position in both strings
    //         [8] char array, [12] offset, [16] count
    Register str1   = opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */;
    Register str2   = opnd_array(2)->as_Register(ra_,this,idx2)/* str2 */;
    Register cnt    = opnd_array(3)->as_Register(ra_,this,idx3)/* cnt */;
    Register tmp    = as_Register(A7_enc);
    Register result = opnd_array(0)->as_Register(ra_,this)/* result */;

    Label Loop, True, False;

    __ addi_d(result, R0, 1);
    __ beq(str1, str2, True);  // same char[] ?

    __ beq(cnt, R0, True);

    __ bind(Loop);

    // compare current character
    __ ld_hu(AT, str1, 0);
    __ ld_hu(tmp, str2, 0);
    __ addi_d(str1, str1, 2);
    __ bne(AT, tmp, False);
    __ addi_d(cnt, cnt, -1);
    __ addi_d(str2, str2, 2);
    __ bne(cnt, R0, Loop);

    __ b(True);

    __ bind(False);
    __ addi_d(result, R0, 0);

    __ bind(True);
  
#line 12845 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void addI_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8757 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    __ add_w(dst, src1, src2);
  
#line 12865 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void addI_Reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8770 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    int       imm = opnd_array(2)->constant();

    if(Assembler::is_simm12(imm)) {
       __ addi_w(dst, src1, imm);
    } else {
       __ move(AT, imm);
       __ add_w(dst, src1, AT);
    }
  
#line 12891 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void addI_salI_Reg_Reg_immI_1_4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 8789 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    int        sh = opnd_array(3)->constant();
    __ alsl_w(dst, src2, src1, sh - 1);
  
#line 12913 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void addI_salI_Reg_Reg_immI_1_4_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8789 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(3)->as_Register(ra_,this,idx3)/* src1 */;
    Register src2 = opnd_array(1)->as_Register(ra_,this,idx1)/* src2 */;
    int        sh = opnd_array(2)->constant();
    __ alsl_w(dst, src2, src1, sh - 1);
  
#line 12935 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void addP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8804 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    __ add_d(dst, src1, src2);
  
#line 12955 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void addP_reg_reg_convI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8819 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    __ add_d(dst, src1, src2);
  
#line 12975 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void addP_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8833 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    long      src2 = opnd_array(2)->constantL();
    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;

    if(Assembler::is_simm12(src2)) {
       __ addi_d(dst, src1, src2);
    } else {
       __ set64(AT, src2);
       __ add_d(dst, src1, AT);
    }
  
#line 13001 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void addP_salL_Reg_RegI2L_immI_1_4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 8853 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    int        sh = opnd_array(3)->constant();
    __ alsl_d(dst, src2, src1, sh - 1);
  
#line 13023 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void addL_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8870 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);

    __ add_d(dst_reg, src1_reg, src2_reg);
  
#line 13044 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void addL_Reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8886 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst_reg  = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int      src2_imm = opnd_array(2)->constantL();

    __ addi_d(dst_reg, src1_reg, src2_imm);
  
#line 13065 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void addL_RegI2L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8902 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst_reg  = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int      src2_imm = opnd_array(2)->constantL();

    __ addi_d(dst_reg, src1_reg, src2_imm);
  
#line 13086 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void addL_RegI2L_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8918 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);

    __ add_d(dst_reg, src1_reg, src2_reg);
  
#line 13107 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void addL_RegI2L_Reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8918 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
    Register src2_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */);

    __ add_d(dst_reg, src1_reg, src2_reg);
  
#line 13128 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void addL_RegI2L_RegI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8934 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);

    __ add_d(dst_reg, src1_reg, src2_reg);
  
#line 13149 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void addL_RegI2L_RegI2L_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8934 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
    Register src2_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */);

    __ add_d(dst_reg, src1_reg, src2_reg);
  
#line 13170 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void addL_Reg_RegI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8950 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);

    __ add_d(dst_reg, src1_reg, src2_reg);
  
#line 13191 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void addL_Reg_RegI2L_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8950 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
    Register src2_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */);

    __ add_d(dst_reg, src1_reg, src2_reg);
  
#line 13212 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void subI_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8968 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    __ sub_w(dst, src1, src2);
  
#line 13232 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void subI_Reg_immI_M2047_2048Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8982 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    __ addi_w(dst, src1, -1 * opnd_array(2)->constant());
  
#line 13251 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void negI_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 8995 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register  src = opnd_array(2)->as_Register(ra_,this,idx2)/* src */;
    __ sub_w(dst, R0, src);
  
#line 13270 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void negL_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 9008 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register  src = opnd_array(2)->as_Register(ra_,this,idx2)/* src */;
    __ sub_d(dst, R0, src);
  
#line 13289 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void subL_Reg_immL_M2047_2048Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9021 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    __ addi_d(dst, src1, -1 * opnd_array(2)->constantL());
  
#line 13308 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void subL_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9034 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst  = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register src2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);

    __ sub_d(dst, src1, src2);
  
#line 13329 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void subL_Reg_RegI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9048 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst  = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register src2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);

    __ sub_d(dst, src1, src2);
  
#line 13350 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void subL_RegI2L_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9062 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst  = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register src2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);

    __ sub_d(dst, src1, src2);
  
#line 13371 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void subL_RegI2L_RegI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9076 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst  = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register src2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);

    __ sub_d(dst, src1, src2);
  
#line 13392 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void modI_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9091 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;

    __ mod_w(dst, src1, src2);
  
#line 13413 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void modL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9107 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register op1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register op2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);

    __ mod_d(dst, op1, op2);
  
#line 13434 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void mulI_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9122 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

     Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
     Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
     Register dst  = opnd_array(0)->as_Register(ra_,this)/* dst */;

     __ mul_w(dst, src1, src2);
  
#line 13455 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void maddI_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9137 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

  //TODO: LA
  guarantee(0, "LA not implemented yet");
#if 0
     Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
     Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
     Register src3 = opnd_array(3)->as_Register(ra_,this,idx3)/* src3 */;
     Register dst  = opnd_array(0)->as_Register(ra_,this)/* dst */;

     __ mul_w(dst, src1, src2);
     __ add_w(dst, dst, src3);
#endif
  
#line 13483 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void maddI_Reg_Reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9137 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

  //TODO: LA
  guarantee(0, "LA not implemented yet");
#if 0
     Register src1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
     Register src2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;
     Register src3 = opnd_array(1)->as_Register(ra_,this,idx1)/* src3 */;
     Register dst  = opnd_array(0)->as_Register(ra_,this)/* dst */;

     __ mul_w(dst, src1, src2);
     __ add_w(dst, dst, src3);
#endif
  
#line 13511 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void divI_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9158 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

     Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
     Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
     Register dst  = opnd_array(0)->as_Register(ra_,this)/* dst */;

    // In MIPS, div does not cause exception.
    //   We must trap an exception manually.
    //TODO: LA not implemented yet teq
    #if 0
    __ teq(R0, src2, 0x7);
    #endif
    {
      Label LnotZero;
      __ bnez(src2, LnotZero);
      __ stop("LA not implemented yet");
      __ bind(LnotZero);
    }

    __ div_w(dst, src1, src2);

  
#line 13546 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void divF_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9187 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

     FloatRegister src1 = opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */;
     FloatRegister src2 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */;
     FloatRegister dst  = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;

    /* Here do we need to trap an exception manually ? */
    __ fdiv_s(dst, src1, src2);
  
#line 13568 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void divD_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9203 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

     FloatRegister src1 = opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */;
     FloatRegister src2 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */;
     FloatRegister dst  = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;

    /* Here do we need to trap an exception manually ? */
    __ fdiv_d(dst, src1, src2);
  
#line 13590 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void mulL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9217 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register op1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register op2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);

    __ mul_d(dst, op1, op2);
  
#line 13611 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void mulL_reg_regI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9230 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register op1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register op2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);

    __ mul_d(dst, op1, op2);
  
#line 13632 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void mulL_reg_regI2L_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9230 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register op1 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
    Register op2 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */);

    __ mul_d(dst, op1, op2);
  
#line 13653 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void divL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9244 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register op1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register op2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);

    __ div_d(dst, op1, op2);
  
#line 13674 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void addF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9257 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister src1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    FloatRegister src2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    FloatRegister dst  = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fadd_s(dst, src1, src2);
  
#line 13695 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void subF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9270 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister src1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    FloatRegister src2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    FloatRegister dst  = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fsub_s(dst, src1, src2);
  
#line 13716 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void addD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9282 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister src1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    FloatRegister src2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    FloatRegister dst  = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fadd_d(dst, src1, src2);
  
#line 13737 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void subD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9295 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister src1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    FloatRegister src2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    FloatRegister dst  = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fsub_d(dst, src1, src2);
  
#line 13758 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void negF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 9308 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister src = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    FloatRegister dst = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fneg_s(dst, src);
  
#line 13777 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void negD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 9320 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister src = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    FloatRegister dst = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fneg_d(dst, src);
  
#line 13796 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void mulF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister src1 = opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */;
    FloatRegister src2 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */;
    FloatRegister dst  = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;

    __ fmul_s(dst, src1, src2);
  
#line 13817 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void maddF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9348 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister src1 = opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */;
    FloatRegister src2 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */;
    FloatRegister src3 = opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */;
    FloatRegister dst  = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;

    __ fmadd_s(dst, src1, src2, src3);
  
#line 13840 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void maddF_reg_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9348 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister src1 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */;
    FloatRegister src2 = opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */;
    FloatRegister src3 = opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */;
    FloatRegister dst  = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;

    __ fmadd_s(dst, src1, src2, src3);
  
#line 13863 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void mulD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9363 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister src1 = opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */;
    FloatRegister src2 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */;
    FloatRegister dst  = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;

    __ fmul_d(dst, src1, src2);
  
#line 13884 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void maddD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9378 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister src1 = opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */;
    FloatRegister src2 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */;
    FloatRegister src3 = opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src3 */;
    FloatRegister dst  = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;

    __ fmadd_d(dst, src1, src2, src3);
  
#line 13907 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void maddD_reg_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9378 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister src1 = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */;
    FloatRegister src2 = opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */;
    FloatRegister src3 = opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src3 */;
    FloatRegister dst  = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;

    __ fmadd_d(dst, src1, src2, src3);
  
#line 13930 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void absF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 9393 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister src = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    FloatRegister dst = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fabs_s(dst, src);
  
#line 13949 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void absD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 9410 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister src = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    FloatRegister dst = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fabs_d(dst, src);
  
#line 13968 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void sqrtD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 9423 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister src = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    FloatRegister dst = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fsqrt_d(dst, src);
  
#line 13987 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void sqrtF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 9436 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister src = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    FloatRegister dst = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ fsqrt_s(dst, src);
  
#line 14006 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void andI_Reg_immINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9453 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    int      val = opnd_array(2)->constant();

    __ move(AT, val);
    __ andr(dst, src, AT);
  
#line 14028 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void andI_Reg_imm_0_4095Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9469 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    int      val = opnd_array(2)->constant();

    __ andi(dst, src, val);

  
#line 14050 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void andI_Reg_immI_nonneg_maskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9485 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    int     size = Assembler::is_int_mask(opnd_array(2)->constant());

    __ bstrpick_w(dst, src, size-1, 0);
  
#line 14071 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void andL_Reg_immL_nonneg_maskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9500 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    int     size = Assembler::is_jlong_mask(opnd_array(2)->constantL());

    __ bstrpick_d(dst, src, size-1, 0);
  
#line 14092 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void xorI_Reg_imm_0_4095Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9515 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    int      val = opnd_array(2)->constant();

       __ xori(dst, src, val);
  
#line 14113 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void xorI_Reg_immI_M1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// M1
  {
    MacroAssembler _masm(&cbuf);

#line 9530 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;

    __ orn(dst, R0, src);
  
#line 14133 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void xorL2I_Reg_immI_M1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// M1
  {
    MacroAssembler _masm(&cbuf);

#line 9544 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;

    __ orn(dst, R0, src);
  
#line 14153 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void xorL_Reg_imm_0_4095Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9558 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    int      val = opnd_array(2)->constantL();

    __ xori(dst, src, val);
  
#line 14174 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void lbu_and_lmaskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mask
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 1666 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(2)->base(ra_,this,idx2);
    int  index = opnd_array(2)->index(ra_,this,idx2);
    int  scale = opnd_array(2)->scale();
    int  disp = opnd_array(2)->disp(ra_,this,idx2);

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ ld_bu(as_Register(dst), AT, disp);
      } else {
        __ move(T4, disp);
        __ ldx_bu(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_bu(as_Register(dst), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ ldx_bu(as_Register(dst), as_Register(base), T4);
      }
    }
  
#line 14216 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void lbu_and_lmask_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 1666 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ ld_bu(as_Register(dst), AT, disp);
      } else {
        __ move(T4, disp);
        __ ldx_bu(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_bu(as_Register(dst), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ ldx_bu(as_Register(dst), as_Register(base), T4);
      }
    }
  
#line 14258 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void lbu_and_rmaskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 1666 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ ld_bu(as_Register(dst), AT, disp);
      } else {
        __ move(T4, disp);
        __ ldx_bu(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_bu(as_Register(dst), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ ldx_bu(as_Register(dst), as_Register(base), T4);
      }
    }
  
#line 14300 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void andI_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9591 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;

    __ andr(dst, src1, src2);
  
#line 14321 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void andnI_Reg_nRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// M1
  {
    MacroAssembler _masm(&cbuf);

#line 9605 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;

    __ andn(dst, src1, src2);
  
#line 14343 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void andnI_Reg_nReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// M1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9605 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(3)->as_Register(ra_,this,idx3)/* src1 */;
    Register src2 = opnd_array(1)->as_Register(ra_,this,idx1)/* src2 */;

    __ andn(dst, src1, src2);
  
#line 14365 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void ornI_Reg_nRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// M1
  {
    MacroAssembler _masm(&cbuf);

#line 9619 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;

    __ orn(dst, src1, src2);
  
#line 14387 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void ornI_Reg_nReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// M1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9619 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(3)->as_Register(ra_,this,idx3)/* src1 */;
    Register src2 = opnd_array(1)->as_Register(ra_,this,idx1)/* src2 */;

    __ orn(dst, src1, src2);
  
#line 14409 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void andnI_nReg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// M1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9633 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;

    __ andn(dst, src2, src1);
  
#line 14431 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void andnI_nReg_Reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// M1
  {
    MacroAssembler _masm(&cbuf);

#line 9633 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register src2 = opnd_array(1)->as_Register(ra_,this,idx1)/* src2 */;

    __ andn(dst, src2, src1);
  
#line 14453 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void ornI_nReg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// M1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9647 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;

    __ orn(dst, src2, src1);
  
#line 14475 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void ornI_nReg_Reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// M1
  {
    MacroAssembler _masm(&cbuf);

#line 9647 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register src2 = opnd_array(1)->as_Register(ra_,this,idx1)/* src2 */;

    __ orn(dst, src2, src1);
  
#line 14497 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void andL_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9661 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);

    __ andr(dst_reg, src1_reg, src2_reg);
  
#line 14518 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void andL_Reg_Reg_convI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9674 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);

    __ andr(dst_reg, src1_reg, src2_reg);
  
#line 14539 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void andL_Reg_Reg_convI2L_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9674 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */);
    Register src2_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */);

    __ andr(dst_reg, src1_reg, src2_reg);
  
#line 14560 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void andL_Reg_imm_0_4095Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9689 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    long     val = opnd_array(2)->constantL();

    __ andi(dst, src, val);
  
#line 14581 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void andL2I_Reg_imm_0_4095Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9704 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    long     val = opnd_array(2)->constantL();

    __ andi(dst, src, val);
  
#line 14602 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void andL_Reg_immL_M8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// M8
  {
    MacroAssembler _masm(&cbuf);

#line 9720 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;

    __ bstrins_d(dst, R0, 2, 0);
  
#line 14621 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void andL_Reg_immL_M5Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// M5
  {
    MacroAssembler _masm(&cbuf);

#line 9733 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;

    __ bstrins_d(dst, R0, 2, 2);
  
#line 14640 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void andL_Reg_immL_M7Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// M7
  {
    MacroAssembler _masm(&cbuf);

#line 9746 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;

    __ bstrins_d(dst, R0, 2, 1);
  
#line 14659 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void andL_Reg_immL_M4Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// M4
  {
    MacroAssembler _masm(&cbuf);

#line 9759 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;

    __ bstrins_d(dst, R0, 1, 0);
  
#line 14678 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void andL_Reg_immL_M121Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// M121
  {
    MacroAssembler _masm(&cbuf);

#line 9772 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;

    __ bstrins_d(dst, R0, 6, 3);
  
#line 14697 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void orL_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9784 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst_reg  = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1_reg = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2_reg = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;

    __ orr(dst_reg, src1_reg, src2_reg);
  
#line 14718 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void orL_Reg_P2XRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9797 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst_reg  = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1_reg = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2_reg = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;

    __ orr(dst_reg, src1_reg, src2_reg);
  
#line 14739 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void orL_Reg_P2XReg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9797 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst_reg  = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1_reg = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register src2_reg = opnd_array(1)->as_Register(ra_,this,idx1)/* src2 */;

    __ orr(dst_reg, src1_reg, src2_reg);
  
#line 14760 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void xorL_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9811 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);

    __ xorr(dst_reg, src1_reg, src2_reg);
  
#line 14781 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void salI_Reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 9826 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    int    shamt = opnd_array(2)->constant();

    __ slli_w(dst, src, Assembler::low(shamt, 5));
  
#line 14802 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void salL2I_Reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 9840 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    int    shamt = opnd_array(2)->constant();

    __ slli_w(dst, src, Assembler::low(shamt, 5));
  
#line 14823 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void salI_Reg_imm_and_M65536Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9854 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;

    __ slli_w(dst, src, 16);
  
#line 14844 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void land7_2_sNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// seven
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// sixteen
  {
    MacroAssembler _masm(&cbuf);

#line 9868 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;

    __ andi(dst, src, 7);
  
#line 14865 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void ori2sNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// sixteen
  {
    MacroAssembler _masm(&cbuf);

#line 9882 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    int      val = opnd_array(2)->constant();
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;

    __ ori(dst, src, val);
  
#line 14887 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void i2sNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// sixteen
  {
    MacroAssembler _masm(&cbuf);

#line 9899 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;

    __ ext_w_h(dst, src);
  
#line 14907 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void i2bNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// twentyfour
  {
    MacroAssembler _masm(&cbuf);

#line 9915 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;

    __ ext_w_b(dst, src);
  
#line 14927 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void salI_RegL2I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 9929 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    int    shamt = opnd_array(2)->constant();

    __ slli_w(dst, src, Assembler::low(shamt, 5));
  
#line 14948 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void salI_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 9944 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register shamt = opnd_array(2)->as_Register(ra_,this,idx2)/* shift */;
    __ sll_w(dst, src, shamt);
  
#line 14968 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void salL_Reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 9959 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    int      shamt = opnd_array(2)->constant();

    __ slli_d(dst_reg, src_reg, Assembler::low(shamt, 6));
  
#line 14989 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void salL_RegI2L_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 9973 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    int      shamt = opnd_array(2)->constant();

    __ slli_d(dst_reg, src_reg, Assembler::low(shamt, 6));
  
#line 15010 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void salL_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 9988 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);

    __ sll_d(dst_reg, src_reg, opnd_array(2)->as_Register(ra_,this,idx2)/* shift */);
  
#line 15030 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void sarL_Reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 10002 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    int      shamt = (opnd_array(2)->constant()& 0x3f);

    __ srai_d(dst_reg, src_reg, shamt);
  
#line 15051 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void sarL2I_Reg_immI_32_63Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 10016 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    int      shamt   = opnd_array(2)->constant();

    __ srai_d(dst_reg, src_reg, shamt);
  
#line 15072 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void sarL_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 10031 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);

    __ sra_d(dst_reg, src_reg, opnd_array(2)->as_Register(ra_,this,idx2)/* shift */);
  
#line 15092 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void slrL_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 10045 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);

    __ srl_d(dst_reg, src_reg, opnd_array(2)->as_Register(ra_,this,idx2)/* shift */);
  
#line 15112 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void slrL_Reg_immI_0_31Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 10058 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    int        shamt = opnd_array(2)->constant();

    __ srli_d(dst_reg, src_reg, shamt);
  
#line 15133 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void slrL_Reg_immI_0_31_and_max_intNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// max_int
  {
    MacroAssembler _masm(&cbuf);

#line 10072 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    int        shamt = opnd_array(2)->constant();

    __ bstrpick_d(dst_reg, src_reg, shamt+30, shamt);
  
#line 15155 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void slrL_P2XReg_immI_0_31Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 10086 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    int        shamt = opnd_array(2)->constant();

    __ srli_d(dst_reg, src_reg, shamt);
  
#line 15176 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void slrL_Reg_immI_32_63Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 10100 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    int        shamt = opnd_array(2)->constant();

    __ srli_d(dst_reg, src_reg, shamt);
  
#line 15197 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void slrL_Reg_immI_convL2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 10115 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    int        shamt = opnd_array(2)->constant();

    __ srli_d(dst_reg, src_reg, shamt);
  
#line 15218 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void slrL_P2XReg_immI_32_63Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 10129 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    int        shamt = opnd_array(2)->constant();

    __ srli_d(dst_reg, src_reg, shamt);
  
#line 15239 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void xorI_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10146 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    __ xorr(dst, src1, src2);
    __ slli_w(dst, dst, 0); /* long -> int */
  
#line 15260 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void orI_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10163 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    __ orr(dst, src1, src2);
  
#line 15280 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void rotI_shr_logical_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    MacroAssembler _masm(&cbuf);

#line 10179 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register   dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register   src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    int     rshift = opnd_array(2)->constant();

    __ rotri_w(dst, src, 1);
    if (rshift - 1) {
      __ srli_w(dst, dst, rshift - 1);
    }
  
#line 15306 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void rotI_shr_logical_Reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// one
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 10179 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register   dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register   src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    int     rshift = opnd_array(4)->constant();

    __ rotri_w(dst, src, 1);
    if (rshift - 1) {
      __ srli_w(dst, dst, rshift - 1);
    }
  
#line 15332 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void orI_Reg_castP2XNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10197 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    __ orr(dst, src1, src2);
  
#line 15352 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void orI_Reg_castP2X_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 10197 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register  dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */;
    Register src2 = opnd_array(1)->as_Register(ra_,this,idx1)/* src2 */;
    __ orr(dst, src1, src2);
  
#line 15372 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void shr_logical_Reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 10213 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    int    shift = opnd_array(2)->constant();

    __ srli_w(dst, src, Assembler::low(shift, 5));
  
#line 15393 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void shr_logical_Reg_imm_nonneg_maskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 10227 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    int      pos = opnd_array(2)->constant();
    int     size = Assembler::is_int_mask(opnd_array(3)->constant());

    __ bstrpick_w(dst, src, pos+size-1, pos);
  
#line 15416 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void rolI_Reg_immI_0_31Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 10245 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;
    int      sa  = opnd_array(3)->constant();

    __ rotri_w(dst, dst, sa);
  
#line 15437 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void rolI_Reg_immI_0_31_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    MacroAssembler _masm(&cbuf);

#line 10245 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;
    int      sa  = opnd_array(2)->constant();

    __ rotri_w(dst, dst, sa);
  
#line 15458 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void rolL_Reg_immI_0_31Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 10261 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;
    int      sa  = opnd_array(3)->constant();

    __ rotri_d(dst, dst, sa);
  
#line 15479 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void rolL_Reg_immI_0_31_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    MacroAssembler _masm(&cbuf);

#line 10261 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;
    int      sa  = opnd_array(2)->constant();

    __ rotri_d(dst, dst, sa);
  
#line 15500 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void rolL_Reg_immI_32_63Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 10277 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;
    int      sa  = opnd_array(3)->constant();

    __ rotri_d(dst, dst, sa);
  
#line 15521 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void rolL_Reg_immI_32_63_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    MacroAssembler _masm(&cbuf);

#line 10277 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;
    int      sa  = opnd_array(2)->constant();

    __ rotri_d(dst, dst, sa);
  
#line 15542 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void rorI_Reg_immI_0_31Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    MacroAssembler _masm(&cbuf);

#line 10293 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;
    int      sa  = opnd_array(2)->constant();

    __ rotri_w(dst, dst, sa);
  
#line 15563 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void rorI_Reg_immI_0_31_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 10293 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;
    int      sa  = opnd_array(3)->constant();

    __ rotri_w(dst, dst, sa);
  
#line 15584 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void rorL_Reg_immI_0_31Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    MacroAssembler _masm(&cbuf);

#line 10309 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;
    int      sa  = opnd_array(2)->constant();

    __ rotri_d(dst, dst, sa);
  
#line 15605 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void rorL_Reg_immI_0_31_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 10309 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;
    int      sa  = opnd_array(3)->constant();

    __ rotri_d(dst, dst, sa);
  
#line 15626 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void rorL_Reg_immI_32_63Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {
    MacroAssembler _masm(&cbuf);

#line 10325 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;
    int      sa  = opnd_array(2)->constant();

    __ rotri_d(dst, dst, sa);
  
#line 15647 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void rorL_Reg_immI_32_63_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 10325 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;
    int      sa  = opnd_array(3)->constant();

    __ rotri_d(dst, dst, sa);
  
#line 15668 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void shr_logical_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 10339 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register shift = opnd_array(2)->as_Register(ra_,this,idx2)/* shift */;
    __ srl_w(dst, src, shift);
  
#line 15688 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void shr_arith_Reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 10354 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    int    shift = opnd_array(2)->constant();
    __ srai_w(dst, src, Assembler::low(shift, 5));
  
#line 15708 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void shr_arith_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 10368 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register shift = opnd_array(2)->as_Register(ra_,this,idx2)/* shift */;
    __ sra_w(dst, src, shift);
  
#line 15728 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void convI2BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10384 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);

    if (dst != src) {
      __ addi_d(dst, R0, 1);
      __ maskeqz(dst, dst, src);
    } else {
      __ move(AT, src);
      __ addi_d(dst, R0, 1);
      __ maskeqz(dst, dst, AT);
    }
  
#line 15754 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void convI2L_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10406 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);

    if(dst != src) __ slli_w(dst, src, 0);
  
#line 15773 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void convL2I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10420 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);

    __ slli_w(dst, src, 0);
  
#line 15792 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void convL2I2L_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10434 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);

    __ slli_w(dst, src, 0);
  
#line 15811 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void convL2D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10447 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    FloatRegister dst = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ movgr2fr_d(dst, src);
    __ ffint_d_l(dst, dst);
  
#line 15831 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void convD2L_reg_fastNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10463 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    FloatRegister src = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */);

    Label Done, L;

    __ ftintrz_l_d(F30, src);
    // max_long:    0x7fffffffffffffff
    // __ set64(AT, 0x7fffffffffffffff);
    __ addi_d(AT, R0, -1);
    __ srli_d(AT, AT, 1);
    __ movfr2gr_d(dst, F30);

    __ movgr2fr_w(F30, R0);
    __ bne(dst, AT, Done);

    __ ffint_d_w(F30, F30);
    __ fcmp_cult_d(FCC0, src, F30);
    __ addi_d(T4, R0, -1);
    __ bceqz(FCC0, Done);

    __ fcmp_cun_d(FCC0, src, src);    //NaN?
    __ sub_d(dst, T4, AT);
    __ bceqz(FCC0, Done);
    __ move(dst, R0);

    __ bind(Done);
  
#line 15872 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void convD2L_reg_slowNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10500 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    FloatRegister src = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */);

    Label L;

    __ fcmp_cun_d(FCC0, src, src);    //NaN?
    __ move(dst, R0);
    __ bcnez(FCC0, L);

    __ ftintrz_l_d(F30, src);
    __ movfcsr2gr(AT, 31);
    __ lu12i_w(T4, 0x10);
    __ andr(AT, AT, T4);
    __ movfr2gr_d(dst, F30);
    __ beq(AT, R0, L);

    __ fmov_d(FA0, src);
    __ call_VM_leaf(CAST_FROM_FN_PTR(address, SharedRuntime::d2l), 1);
    __ move(dst, V0);
    __ bind(L);
  
#line 15907 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void convF2I_reg_fastNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10531 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register      dreg = opnd_array(0)->as_Register(ra_,this)/* dst */;
    FloatRegister fval = opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */;
    Label L, L1;

    __ ftintrz_w_s(F30, fval);
    __ move(AT, 0x7fffffff);
    __ movfr2gr_s(dreg, F30);
    __ fcmp_cun_s(FCC0, fval, fval);    //NaN?
    __ bceqz(FCC0, L1);
    __ move(dreg, R0);
    __ bind(L1);

    __ lu12i_w(T4, 0x80000);
    __ bne(AT, dreg, L);

    __ movfr2gr_s(AT, fval);
    __ andr(AT, AT, T4);

    __ beqz(AT, L);
    __ move(dreg, T4);

    __ bind(L);
  
#line 15944 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void convF2I_reg_slowNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10565 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register      dreg = opnd_array(0)->as_Register(ra_,this)/* dst */;
    FloatRegister fval = opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */;
    Label L;

    __ fcmp_cun_s(FCC0, fval, fval);    //NaN?
    __ move(dreg, R0);
    __ bcnez(FCC0, L);

    __ ftintrz_w_s(F30, fval);

    /* Call SharedRuntime:f2i() to do valid convention */
    __ movfcsr2gr(AT, 31);
    __ lu12i_w(T4, 0x10);
    __ andr(AT, AT, T4);
    __ movfr2gr_s(dreg, F30);
    __ beq(AT, R0, L);

    __ fmov_s(FA0, fval);

    //This bug was found when running ezDS's control-panel.
    //    J 982 C2 javax.swing.text.BoxView.layoutMajorAxis(II[I[I)V (283 bytes) @ 0x000000555c46aa74
    //
    // An interger array index has been assigned to V0, and then changed from 1 to Integer.MAX_VALUE.
    // V0 is corrupted during call_VM_leaf(), and should be preserved.
    //
    __ push(fval);
    if(dreg != V0) {
      __ push(V0);
    }
    __ call_VM_leaf(CAST_FROM_FN_PTR(address, SharedRuntime::f2i), 1);
    if(dreg != V0) {
      __ move(dreg, V0);
      __ pop(V0);
    }
    __ pop(fval);
    __ bind(L);
  
#line 15995 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void convF2L_reg_fastNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10612 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register      dreg = opnd_array(0)->as_Register(ra_,this)/* dst */;
    FloatRegister fval = opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */;
    Label L, L1;

    __ ftintrz_l_s(F30, fval);
    __ addi_d(AT, R0, -1);
    __ srli_d(AT, AT, 1);
    __ movfr2gr_d(dreg, F30);
    __ fcmp_cun_s(FCC0, fval, fval);    //NaN?
    __ bceqz(FCC0, L1);
    __ move(dreg, R0);
    __ bind(L1);
    __ lu12i_w(T4, 0x80000);
    __ bne(AT, dreg, L);

    __ movfr2gr_s(AT, fval);
    __ andr(AT, AT, T4);

    __ slli_d(T4, T4, 32);
    __ beqz(AT, L);
    __ move(dreg, T4);

    __ bind(L);
  
#line 16033 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void convF2L_reg_slowNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10646 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    FloatRegister fval = opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */;
    Label L;

    __ fcmp_cun_s(FCC0, fval, fval);    //NaN?
    __ move(dst, R0);
    __ bcnez(FCC0, L);

    __ ftintrz_l_s(F30, fval);
    __ movfcsr2gr(AT, 31);
    __ lu12i_w(T4, 0x10);
    __ andr(AT, AT, T4);
    __ movfr2gr_d(dst, F30);
    __ beq(AT, R0, L);

    __ fmov_s(FA0, fval);
    __ call_VM_leaf(CAST_FROM_FN_PTR(address, SharedRuntime::f2l), 1);
    __ move(dst, V0);
    __ bind(L);
  
#line 16067 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void convL2F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10674 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister dst = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;
    Register src = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Label L;

    __ movgr2fr_d(dst, src);
    __ ffint_s_l(dst, dst);
  
#line 16088 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void convI2F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10689 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register      src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    FloatRegister dst = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;

    __ movgr2fr_w(dst, src);
    __ ffint_s_w(dst, dst);
  
#line 16108 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmpLTMask_immI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// p
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 10705 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

       Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* p */;
       Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;

       __ srai_w(dst, src, 31);
    
#line 16128 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmpLTMaskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// p
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// q
  {
    MacroAssembler _masm(&cbuf);

#line 10720 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register p   = opnd_array(1)->as_Register(ra_,this,idx1)/* p */;
    Register q   = opnd_array(2)->as_Register(ra_,this,idx2)/* q */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;

    __ slt(dst, p, q);
    __ sub_d(dst, R0, dst);
    
#line 16150 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void convP2BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10736 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);

    if (dst != src) {
      __ addi_d(dst, R0, 1);
      __ maskeqz(dst, dst, src);
    } else {
      __ move(AT, src);
      __ addi_d(dst, R0, 1);
      __ maskeqz(dst, dst, AT);
    }
  
#line 16176 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void convI2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10757 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register      src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    FloatRegister dst = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;
    __ movgr2fr_w(dst ,src);
    __ ffint_d_w(dst, dst);
    
#line 16195 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void convF2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10769 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister dst = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;
    FloatRegister src = opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */;

    __ fcvt_d_s(dst, src);
  
#line 16214 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void convD2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10781 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister dst = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;
    FloatRegister src = opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */;

    __ fcvt_s_d(dst, src);
  
#line 16233 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void convD2I_reg_reg_fastNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10798 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister src = opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */;
    Register      dst = opnd_array(0)->as_Register(ra_,this)/* dst */;

    Label Done;

    __ ftintrz_w_d(F30, src);
    // max_int: 2147483647
    __ move(AT, 0x7fffffff);
    __ movfr2gr_s(dst, F30);

    __ movgr2fr_w(F30, R0);
    __ bne(dst, AT, Done);

    __ ffint_d_w(F30, F30);
    __ fcmp_cult_d(FCC0, src, F30);
    __ addi_d(T4, R0, -1);
    __ bceqz(FCC0, Done);

    __ fcmp_cun_d(FCC0, src, src);    //NaN?
    __ sub_w(dst, T4, AT);
    __ bceqz(FCC0, Done);
    __ move(dst, R0);

    __ bind(Done);
  
#line 16272 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void convD2I_reg_reg_slowNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10834 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister src = opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */;
    Register      dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Label L;

    __ ftintrz_w_d(F30, src);
    __ movfcsr2gr(AT, 31);
    __ lu12i_w(T4, 0x10);
    __ andr(AT, AT, T4);
    __ movfr2gr_s(dst, F30);
    __ beq(AT, R0, L);

    __ fmov_d(FA0, src);
    __ call_VM_leaf(CAST_FROM_FN_PTR(address, SharedRuntime::d2i), 1);
    __ move(dst, V0);
    __ bind(L);
  
#line 16302 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void encodeHeapOopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10859 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;

    __ encode_heap_oop(dst, src);
  
#line 16321 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void encodeHeapOop_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10872 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ encode_heap_oop_not_null(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 16337 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void decodeHeapOopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10883 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;

    __ decode_heap_oop(d, s);
  
#line 16356 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void decodeHeapOop_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10897 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    if (s != d) {
      __ decode_heap_oop_not_null(d, s);
    } else {
      __ decode_heap_oop_not_null(d);
    }
  
#line 16378 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void encodeKlass_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10912 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ encode_klass_not_null(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 16394 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void decodeKlass_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10921 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    if (s != d) {
      __ decode_klass_not_null(d, s);
    } else {
      __ decode_klass_not_null(d);
    }
  
#line 16416 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void tlsLoadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 10939 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
#ifdef OPT_THREAD
    __ move(dst, TREG);
#else
    __ get_thread(dst);
#endif
  
#line 16437 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void checkCastPPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

void castPPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castPPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castIINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

void RetNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 10984 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

   __ jr(RA);
  
#line 16482 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void tailjmpIndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// ex_oop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 11004 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register target = opnd_array(1)->as_Register(ra_,this,idx1)/* jump_target */;

    // V0, V1 are indicated in:
    //     [stubGenerator_mips.cpp] generate_forward_exception()
    //     [runtime_mips.cpp] OptoRuntime::generate_exception_blob()
    //
    Register oop  = opnd_array(2)->as_Register(ra_,this,idx2)/* ex_oop */;
    Register exception_oop = V0;
    Register exception_pc = V1;

    __ move(exception_pc, RA);
    __ move(exception_oop, oop);

    __ jr(target);
  
#line 16512 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void CallStaticJavaDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2609 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    // CALL to fixup routine.  Fixup routine uses ScopeDesc info to determine
    // who we intended to call.
    MacroAssembler _masm(&cbuf);
    cbuf.set_insts_mark();

    if ( !_method ) {
      __ relocate(relocInfo::runtime_call_type);
    } else if(_optimized_virtual) {
      __ relocate(relocInfo::opt_virtual_call_type);
    } else {
      __ relocate(relocInfo::static_call_type);
    }

    __ patchable_call((address)(opnd_array(1)->method()));
    if( _method ) {  // Emit stub for static call
      emit_java_to_interp(cbuf);
    }
  
#line 16543 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void CallDynamicJavaDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2633 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    __ block_comment("Java_Dynamic_Call");
    __ ic_call((address)opnd_array(1)->method());
  
#line 16560 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void CallLeafNoFPDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2599 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    // This is the instruction starting address for relocation info.
    __ block_comment("Java_To_Runtime");
    cbuf.set_insts_mark();
    __ relocate(relocInfo::runtime_call_type);

    __ patchable_call((address)opnd_array(1)->method());
  
#line 16581 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void prefetchrNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 11075 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
    } else {
      __ move(AT, as_Register(base));
    }
    if( Assembler::is_simm12(disp) ) {
      __ addi_d(AT, AT, disp);
    } else {
      __ move(T4, disp);
      __ add_d(AT, AT, T4);
    }
    __ preld(0, AT, 0); //hint: 0:load
  
#line 16617 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void prefetchwNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 11105 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
    } else {
      __ move(AT, as_Register(base));
    }
    if( Assembler::is_simm12(disp) ) {
      __ addi_d(AT, AT, disp);
    } else {
      __ move(T4, disp);
      __ add_d(AT, AT, T4);
    }
     __ preld(8, AT, 0); //hint: 8:store
  
#line 16653 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void prefetchAllocNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 11137 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if ( index != 0 ) {
      if ( Assembler::is_simm12(disp) ) {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ preld(8, AT, disp);
      } else {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ move(T4, disp);
        __ preldx(8, AT, T4);
      }
    } else {
      if ( Assembler::is_simm12(disp) ) {
        __ preld(8, as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ preldx(8, as_Register(base), T4);
      }
    }
  
#line 16698 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void CallLeafDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2599 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    // This is the instruction starting address for relocation info.
    __ block_comment("Java_To_Runtime");
    cbuf.set_insts_mark();
    __ relocate(relocInfo::runtime_call_type);

    __ patchable_call((address)opnd_array(1)->method());
  
#line 16719 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadUSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1882 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ ld_hu(as_Register(dst), AT, disp);
      } else {
        __ move(T4, disp);
        __ ldx_hu(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_hu(as_Register(dst), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ ldx_hu(as_Register(dst), as_Register(base), T4);
      }
    }
  
#line 16760 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadUS_convI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1882 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ ld_hu(as_Register(dst), AT, disp);
      } else {
        __ move(T4, disp);
        __ ldx_hu(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_hu(as_Register(dst), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ ldx_hu(as_Register(dst), as_Register(base), T4);
      }
    }
  
#line 16801 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeCNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1913 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  src = opnd_array(2)->reg(ra_,this,idx2)/* src */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if( Assembler::is_simm12(disp) ) {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ st_h(as_Register(src), AT, disp);
      } else {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ move(T4, disp);
        __ stx_h(as_Register(src), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ st_h(as_Register(src), as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ stx_h(as_Register(src), as_Register(base), T4);
      }
    }
  
#line 16848 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeC_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 1948 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if ( Assembler::is_simm12(disp) ) {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ st_h(R0, AT, disp);
      } else {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ move(T4, disp);
        __ stx_h(R0, AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ st_h(R0, as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ stx_h(R0, as_Register(base), T4);
      }
    }
  
#line 16894 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadConF_immF_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 11230 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister dst = opnd_array(0)->as_FloatRegister(ra_,this)/* dst */;

    __ movgr2fr_w(dst, R0);
  
#line 16912 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadConFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11244 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    int con_offset = constant_offset();

    if (Assembler::is_simm12(con_offset)) {
      __ fld_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, as_Register(ra_->get_encode(in(mach_constant_base_node_input()))), con_offset);
    } else {
      __ set64(AT, con_offset);
      __ fldx_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, as_Register(ra_->get_encode(in(mach_constant_base_node_input()))), AT);
    }
  
#line 16935 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadConFNode::eval_constant(Compile* C) {
  {

#line 11245 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
    _constant = C->constant_table().add(this, opnd_array(1));
#line 16944 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}
void loadConD_immD_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 11263 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    FloatRegister dst = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    __ movgr2fr_d(dst, R0);
  
#line 16961 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadConDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11276 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    int con_offset = constant_offset();

    if (Assembler::is_simm12(con_offset)) {
      __ fld_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, as_Register(ra_->get_encode(in(mach_constant_base_node_input()))), con_offset);
    } else {
      __ set64(AT, con_offset);
      __ fldx_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, as_Register(ra_->get_encode(in(mach_constant_base_node_input()))), AT);
    }
  
#line 16984 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadConDNode::eval_constant(Compile* C) {
  {

#line 11277 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
    _constant = C->constant_table().add(this, opnd_array(1));
#line 16993 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}
void storeF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2494 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);
    FloatRegister src = opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src */;

    if( index != 0 ) {
      if ( Assembler::is_simm12(disp) ) {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ fst_s(src, AT, disp);
      } else {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ move(T4, disp);
        __ fstx_s(src, AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ fst_s(src, as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ fstx_s(src, as_Register(base), T4);
      }
    }
  
#line 17039 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeF_immF_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 11304 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    int      base = opnd_array(1)->base(ra_,this,idx1);
    int     index = opnd_array(1)->index(ra_,this,idx1);
    int     scale = opnd_array(1)->scale();
    int      disp = opnd_array(1)->disp(ra_,this,idx1);

    if( index != 0 ) {
      if(scale != 0) {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      } else {
        __ add_d(AT, as_Register(base), as_Register(index));
      }
      if( Assembler::is_simm12(disp) ) {
        __ st_w(R0, AT, disp);
      } else {
        __ move(T4, disp);
        __ stx_w(R0, AT, T4);
      }
    } else { //index is 0
      if( Assembler::is_simm12(disp) ) {
        __ st_w(R0, as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ stx_w(R0, as_Register(base), T4);
      }
    }
  
#line 17080 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2529 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);
    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    if ( index != 0 ) {
      if ( Assembler::is_simm12(disp) ) {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ fld_d(dst_reg, AT, disp);
      } else {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ move(T4, disp);
        __ fldx_d(dst_reg, AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ fld_d(dst_reg, as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ fldx_d(dst_reg, as_Register(base), T4);
      }
    }
  
#line 17126 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadD_unalignedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2529 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);
    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    if ( index != 0 ) {
      if ( Assembler::is_simm12(disp) ) {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ fld_d(dst_reg, AT, disp);
      } else {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ move(T4, disp);
        __ fldx_d(dst_reg, AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ fld_d(dst_reg, as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ fldx_d(dst_reg, as_Register(base), T4);
      }
    }
  
#line 17172 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2564 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);
    FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);

    if ( index != 0 ) {
      if ( Assembler::is_simm12(disp) ) {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ fst_d(src_reg, AT, disp);
      } else {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ move(T4, disp);
        __ fstx_d(src_reg, AT, T4);
      }
    } else {
      if ( Assembler::is_simm12(disp) ) {
        __ fst_d(src_reg, as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ fstx_d(src_reg, as_Register(base), T4);
      }
    }
  
#line 17219 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeD_immD_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 11368 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    int      base = opnd_array(1)->base(ra_,this,idx1);
    int     index = opnd_array(1)->index(ra_,this,idx1);
    int     scale = opnd_array(1)->scale();
    int      disp = opnd_array(1)->disp(ra_,this,idx1);

    __ movgr2fr_w(F30, R0);
    __ ffint_d_w(F30, F30);

    if( index != 0 ) {
      if(scale != 0) {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      } else {
        __ add_d(AT, as_Register(base), as_Register(index));
      }
      if( Assembler::is_simm12(disp) ) {
        __ fst_d(F30, AT, disp);
      } else {
        __ move(T4, disp);
        __ fstx_d(F30, AT, T4);
      }
    } else {// index is 0
      if( Assembler::is_simm12(disp) ) {
        __ fst_d(F30, as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ fstx_d(F30, as_Register(base), T4);
      }
    }
  
#line 17263 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadSSINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11407 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    guarantee( Assembler::is_simm12(opnd_array(1)->disp(ra_,this,idx1)), "disp too long (loadSSI) !");
    __ ld_w(opnd_array(0)->as_Register(ra_,this)/* dst */, SP, opnd_array(1)->disp(ra_,this,idx1));
  
#line 17280 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeSSINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11420 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    guarantee( Assembler::is_simm12(opnd_array(0)->disp(ra_,this,0)), "disp too long (storeSSI) !");
    __ st_w(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, SP, opnd_array(0)->disp(ra_,this,0));
  
#line 17297 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadSSLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11433 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    guarantee( Assembler::is_simm12(opnd_array(1)->disp(ra_,this,idx1)), "disp too long (loadSSL) !");
    __ ld_d(opnd_array(0)->as_Register(ra_,this)/* dst */, SP, opnd_array(1)->disp(ra_,this,idx1));
  
#line 17314 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeSSLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11446 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    guarantee( Assembler::is_simm12(opnd_array(0)->disp(ra_,this,0)), "disp too long (storeSSL) !");
    __ st_d(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, SP, opnd_array(0)->disp(ra_,this,0));
  
#line 17331 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadSSPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11459 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    guarantee( Assembler::is_simm12(opnd_array(1)->disp(ra_,this,idx1)), "disp too long (loadSSP) !");
    __ ld_d(opnd_array(0)->as_Register(ra_,this)/* dst */, SP, opnd_array(1)->disp(ra_,this,idx1));
  
#line 17348 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeSSPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11472 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    guarantee( Assembler::is_simm12(opnd_array(0)->disp(ra_,this,0)), "disp too long (storeSSP) !");
    __ st_d(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, SP, opnd_array(0)->disp(ra_,this,0));
  
#line 17365 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadSSFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11485 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    guarantee( Assembler::is_simm12(opnd_array(1)->disp(ra_,this,idx1)), "disp too long (loadSSF) !");
    __ fld_s(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, SP, opnd_array(1)->disp(ra_,this,idx1));
  
#line 17382 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeSSFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11498 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    guarantee( Assembler::is_simm12(opnd_array(0)->disp(ra_,this,0)), "disp too long (storeSSF) !");
    __ fst_s(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, SP, opnd_array(0)->disp(ra_,this,0));
  
#line 17399 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadSSDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11512 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    guarantee( Assembler::is_simm12(opnd_array(1)->disp(ra_,this,idx1)), "disp too long (loadSSD) !");
    __ fld_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, SP, opnd_array(1)->disp(ra_,this,idx1));
  
#line 17416 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeSSDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11525 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    guarantee( Assembler::is_simm12(opnd_array(0)->disp(ra_,this,0)), "disp too long (storeSSD) !");
    __ fst_d(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, SP, opnd_array(0)->disp(ra_,this,0));
  
#line 17433 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmpFastLockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// object
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// scr
  {
    MacroAssembler _masm(&cbuf);

#line 11537 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ fast_lock(opnd_array(1)->as_Register(ra_,this,idx1)/* object */, opnd_array(2)->as_Register(ra_,this,idx2)/* box */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, opnd_array(4)->as_Register(ra_,this,idx4)/* scr */);
  
#line 17452 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void cmpFastUnlockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// object
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {
    MacroAssembler _masm(&cbuf);

#line 11550 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ fast_unlock(opnd_array(1)->as_Register(ra_,this,idx1)/* object */, opnd_array(2)->as_Register(ra_,this,idx2)/* box */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */);
  
#line 17470 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeImmCMNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1795 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);
    int value = opnd_array(2)->constant();

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        if (value == 0) {
          __ st_b(R0, AT, disp);
        } else {
          __ move(T4, value);
          __ st_b(T4, AT, disp);
        }
      } else {
        if (value == 0) {
          __ move(T4, disp);
          __ stx_b(R0, AT, T4);
        } else {
          __ move(T4, disp);
          __ add_d(AT, AT, T4);
          __ move(T4, value);
          __ st_b(T4, AT, 0);
        }
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        if (value == 0) {
          __ st_b(R0, as_Register(base), disp);
        } else {
          __ move(AT, value);
          __ st_b(AT, as_Register(base), disp);
        }
      } else {
        if (value == 0) {
          __ move(T4, disp);
          __ stx_b(R0, as_Register(base), T4);
        } else {
          __ move(T4, disp);
          __ add_d(AT, as_Register(base), T4);
          __ move(T4, value);
          __ st_b(T4, AT, 0);
        }
      }
    }
    __ dbar(0);
  
#line 17537 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void ShouldNotReachHereNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 11577 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    // Here we should emit illtrap!
    __ brk(18);
  
#line 17554 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void leaP8NarrowNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 11591 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register  dst  = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register  base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    int       disp = opnd_array(1)->disp(ra_,this,idx1);

    __ addi_d(dst, base, disp);
  
#line 17574 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void leaPPosIdxScaleOff8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 11607 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register  dst   = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register  base  = as_Register(opnd_array(1)->base(ra_,this,idx1));
    Register  index = as_Register(opnd_array(1)->index(ra_,this,idx1));
    int       scale = opnd_array(1)->scale();
    int       disp  = opnd_array(1)->disp(ra_,this,idx1);

    if (scale == 0) {
      __ add_d(AT, base, index);
      __ addi_d(dst, AT, disp);
    } else {
      __ alsl_d(AT, index, base, scale - 1);
      __ addi_d(dst, AT, disp);
    }
 
#line 17602 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void leaPIdxScaleNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {
    MacroAssembler _masm(&cbuf);

#line 11632 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register  dst   = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register  base  = as_Register(opnd_array(1)->base(ra_,this,idx1));
    Register  index = as_Register(opnd_array(1)->index(ra_,this,idx1));
    int       scale = opnd_array(1)->scale();

    if (scale == 0) {
       __ add_d(dst, base, index);
    } else {
       __ alsl_d(dst, index, base, scale - 1);
    }
 
#line 17627 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void partialSubtypeCheckNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// sub
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// super
  {

#line 2648 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register result = opnd_array(0)->as_Register(ra_,this)/* result */;
    Register sub    = opnd_array(1)->as_Register(ra_,this,idx1)/* sub */;
    Register super  = opnd_array(2)->as_Register(ra_,this,idx2)/* super */;
    Register length = as_Register(T8_enc);
    Register tmp    = T4;
    Label miss;

    // result may be the same as sub
    //    47c   B40: #    B21 B41 <- B20  Freq: 0.155379
    //    47c     partialSubtypeCheck result=S1, sub=S1, super=S3, length=S0
    //    4bc     mov   S2, NULL #@loadConP
    //    4c0     beq   S1, S2, B21 #@branchConP  P=0.999999 C=-1.000000
    //
    MacroAssembler _masm(&cbuf);
    Label done;
    __ check_klass_subtype_slow_path(sub, super, length, tmp,
        NULL, &miss,
        /*set_cond_codes:*/ true);
    // Refer to X86_64's RDI
    __ move(result, 0);
    __ b(done);

    __ bind(miss);
    __ move(result, 1);
    __ bind(done);
  
#line 17667 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storePConditionalNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// heap_top_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    MacroAssembler _masm(&cbuf);

#line 11672 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register oldval = opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */;
    Register newval = opnd_array(3)->as_Register(ra_,this,idx3)/* newval */;
    Address addr(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1));

    int     index = opnd_array(1)->index(ra_,this,idx1);
    int     scale = opnd_array(1)->scale();
    int      disp = opnd_array(1)->disp(ra_,this,idx1);

    guarantee(Assembler::is_simm12(disp), "");

    if( index != 0 ) {
      __ stop("in storePConditional: index != 0");
    } else {
      __ cmpxchg(newval, addr, oldval);
    }
  
#line 17699 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeIConditionalNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    MacroAssembler _masm(&cbuf);

#line 11699 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register oldval = opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */;
    Register newval = opnd_array(3)->as_Register(ra_,this,idx3)/* newval */;
    Address  addr(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1));
    Label    again, failure, L1;

    int     index = opnd_array(1)->index(ra_,this,idx1);
    int     scale = opnd_array(1)->scale();
    int      disp = opnd_array(1)->disp(ra_,this,idx1);

    guarantee(Assembler::is_simm12(disp), "");

    if( index != 0 ) {
      __ stop("in storeIConditional: index != 0");
    } else {
      __ bind(again);
      __ ll_w(AT, addr);
      __ beq(AT, oldval, L1);
      __ add_d(AT, R0, R0);
      __ b(failure);
      __ bind(L1);

      __ add_d(AT, newval, R0);
      __ sc_w(AT, addr);
      __ beq(AT, R0, again);
      __ addi_d(AT, R0, 0xFF);
      __ bind(failure);
      __ dbar(0);
    }

#line 17744 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeLConditionalNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    MacroAssembler _masm(&cbuf);

#line 11741 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register oldval = opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */;
    Register newval = opnd_array(3)->as_Register(ra_,this,idx3)/* newval */;
    Address addr(as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->disp(ra_,this,idx1));

    int     index = opnd_array(1)->index(ra_,this,idx1);
    int     scale = opnd_array(1)->scale();
    int      disp = opnd_array(1)->disp(ra_,this,idx1);

    guarantee(Assembler::is_simm12(disp), "");

    if( index != 0 ) {
      __ stop("in storeIConditional: index != 0");
    } else {
      __ cmpxchg(newval, addr, oldval);
    }
  
#line 17776 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadPLockedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2173 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    assert(disp_reloc == relocInfo::none, "cannot have disp");

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ ld_d(as_Register(dst), AT, disp);
      } else {
        __ set64(T4, disp);
        __ ldx_d(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_d(as_Register(dst), as_Register(base), disp);
      } else {
        __ set64(T4, disp);
        __ ldx_d(as_Register(dst), as_Register(base), T4);
      }
    }
    __ dbar(0);
  
#line 17820 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

uint loadPLockedNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 12, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 12);
}

void compareAndSwapINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    MacroAssembler _masm(&cbuf);

#line 11784 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register newval = opnd_array(3)->as_Register(ra_,this,idx3)/* newval */;
    Register oldval = opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */;
    Register res    = opnd_array(0)->as_Register(ra_,this)/* res */;
    Address  addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem_ptr */, 0);
    Label L;

    __ cmpxchg32(newval, addr, oldval);
    __ move(res, AT);
  
#line 17850 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void compareAndSwapLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    MacroAssembler _masm(&cbuf);

#line 11806 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register newval = opnd_array(3)->as_Register(ra_,this,idx3)/* newval */;
    Register oldval = opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */;
    Register res    = opnd_array(0)->as_Register(ra_,this)/* res */;
    Address  addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem_ptr */, 0);
    Label L;

    __ cmpxchg(newval, addr, oldval);
    __ move(res, AT);
  
#line 17875 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void compareAndSwapPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    MacroAssembler _masm(&cbuf);

#line 11826 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register newval = opnd_array(3)->as_Register(ra_,this,idx3)/* newval */;
    Register oldval = opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */;
    Register res    = opnd_array(0)->as_Register(ra_,this)/* res */;
    Address  addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem_ptr */, 0);
    Label L;

    __ cmpxchg(newval, addr, oldval);
    __ move(res, AT);
  
#line 17900 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void compareAndSwapNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {
    MacroAssembler _masm(&cbuf);

#line 11845 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register newval = opnd_array(3)->as_Register(ra_,this,idx3)/* newval */;
    Register oldval = opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */;
    Register res    = opnd_array(0)->as_Register(ra_,this)/* res */;
    Address  addr(opnd_array(1)->as_Register(ra_,this,idx1)/* mem_ptr */, 0);
    Label L;

    // cmpxchg32 is implemented with ll/sc, which will do sign extension.
    //      Thus, we should extend oldval's sign for correct comparision.
    //
    __ slli_w(oldval, oldval, 0);

    __ cmpxchg32(newval, addr, oldval);
    __ move(res, AT);
  
#line 17930 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void minI_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11896 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst   = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;
    Register src   = opnd_array(2)->as_Register(ra_,this,idx2)/* src */;

    __ slt(AT, src, dst);
    __ masknez(dst, dst, AT);
    __ maskeqz(AT, src, AT);
    __ OR(dst, dst, AT);
  
#line 17953 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void maxI_Reg_RegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 11940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst   = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;
    Register src   = opnd_array(2)->as_Register(ra_,this,idx2)/* src */;

    __ slt(AT, dst, src);
    __ masknez(dst, dst, AT);
    __ maskeqz(AT, src, AT);
    __ OR(dst, dst, AT);
  
#line 17976 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void maxI_Reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 11959 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst   = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;

    __ slt(AT, dst, R0);
    __ masknez(dst, dst, AT);
  
#line 17996 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void zerox_long_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 11974 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;

    __ bstrpick_d(dst, src, 31, 0);
  
#line 18016 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void combine_i2lNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// shift32
  {
    MacroAssembler _masm(&cbuf);

#line 11988 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst  = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */;

    if (src1 == dst) {
       __ bstrins_d(dst, src2, 63, 32);
    } else if (src2 == dst) {
       __ slli_d(dst, dst, 32);
       __ bstrins_d(dst, src1, 31, 0);
    } else {
       __ bstrpick_d(dst, src1, 31, 0);
       __ bstrins_d(dst, src2, 63, 32);
    }
  
#line 18047 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void combine_i2l_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift32
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 11988 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst  = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(3)->as_Register(ra_,this,idx3)/* src1 */;
    Register src2 = opnd_array(1)->as_Register(ra_,this,idx1)/* src2 */;

    if (src1 == dst) {
       __ bstrins_d(dst, src2, 63, 32);
    } else if (src2 == dst) {
       __ slli_d(dst, dst, 32);
       __ bstrins_d(dst, src1, 31, 0);
    } else {
       __ bstrpick_d(dst, src1, 31, 0);
       __ bstrins_d(dst, src2, 63, 32);
    }
  
#line 18078 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void convI2L_reg_reg_zexNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 12012 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;

    __ bstrpick_d(dst, src, 31, 0);
  
#line 18098 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void convL2I2L_reg_reg_zexNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 12026 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;

    __ bstrpick_d(dst, src, 31, 0);
  
#line 18118 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadUI2L_rmaskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 2106 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    assert(disp_reloc == relocInfo::none, "cannot have disp");

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ ld_wu(as_Register(dst), AT, disp);
      } else {
        __ set64(T4, disp);
        __ ldx_wu(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_wu(as_Register(dst), as_Register(base), disp);
      } else {
        __ set64(T4, disp);
        __ ldx_wu(as_Register(dst), as_Register(base), T4);
      }
    }
  
#line 18162 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadUI2L_lmaskNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mask
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 2106 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(2)->base(ra_,this,idx2);
    int  index = opnd_array(2)->index(ra_,this,idx2);
    int  scale = opnd_array(2)->scale();
    int  disp = opnd_array(2)->disp(ra_,this,idx2);
    relocInfo::relocType disp_reloc = opnd_array(2)->disp_reloc();
    assert(disp_reloc == relocInfo::none, "cannot have disp");

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ ld_wu(as_Register(dst), AT, disp);
      } else {
        __ set64(T4, disp);
        __ ldx_wu(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_wu(as_Register(dst), as_Register(base), disp);
      } else {
        __ set64(T4, disp);
        __ ldx_wu(as_Register(dst), as_Register(base), T4);
      }
    }
  
#line 18206 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadUI2L_lmask_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 2106 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  dst = opnd_array(0)->reg(ra_,this)/* dst */;
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);
    relocInfo::relocType disp_reloc = opnd_array(1)->disp_reloc();
    assert(disp_reloc == relocInfo::none, "cannot have disp");

    if( index != 0 ) {
      if (scale == 0) {
        __ add_d(AT, as_Register(base), as_Register(index));
      } else {
        __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
      }
      if( Assembler::is_simm12(disp) ) {
        __ ld_wu(as_Register(dst), AT, disp);
      } else {
        __ set64(T4, disp);
        __ ldx_wu(as_Register(dst), AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ ld_wu(as_Register(dst), as_Register(base), disp);
      } else {
        __ set64(T4, disp);
        __ ldx_wu(as_Register(dst), as_Register(base), T4);
      }
    }
  
#line 18250 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void safePoint_poll_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 12064 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    Register poll_reg = opnd_array(1)->as_Register(ra_,this,idx1)/* poll */;

    __ block_comment("Safepoint:");
    __ relocate(relocInfo::poll_type);
    __ ld_w(AT, poll_reg, 0);
  
#line 18270 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void safePoint_pollNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 12081 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ block_comment("Safepoint:");
    __ set64(T4, (long)os::get_polling_page());
    __ relocate(relocInfo::poll_type);
    __ ld_w(AT, T4, 0);
  
#line 18289 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void roundFloat_nopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

void roundDouble_nopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

void countLeadingZerosINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 12118 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ clz_w(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 18321 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void countLeadingZerosLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 12129 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ clz_d(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 18337 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void countTrailingZerosINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 12140 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    // ctz and dctz is gs instructions.
    __ ctz_w(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 18354 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void countTrailingZerosLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 12152 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ ctz_d(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 18370 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void loadV8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2529 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);
    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);

    if ( index != 0 ) {
      if ( Assembler::is_simm12(disp) ) {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ fld_d(dst_reg, AT, disp);
      } else {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ move(T4, disp);
        __ fldx_d(dst_reg, AT, T4);
      }
    } else {
      if( Assembler::is_simm12(disp) ) {
        __ fld_d(dst_reg, as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ fldx_d(dst_reg, as_Register(base), T4);
      }
    }
  
#line 18416 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void storeV8Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2564 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    MacroAssembler _masm(&cbuf);
    int  base = opnd_array(1)->base(ra_,this,idx1);
    int  index = opnd_array(1)->index(ra_,this,idx1);
    int  scale = opnd_array(1)->scale();
    int  disp = opnd_array(1)->disp(ra_,this,idx1);
    FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);

    if ( index != 0 ) {
      if ( Assembler::is_simm12(disp) ) {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ fst_d(src_reg, AT, disp);
      } else {
        if (scale == 0) {
          __ add_d(AT, as_Register(base), as_Register(index));
        } else {
          __ alsl_d(AT, as_Register(index), as_Register(base), scale - 1);
        }
        __ move(T4, disp);
        __ fstx_d(src_reg, AT, T4);
      }
    } else {
      if ( Assembler::is_simm12(disp) ) {
        __ fst_d(src_reg, as_Register(base), disp);
      } else {
        __ move(T4, disp);
        __ fstx_d(src_reg, as_Register(base), T4);
      }
    }
  
#line 18463 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void Repl8B_DSPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 12186 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    guarantee(0, "LA not implemented yet");
  
#line 18479 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void Repl8BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 12201 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ move(AT, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ bstrins_d(AT, AT, 15, 8);
    __ bstrins_d(AT, AT, 31, 16);
    __ bstrins_d(AT, AT, 63, 32);
    __ movgr2fr_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, AT);
  
#line 18499 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void Repl8B_imm_DSPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 12217 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    guarantee(0, "LA not implemented yet");
  
#line 18515 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void Repl8B_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 12232 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ move(AT, opnd_array(1)->constant());
    __ bstrins_d(AT, AT, 15, 8);
    __ bstrins_d(AT, AT, 31, 16);
    __ bstrins_d(AT, AT, 63, 32);
    __ movgr2fr_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, AT);
  
#line 18535 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void Repl8B_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 12247 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ movgr2fr_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, R0);
  
#line 18551 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void Repl8B_M1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// M1
  {
    MacroAssembler _masm(&cbuf);

#line 12258 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ nor(AT, R0, R0);
    __ movgr2fr_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, AT);
  
#line 18568 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void Repl4S_DSPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 12271 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    //TODO: LA
    guarantee(0, "LA not implemented yet");
  
#line 18585 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void Repl4SNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 12286 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ move(AT, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ bstrins_d(AT, AT, 31, 16);
    __ bstrins_d(AT, AT, 63, 32);
    __ movgr2fr_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, AT);
  
#line 18604 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void Repl4S_imm_DSPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 12301 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    //TODO: LA
    guarantee(0, "LA not implemented yet");
  
#line 18621 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void Repl4S_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 12316 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ move(AT, opnd_array(1)->constant());
    __ bstrins_d(AT, AT, 31, 16);
    __ bstrins_d(AT, AT, 63, 32);
    __ movgr2fr_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, AT);
  
#line 18640 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void Repl4S_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 12329 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ movgr2fr_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, R0);
  
#line 18656 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void Repl4S_M1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// M1
  {
    MacroAssembler _masm(&cbuf);

#line 12339 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ nor(AT, R0, R0);
    __ movgr2fr_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, AT);
  
#line 18673 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void Repl2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 12353 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ bstrins_d(AT, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, 31, 0);
    __ bstrins_d(AT, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, 63, 32);
    __ movgr2fr_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, AT);
  
#line 18691 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void Repl2I_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 12369 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    int      val = opnd_array(1)->constant();
    __ li32(AT, val);
    __ bstrins_d(AT, AT, 63, 32);
    __ movgr2fr_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, AT);
  
#line 18710 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void Repl2I_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 12383 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ movgr2fr_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, R0);
  
#line 18726 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void Repl2I_M1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// M1
  {
    MacroAssembler _masm(&cbuf);

#line 12394 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"


    __ nor(AT, R0, R0);
    __ movgr2fr_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, AT);

  
#line 18745 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void Repl2FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 12408 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    //TODO: LA
    guarantee(0, "LA not implemented yet");
  
#line 18762 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void Repl2F_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 12420 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    __ movgr2fr_d(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, R0);
  
#line 18778 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void vadd2FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 12437 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    //TODO: LA
    guarantee(0, "LA not implemented yet");
  
#line 18796 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void vadd2F3Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12448 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    //TODO: LA
    guarantee(0, "LA not implemented yet");
  
#line 18814 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void vsub2FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 12462 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    //TODO: LA
    guarantee(0, "LA not implemented yet");
  
#line 18832 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void vmul2FNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 12476 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    //TODO: LA
    guarantee(0, "LA not implemented yet");
  
#line 18850 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

void vmul2F3Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 12487 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    //TODO: LA
    guarantee(0, "LA not implemented yet");
  
#line 18868 "../generated/adfiles/ad_loongarch_64.cpp"
  }
}

const MachOper* loadINode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI_convI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2BNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2UBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2SNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2USNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadLNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadL_unalignedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeL_regNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeL_immL_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeL_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadNNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadN2PNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadPNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadNKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadN2PKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadRangeNode::memory_operand() const { return _opnds[1]; }
const MachOper* storePNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmP_immP_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmBNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeNNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeP2NNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeNKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeP2NKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmN_immN_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeBNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeB_convL2INode::memory_operand() const { return _opnds[1]; }
const MachOper* loadBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadB_convI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUB_convI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadS2BNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadS_convI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmINode::memory_operand() const { return _opnds[1]; }
const MachOper* storeINode::memory_operand() const { return _opnds[1]; }
const MachOper* storeI_convL2INode::memory_operand() const { return _opnds[1]; }
const MachOper* loadFNode::memory_operand() const { return _opnds[1]; }
const TypePtr *membar_acquireNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_acquireNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *load_fenceNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* load_fenceNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_acquire_lockNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_acquire_lockNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_releaseNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_releaseNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *store_fenceNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* store_fenceNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_release_lockNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_release_lockNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_volatileNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_volatileNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *unnecessary_membar_volatileNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* unnecessary_membar_volatileNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_storestoreNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_storestoreNode::memory_operand() const { return (MachOper*)-1; }
const MachOper* lbu_and_lmaskNode::memory_operand() const { return _opnds[2]; }
const MachOper* lbu_and_lmask_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* lbu_and_rmaskNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchrNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchwNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchAllocNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS_convI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeCNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeC_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeF_regNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeF_immF_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadDNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadD_unalignedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeD_regNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeD_immD_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmCMNode::memory_operand() const { return _opnds[1]; }
const MachOper* storePConditionalNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeIConditionalNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeLConditionalNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadPLockedNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUI2L_rmaskNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUI2L_lmaskNode::memory_operand() const { return _opnds[2]; }
const MachOper* loadUI2L_lmask_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadV8Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeV8Node::memory_operand() const { return _opnds[1]; }


const bool Matcher::has_match_rule(int opcode) {
  assert(_last_machine_leaf < opcode && opcode < _last_opcode, "opcode in range");
  return _hasMatchRule[opcode];
}

const bool Matcher::_hasMatchRule[_last_opcode] = {
    false,  // Node
    false,  // Set
    false,  // RegN
    false,  // RegI
    false,  // RegP
    false,  // RegF
    false,  // RegD
    false,  // RegL
    false,  // RegFlags
    false,  // VecS
    false,  // VecD
    false,  // VecX
    false,  // VecY
    false,  // _last_machine_leaf
    true ,  // AbsD
    true ,  // AbsF
    false,  // AbsI
    true ,  // AddD
    true ,  // AddF
    true ,  // AddI
    true ,  // AddL
    true ,  // AddP
    false,  // Allocate
    false,  // AllocateArray
    true ,  // AndI
    true ,  // AndL
    false,  // AryEq
    false,  // AtanD
    true ,  // Binary
    true ,  // Bool
    false,  // BoxLock
    false,  // ReverseBytesI
    false,  // ReverseBytesL
    false,  // ReverseBytesUS
    false,  // ReverseBytesS
    false,  // CProj
    true ,  // CallDynamicJava
    false,  // CallJava
    true ,  // CallLeaf
    true ,  // CallLeafNoFP
    true ,  // CallRuntime
    true ,  // CallStaticJava
    true ,  // CastII
    true ,  // CastX2P
    true ,  // CastP2X
    true ,  // CastPP
    false,  // Catch
    false,  // CatchProj
    true ,  // CheckCastPP
    true ,  // ClearArray
    false,  // ConstraintCast
    true ,  // CMoveD
    true ,  // CMoveF
    true ,  // CMoveI
    true ,  // CMoveL
    true ,  // CMoveP
    true ,  // CMoveN
    true ,  // CmpN
    true ,  // CmpD
    true ,  // CmpD3
    true ,  // CmpF
    true ,  // CmpF3
    true ,  // CmpI
    true ,  // CmpL
    true ,  // CmpL3
    true ,  // CmpLTMask
    true ,  // CmpP
    true ,  // CmpU
    false,  // CmpUL
    true ,  // CompareAndSwapI
    true ,  // CompareAndSwapL
    true ,  // CompareAndSwapP
    true ,  // CompareAndSwapN
    false,  // GetAndAddI
    false,  // GetAndAddL
    false,  // GetAndSetI
    false,  // GetAndSetL
    false,  // GetAndSetP
    false,  // GetAndSetN
    false,  // Con
    true ,  // ConN
    true ,  // ConNKlass
    true ,  // ConD
    true ,  // ConF
    true ,  // ConI
    true ,  // ConL
    true ,  // ConP
    true ,  // Conv2B
    true ,  // ConvD2F
    true ,  // ConvD2I
    true ,  // ConvD2L
    true ,  // ConvF2D
    true ,  // ConvF2I
    true ,  // ConvF2L
    true ,  // ConvI2D
    true ,  // ConvI2F
    true ,  // ConvI2L
    true ,  // ConvL2D
    true ,  // ConvL2F
    true ,  // ConvL2I
    false,  // CosD
    false,  // CountedLoop
    true ,  // CountedLoopEnd
    true ,  // CountLeadingZerosI
    true ,  // CountLeadingZerosL
    true ,  // CountTrailingZerosI
    true ,  // CountTrailingZerosL
    true ,  // CreateEx
    true ,  // DecodeN
    true ,  // DecodeNKlass
    true ,  // DivD
    true ,  // DivF
    true ,  // DivI
    true ,  // DivL
    false,  // DivMod
    false,  // DivModI
    false,  // DivModL
    false,  // EncodeISOArray
    true ,  // EncodeP
    true ,  // EncodePKlass
    false,  // ExpD
    true ,  // FastLock
    true ,  // FastUnlock
    true ,  // Goto
    true ,  // Halt
    true ,  // If
    false,  // IfFalse
    false,  // IfTrue
    false,  // Initialize
    false,  // JProj
    false,  // Jump
    false,  // JumpProj
    true ,  // LShiftI
    true ,  // LShiftL
    true ,  // LoadB
    true ,  // LoadUB
    true ,  // LoadUS
    true ,  // LoadD
    true ,  // LoadD_unaligned
    true ,  // LoadF
    true ,  // LoadI
    true ,  // LoadKlass
    true ,  // LoadNKlass
    true ,  // LoadL
    true ,  // LoadL_unaligned
    true ,  // LoadPLocked
    true ,  // LoadP
    true ,  // LoadN
    true ,  // LoadRange
    true ,  // LoadS
    false,  // Lock
    false,  // LogD
    false,  // Log10D
    false,  // Loop
    false,  // LoopLimit
    false,  // Mach
    false,  // MachProj
    true ,  // MaxI
    true ,  // MemBarAcquire
    true ,  // LoadFence
    true ,  // MemBarAcquireLock
    false,  // MemBarCPUOrder
    true ,  // MemBarRelease
    true ,  // StoreFence
    true ,  // MemBarReleaseLock
    true ,  // MemBarVolatile
    true ,  // MemBarStoreStore
    false,  // MergeMem
    true ,  // MinI
    false,  // ModD
    false,  // ModF
    true ,  // ModI
    true ,  // ModL
    true ,  // MoveI2F
    true ,  // MoveF2I
    true ,  // MoveL2D
    true ,  // MoveD2L
    true ,  // MulD
    true ,  // MulF
    false,  // MulHiL
    true ,  // MulI
    true ,  // MulL
    false,  // Multi
    true ,  // NegD
    true ,  // NegF
    false,  // NeverBranch
    false,  // Opaque1
    false,  // Opaque2
    false,  // Opaque3
    false,  // ProfileBoolean
    true ,  // OrI
    true ,  // OrL
    false,  // OverflowAddI
    false,  // OverflowSubI
    false,  // OverflowMulI
    false,  // OverflowAddL
    false,  // OverflowSubL
    false,  // OverflowMulL
    false,  // PCTable
    false,  // Parm
    true ,  // PartialSubtypeCheck
    false,  // Phi
    false,  // PopCountI
    false,  // PopCountL
    false,  // PowD
    true ,  // PrefetchAllocation
    true ,  // PrefetchRead
    true ,  // PrefetchWrite
    false,  // Proj
    true ,  // RShiftI
    true ,  // RShiftL
    false,  // Region
    true ,  // Rethrow
    true ,  // Return
    false,  // Root
    true ,  // RoundDouble
    true ,  // RoundFloat
    true ,  // SafePoint
    false,  // SafePointScalarObject
    false,  // SCMemProj
    false,  // SinD
    true ,  // SqrtD
    false,  // Start
    false,  // StartOSR
    true ,  // StoreB
    true ,  // StoreC
    true ,  // StoreCM
    true ,  // StorePConditional
    true ,  // StoreIConditional
    true ,  // StoreLConditional
    true ,  // StoreD
    true ,  // StoreF
    true ,  // StoreI
    true ,  // StoreL
    true ,  // StoreP
    true ,  // StoreN
    true ,  // StoreNKlass
    true ,  // StrComp
    true ,  // StrEquals
    false,  // StrIndexOf
    true ,  // SubD
    true ,  // SubF
    true ,  // SubI
    true ,  // SubL
    true ,  // TailCall
    true ,  // TailJump
    false,  // TanD
    true ,  // ThreadLocal
    false,  // Unlock
    true ,  // URShiftI
    true ,  // URShiftL
    true ,  // XorI
    true ,  // XorL
    false,  // Vector
    false,  // AddVB
    false,  // AddVS
    false,  // AddVI
    false,  // AddVL
    true ,  // AddVF
    false,  // AddVD
    false,  // SubVB
    false,  // SubVS
    false,  // SubVI
    false,  // SubVL
    true ,  // SubVF
    false,  // SubVD
    false,  // MulVS
    false,  // MulVI
    true ,  // MulVF
    false,  // MulVD
    false,  // DivVF
    false,  // DivVD
    false,  // LShiftCntV
    false,  // RShiftCntV
    false,  // LShiftVB
    false,  // LShiftVS
    false,  // LShiftVI
    false,  // LShiftVL
    false,  // RShiftVB
    false,  // RShiftVS
    false,  // RShiftVI
    false,  // RShiftVL
    false,  // URShiftVB
    false,  // URShiftVS
    false,  // URShiftVI
    false,  // URShiftVL
    false,  // AndV
    false,  // OrV
    false,  // XorV
    true ,  // LoadVector
    true ,  // StoreVector
    false,  // Pack
    false,  // PackB
    false,  // PackS
    false,  // PackI
    false,  // PackL
    false,  // PackF
    false,  // PackD
    false,  // Pack2L
    false,  // Pack2D
    true ,  // ReplicateB
    true ,  // ReplicateS
    true ,  // ReplicateI
    false,  // ReplicateL
    true ,  // ReplicateF
    false,  // ReplicateD
    false,  // Extract
    false,  // ExtractB
    false,  // ExtractUB
    false,  // ExtractC
    false,  // ExtractS
    false,  // ExtractI
    false,  // ExtractL
    false,  // ExtractF
    false   // ExtractD
};


bool Matcher::stack_direction() const { return false; }

int Compile::sync_stack_slots() const { return 2; }

uint Matcher::stack_alignment_in_bytes() { return StackAlignmentInBytes; }

OptoReg::Name Matcher::return_addr() const { return OptoReg::Name(RA_num); }

uint Compile::in_preserve_stack_slots() { return 4; }

uint Compile::out_preserve_stack_slots() { return SharedRuntime::out_preserve_stack_slots(); }

uint Compile::varargs_C_out_slots_killed() const { return 0; }

void Matcher::calling_convention(BasicType *sig_bt, VMRegPair *regs, uint length, bool is_outgoing) {

#line 2793 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    SharedRuntime::java_calling_convention(sig_bt, regs, length, false);
  
#line 19301 "../generated/adfiles/ad_loongarch_64.cpp"

}

void Matcher::c_calling_convention(BasicType *sig_bt, VMRegPair *regs, uint length) {

#line 2809 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

   (void) SharedRuntime::c_calling_convention(sig_bt, regs, /*regs2=*/NULL, length);
  
#line 19311 "../generated/adfiles/ad_loongarch_64.cpp"

}

OptoRegPair Matcher::return_value(uint ideal_reg, bool is_outgoing) {

#line 2829 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    assert( ideal_reg >= Op_RegI && ideal_reg <= Op_RegL, "only return normal values" );
                               /* -- , -- , Op_RegN, Op_RegI, Op_RegP, Op_RegF, Op_RegD, Op_RegL */
    static int lo[Op_RegL+1] = { 0, 0, V0_num,       V0_num,       V0_num,       F0_num,       F0_num,     V0_num };
    static int hi[Op_RegL+1] = { 0, 0, OptoReg::Bad, OptoReg::Bad, V0_H_num,     OptoReg::Bad, F0_H_num,   V0_H_num};
    return OptoRegPair(hi[ideal_reg],lo[ideal_reg]);
  
#line 19325 "../generated/adfiles/ad_loongarch_64.cpp"

}

OptoRegPair Matcher::c_return_value(uint ideal_reg, bool is_outgoing) {

#line 2817 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"

    assert( ideal_reg >= Op_RegI && ideal_reg <= Op_RegL, "only return normal values" );
                               /* -- , -- , Op_RegN, Op_RegI, Op_RegP, Op_RegF, Op_RegD, Op_RegL */
    static int lo[Op_RegL+1] = { 0, 0, V0_num,       V0_num,       V0_num,       F0_num,       F0_num,    V0_num };
    static int hi[Op_RegL+1] = { 0, 0, OptoReg::Bad, OptoReg::Bad, V0_H_num,     OptoReg::Bad, F0_H_num,  V0_H_num };
    return OptoRegPair(hi[ideal_reg],lo[ideal_reg]);
  
#line 19339 "../generated/adfiles/ad_loongarch_64.cpp"

}

OptoReg::Name Matcher::inline_cache_reg() { return OptoReg::Name(T1_num); }

int Matcher::inline_cache_reg_encode() { return _regEncode[inline_cache_reg()]; }

OptoReg::Name Matcher::interpreter_method_oop_reg() { return OptoReg::Name(S3_num); }

int Matcher::interpreter_method_oop_reg_encode() { return _regEncode[interpreter_method_oop_reg()]; }

OptoReg::Name Matcher::interpreter_frame_pointer_reg() { return OptoReg::Name(FP_num); }

OptoReg::Name Matcher::c_frame_pointer() const { return OptoReg::Name(SP_num); }

// Number of callee-save + always-save registers
int  Matcher::number_of_saved_registers() {
  return 0;
};

bool Compile::needs_clone_jvms() { return false; }

// Check consistency of C++ compilation with ADLC options:
// Check adlc -DLINUX=1
#ifndef LINUX
#  error "LINUX must be defined"
#endif // LINUX
// Check adlc -D_GNU_SOURCE=1
#ifndef _GNU_SOURCE
#  error "_GNU_SOURCE must be defined"
#endif // _GNU_SOURCE
// Check adlc -DLOONGARCH64=1
#ifndef LOONGARCH64
#  error "LOONGARCH64 must be defined"
#endif // LOONGARCH64
// Check adlc -D_LP64=1
#ifndef _LP64
#  error "_LP64 must be defined"
#endif // _LP64
