//
// Copyright (c) 2003, 2013, Oracle and/or its affiliates. All rights reserved.
// Copyright (c) 2015, 2021, Loongson Technology. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/ad_loongarch_64.hpp"
#include "opto/cfgnode.hpp"
#include "opto/matcher.hpp"
#include "opto/opcodes.hpp"

//------------------------- Source -----------------------------------------

//------------------------- Attributes -------------------------------------

// AttributeForm 
static const int op_cost = 0;

// AttributeForm 
static const int ins_cost = 100;

// AttributeForm 
static const int ins_size = 32;

// AttributeForm 
static const int ins_pc_relative = 0;

// AttributeForm 
static const int ins_short_branch = 0;

// AttributeForm 
static const int ins_alignment = 4;

//------------------------- Macros -----------------------------------------
#define DFA_PRODUCTION(result, rule, cost)\
  _cost[ (result) ] = cost; _rule[ (result) ] = rule;

#define DFA_PRODUCTION__SET_VALID(result, rule, cost)\
  DFA_PRODUCTION( (result), (rule), (cost) ); STATE__SET_VALID( (result) );

//------------------------- DFA --------------------------------------------
// DFA is a large switch with case statements for each ideal opcode encountered
// in any match rule in the ad file.  Each case has a series of if's to handle
// the match or fail decisions.  The matches test the cost function of that
// rule, and prune any cases which are higher cost for the same reduction.
// In order to generate the DFA we walk the table of ideal opcode/MatchList
// pairs generated by the ADLC front end to build the contents of the case
// statements (a series of if statements).


void  State::_sub_Op_RegN(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(S7_REGN, s7_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(S6_REGN, s6_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(S5_REGN, s5_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(S4_REGN, s4_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(S3_REGN, s3_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(S2_REGN, s2_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(S1_REGN, s1_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(S0_REGN, s0_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A7_REGN, a7_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A6_REGN, a6_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A5_REGN, a5_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A4_REGN, a4_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A3_REGN, a3_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A2_REGN, a2_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A1_REGN, a1_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A0_REGN, a0_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(T8_REGN, t8_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(T3_REGN, t3_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(T2_REGN, t2_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(T1_REGN, t1_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(T0_REGN, t0_RegN_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MREGN, mRegN_rule, c)
    }
}
void  State::_sub_Op_RegI(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MA7REGI, mA7RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MA6REGI, mA6RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MA5REGI, mA5RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MA4REGI, mA4RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MA3REGI, mA3RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MA2REGI, mA2RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MA1REGI, mA1RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MA0REGI, mA0RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MT4REGI, mT4RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MT8REGI, mT8RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MT3REGI, mT3RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MT2REGI, mT2RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MT1REGI, mT1RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MT0REGI, mT0RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MS7REGI, mS7RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MS6REGI, mS6RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MS5REGI, mS5RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MS4REGI, mS4RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MS3REGI, mS3RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MS2REGI, mS2RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MS1REGI, mS1RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MS0REGI, mS0RegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, no_Ax_mRegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MREGI, mRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
    }
}
void  State::_sub_Op_RegP(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, load_long_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, load_long_indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(V1_REGP, v1_RegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(V0_REGP, v0_RegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A7_REGP, a7_RegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A6_REGP, a6_RegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A5_REGP, a5_RegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A4_REGP, a4_RegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A3_REGP, a3_RegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A2_REGP, a2_RegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A1_REGP, a1_RegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A0_REGP, a0_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(MREGP, mRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, no_T8_mRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(S0_REGP, s0_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(S1_REGP, s1_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(S2_REGP, s2_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(S3_REGP, s3_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(S4_REGP, s4_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(S5_REGP, s5_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(S6_REGP, s6_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(S7_REGP, s7_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(T0_REGP, t0_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(T1_REGP, t1_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(T2_REGP, t2_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(T3_REGP, t3_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, no_Ax_mRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(T8_REGP, t8_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, indirect_rule, c)
        DFA_PRODUCTION(MEMORY, indirect_rule, c)	  // overwrites higher cost rule
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
    {
      unsigned int c = 0;
    }
}
void  State::_sub_Op_RegF(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(REGF, regF_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_RegD(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(REGD, regD_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_RegL(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(S7REGL, s7RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(S4REGL, s4RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(S3REGL, s3RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(S2REGL, s2RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(S1REGL, s1RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(S0REGL, s0RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A7REGL, a7RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A6REGL, a6RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A5REGL, a5RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A4REGL, a4RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(T8REGL, t8RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(T3REGL, t3RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(T2REGL, t2RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(T1REGL, t1RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(T0REGL, t0RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A3REGL, a3RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A2REGL, a2RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A1REGL, a1RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(A0REGL, a0RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(V1REGL, v1RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(V0REGL, v0RegL_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MREGL, mRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
    }
}
void  State::_sub_Op_RegFlags(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(FLAGSREG, FlagsReg_rule, c)
    }
}
void  State::_sub_Op_VecD(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(VECD, vecD_rule, c)
    }
}
void  State::_sub_Op_AbsD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(REGD, absD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_AbsF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION__SET_VALID(REGF, absF_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_AddD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _MULD_REGD_REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_MULD_REGD_REGD]+44444;
        DFA_PRODUCTION__SET_VALID(REGD, maddD_reg_reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULD_REGD_REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[_MULD_REGD_REGD]+_kids[1]->_cost[REGD]+44444;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, maddD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100)
      }
    }
}
void  State::_sub_Op_AddF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _MULF_REGF_REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_MULF_REGF_REGF]+44444;
        DFA_PRODUCTION__SET_VALID(REGF, maddF_reg_reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULF_REGF_REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[_MULF_REGF_REGF]+_kids[1]->_cost[REGF]+44444;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, maddF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+100)
      }
    }
}
void  State::_sub_Op_AddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], _MULI_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[_MULI_MREGI_MREGI]+999;
        DFA_PRODUCTION__SET_VALID(MREGI, maddI_Reg_Reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, maddI_Reg_Reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, maddI_Reg_Reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, maddI_Reg_Reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, maddI_Reg_Reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, maddI_Reg_Reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, maddI_Reg_Reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, maddI_Reg_Reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, maddI_Reg_Reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, maddI_Reg_Reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, maddI_Reg_Reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, maddI_Reg_Reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, maddI_Reg_Reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, maddI_Reg_Reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, maddI_Reg_Reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, maddI_Reg_Reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, maddI_Reg_Reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, maddI_Reg_Reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, maddI_Reg_Reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, maddI_Reg_Reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, maddI_Reg_Reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, maddI_Reg_Reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, maddI_Reg_Reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, maddI_Reg_Reg_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULI_MREGI_MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[_MULI_MREGI_MREGI]+_kids[1]->_cost[MREGI]+999;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, maddI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, maddI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, maddI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, maddI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, maddI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, maddI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, maddI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, maddI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, maddI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, maddI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, maddI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, maddI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, maddI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, maddI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, maddI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, maddI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, maddI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, maddI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, maddI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, maddI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, maddI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, maddI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, maddI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, maddI_Reg_Reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_MREGI_IMMI_1_4) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_MREGI_IMMI_1_4]+_kids[1]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, addI_salI_Reg_Reg_immI_1_4_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_MREGI_IMMI_1_4) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[_LSHIFTI_MREGI_IMMI_1_4]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, addI_salI_Reg_Reg_immI_1_4_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, addI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, addI_Reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, addI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, addI_Reg_Reg_rule, c)
      }
    }
}
void  State::_sub_Op_AddL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_MREGI_) && STATE__VALID_CHILD(_kids[1], _CONVI2L_MREGI_) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_MREGI_]+_kids[1]->_cost[_CONVI2L_MREGI_]+200;
        DFA_PRODUCTION__SET_VALID(MREGL, addL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(V0REGL, addL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(V1REGL, addL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A0REGL, addL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A1REGL, addL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A2REGL, addL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A3REGL, addL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(T0REGL, addL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(T1REGL, addL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(T2REGL, addL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(T3REGL, addL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(T8REGL, addL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A4REGL, addL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A5REGL, addL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A6REGL, addL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A7REGL, addL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(S0REGL, addL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(S1REGL, addL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(S2REGL, addL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(S3REGL, addL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(S4REGL, addL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(S7REGL, addL_RegI2L_RegI2L_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], _CONVI2L_MREGI_) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[_CONVI2L_MREGI_]+200;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, addL_RegI2L_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, addL_RegI2L_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, addL_RegI2L_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, addL_RegI2L_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, addL_RegI2L_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, addL_RegI2L_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, addL_RegI2L_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, addL_RegI2L_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, addL_RegI2L_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, addL_RegI2L_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, addL_RegI2L_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, addL_RegI2L_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, addL_RegI2L_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, addL_RegI2L_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, addL_RegI2L_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, addL_RegI2L_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, addL_RegI2L_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, addL_RegI2L_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, addL_RegI2L_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, addL_RegI2L_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, addL_RegI2L_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, addL_RegI2L_Reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_MREGI_) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_MREGI_]+_kids[1]->_cost[MREGL]+200;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, addL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, addL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, addL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, addL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, addL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, addL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, addL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, addL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, addL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, addL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, addL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, addL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, addL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, addL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, addL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, addL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, addL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, addL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, addL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, addL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, addL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, addL_RegI2L_Reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_MREGI_) && STATE__VALID_CHILD(_kids[1], IMML12) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_MREGI_]+_kids[1]->_cost[IMML12]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, addL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, addL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, addL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, addL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, addL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, addL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, addL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, addL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, addL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, addL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, addL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, addL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, addL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, addL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, addL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, addL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, addL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, addL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, addL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, addL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, addL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, addL_RegI2L_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML12) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML12]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, addL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, addL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, addL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, addL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, addL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, addL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, addL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, addL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, addL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, addL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, addL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, addL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, addL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, addL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, addL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, addL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, addL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, addL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, addL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, addL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, addL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, addL_Reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGL]+200;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, addL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, addL_Reg_Reg_rule, c)
      }
    }
}
void  State::_sub_Op_AddP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__CONVI2L_MREGI__IMMI_1_4) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_LSHIFTL__CONVI2L_MREGI__IMMI_1_4]+100;
        DFA_PRODUCTION__SET_VALID(MREGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(S0_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(S1_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(S2_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(S3_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(S4_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(S5_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(S6_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(S7_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(T0_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(T1_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(T2_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(T3_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(A0_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(A1_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(A2_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(A3_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(A4_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(A5_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(A6_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(A7_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(V0_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(V1_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(T8_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, addP_salL_Reg_RegI2L_immI_1_4_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, addP_salL_Reg_RegI2L_immI_1_4_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, addP_salL_Reg_RegI2L_immI_1_4_rule, c+100)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(MREGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0_REGP) || _cost[S0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S0_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S1_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2_REGP) || _cost[S2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S2_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S3_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S4_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S5_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S6_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S7_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T0_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T1_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T2_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T3_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A0_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A1_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A2_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A3_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A4_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A5_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A6_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A7_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V0_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V1_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T8_REGP, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, addP_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, addP_reg_imm_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, addP_reg_imm_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _CONVI2L_MREGI_) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_CONVI2L_MREGI_]+100;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(MREGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0_REGP) || _cost[S0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S0_REGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S1_REGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2_REGP) || _cost[S2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S2_REGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S3_REGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S4_REGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S5_REGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S6_REGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S7_REGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T0_REGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T1_REGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T2_REGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T3_REGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A0_REGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A1_REGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A2_REGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A3_REGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A4_REGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A5_REGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A6_REGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A7_REGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V0_REGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V1_REGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T8_REGP, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, addP_reg_reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, addP_reg_reg_convI2L_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, addP_reg_reg_convI2L_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[MREGL]+100;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(MREGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0_REGP) || _cost[S0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S0_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S1_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2_REGP) || _cost[S2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S2_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S3_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S4_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S5_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S6_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S7_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T0_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T1_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T2_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T3_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A0_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A1_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A2_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A3_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A4_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A5_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A6_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A7_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V0_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V1_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T8_REGP, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, addP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, addP_reg_reg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, addP_reg_reg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], LOAD_LONG_REGP) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[LOAD_LONG_REGP]+_kids[1]->_cost[IMML32];
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDOFFSET32, load_long_indOffset32_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indOffset32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP__DECODEN_MREGN__MREGL) && STATE__VALID_CHILD(_kids[1], IMML8) &&
        
#line 4618 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
Universe::narrow_oop_shift() == 0
#line 1713 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_ADDP__DECODEN_MREGN__MREGL]+_kids[1]->_cost[IMML8]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXOFFSET8NARROW, indIndexOffset8Narrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexOffset8Narrow_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_MREGN_) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_MREGN_]+_kids[1]->_cost[MREGL];
        DFA_PRODUCTION__SET_VALID(_ADDP__DECODEN_MREGN__MREGL, _AddP__DecodeN_mRegN__mRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_MREGN_) && STATE__VALID_CHILD(_kids[1], IMML8) &&
        
#line 4601 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
Universe::narrow_oop_shift() == 0
#line 1729 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_MREGN_]+_kids[1]->_cost[IMML8]+10;
        DFA_PRODUCTION__SET_VALID(INDOFFSET8NARROW, indOffset8Narrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffset8Narrow_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(MREGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S0_REGP) || _cost[S0_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S0_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S1_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S2_REGP) || _cost[S2_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S2_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S3_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S4_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S5_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S6_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S7_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(T0_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(T1_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(T2_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(T3_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A0_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A1_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A2_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A3_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A4_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A5_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A6_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A7_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(V0_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(V1_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(T8_REGP, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaP8Narrow_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, leaP8Narrow_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, leaP8Narrow_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+110+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODENKLASS_MREGN_) && STATE__VALID_CHILD(_kids[1], MREGL) &&
        
#line 4567 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
Universe::narrow_klass_shift() == 0
#line 1837 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODENKLASS_MREGN_]+_kids[1]->_cost[MREGL]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXNARROWKLASS, indIndexNarrowKlass_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP__DECODENKLASS_MREGN__MREGL) && STATE__VALID_CHILD(_kids[1], IMML32) &&
        
#line 4551 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
Universe::narrow_klass_shift() == 0
#line 1846 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_ADDP__DECODENKLASS_MREGN__MREGL]+_kids[1]->_cost[IMML32]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXOFFSETNARROWKLASS, indIndexOffsetNarrowKlass_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODENKLASS_MREGN_) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[_DECODENKLASS_MREGN_]+_kids[1]->_cost[MREGL];
        DFA_PRODUCTION__SET_VALID(_ADDP__DECODENKLASS_MREGN__MREGL, _AddP__DecodeNKlass_mRegN__mRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODENKLASS_MREGN_) && STATE__VALID_CHILD(_kids[1], IMML32) &&
        
#line 4535 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
Universe::narrow_klass_shift() == 0
#line 1859 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODENKLASS_MREGN_]+_kids[1]->_cost[IMML32]+10;
        DFA_PRODUCTION__SET_VALID(INDOFFSET32NARROWKLASS, indOffset32NarrowKlass_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODENKLASS_MREGN_) && STATE__VALID_CHILD(_kids[1], IMML8) &&
        
#line 4519 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
Universe::narrow_klass_shift() == 0
#line 1868 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_DECODENKLASS_MREGN_]+_kids[1]->_cost[IMML8]+10;
        DFA_PRODUCTION__SET_VALID(INDOFFSET8NARROWKLASS, indOffset8NarrowKlass_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[MREGL]+20;
        DFA_PRODUCTION__SET_VALID(INDINDEX, indIndex_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[IMML32]+20;
        DFA_PRODUCTION__SET_VALID(INDOFFSET32, indOffset32_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffset32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP__DECODEN_MREGN___LSHIFTL__CONVI2L_MREGI__IMMI_0_31) && STATE__VALID_CHILD(_kids[1], IMML8) &&
        
#line 4457 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
Universe::narrow_oop_shift() == 0
#line 1891 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_ADDP__DECODEN_MREGN___LSHIFTL__CONVI2L_MREGI__IMMI_0_31]+_kids[1]->_cost[IMML8]+10;
        DFA_PRODUCTION__SET_VALID(INDPOSINDEXI2LSCALEOFFSET8NARROW, indPosIndexI2LScaleOffset8Narrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indPosIndexI2LScaleOffset8Narrow_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_MREGN_) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__CONVI2L_MREGI__IMMI_0_31) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_MREGN_]+_kids[1]->_cost[_LSHIFTL__CONVI2L_MREGI__IMMI_0_31];
        DFA_PRODUCTION__SET_VALID(_ADDP__DECODEN_MREGN___LSHIFTL__CONVI2L_MREGI__IMMI_0_31, _AddP__DecodeN_mRegN___LShiftL__ConvI2L_mRegI__immI_0_31_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP__DECODEN_MREGN___LSHIFTL_MREGL_IMMI_0_3) && STATE__VALID_CHILD(_kids[1], IMML8) &&
        
#line 4438 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
Universe::narrow_oop_shift() == 0
#line 1907 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[_ADDP__DECODEN_MREGN___LSHIFTL_MREGL_IMMI_0_3]+_kids[1]->_cost[IMML8]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALEOFFSETNARROW, indIndexScaleOffsetNarrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScaleOffsetNarrow_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_MREGN_) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_MREGL_IMMI_0_3) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_MREGN_]+_kids[1]->_cost[_LSHIFTL_MREGL_IMMI_0_3];
        DFA_PRODUCTION__SET_VALID(_ADDP__DECODEN_MREGN___LSHIFTL_MREGL_IMMI_0_3, _AddP__DecodeN_mRegN___LShiftL_mRegL_immI_0_3_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_MREGP__LSHIFTL__CONVI2L_MREGI__IMMI_0_31) && STATE__VALID_CHILD(_kids[1], IMML8) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_MREGP__LSHIFTL__CONVI2L_MREGI__IMMI_0_31]+_kids[1]->_cost[IMML8]+10;
        DFA_PRODUCTION__SET_VALID(BASEPOSINDEXSCALEOFFSET8, basePosIndexScaleOffset8_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, basePosIndexScaleOffset8_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(MREGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S0_REGP) || _cost[S0_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S0_REGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S1_REGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S2_REGP) || _cost[S2_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S2_REGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S3_REGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S4_REGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S5_REGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S6_REGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S7_REGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(T0_REGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(T1_REGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(T2_REGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(T3_REGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A0_REGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A1_REGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A2_REGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A3_REGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A4_REGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A5_REGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A6_REGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A7_REGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(V0_REGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(V1_REGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(T8_REGP, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPPosIdxScaleOff8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, leaPPosIdxScaleOff8_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, leaPPosIdxScaleOff8_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+110+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__CONVI2L_MREGI__IMMI_0_31) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_LSHIFTL__CONVI2L_MREGI__IMMI_0_31];
        DFA_PRODUCTION__SET_VALID(_ADDP_MREGP__LSHIFTL__CONVI2L_MREGI__IMMI_0_31, _AddP_mRegP__LShiftL__ConvI2L_mRegI__immI_0_31_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_MREGP__LSHIFTL__CONVI2L_MREGI__IMMI_0_3) && STATE__VALID_CHILD(_kids[1], IMML8) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_MREGP__LSHIFTL__CONVI2L_MREGI__IMMI_0_3]+_kids[1]->_cost[IMML8]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALEOFFSET8_CONVI2L, indIndexScaleOffset8_convI2L_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScaleOffset8_convI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__CONVI2L_MREGI__IMMI_0_3) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_LSHIFTL__CONVI2L_MREGI__IMMI_0_3];
        DFA_PRODUCTION__SET_VALID(_ADDP_MREGP__LSHIFTL__CONVI2L_MREGI__IMMI_0_3, _AddP_mRegP__LShiftL__ConvI2L_mRegI__immI_0_3_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_MREGP__LSHIFTL_MREGL_IMMI_0_3) && STATE__VALID_CHILD(_kids[1], IMML8) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_MREGP__LSHIFTL_MREGL_IMMI_0_3]+_kids[1]->_cost[IMML8]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALEOFFSET8, indIndexScaleOffset8_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScaleOffset8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_MREGL_IMMI_0_3) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_LSHIFTL_MREGL_IMMI_0_3];
        DFA_PRODUCTION__SET_VALID(_ADDP_MREGP__LSHIFTL_MREGL_IMMI_0_3, _AddP_mRegP__LShiftL_mRegL_immI_0_3_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_MREGP__CONVI2L_MREGI_) && STATE__VALID_CHILD(_kids[1], IMML8) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_MREGP__CONVI2L_MREGI_]+_kids[1]->_cost[IMML8]+5;
        DFA_PRODUCTION__SET_VALID(BASEINDEXOFFSET8_CONVI2L, baseIndexOffset8_convI2L_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, baseIndexOffset8_convI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _CONVI2L_MREGI_) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_CONVI2L_MREGI_];
        DFA_PRODUCTION__SET_VALID(_ADDP_MREGP__CONVI2L_MREGI_, _AddP_mRegP__ConvI2L_mRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_MREGP_MREGL) && STATE__VALID_CHILD(_kids[1], IMML8) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_MREGP_MREGL]+_kids[1]->_cost[IMML8]+5;
        DFA_PRODUCTION__SET_VALID(BASEINDEXOFFSET8, baseIndexOffset8_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, baseIndexOffset8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[MREGL];
        DFA_PRODUCTION__SET_VALID(_ADDP_MREGP_MREGL, _AddP_mRegP_mRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_MREGL_IMMI_0_3) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_LSHIFTL_MREGL_IMMI_0_3]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALE, indIndexScale_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScale_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(MREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S0_REGP) || _cost[S0_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S0_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S1_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S2_REGP) || _cost[S2_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S2_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S3_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S4_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S5_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S6_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(S7_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(T0_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(T1_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(T2_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(T3_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A0_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A1_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A2_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A3_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A4_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A5_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A6_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(A7_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(V0_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(V1_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(T8_REGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, leaPIdxScale_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, leaPIdxScale_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+110+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], IMML8) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[IMML8]+10;
        DFA_PRODUCTION__SET_VALID(INDOFFSET8, indOffset8_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffset8_rule, c)
      }
    }
}
void  State::_sub_Op_AndI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_MREGI_IMMI_0_31) && STATE__VALID_CHILD(_kids[1], IMMI_NONNEG_MASK) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_MREGI_IMMI_0_31]+_kids[1]->_cost[IMMI_NONNEG_MASK]+100;
        DFA_PRODUCTION__SET_VALID(MREGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, shr_logical_Reg_imm_nonneg_mask_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_1) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_1];
        DFA_PRODUCTION__SET_VALID(_ANDI_MREGI_IMMI_1, _AndI_mRegI_immI_1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVL2I__URSHIFTL_MREGL_IMMI_0_31_) && STATE__VALID_CHILD(_kids[1], IMMI_MAXI) ) {
      unsigned int c = _kids[0]->_cost[_CONVL2I__URSHIFTL_MREGL_IMMI_0_31_]+_kids[1]->_cost[IMMI_MAXI]+80;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, slrL_Reg_immI_0_31_and_max_int_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_MREGI_IMMI_16) && STATE__VALID_CHILD(_kids[1], IMMI_M65536) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_MREGI_IMMI_16]+_kids[1]->_cost[IMMI_M65536]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, salI_Reg_imm_and_M65536_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, salI_Reg_imm_and_M65536_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI_MREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[_XORI_MREGI_IMMI_M1]+_kids[1]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, andnI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, andnI_Reg_nReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], _XORI_MREGI_IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[_XORI_MREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, andnI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, andnI_Reg_nReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, andI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, andI_Reg_Reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+_kids[1]->_cost[IMMI_255]+60;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, lbu_and_lmask_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, lbu_and_lmask_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_255) && STATE__VALID_CHILD(_kids[1], _LOADB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[IMMI_255]+_kids[1]->_cost[_LOADB_MEMORY_]+60;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, lbu_and_lmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, lbu_and_lmask_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_NONNEG_MASK) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_NONNEG_MASK]+60;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, andI_Reg_immI_nonneg_mask_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_0_4095) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_0_4095]+60;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, andI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, andI_Reg_imm_0_4095_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, andI_Reg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, andI_Reg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, andI_Reg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, andI_Reg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, andI_Reg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, andI_Reg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, andI_Reg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, andI_Reg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, andI_Reg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, andI_Reg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, andI_Reg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, andI_Reg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, andI_Reg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, andI_Reg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, andI_Reg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, andI_Reg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, andI_Reg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, andI_Reg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, andI_Reg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, andI_Reg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, andI_Reg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, andI_Reg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, andI_Reg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, andI_Reg_immI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_65535]+125;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, loadI2US_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_255]+125;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, loadI2UB_rule, c)
      }
    }
}
void  State::_sub_Op_AndL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMML_MAXUI) && STATE__VALID_CHILD(_kids[1], _CONVI2L__LOADI_MEMORY__) ) {
      unsigned int c = _kids[0]->_cost[IMML_MAXUI]+_kids[1]->_cost[_CONVI2L__LOADI_MEMORY__]+100;
        DFA_PRODUCTION__SET_VALID(MREGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(V0REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION__SET_VALID(V1REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION__SET_VALID(A0REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION__SET_VALID(A1REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION__SET_VALID(A2REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION__SET_VALID(A3REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION__SET_VALID(T0REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION__SET_VALID(T1REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION__SET_VALID(T2REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION__SET_VALID(T3REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION__SET_VALID(T8REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION__SET_VALID(A4REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION__SET_VALID(A5REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION__SET_VALID(A6REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION__SET_VALID(A7REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION__SET_VALID(S0REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION__SET_VALID(S1REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION__SET_VALID(S2REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION__SET_VALID(S3REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION__SET_VALID(S4REGL, loadUI2L_lmask_rule, c)
        DFA_PRODUCTION__SET_VALID(S7REGL, loadUI2L_lmask_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L__LOADI_MEMORY__) && STATE__VALID_CHILD(_kids[1], IMML_MAXUI) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L__LOADI_MEMORY__]+_kids[1]->_cost[IMML_MAXUI]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, loadUI2L_rmask_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, loadUI2L_rmask_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L__CONVL2I_MREGL__) && STATE__VALID_CHILD(_kids[1], IMML_MAXUI) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L__CONVL2I_MREGL__]+_kids[1]->_cost[IMML_MAXUI]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, convL2I2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, convL2I2L_reg_reg_zex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_MREGI_) && STATE__VALID_CHILD(_kids[1], IMML_MAXUI) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_MREGI_]+_kids[1]->_cost[IMML_MAXUI]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, convI2L_reg_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, convI2L_reg_reg_zex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_MREGI_) && STATE__VALID_CHILD(_kids[1], IMML_MAXUI) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_MREGI_]+_kids[1]->_cost[IMML_MAXUI];
        DFA_PRODUCTION__SET_VALID(_ANDL__CONVI2L_MREGI__IMML_MAXUI, _AndL__ConvI2L_mRegI__immL_MaxUI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_MAXUI) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_MAXUI]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, zerox_long_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, zerox_long_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_7) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_7];
        DFA_PRODUCTION__SET_VALID(_ANDL_MREGL_IMML_7, _AndL_mRegL_immL_7_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_M121) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_M121]+60;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, andL_Reg_immL_M121_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, andL_Reg_immL_M121_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_M4) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_M4]+60;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, andL_Reg_immL_M4_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, andL_Reg_immL_M4_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_M7) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_M7]+60;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, andL_Reg_immL_M7_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, andL_Reg_immL_M7_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_M5) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_M5]+60;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, andL_Reg_immL_M5_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, andL_Reg_immL_M5_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_M8) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_M8]+60;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, andL_Reg_immL_M8_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, andL_Reg_immL_M8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_0_4095) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_0_4095];
        DFA_PRODUCTION__SET_VALID(_ANDL_MREGL_IMML_0_4095, _AndL_mRegL_immL_0_4095_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_0_4095) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_0_4095]+60;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, andL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, andL_Reg_imm_0_4095_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_MREGI_) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_MREGI_]+_kids[1]->_cost[MREGL]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, andL_Reg_Reg_convI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, andL_Reg_Reg_convI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, andL_Reg_Reg_convI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, andL_Reg_Reg_convI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, andL_Reg_Reg_convI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, andL_Reg_Reg_convI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, andL_Reg_Reg_convI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, andL_Reg_Reg_convI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, andL_Reg_Reg_convI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, andL_Reg_Reg_convI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, andL_Reg_Reg_convI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, andL_Reg_Reg_convI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, andL_Reg_Reg_convI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, andL_Reg_Reg_convI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, andL_Reg_Reg_convI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, andL_Reg_Reg_convI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, andL_Reg_Reg_convI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, andL_Reg_Reg_convI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, andL_Reg_Reg_convI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, andL_Reg_Reg_convI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, andL_Reg_Reg_convI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, andL_Reg_Reg_convI2L_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], _CONVI2L_MREGI_) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[_CONVI2L_MREGI_]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, andL_Reg_Reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, andL_Reg_Reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, andL_Reg_Reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, andL_Reg_Reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, andL_Reg_Reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, andL_Reg_Reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, andL_Reg_Reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, andL_Reg_Reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, andL_Reg_Reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, andL_Reg_Reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, andL_Reg_Reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, andL_Reg_Reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, andL_Reg_Reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, andL_Reg_Reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, andL_Reg_Reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, andL_Reg_Reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, andL_Reg_Reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, andL_Reg_Reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, andL_Reg_Reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, andL_Reg_Reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, andL_Reg_Reg_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, andL_Reg_Reg_convI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGL]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, andL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, andL_Reg_Reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_NONNEG_MASK) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_NONNEG_MASK]+60;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, andL_Reg_immL_nonneg_mask_rule, c)
      }
    }
}
void  State::_sub_Op_Binary(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], T2_REGN) && STATE__VALID_CHILD(_kids[1], MREGN) ) {
      unsigned int c = _kids[0]->_cost[T2_REGN]+_kids[1]->_cost[MREGN];
        DFA_PRODUCTION__SET_VALID(_BINARY_T2_REGN_MREGN, _Binary_t2_RegN_mRegN_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], S2_REGP) && STATE__VALID_CHILD(_kids[1], MREGP) ) {
      unsigned int c = _kids[0]->_cost[S2_REGP]+_kids[1]->_cost[MREGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_S2_REGP_MREGP, _Binary_s2_RegP_mRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], S2REGL) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[S2REGL]+_kids[1]->_cost[MREGL];
        DFA_PRODUCTION__SET_VALID(_BINARY_S2REGL_MREGL, _Binary_s2RegL_mRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MS2REGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MS2REGI]+_kids[1]->_cost[MREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_MS2REGI_MREGI, _Binary_mS2RegI_mRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], T2REGL) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[T2REGL]+_kids[1]->_cost[MREGL];
        DFA_PRODUCTION__SET_VALID(_BINARY_T2REGL_MREGL, _Binary_t2RegL_mRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], A4_REGP) && STATE__VALID_CHILD(_kids[1], A5_REGP) ) {
      unsigned int c = _kids[0]->_cost[A4_REGP]+_kids[1]->_cost[A5_REGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_A4_REGP_A5_REGP, _Binary_a4_RegP_a5_RegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], A6_REGP) && STATE__VALID_CHILD(_kids[1], MA7REGI) ) {
      unsigned int c = _kids[0]->_cost[A6_REGP]+_kids[1]->_cost[MA7REGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_A6_REGP_MA7REGI, _Binary_a6_RegP_mA7RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], A4_REGP) && STATE__VALID_CHILD(_kids[1], MA5REGI) ) {
      unsigned int c = _kids[0]->_cost[A4_REGP]+_kids[1]->_cost[MA5REGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_A4_REGP_MA5REGI, _Binary_a4_RegP_mA5RegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPP_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPP_MREGP_MREGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP__CMPP_MREGP_MREGP, _Binary_cmpOp__CmpP_mRegP_mRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGF_REGF, _Binary_regF_regF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGD_REGD, _Binary_regD_regD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGL];
        DFA_PRODUCTION__SET_VALID(_BINARY_MREGL_MREGL, _Binary_mRegL_mRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPL_MREGL_MREGL) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPL_MREGL_MREGL];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP__CMPL_MREGL_MREGL, _Binary_cmpOp__CmpL_mRegL_mRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPD_REGD_REGD) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPD_REGD_REGD];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP__CMPD_REGD_REGD, _Binary_cmpOp__CmpD_regD_regD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGN) && STATE__VALID_CHILD(_kids[1], MREGN) ) {
      unsigned int c = _kids[0]->_cost[MREGN]+_kids[1]->_cost[MREGN];
        DFA_PRODUCTION__SET_VALID(_BINARY_MREGN_MREGN, _Binary_mRegN_mRegN_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPF_REGF_REGF) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPF_REGF_REGF];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP__CMPF_REGF_REGF, _Binary_cmpOp__CmpF_regF_regF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[MREGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_MREGP_MREGP, _Binary_mRegP_mRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPU_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPU_MREGI_MREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOPU__CMPU_MREGI_MREGI, _Binary_cmpOpU__CmpU_mRegI_mRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPN_MREGN_MREGN) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPN_MREGN_MREGN];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOPU__CMPN_MREGN_MREGN, _Binary_cmpOpU__CmpN_mRegN_mRegN_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPP_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPP_MREGP_MREGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOPU__CMPP_MREGP_MREGP, _Binary_cmpOpU__CmpP_mRegP_mRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_MREGI_MREGI, _Binary_mRegI_mRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI_MREGI_MREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP__CMPI_MREGI_MREGI, _Binary_cmpOp__CmpI_mRegI_mRegI_rule, c)
    }
}
void  State::_sub_Op_Bool(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOPU, cmpOpU_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOP, cmpOp_rule, c)
    }
}
void  State::_sub_Op_CallDynamicJava(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallDynamicJavaDirect_rule, c)
    }
}
void  State::_sub_Op_CallLeaf(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallLeafDirect_rule, c)
    }
}
void  State::_sub_Op_CallLeafNoFP(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallLeafNoFPDirect_rule, c)
    }
}
void  State::_sub_Op_CallRuntime(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallRuntimeDirect_rule, c)
    }
}
void  State::_sub_Op_CallStaticJava(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallStaticJavaDirect_rule, c)
    }
}
void  State::_sub_Op_CastII(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI];
        DFA_PRODUCTION__SET_VALID(MREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, castII_rule, c)
    }
}
void  State::_sub_Op_CastX2P(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+10;
        DFA_PRODUCTION__SET_VALID(MREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(S0_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(S1_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(S2_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(S3_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(S4_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(S5_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(S6_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(S7_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(T0_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(T1_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(T2_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(T3_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(A0_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(A1_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(A2_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(A3_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(A4_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(A5_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(A6_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(A7_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(V0_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(V1_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(T8_REGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, castX2P_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, castX2P_rule, c+100)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+100)
      }
    }
}
void  State::_sub_Op_CastP2X(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP];
        DFA_PRODUCTION__SET_VALID(_CASTP2X_MREGP_, _CastP2X_mRegP__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+100;
        DFA_PRODUCTION__SET_VALID(MREGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(V0REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(V1REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(A0REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(A1REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(A2REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(A3REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(T0REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(T1REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(T2REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(T3REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(T8REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(A4REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(A5REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(A6REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(A7REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(S0REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(S1REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(S2REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(S3REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(S4REGL, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(S7REGL, castP2X_rule, c)
    }
}
void  State::_sub_Op_CastPP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+100;
        DFA_PRODUCTION__SET_VALID(MREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(S0_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(S1_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(S2_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(S3_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(S4_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(S5_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(S6_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(S7_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(T0_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(T1_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(T2_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(T3_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(A0_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(A1_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(A2_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(A3_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(A4_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(A5_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(A6_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(A7_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(V0_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(V1_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(T8_REGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, castPP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, castPP_rule, c+100)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+100)
      }
    }
}
void  State::_sub_Op_CheckCastPP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+100;
        DFA_PRODUCTION__SET_VALID(MREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(S0_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(S1_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(S2_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(S3_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(S4_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(S5_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(S6_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(S7_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(T0_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(T1_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(T2_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(T3_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(A0_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(A1_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(A2_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(A3_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(A4_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(A5_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(A6_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(A7_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(V0_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(V1_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(T8_REGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, checkCastPP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, checkCastPP_rule, c+100)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+100)
      }
    }
}
void  State::_sub_Op_ClearArray(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGP]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, clear_array_rule, c)
    }
}
void  State::_sub_Op_CMoveD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPP_MREGP_MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPP_MREGP_MREGP]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
        DFA_PRODUCTION__SET_VALID(REGD, cmovD_cmpP_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPI_MREGI_MREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPI_MREGI_MREGI]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, cmovD_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPD_REGD_REGD) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPD_REGD_REGD]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, cmovD_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100)
      }
    }
}
void  State::_sub_Op_CMoveF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPF_REGF_REGF) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPF_REGF_REGF]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
        DFA_PRODUCTION__SET_VALID(REGF, cmovF_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPI_MREGI_MREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPI_MREGI_MREGI]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, cmovF_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+100)
      }
    }
}
void  State::_sub_Op_CMoveI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPF_REGF_REGF) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPF_REGF_REGF]+_kids[1]->_cost[_BINARY_MREGI_MREGI]+80;
        DFA_PRODUCTION__SET_VALID(MREGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, cmovI_cmpF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, cmovI_cmpF_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPD_REGD_REGD) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPD_REGD_REGD]+_kids[1]->_cost[_BINARY_MREGI_MREGI]+80;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, cmovI_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, cmovI_cmpD_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPL_MREGL_MREGL) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPL_MREGL_MREGL]+_kids[1]->_cost[_BINARY_MREGI_MREGI]+80;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, cmovI_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, cmovI_cmpL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU__CMPU_MREGI_MREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU__CMPU_MREGI_MREGI]+_kids[1]->_cost[_BINARY_MREGI_MREGI]+80;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, cmovI_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, cmovI_cmpU_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU__CMPN_MREGN_MREGN) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU__CMPN_MREGN_MREGN]+_kids[1]->_cost[_BINARY_MREGI_MREGI]+80;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, cmovI_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, cmovI_cmpN_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU__CMPP_MREGP_MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU__CMPP_MREGP_MREGP]+_kids[1]->_cost[_BINARY_MREGI_MREGI]+80;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, cmovI_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, cmovI_cmpP_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPI_MREGI_MREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPI_MREGI_MREGI]+_kids[1]->_cost[_BINARY_MREGI_MREGI]+80;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, cmovI_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, cmovI_cmpI_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPD_REGD_REGD) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGL_MREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPD_REGD_REGD]+_kids[1]->_cost[_BINARY_MREGL_MREGL]+80;
        DFA_PRODUCTION__SET_VALID(MREGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(V0REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(V1REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A0REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A1REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A2REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A3REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T0REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T1REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T2REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T3REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T8REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A4REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A5REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A6REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A7REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S0REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S1REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S2REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S3REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S4REGL, cmovL_cmpD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S7REGL, cmovL_cmpD_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU__CMPN_MREGN_MREGN) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGL_MREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU__CMPN_MREGN_MREGN]+_kids[1]->_cost[_BINARY_MREGL_MREGL]+80;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, cmovL_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, cmovL_cmpN_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPL_MREGL_MREGL) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGL_MREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPL_MREGL_MREGL]+_kids[1]->_cost[_BINARY_MREGL_MREGL]+80;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, cmovL_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, cmovL_cmpL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPI_MREGI_MREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGL_MREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPI_MREGI_MREGI]+_kids[1]->_cost[_BINARY_MREGL_MREGL]+80;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, cmovL_cmpI_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, cmovL_cmpI_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPF_REGF_REGF) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGL_MREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPF_REGF_REGF]+_kids[1]->_cost[_BINARY_MREGL_MREGL]+80;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, cmovL_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, cmovL_cmpF_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU__CMPU_MREGI_MREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGL_MREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU__CMPU_MREGI_MREGI]+_kids[1]->_cost[_BINARY_MREGL_MREGL]+80;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, cmovL_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, cmovL_cmpU_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU__CMPP_MREGP_MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGL_MREGL) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU__CMPP_MREGP_MREGP]+_kids[1]->_cost[_BINARY_MREGL_MREGL]+80;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, cmovL_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, cmovL_cmpP_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPI_MREGI_MREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPI_MREGI_MREGI]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+80;
        DFA_PRODUCTION__SET_VALID(MREGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S0_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S1_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S2_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S3_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S4_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S5_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S6_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S7_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T0_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T1_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T2_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T3_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A0_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A1_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A2_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A3_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A4_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A5_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A6_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A7_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(V0_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(V1_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T8_REGP, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovP_cmpI_reg_reg_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovP_cmpI_reg_reg_rule, c+100)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU__CMPP_MREGP_MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU__CMPP_MREGP_MREGP]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+80;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(MREGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0_REGP) || _cost[S0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S0_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S1_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2_REGP) || _cost[S2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S2_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S3_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S4_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S5_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S6_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S7_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T0_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T1_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T2_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T3_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A0_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A1_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A2_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A3_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A4_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A5_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A6_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A7_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V0_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V1_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T8_REGP, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovP_cmpP_reg_reg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovP_cmpP_reg_reg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPL_MREGL_MREGL) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPL_MREGL_MREGL]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+80;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(MREGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0_REGP) || _cost[S0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S0_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S1_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2_REGP) || _cost[S2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S2_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S3_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S4_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S5_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S6_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S7_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T0_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T1_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T2_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T3_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A0_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A1_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A2_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A3_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A4_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A5_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A6_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A7_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V0_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V1_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T8_REGP, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovP_cmpL_reg_reg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovP_cmpL_reg_reg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPD_REGD_REGD) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPD_REGD_REGD]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+80;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(MREGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0_REGP) || _cost[S0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S0_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S1_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2_REGP) || _cost[S2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S2_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S3_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S4_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S5_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S6_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S7_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T0_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T1_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T2_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T3_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A0_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A1_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A2_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A3_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A4_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A5_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A6_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A7_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V0_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V1_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T8_REGP, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_cmpD_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovP_cmpD_reg_reg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovP_cmpD_reg_reg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU__CMPN_MREGN_MREGN) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU__CMPN_MREGN_MREGN]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+80;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(MREGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0_REGP) || _cost[S0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S0_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S1_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2_REGP) || _cost[S2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S2_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S3_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S4_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S5_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S6_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S7_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T0_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T1_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T2_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T3_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A0_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A1_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A2_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A3_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A4_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A5_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A6_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A7_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V0_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V1_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T8_REGP, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovP_cmpN_reg_reg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovP_cmpN_reg_reg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPF_REGF_REGF) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPF_REGF_REGF]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+80;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(MREGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0_REGP) || _cost[S0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S0_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S1_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2_REGP) || _cost[S2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S2_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S3_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S4_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S5_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S6_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S7_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T0_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T1_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T2_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T3_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A0_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A1_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A2_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A3_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A4_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A5_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A6_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A7_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V0_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V1_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T8_REGP, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_cmpF_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovP_cmpF_reg_reg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovP_cmpF_reg_reg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU__CMPU_MREGI_MREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU__CMPU_MREGI_MREGI]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+80;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(MREGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0_REGP) || _cost[S0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S0_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S1_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2_REGP) || _cost[S2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S2_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S3_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S4_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S5_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S6_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S7_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T0_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T1_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T2_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T3_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A0_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A1_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A2_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A3_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A4_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A5_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A6_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A7_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V0_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V1_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T8_REGP, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovP_cmpU_reg_reg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovP_cmpU_reg_reg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+100)
      }
    }
}
void  State::_sub_Op_CMoveN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPI_MREGI_MREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGN_MREGN) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPI_MREGI_MREGI]+_kids[1]->_cost[_BINARY_MREGN_MREGN]+80;
        DFA_PRODUCTION__SET_VALID(MREGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T0_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T1_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T2_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T3_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T8_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A0_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A1_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A2_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A3_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A4_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A5_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A6_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A7_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S0_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S1_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S2_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S3_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S4_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S5_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S6_REGN, cmovN_cmpI_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S7_REGN, cmovN_cmpI_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP__CMPL_MREGL_MREGL) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGN_MREGN) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP__CMPL_MREGL_MREGL]+_kids[1]->_cost[_BINARY_MREGN_MREGN]+80;
      if (STATE__NOT_YET_VALID(MREGN) || _cost[MREGN] > c) {
        DFA_PRODUCTION__SET_VALID(MREGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGN) || _cost[T0_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T0_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGN) || _cost[T1_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T1_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGN) || _cost[T2_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T2_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGN) || _cost[T3_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T3_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGN) || _cost[T8_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T8_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGN) || _cost[A0_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A0_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGN) || _cost[A1_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A1_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGN) || _cost[A2_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A2_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGN) || _cost[A3_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A3_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGN) || _cost[A4_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A4_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGN) || _cost[A5_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A5_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGN) || _cost[A6_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A6_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGN) || _cost[A7_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A7_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0_REGN) || _cost[S0_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S0_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGN) || _cost[S1_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S1_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2_REGN) || _cost[S2_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S2_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGN) || _cost[S3_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S3_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGN) || _cost[S4_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S4_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGN) || _cost[S5_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S5_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGN) || _cost[S6_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S6_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGN) || _cost[S7_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S7_REGN, cmovN_cmpL_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU__CMPU_MREGI_MREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGN_MREGN) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU__CMPU_MREGI_MREGI]+_kids[1]->_cost[_BINARY_MREGN_MREGN]+80;
      if (STATE__NOT_YET_VALID(MREGN) || _cost[MREGN] > c) {
        DFA_PRODUCTION__SET_VALID(MREGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGN) || _cost[T0_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T0_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGN) || _cost[T1_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T1_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGN) || _cost[T2_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T2_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGN) || _cost[T3_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T3_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGN) || _cost[T8_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T8_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGN) || _cost[A0_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A0_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGN) || _cost[A1_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A1_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGN) || _cost[A2_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A2_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGN) || _cost[A3_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A3_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGN) || _cost[A4_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A4_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGN) || _cost[A5_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A5_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGN) || _cost[A6_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A6_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGN) || _cost[A7_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A7_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0_REGN) || _cost[S0_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S0_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGN) || _cost[S1_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S1_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2_REGN) || _cost[S2_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S2_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGN) || _cost[S3_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S3_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGN) || _cost[S4_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S4_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGN) || _cost[S5_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S5_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGN) || _cost[S6_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S6_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGN) || _cost[S7_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S7_REGN, cmovN_cmpU_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU__CMPN_MREGN_MREGN) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGN_MREGN) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU__CMPN_MREGN_MREGN]+_kids[1]->_cost[_BINARY_MREGN_MREGN]+80;
      if (STATE__NOT_YET_VALID(MREGN) || _cost[MREGN] > c) {
        DFA_PRODUCTION__SET_VALID(MREGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGN) || _cost[T0_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T0_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGN) || _cost[T1_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T1_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGN) || _cost[T2_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T2_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGN) || _cost[T3_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T3_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGN) || _cost[T8_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T8_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGN) || _cost[A0_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A0_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGN) || _cost[A1_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A1_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGN) || _cost[A2_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A2_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGN) || _cost[A3_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A3_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGN) || _cost[A4_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A4_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGN) || _cost[A5_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A5_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGN) || _cost[A6_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A6_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGN) || _cost[A7_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A7_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0_REGN) || _cost[S0_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S0_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGN) || _cost[S1_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S1_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2_REGN) || _cost[S2_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S2_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGN) || _cost[S3_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S3_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGN) || _cost[S4_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S4_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGN) || _cost[S5_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S5_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGN) || _cost[S6_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S6_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGN) || _cost[S7_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S7_REGN, cmovN_cmpN_reg_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU__CMPP_MREGP_MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGN_MREGN) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU__CMPP_MREGP_MREGP]+_kids[1]->_cost[_BINARY_MREGN_MREGN]+80;
      if (STATE__NOT_YET_VALID(MREGN) || _cost[MREGN] > c) {
        DFA_PRODUCTION__SET_VALID(MREGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGN) || _cost[T0_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T0_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGN) || _cost[T1_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T1_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGN) || _cost[T2_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T2_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGN) || _cost[T3_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T3_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGN) || _cost[T8_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T8_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGN) || _cost[A0_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A0_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGN) || _cost[A1_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A1_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGN) || _cost[A2_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A2_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGN) || _cost[A3_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A3_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGN) || _cost[A4_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A4_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGN) || _cost[A5_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A5_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGN) || _cost[A6_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A6_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGN) || _cost[A7_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A7_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0_REGN) || _cost[S0_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S0_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGN) || _cost[S1_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S1_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2_REGN) || _cost[S2_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S2_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGN) || _cost[S3_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S3_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGN) || _cost[S4_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S4_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGN) || _cost[S5_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S5_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGN) || _cost[S6_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S6_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGN) || _cost[S7_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S7_REGN, cmovN_cmpP_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGN) && STATE__VALID_CHILD(_kids[1], MREGN) ) {
      unsigned int c = _kids[0]->_cost[MREGN]+_kids[1]->_cost[MREGN];
        DFA_PRODUCTION__SET_VALID(_CMPN_MREGN_MREGN, _CmpN_mRegN_mRegN_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGN) && STATE__VALID_CHILD(_kids[1], IMMN_0) ) {
      unsigned int c = _kids[0]->_cost[MREGN]+_kids[1]->_cost[IMMN_0];
        DFA_PRODUCTION__SET_VALID(_CMPN_MREGN_IMMN_0, _CmpN_mRegN_immN_0_rule, c)
    }
}
void  State::_sub_Op_CmpD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD];
        DFA_PRODUCTION__SET_VALID(_CMPD_REGD_REGD, _CmpD_regD_regD_rule, c)
    }
}
void  State::_sub_Op_CmpD3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+1000;
        DFA_PRODUCTION__SET_VALID(MREGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, cmpD3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, cmpD3_reg_reg_rule, c)
    }
}
void  State::_sub_Op_CmpF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF];
        DFA_PRODUCTION__SET_VALID(_CMPF_REGF_REGF, _CmpF_regF_regF_rule, c)
    }
}
void  State::_sub_Op_CmpF3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+1000;
        DFA_PRODUCTION__SET_VALID(MREGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, cmpF3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, cmpF3_reg_reg_rule, c)
    }
}
void  State::_sub_Op_CmpI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_0) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_0];
        DFA_PRODUCTION__SET_VALID(_CMPI_MREGI_IMMI_0, _CmpI_mRegI_immI_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_CMPI_MREGI_IMMI, _CmpI_mRegI_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI];
        DFA_PRODUCTION__SET_VALID(_CMPI_MREGI_MREGI, _CmpI_mRegI_mRegI_rule, c)
    }
}
void  State::_sub_Op_CmpL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML];
        DFA_PRODUCTION__SET_VALID(_CMPL_MREGL_IMML, _CmpL_mRegL_immL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_0) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_0];
        DFA_PRODUCTION__SET_VALID(_CMPL_MREGL_IMML_0, _CmpL_mRegL_immL_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGL];
        DFA_PRODUCTION__SET_VALID(_CMPL_MREGL_MREGL, _CmpL_mRegL_mRegL_rule, c)
    }
}
void  State::_sub_Op_CmpL3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGL]+1000;
        DFA_PRODUCTION__SET_VALID(MREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, cmpL3_reg_reg_rule, c)
    }
}
void  State::_sub_Op_CmpLTMask(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+400;
        DFA_PRODUCTION__SET_VALID(MREGI, cmpLTMask_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, cmpLTMask_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, cmpLTMask_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, cmpLTMask_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_0) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_0]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, cmpLTMask_immI_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, cmpLTMask_immI_0_rule, c)
      }
    }
}
void  State::_sub_Op_CmpP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[MREGP];
        DFA_PRODUCTION__SET_VALID(_CMPP_MREGP_MREGP, _CmpP_mRegP_mRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _DECODEN_MREGN_) && STATE__VALID_CHILD(_kids[1], IMMP_0) ) {
      unsigned int c = _kids[0]->_cost[_DECODEN_MREGN_]+_kids[1]->_cost[IMMP_0];
        DFA_PRODUCTION__SET_VALID(_CMPP__DECODEN_MREGN__IMMP_0, _CmpP__DecodeN_mRegN__immP_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], IMMP_0) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[IMMP_0];
        DFA_PRODUCTION__SET_VALID(_CMPP_MREGP_IMMP_0, _CmpP_mRegP_immP_0_rule, c)
    }
}
void  State::_sub_Op_CmpU(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_0) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_0];
        DFA_PRODUCTION__SET_VALID(_CMPU_MREGI_IMMI_0, _CmpU_mRegI_immI_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_CMPU_MREGI_IMMI, _CmpU_mRegI_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI];
        DFA_PRODUCTION__SET_VALID(_CMPU_MREGI_MREGI, _CmpU_mRegI_mRegI_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_MS2REGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_BINARY_MS2REGI_MREGI]+100;
        DFA_PRODUCTION__SET_VALID(MREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, compareAndSwapI_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_S2REGL_MREGL) &&
        (
#line 11798 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
VM_Version::supports_cx8()
#line 6760 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_BINARY_S2REGL_MREGL]+100;
        DFA_PRODUCTION__SET_VALID(MREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, compareAndSwapL_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_S2_REGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_BINARY_S2_REGP_MREGP]+100;
        DFA_PRODUCTION__SET_VALID(MREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, compareAndSwapP_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_T2_REGN_MREGN) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[_BINARY_T2_REGN_MREGN]+100;
        DFA_PRODUCTION__SET_VALID(MREGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, compareAndSwapN_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, compareAndSwapN_rule, c)
    }
}
void  State::_sub_Op_ConN(const Node *n){
    if(         
#line 3260 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->get_narrowcon() == 0
#line 6854 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMN_0, immN_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MREGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(T0_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(T1_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(T2_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(T3_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(T8_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(A0_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(A1_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(A2_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(A3_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(A4_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(A5_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(A6_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(A7_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(S0_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(S1_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(S2_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(S3_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(S4_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(S5_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(S6_REGN, loadConN_immN_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(S7_REGN, loadConN_immN_0_rule, c+100)
    }
    {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMN, immN_rule, c)
      if (STATE__NOT_YET_VALID(MREGN) || _cost[MREGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(MREGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(T0_REGN) || _cost[T0_REGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(T0_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(T1_REGN) || _cost[T1_REGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(T1_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(T2_REGN) || _cost[T2_REGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(T2_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(T3_REGN) || _cost[T3_REGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(T3_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(T8_REGN) || _cost[T8_REGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(T8_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(A0_REGN) || _cost[A0_REGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(A0_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(A1_REGN) || _cost[A1_REGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(A1_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(A2_REGN) || _cost[A2_REGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(A2_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(A3_REGN) || _cost[A3_REGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(A3_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(A4_REGN) || _cost[A4_REGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(A4_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(A5_REGN) || _cost[A5_REGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(A5_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(A6_REGN) || _cost[A6_REGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(A6_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(A7_REGN) || _cost[A7_REGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(A7_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(S0_REGN) || _cost[S0_REGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(S0_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(S1_REGN) || _cost[S1_REGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(S1_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(S2_REGN) || _cost[S2_REGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(S2_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(S3_REGN) || _cost[S3_REGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(S3_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(S4_REGN) || _cost[S4_REGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(S4_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(S5_REGN) || _cost[S5_REGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(S5_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(S6_REGN) || _cost[S6_REGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(S6_REGN, loadConN_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(S7_REGN) || _cost[S7_REGN] > c+125) {
        DFA_PRODUCTION__SET_VALID(S7_REGN, loadConN_rule, c+125)
      }
    }
   if ( /* MREGN KNOWN_VALID || */ _cost[MREGN] > 125) {
     DFA_PRODUCTION(MREGN, loadConN_rule, 125)
   }
   if ( /* T0_REGN KNOWN_VALID || */ _cost[T0_REGN] > 125) {
     DFA_PRODUCTION(T0_REGN, loadConN_rule, 125)
   }
   if ( /* T1_REGN KNOWN_VALID || */ _cost[T1_REGN] > 125) {
     DFA_PRODUCTION(T1_REGN, loadConN_rule, 125)
   }
   if ( /* T2_REGN KNOWN_VALID || */ _cost[T2_REGN] > 125) {
     DFA_PRODUCTION(T2_REGN, loadConN_rule, 125)
   }
   if ( /* T3_REGN KNOWN_VALID || */ _cost[T3_REGN] > 125) {
     DFA_PRODUCTION(T3_REGN, loadConN_rule, 125)
   }
   if ( /* T8_REGN KNOWN_VALID || */ _cost[T8_REGN] > 125) {
     DFA_PRODUCTION(T8_REGN, loadConN_rule, 125)
   }
   if ( /* A0_REGN KNOWN_VALID || */ _cost[A0_REGN] > 125) {
     DFA_PRODUCTION(A0_REGN, loadConN_rule, 125)
   }
   if ( /* A1_REGN KNOWN_VALID || */ _cost[A1_REGN] > 125) {
     DFA_PRODUCTION(A1_REGN, loadConN_rule, 125)
   }
   if ( /* A2_REGN KNOWN_VALID || */ _cost[A2_REGN] > 125) {
     DFA_PRODUCTION(A2_REGN, loadConN_rule, 125)
   }
   if ( /* A3_REGN KNOWN_VALID || */ _cost[A3_REGN] > 125) {
     DFA_PRODUCTION(A3_REGN, loadConN_rule, 125)
   }
   if ( /* A4_REGN KNOWN_VALID || */ _cost[A4_REGN] > 125) {
     DFA_PRODUCTION(A4_REGN, loadConN_rule, 125)
   }
   if ( /* A5_REGN KNOWN_VALID || */ _cost[A5_REGN] > 125) {
     DFA_PRODUCTION(A5_REGN, loadConN_rule, 125)
   }
   if ( /* A6_REGN KNOWN_VALID || */ _cost[A6_REGN] > 125) {
     DFA_PRODUCTION(A6_REGN, loadConN_rule, 125)
   }
   if ( /* A7_REGN KNOWN_VALID || */ _cost[A7_REGN] > 125) {
     DFA_PRODUCTION(A7_REGN, loadConN_rule, 125)
   }
   if ( /* S0_REGN KNOWN_VALID || */ _cost[S0_REGN] > 125) {
     DFA_PRODUCTION(S0_REGN, loadConN_rule, 125)
   }
   if ( /* S1_REGN KNOWN_VALID || */ _cost[S1_REGN] > 125) {
     DFA_PRODUCTION(S1_REGN, loadConN_rule, 125)
   }
   if ( /* S2_REGN KNOWN_VALID || */ _cost[S2_REGN] > 125) {
     DFA_PRODUCTION(S2_REGN, loadConN_rule, 125)
   }
   if ( /* S3_REGN KNOWN_VALID || */ _cost[S3_REGN] > 125) {
     DFA_PRODUCTION(S3_REGN, loadConN_rule, 125)
   }
   if ( /* S4_REGN KNOWN_VALID || */ _cost[S4_REGN] > 125) {
     DFA_PRODUCTION(S4_REGN, loadConN_rule, 125)
   }
   if ( /* S5_REGN KNOWN_VALID || */ _cost[S5_REGN] > 125) {
     DFA_PRODUCTION(S5_REGN, loadConN_rule, 125)
   }
   if ( /* S6_REGN KNOWN_VALID || */ _cost[S6_REGN] > 125) {
     DFA_PRODUCTION(S6_REGN, loadConN_rule, 125)
   }
   if ( /* S7_REGN KNOWN_VALID || */ _cost[S7_REGN] > 125) {
     DFA_PRODUCTION(S7_REGN, loadConN_rule, 125)
   }
}
void  State::_sub_Op_ConNKlass(const Node *n){
    {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMNKLASS, immNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(MREGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION__SET_VALID(T0_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION__SET_VALID(T1_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION__SET_VALID(T2_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION__SET_VALID(T3_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION__SET_VALID(T8_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION__SET_VALID(A0_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION__SET_VALID(A1_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION__SET_VALID(A2_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION__SET_VALID(A3_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION__SET_VALID(A4_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION__SET_VALID(A5_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION__SET_VALID(A6_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION__SET_VALID(A7_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION__SET_VALID(S0_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION__SET_VALID(S1_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION__SET_VALID(S2_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION__SET_VALID(S3_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION__SET_VALID(S4_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION__SET_VALID(S5_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION__SET_VALID(S6_REGN, loadConNKlass_rule, c+125)
        DFA_PRODUCTION__SET_VALID(S7_REGN, loadConNKlass_rule, c+125)
    }
     DFA_PRODUCTION(MREGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(T0_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(T1_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(T2_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(T3_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(T8_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(A0_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(A1_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(A2_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(A3_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(A4_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(A5_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(A6_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(A7_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(S0_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(S1_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(S2_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(S3_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(S4_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(S5_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(S6_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
     DFA_PRODUCTION(S7_REGN, loadConNKlass_rule, 125)	  // overwrites higher cost rule
}
void  State::_sub_Op_ConD(const Node *n){
    if(         
#line 3306 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
jlong_cast(n->getd()) == 0
#line 7072 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMD_0, immD_0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD, loadConD_immD_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100+100)
    }
    {
      unsigned int c = 20;
        DFA_PRODUCTION__SET_VALID(IMMD, immD_rule, c)
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGD, loadConD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c+125+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+125+100)
      }
    }
   if ( /* REGD KNOWN_VALID || */ _cost[REGD] > 125) {
     DFA_PRODUCTION(REGD, loadConD_rule, 125)
   }
   if ( /* STACKSLOTD KNOWN_VALID || */ _cost[STACKSLOTD] > 125+100) {
     DFA_PRODUCTION(STACKSLOTD, storeSSD_rule, 125+100)
   }
}
void  State::_sub_Op_ConF(const Node *n){
    if(         
#line 3287 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
jint_cast(n->getf()) == 0
#line 7100 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMF_0, immF_0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGF, loadConF_immF_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+100+100)
    }
    {
      unsigned int c = 20;
        DFA_PRODUCTION__SET_VALID(IMMF, immF_rule, c)
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGF, loadConF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+125+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+125+100)
      }
    }
   if ( /* REGF KNOWN_VALID || */ _cost[REGF] > 125) {
     DFA_PRODUCTION(REGF, loadConF_rule, 125)
   }
   if ( /* STACKSLOTF KNOWN_VALID || */ _cost[STACKSLOTF] > 125+100) {
     DFA_PRODUCTION(STACKSLOTF, storeSSF_rule, 125+100)
   }
}
void  State::_sub_Op_ConI(const Node *n){
    int _n_get_int__ = n->get_int();
    if(         
#line 3057 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
(_n_get_int__ >= 0) && (Assembler::is_int_mask(_n_get_int__) != -1)
#line 7129 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_NONNEG_MASK, immI_nonneg_mask_rule, c)
    }
    if(         
#line 3047 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_int__ >= 32 && _n_get_int__ <= 63
#line 7137 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_32_63, immI_32_63_rule, c)
    }
    if(         
#line 3039 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
1 <= _n_get_int__ && (_n_get_int__ <= 4)
#line 7145 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_1_4, immI_1_4_rule, c)
    }
    if(         
#line 3030 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_int__ >= 0 && _n_get_int__ <= 32767
#line 7153 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_0_32767, immI_0_32767_rule, c)
    }
    if(         
#line 3021 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_int__ >= 0 && _n_get_int__ <= 4095
#line 7161 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_0_4095, immI_0_4095_rule, c)
    }
    if(         
#line 3012 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_int__ >= 0 && _n_get_int__ <= 31
#line 7169 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_0_31, immI_0_31_rule, c)
    }
    if(         
#line 3004 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
0 <= _n_get_int__ && (_n_get_int__ <= 3)
#line 7177 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_0_3, immI_0_3_rule, c)
    }
    if(         
#line 2994 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
(-2047 <= _n_get_int__) && (_n_get_int__ <= 2048)
#line 7185 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMI_M2047_2048, immI_M2047_2048_rule, c)
    }
    if(         
#line 2985 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_int__ == 2147483647
#line 7193 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_MAXI, immI_MaxI_rule, c)
    }
    if(         
#line 2976 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_int__ == 65535
#line 7201 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMI_65535, immI_65535_rule, c)
    }
    if(         
#line 2967 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_int__ == 255
#line 7209 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_255, immI_255_rule, c)
    }
    if(         
#line 2957 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_int__ == 32
#line 7217 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_32, immI_32_rule, c)
    }
    if(         
#line 2948 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_int__ == 24
#line 7225 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_24, immI_24_rule, c)
    }
    if(         
#line 2940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_int__ == 16
#line 7233 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_16, immI_16_rule, c)
    }
    if(         
#line 2931 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_int__ == 1
#line 7241 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_1, immI_1_rule, c)
    }
    if(         
#line 2922 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_int__ == 0
#line 7249 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_0, immI_0_rule, c)
    }
    if(         
#line 2912 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_int__ == -1
#line 7257 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_M1, immI_M1_rule, c)
    }
    if(         
#line 2902 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_int__ == -65536
#line 7265 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMI_M65536, immI_M65536_rule, c)
    }
    if(         
#line 2893 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
(-128 <= _n_get_int__) && (_n_get_int__ <= 127)
#line 7273 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMI8, immI8_rule, c)
        DFA_PRODUCTION__SET_VALID(IMMI, immI_rule, c+20)
        DFA_PRODUCTION__SET_VALID(MREGI, loadConI_rule, c+20+150)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+20+150+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, loadConI_rule, c+20+150)
        DFA_PRODUCTION__SET_VALID(MS0REGI, loadConI_rule, c+20+150)
        DFA_PRODUCTION__SET_VALID(MS1REGI, loadConI_rule, c+20+150)
        DFA_PRODUCTION__SET_VALID(MS2REGI, loadConI_rule, c+20+150)
        DFA_PRODUCTION__SET_VALID(MS3REGI, loadConI_rule, c+20+150)
        DFA_PRODUCTION__SET_VALID(MS4REGI, loadConI_rule, c+20+150)
        DFA_PRODUCTION__SET_VALID(MS5REGI, loadConI_rule, c+20+150)
        DFA_PRODUCTION__SET_VALID(MS6REGI, loadConI_rule, c+20+150)
        DFA_PRODUCTION__SET_VALID(MS7REGI, loadConI_rule, c+20+150)
        DFA_PRODUCTION__SET_VALID(MT0REGI, loadConI_rule, c+20+150)
        DFA_PRODUCTION__SET_VALID(MT1REGI, loadConI_rule, c+20+150)
        DFA_PRODUCTION__SET_VALID(MT2REGI, loadConI_rule, c+20+150)
        DFA_PRODUCTION__SET_VALID(MT3REGI, loadConI_rule, c+20+150)
        DFA_PRODUCTION__SET_VALID(MT8REGI, loadConI_rule, c+20+150)
        DFA_PRODUCTION__SET_VALID(MT4REGI, loadConI_rule, c+20+150)
        DFA_PRODUCTION__SET_VALID(MA0REGI, loadConI_rule, c+20+150)
        DFA_PRODUCTION__SET_VALID(MA1REGI, loadConI_rule, c+20+150)
        DFA_PRODUCTION__SET_VALID(MA2REGI, loadConI_rule, c+20+150)
        DFA_PRODUCTION__SET_VALID(MA3REGI, loadConI_rule, c+20+150)
        DFA_PRODUCTION__SET_VALID(MA4REGI, loadConI_rule, c+20+150)
        DFA_PRODUCTION__SET_VALID(MA5REGI, loadConI_rule, c+20+150)
        DFA_PRODUCTION__SET_VALID(MA6REGI, loadConI_rule, c+20+150)
        DFA_PRODUCTION__SET_VALID(MA7REGI, loadConI_rule, c+20+150)
    }
    {
      unsigned int c = 20;
      if (STATE__NOT_YET_VALID(IMMI) || _cost[IMMI] > c) {
        DFA_PRODUCTION__SET_VALID(IMMI, immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(MREGI, loadConI_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+150+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+150+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, loadConI_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, loadConI_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, loadConI_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, loadConI_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, loadConI_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, loadConI_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, loadConI_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, loadConI_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, loadConI_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, loadConI_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, loadConI_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, loadConI_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, loadConI_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, loadConI_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, loadConI_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, loadConI_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, loadConI_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, loadConI_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, loadConI_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, loadConI_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, loadConI_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, loadConI_rule, c+150)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c+150) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, loadConI_rule, c+150)
      }
    }
     DFA_PRODUCTION(MREGI, loadConI_rule, 150)	  // overwrites higher cost rule
     DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, 150+100)	  // overwrites higher cost rule
     DFA_PRODUCTION(NO_AX_MREGI, loadConI_rule, 150)	  // overwrites higher cost rule
     DFA_PRODUCTION(MS0REGI, loadConI_rule, 150)	  // overwrites higher cost rule
     DFA_PRODUCTION(MS1REGI, loadConI_rule, 150)	  // overwrites higher cost rule
     DFA_PRODUCTION(MS2REGI, loadConI_rule, 150)	  // overwrites higher cost rule
     DFA_PRODUCTION(MS3REGI, loadConI_rule, 150)	  // overwrites higher cost rule
     DFA_PRODUCTION(MS4REGI, loadConI_rule, 150)	  // overwrites higher cost rule
     DFA_PRODUCTION(MS5REGI, loadConI_rule, 150)	  // overwrites higher cost rule
     DFA_PRODUCTION(MS6REGI, loadConI_rule, 150)	  // overwrites higher cost rule
     DFA_PRODUCTION(MS7REGI, loadConI_rule, 150)	  // overwrites higher cost rule
     DFA_PRODUCTION(MT0REGI, loadConI_rule, 150)	  // overwrites higher cost rule
     DFA_PRODUCTION(MT1REGI, loadConI_rule, 150)	  // overwrites higher cost rule
     DFA_PRODUCTION(MT2REGI, loadConI_rule, 150)	  // overwrites higher cost rule
     DFA_PRODUCTION(MT3REGI, loadConI_rule, 150)	  // overwrites higher cost rule
     DFA_PRODUCTION(MT8REGI, loadConI_rule, 150)	  // overwrites higher cost rule
     DFA_PRODUCTION(MT4REGI, loadConI_rule, 150)	  // overwrites higher cost rule
     DFA_PRODUCTION(MA0REGI, loadConI_rule, 150)	  // overwrites higher cost rule
     DFA_PRODUCTION(MA1REGI, loadConI_rule, 150)	  // overwrites higher cost rule
     DFA_PRODUCTION(MA2REGI, loadConI_rule, 150)	  // overwrites higher cost rule
     DFA_PRODUCTION(MA3REGI, loadConI_rule, 150)	  // overwrites higher cost rule
     DFA_PRODUCTION(MA4REGI, loadConI_rule, 150)	  // overwrites higher cost rule
     DFA_PRODUCTION(MA5REGI, loadConI_rule, 150)	  // overwrites higher cost rule
     DFA_PRODUCTION(MA6REGI, loadConI_rule, 150)	  // overwrites higher cost rule
     DFA_PRODUCTION(MA7REGI, loadConI_rule, 150)	  // overwrites higher cost rule
}
void  State::_sub_Op_ConL(const Node *n){
    jlong _n_get_long__ = n->get_long();
    if(         
#line 3201 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
(_n_get_long__ >= 0) && (Assembler::is_jlong_mask(_n_get_long__) != -1)
#line 7416 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_NONNEG_MASK, immL_nonneg_mask_rule, c)
    }
    if(         
#line 3191 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_long__ >= 0 && _n_get_long__ <= 4095
#line 7424 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_0_4095, immL_0_4095_rule, c)
    }
    if(         
#line 3182 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
(-2047 <= _n_get_long__) && (_n_get_long__ <= 2048)
#line 7432 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMML_M2047_2048, immL_M2047_2048_rule, c)
    }
    if(         
#line 3173 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_long__ == 0xFFFFFFFFL
#line 7440 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 20;
        DFA_PRODUCTION__SET_VALID(IMML_MAXUI, immL_MaxUI_rule, c)
    }
    if(         
#line 3164 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_long__ == 7L
#line 7448 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_7, immL_7_rule, c)
    }
    if(         
#line 3155 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_long__ == 0L
#line 7456 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_0, immL_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MREGL, loadConL_immL_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(V0REGL, loadConL_immL_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(V1REGL, loadConL_immL_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(A0REGL, loadConL_immL_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(A1REGL, loadConL_immL_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(A2REGL, loadConL_immL_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(A3REGL, loadConL_immL_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(T0REGL, loadConL_immL_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(T1REGL, loadConL_immL_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(T2REGL, loadConL_immL_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(T3REGL, loadConL_immL_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(T8REGL, loadConL_immL_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(A4REGL, loadConL_immL_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(A5REGL, loadConL_immL_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(A6REGL, loadConL_immL_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(A7REGL, loadConL_immL_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(S0REGL, loadConL_immL_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(S1REGL, loadConL_immL_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(S2REGL, loadConL_immL_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(S3REGL, loadConL_immL_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(S4REGL, loadConL_immL_0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(S7REGL, loadConL_immL_0_rule, c+100)
    }
    if(         
#line 3145 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_long__ == -4L
#line 7487 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_M4, immL_M4_rule, c)
    }
    if(         
#line 3135 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_long__ == -5L
#line 7495 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_M5, immL_M5_rule, c)
    }
    if(         
#line 3125 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_long__ == -7L
#line 7503 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_M7, immL_M7_rule, c)
    }
    if(         
#line 3115 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_long__ == -8L
#line 7511 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_M8, immL_M8_rule, c)
    }
    if(         
#line 3105 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_long__ == -121L
#line 7519 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_M121, immL_M121_rule, c)
    }
    if(         
#line 3095 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
_n_get_long__ == (int)n->get_long()
#line 7527 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 15;
        DFA_PRODUCTION__SET_VALID(IMML32, immL32_rule, c)
    }
    if(         
#line 3084 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
(-2048 <= _n_get_long__) && (_n_get_long__ <= 2047)
#line 7535 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMML12, immL12_rule, c)
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c+105) {
        DFA_PRODUCTION__SET_VALID(MREGL, loadConL12_rule, c+105)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+105+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+105+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c+105) {
        DFA_PRODUCTION__SET_VALID(V0REGL, loadConL12_rule, c+105)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c+105) {
        DFA_PRODUCTION__SET_VALID(V1REGL, loadConL12_rule, c+105)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c+105) {
        DFA_PRODUCTION__SET_VALID(A0REGL, loadConL12_rule, c+105)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c+105) {
        DFA_PRODUCTION__SET_VALID(A1REGL, loadConL12_rule, c+105)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c+105) {
        DFA_PRODUCTION__SET_VALID(A2REGL, loadConL12_rule, c+105)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c+105) {
        DFA_PRODUCTION__SET_VALID(A3REGL, loadConL12_rule, c+105)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c+105) {
        DFA_PRODUCTION__SET_VALID(T0REGL, loadConL12_rule, c+105)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c+105) {
        DFA_PRODUCTION__SET_VALID(T1REGL, loadConL12_rule, c+105)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c+105) {
        DFA_PRODUCTION__SET_VALID(T2REGL, loadConL12_rule, c+105)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c+105) {
        DFA_PRODUCTION__SET_VALID(T3REGL, loadConL12_rule, c+105)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c+105) {
        DFA_PRODUCTION__SET_VALID(T8REGL, loadConL12_rule, c+105)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c+105) {
        DFA_PRODUCTION__SET_VALID(A4REGL, loadConL12_rule, c+105)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c+105) {
        DFA_PRODUCTION__SET_VALID(A5REGL, loadConL12_rule, c+105)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c+105) {
        DFA_PRODUCTION__SET_VALID(A6REGL, loadConL12_rule, c+105)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c+105) {
        DFA_PRODUCTION__SET_VALID(A7REGL, loadConL12_rule, c+105)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c+105) {
        DFA_PRODUCTION__SET_VALID(S0REGL, loadConL12_rule, c+105)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c+105) {
        DFA_PRODUCTION__SET_VALID(S1REGL, loadConL12_rule, c+105)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c+105) {
        DFA_PRODUCTION__SET_VALID(S2REGL, loadConL12_rule, c+105)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c+105) {
        DFA_PRODUCTION__SET_VALID(S3REGL, loadConL12_rule, c+105)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c+105) {
        DFA_PRODUCTION__SET_VALID(S4REGL, loadConL12_rule, c+105)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c+105) {
        DFA_PRODUCTION__SET_VALID(S7REGL, loadConL12_rule, c+105)
      }
    }
    if(         
#line 3075 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
-0x80L <= _n_get_long__ && _n_get_long__ < 0x80L
#line 7612 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMML8, immL8_rule, c)
    }
    {
      unsigned int c = 20;
        DFA_PRODUCTION__SET_VALID(IMML, immL_rule, c)
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c+120) {
        DFA_PRODUCTION__SET_VALID(MREGL, loadConL_set64_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+120+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+120+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c+120) {
        DFA_PRODUCTION__SET_VALID(V0REGL, loadConL_set64_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c+120) {
        DFA_PRODUCTION__SET_VALID(V1REGL, loadConL_set64_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c+120) {
        DFA_PRODUCTION__SET_VALID(A0REGL, loadConL_set64_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c+120) {
        DFA_PRODUCTION__SET_VALID(A1REGL, loadConL_set64_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c+120) {
        DFA_PRODUCTION__SET_VALID(A2REGL, loadConL_set64_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c+120) {
        DFA_PRODUCTION__SET_VALID(A3REGL, loadConL_set64_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c+120) {
        DFA_PRODUCTION__SET_VALID(T0REGL, loadConL_set64_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c+120) {
        DFA_PRODUCTION__SET_VALID(T1REGL, loadConL_set64_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c+120) {
        DFA_PRODUCTION__SET_VALID(T2REGL, loadConL_set64_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c+120) {
        DFA_PRODUCTION__SET_VALID(T3REGL, loadConL_set64_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c+120) {
        DFA_PRODUCTION__SET_VALID(T8REGL, loadConL_set64_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c+120) {
        DFA_PRODUCTION__SET_VALID(A4REGL, loadConL_set64_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c+120) {
        DFA_PRODUCTION__SET_VALID(A5REGL, loadConL_set64_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c+120) {
        DFA_PRODUCTION__SET_VALID(A6REGL, loadConL_set64_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c+120) {
        DFA_PRODUCTION__SET_VALID(A7REGL, loadConL_set64_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c+120) {
        DFA_PRODUCTION__SET_VALID(S0REGL, loadConL_set64_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c+120) {
        DFA_PRODUCTION__SET_VALID(S1REGL, loadConL_set64_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c+120) {
        DFA_PRODUCTION__SET_VALID(S2REGL, loadConL_set64_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c+120) {
        DFA_PRODUCTION__SET_VALID(S3REGL, loadConL_set64_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c+120) {
        DFA_PRODUCTION__SET_VALID(S4REGL, loadConL_set64_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c+120) {
        DFA_PRODUCTION__SET_VALID(S7REGL, loadConL_set64_rule, c+120)
      }
    }
   if ( /* MREGL KNOWN_VALID || */ _cost[MREGL] > 120) {
     DFA_PRODUCTION(MREGL, loadConL_set64_rule, 120)
   }
   if ( /* STACKSLOTL KNOWN_VALID || */ _cost[STACKSLOTL] > 120+100) {
     DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, 120+100)
   }
   if ( /* V0REGL KNOWN_VALID || */ _cost[V0REGL] > 120) {
     DFA_PRODUCTION(V0REGL, loadConL_set64_rule, 120)
   }
   if ( /* V1REGL KNOWN_VALID || */ _cost[V1REGL] > 120) {
     DFA_PRODUCTION(V1REGL, loadConL_set64_rule, 120)
   }
   if ( /* A0REGL KNOWN_VALID || */ _cost[A0REGL] > 120) {
     DFA_PRODUCTION(A0REGL, loadConL_set64_rule, 120)
   }
   if ( /* A1REGL KNOWN_VALID || */ _cost[A1REGL] > 120) {
     DFA_PRODUCTION(A1REGL, loadConL_set64_rule, 120)
   }
   if ( /* A2REGL KNOWN_VALID || */ _cost[A2REGL] > 120) {
     DFA_PRODUCTION(A2REGL, loadConL_set64_rule, 120)
   }
   if ( /* A3REGL KNOWN_VALID || */ _cost[A3REGL] > 120) {
     DFA_PRODUCTION(A3REGL, loadConL_set64_rule, 120)
   }
   if ( /* T0REGL KNOWN_VALID || */ _cost[T0REGL] > 120) {
     DFA_PRODUCTION(T0REGL, loadConL_set64_rule, 120)
   }
   if ( /* T1REGL KNOWN_VALID || */ _cost[T1REGL] > 120) {
     DFA_PRODUCTION(T1REGL, loadConL_set64_rule, 120)
   }
   if ( /* T2REGL KNOWN_VALID || */ _cost[T2REGL] > 120) {
     DFA_PRODUCTION(T2REGL, loadConL_set64_rule, 120)
   }
   if ( /* T3REGL KNOWN_VALID || */ _cost[T3REGL] > 120) {
     DFA_PRODUCTION(T3REGL, loadConL_set64_rule, 120)
   }
   if ( /* T8REGL KNOWN_VALID || */ _cost[T8REGL] > 120) {
     DFA_PRODUCTION(T8REGL, loadConL_set64_rule, 120)
   }
   if ( /* A4REGL KNOWN_VALID || */ _cost[A4REGL] > 120) {
     DFA_PRODUCTION(A4REGL, loadConL_set64_rule, 120)
   }
   if ( /* A5REGL KNOWN_VALID || */ _cost[A5REGL] > 120) {
     DFA_PRODUCTION(A5REGL, loadConL_set64_rule, 120)
   }
   if ( /* A6REGL KNOWN_VALID || */ _cost[A6REGL] > 120) {
     DFA_PRODUCTION(A6REGL, loadConL_set64_rule, 120)
   }
   if ( /* A7REGL KNOWN_VALID || */ _cost[A7REGL] > 120) {
     DFA_PRODUCTION(A7REGL, loadConL_set64_rule, 120)
   }
   if ( /* S0REGL KNOWN_VALID || */ _cost[S0REGL] > 120) {
     DFA_PRODUCTION(S0REGL, loadConL_set64_rule, 120)
   }
   if ( /* S1REGL KNOWN_VALID || */ _cost[S1REGL] > 120) {
     DFA_PRODUCTION(S1REGL, loadConL_set64_rule, 120)
   }
   if ( /* S2REGL KNOWN_VALID || */ _cost[S2REGL] > 120) {
     DFA_PRODUCTION(S2REGL, loadConL_set64_rule, 120)
   }
   if ( /* S3REGL KNOWN_VALID || */ _cost[S3REGL] > 120) {
     DFA_PRODUCTION(S3REGL, loadConL_set64_rule, 120)
   }
   if ( /* S4REGL KNOWN_VALID || */ _cost[S4REGL] > 120) {
     DFA_PRODUCTION(S4REGL, loadConL_set64_rule, 120)
   }
   if ( /* S7REGL KNOWN_VALID || */ _cost[S7REGL] > 120) {
     DFA_PRODUCTION(S7REGL, loadConL_set64_rule, 120)
   }
}
void  State::_sub_Op_ConP(const Node *n){
    if(         
#line 3241 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->get_ptr() != 0 && n->get_ptr() == (intptr_t)os::get_polling_page()
#line 7764 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMP_POLL, immP_poll_rule, c)
        DFA_PRODUCTION__SET_VALID(MREGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+50+100)
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(S0_REGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(S1_REGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(S2_REGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(S3_REGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(S4_REGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(S5_REGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(S6_REGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(S7_REGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(T0_REGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(T1_REGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(T2_REGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(T3_REGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(A0_REGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(A1_REGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(A2_REGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(A3_REGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(A4_REGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(A5_REGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(A6_REGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(A7_REGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(V0_REGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(V1_REGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(T8_REGP, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadConP_poll_rule, c+50)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+50)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, loadConP_poll_rule, c+50+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, loadConP_poll_rule, c+50+100)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+50+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+50+100)
      }
    }
    if(         
#line 3230 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
!n->bottom_type()->isa_oop_ptr() && (MacroAssembler::insts_for_set64(n->get_ptr()) <= 3)
#line 7806 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMP_NO_OOP_CHEAP, immP_no_oop_cheap_rule, c)
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(MREGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+80+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+80+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(S0_REGP) || _cost[S0_REGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(S0_REGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(S1_REGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(S2_REGP) || _cost[S2_REGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(S2_REGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(S3_REGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(S4_REGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(S5_REGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(S6_REGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(S7_REGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(T0_REGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(T1_REGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(T2_REGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(T3_REGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(A0_REGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(A1_REGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(A2_REGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(A3_REGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(A4_REGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(A5_REGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(A6_REGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(A7_REGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(V0_REGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(V1_REGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c+80) {
        DFA_PRODUCTION__SET_VALID(T8_REGP, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+80) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadConP_no_oop_cheap_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+80) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+80)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+80+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, loadConP_no_oop_cheap_rule, c+80+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+80+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, loadConP_no_oop_cheap_rule, c+80+100)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+80+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+80+100)
      }
    }
    if(         
#line 3220 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->get_ptr() == 0
#line 7910 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMP_0, immP_0_rule, c)
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(MREGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+50+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+50+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(S0_REGP) || _cost[S0_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(S0_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(S1_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(S2_REGP) || _cost[S2_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(S2_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(S3_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(S4_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(S5_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(S6_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(S7_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(T0_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(T1_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(T2_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(T3_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(A0_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(A1_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(A2_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(A3_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(A4_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(A5_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(A6_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(A7_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(V0_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(V1_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c+50) {
        DFA_PRODUCTION__SET_VALID(T8_REGP, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+50) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadConP_immP_0_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+50) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+50)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+50+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, loadConP_immP_0_rule, c+50+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+50+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, loadConP_immP_0_rule, c+50+100)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+50+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+50+100)
      }
    }
    {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMP, immP_rule, c)
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(MREGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+120+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+120+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(S0_REGP) || _cost[S0_REGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(S0_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(S1_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(S2_REGP) || _cost[S2_REGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(S2_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(S3_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(S4_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(S5_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(S6_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(S7_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(T0_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(T1_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(T2_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(T3_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(A0_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(A1_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(A2_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(A3_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(A4_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(A5_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(A6_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(A7_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(V0_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(V1_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c+120) {
        DFA_PRODUCTION__SET_VALID(T8_REGP, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+120) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadConP_general_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+120) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+120)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+120+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, loadConP_general_rule, c+120+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+120+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, loadConP_general_rule, c+120+100)
      }
    }
   if ( /* MREGP KNOWN_VALID || */ _cost[MREGP] > 120) {
     DFA_PRODUCTION(MREGP, loadConP_general_rule, 120)
   }
   if ( /* STACKSLOTP KNOWN_VALID || */ _cost[STACKSLOTP] > 120+100) {
     DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, 120+100)
   }
   if ( /* NO_T8_MREGP KNOWN_VALID || */ _cost[NO_T8_MREGP] > 120) {
     DFA_PRODUCTION(NO_T8_MREGP, loadConP_general_rule, 120)
   }
   if ( /* S0_REGP KNOWN_VALID || */ _cost[S0_REGP] > 120) {
     DFA_PRODUCTION(S0_REGP, loadConP_general_rule, 120)
   }
   if ( /* S1_REGP KNOWN_VALID || */ _cost[S1_REGP] > 120) {
     DFA_PRODUCTION(S1_REGP, loadConP_general_rule, 120)
   }
   if ( /* S2_REGP KNOWN_VALID || */ _cost[S2_REGP] > 120) {
     DFA_PRODUCTION(S2_REGP, loadConP_general_rule, 120)
   }
   if ( /* S3_REGP KNOWN_VALID || */ _cost[S3_REGP] > 120) {
     DFA_PRODUCTION(S3_REGP, loadConP_general_rule, 120)
   }
   if ( /* S4_REGP KNOWN_VALID || */ _cost[S4_REGP] > 120) {
     DFA_PRODUCTION(S4_REGP, loadConP_general_rule, 120)
   }
   if ( /* S5_REGP KNOWN_VALID || */ _cost[S5_REGP] > 120) {
     DFA_PRODUCTION(S5_REGP, loadConP_general_rule, 120)
   }
   if ( /* S6_REGP KNOWN_VALID || */ _cost[S6_REGP] > 120) {
     DFA_PRODUCTION(S6_REGP, loadConP_general_rule, 120)
   }
   if ( /* S7_REGP KNOWN_VALID || */ _cost[S7_REGP] > 120) {
     DFA_PRODUCTION(S7_REGP, loadConP_general_rule, 120)
   }
   if ( /* T0_REGP KNOWN_VALID || */ _cost[T0_REGP] > 120) {
     DFA_PRODUCTION(T0_REGP, loadConP_general_rule, 120)
   }
   if ( /* T1_REGP KNOWN_VALID || */ _cost[T1_REGP] > 120) {
     DFA_PRODUCTION(T1_REGP, loadConP_general_rule, 120)
   }
   if ( /* T2_REGP KNOWN_VALID || */ _cost[T2_REGP] > 120) {
     DFA_PRODUCTION(T2_REGP, loadConP_general_rule, 120)
   }
   if ( /* T3_REGP KNOWN_VALID || */ _cost[T3_REGP] > 120) {
     DFA_PRODUCTION(T3_REGP, loadConP_general_rule, 120)
   }
   if ( /* A0_REGP KNOWN_VALID || */ _cost[A0_REGP] > 120) {
     DFA_PRODUCTION(A0_REGP, loadConP_general_rule, 120)
   }
   if ( /* A1_REGP KNOWN_VALID || */ _cost[A1_REGP] > 120) {
     DFA_PRODUCTION(A1_REGP, loadConP_general_rule, 120)
   }
   if ( /* A2_REGP KNOWN_VALID || */ _cost[A2_REGP] > 120) {
     DFA_PRODUCTION(A2_REGP, loadConP_general_rule, 120)
   }
   if ( /* A3_REGP KNOWN_VALID || */ _cost[A3_REGP] > 120) {
     DFA_PRODUCTION(A3_REGP, loadConP_general_rule, 120)
   }
   if ( /* A4_REGP KNOWN_VALID || */ _cost[A4_REGP] > 120) {
     DFA_PRODUCTION(A4_REGP, loadConP_general_rule, 120)
   }
   if ( /* A5_REGP KNOWN_VALID || */ _cost[A5_REGP] > 120) {
     DFA_PRODUCTION(A5_REGP, loadConP_general_rule, 120)
   }
   if ( /* A6_REGP KNOWN_VALID || */ _cost[A6_REGP] > 120) {
     DFA_PRODUCTION(A6_REGP, loadConP_general_rule, 120)
   }
   if ( /* A7_REGP KNOWN_VALID || */ _cost[A7_REGP] > 120) {
     DFA_PRODUCTION(A7_REGP, loadConP_general_rule, 120)
   }
   if ( /* V0_REGP KNOWN_VALID || */ _cost[V0_REGP] > 120) {
     DFA_PRODUCTION(V0_REGP, loadConP_general_rule, 120)
   }
   if ( /* V1_REGP KNOWN_VALID || */ _cost[V1_REGP] > 120) {
     DFA_PRODUCTION(V1_REGP, loadConP_general_rule, 120)
   }
   if ( /* NO_AX_MREGP KNOWN_VALID || */ _cost[NO_AX_MREGP] > 120) {
     DFA_PRODUCTION(NO_AX_MREGP, loadConP_general_rule, 120)
   }
   if ( /* T8_REGP KNOWN_VALID || */ _cost[T8_REGP] > 120) {
     DFA_PRODUCTION(T8_REGP, loadConP_general_rule, 120)
   }
   if ( /* INDIRECT KNOWN_VALID || */ _cost[INDIRECT] > 120) {
     DFA_PRODUCTION(INDIRECT, loadConP_general_rule, 120)
   }
   if ( /* MEMORY KNOWN_VALID || */ _cost[MEMORY] > 120) {
     DFA_PRODUCTION(MEMORY, indirect_rule, 120)
   }
   if ( /* LOAD_LONG_REGP KNOWN_VALID || */ _cost[LOAD_LONG_REGP] > 120+100) {
     DFA_PRODUCTION(LOAD_LONG_REGP, loadConP_general_rule, 120+100)
   }
   if ( /* LOAD_LONG_INDIRECT KNOWN_VALID || */ _cost[LOAD_LONG_INDIRECT] > 120+100) {
     DFA_PRODUCTION(LOAD_LONG_INDIRECT, loadConP_general_rule, 120+100)
   }
}
void  State::_sub_Op_Conv2B(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+100;
        DFA_PRODUCTION__SET_VALID(MREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, convP2B_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, convI2B_rule, c)
      }
    }
}
void  State::_sub_Op_ConvD2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(REGF, convD2F_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], _SQRTD__CONVF2D_REGF__) ) {
      unsigned int c = _kids[0]->_cost[_SQRTD__CONVF2D_REGF__]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, sqrtF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+100)
      }
    }
}
void  State::_sub_Op_ConvD2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
        DFA_PRODUCTION__SET_VALID(MREGI, convD2I_reg_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, convD2I_reg_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, convD2I_reg_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, convD2I_reg_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, convD2I_reg_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, convD2I_reg_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, convD2I_reg_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, convD2I_reg_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, convD2I_reg_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, convD2I_reg_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, convD2I_reg_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, convD2I_reg_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, convD2I_reg_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, convD2I_reg_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, convD2I_reg_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, convD2I_reg_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, convD2I_reg_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, convD2I_reg_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, convD2I_reg_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, convD2I_reg_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, convD2I_reg_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, convD2I_reg_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, convD2I_reg_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, convD2I_reg_reg_fast_rule, c)
    }
}
void  State::_sub_Op_ConvD2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
        DFA_PRODUCTION__SET_VALID(MREGL, convD2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(V0REGL, convD2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(V1REGL, convD2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(A0REGL, convD2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(A1REGL, convD2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(A2REGL, convD2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(A3REGL, convD2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(T0REGL, convD2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(T1REGL, convD2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(T2REGL, convD2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(T3REGL, convD2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(T8REGL, convD2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(A4REGL, convD2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(A5REGL, convD2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(A6REGL, convD2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(A7REGL, convD2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(S0REGL, convD2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(S1REGL, convD2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(S2REGL, convD2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(S3REGL, convD2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(S4REGL, convD2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(S7REGL, convD2L_reg_fast_rule, c)
    }
}
void  State::_sub_Op_ConvF2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION__SET_VALID(REGD, convF2D_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF];
        DFA_PRODUCTION__SET_VALID(_CONVF2D_REGF_, _ConvF2D_regF__rule, c)
    }
}
void  State::_sub_Op_ConvF2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+150;
        DFA_PRODUCTION__SET_VALID(MREGI, convF2I_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, convF2I_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, convF2I_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, convF2I_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, convF2I_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, convF2I_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, convF2I_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, convF2I_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, convF2I_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, convF2I_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, convF2I_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, convF2I_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, convF2I_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, convF2I_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, convF2I_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, convF2I_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, convF2I_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, convF2I_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, convF2I_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, convF2I_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, convF2I_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, convF2I_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, convF2I_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, convF2I_reg_fast_rule, c)
    }
}
void  State::_sub_Op_ConvF2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+150;
        DFA_PRODUCTION__SET_VALID(MREGL, convF2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(V0REGL, convF2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(V1REGL, convF2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(A0REGL, convF2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(A1REGL, convF2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(A2REGL, convF2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(A3REGL, convF2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(T0REGL, convF2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(T1REGL, convF2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(T2REGL, convF2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(T3REGL, convF2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(T8REGL, convF2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(A4REGL, convF2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(A5REGL, convF2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(A6REGL, convF2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(A7REGL, convF2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(S0REGL, convF2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(S1REGL, convF2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(S2REGL, convF2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(S3REGL, convF2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(S4REGL, convF2L_reg_fast_rule, c)
        DFA_PRODUCTION__SET_VALID(S7REGL, convF2L_reg_fast_rule, c)
    }
}
void  State::_sub_Op_ConvI2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
        DFA_PRODUCTION__SET_VALID(REGD, convI2D_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_ConvI2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
        DFA_PRODUCTION__SET_VALID(REGF, convI2F_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_ConvI2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_CONVI2L__LOADI_MEMORY__, _ConvI2L__LoadI_memory___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVL2I_MREGL_) ) {
      unsigned int c = _kids[0]->_cost[_CONVL2I_MREGL_];
        DFA_PRODUCTION__SET_VALID(_CONVI2L__CONVL2I_MREGL__, _ConvI2L__ConvL2I_mRegL___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_]+125;
        DFA_PRODUCTION__SET_VALID(MREGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(V0REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(V1REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A0REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A1REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A2REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A3REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(T0REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(T1REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(T2REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(T3REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(T8REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A4REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A5REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A6REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A7REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(S0REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(S1REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(S2REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(S3REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(S4REGL, loadUS_convI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(S7REGL, loadUS_convI2L_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVL2I_MREGL_) ) {
      unsigned int c = _kids[0]->_cost[_CONVL2I_MREGL_]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, convL2I2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, convL2I2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, convL2I2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, convL2I2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, convL2I2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, convL2I2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, convL2I2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, convL2I2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, convL2I2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, convL2I2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, convL2I2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, convL2I2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, convL2I2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, convL2I2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, convL2I2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, convL2I2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, convL2I2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, convL2I2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, convL2I2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, convL2I2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, convL2I2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, convL2I2L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, convI2L_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, convI2L_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, loadS_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, loadS_convI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADUB_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, loadUB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, loadUB_convI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, loadB_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, loadB_convI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, loadI_convI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, loadI_convI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI];
        DFA_PRODUCTION__SET_VALID(_CONVI2L_MREGI_, _ConvI2L_mRegI__rule, c)
    }
}
void  State::_sub_Op_ConvL2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+100;
        DFA_PRODUCTION__SET_VALID(REGD, convL2D_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_ConvL2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+100;
        DFA_PRODUCTION__SET_VALID(REGF, convL2F_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_ConvL2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+100;
        DFA_PRODUCTION__SET_VALID(MREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, convL2I_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_MREGL_IMMI_32_63) &&
        (
#line 10112 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->in(1)->in(2)->get_int() > 32
#line 8986 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_MREGL_IMMI_32_63]+80;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, slrL_Reg_immI_convL2I_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, slrL_Reg_immI_convL2I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_MREGL_IMMI_0_31) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_MREGL_IMMI_0_31];
        DFA_PRODUCTION__SET_VALID(_CONVL2I__URSHIFTL_MREGL_IMMI_0_31_, _ConvL2I__URShiftL_mRegL_immI_0_31__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL_MREGL_IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL_MREGL_IMMI_32_63]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, sarL2I_Reg_immI_32_63_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDL_MREGL_IMML_7) ) {
      unsigned int c = _kids[0]->_cost[_ANDL_MREGL_IMML_7];
        DFA_PRODUCTION__SET_VALID(_CONVL2I__ANDL_MREGL_IMML_7_, _ConvL2I__AndL_mRegL_immL_7__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDL_MREGL_IMML_0_4095) ) {
      unsigned int c = _kids[0]->_cost[_ANDL_MREGL_IMML_0_4095]+60;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, andL2I_Reg_imm_0_4095_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL];
        DFA_PRODUCTION__SET_VALID(_CONVL2I_MREGL_, _ConvL2I_mRegL__rule, c)
    }
}
void  State::_sub_Op_CountedLoopEnd(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI_MREGI_IMMI) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI_MREGI_IMMI]+300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEnd_reg_immI_long_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI_MREGI_MREGI]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEnd_long_rule, c)
      }
    }
}
void  State::_sub_Op_CountLeadingZerosI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) &&
        (
#line 12114 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
UseCountLeadingZerosInstructionLOONGARCH64
#line 9251 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
        DFA_PRODUCTION__SET_VALID(MREGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, countLeadingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, countLeadingZerosI_rule, c)
    }
}
void  State::_sub_Op_CountLeadingZerosL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) &&
        (
#line 12125 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
UseCountLeadingZerosInstructionLOONGARCH64
#line 9286 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+100;
        DFA_PRODUCTION__SET_VALID(MREGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, countLeadingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, countLeadingZerosL_rule, c)
    }
}
void  State::_sub_Op_CountTrailingZerosI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) &&
        (
#line 12136 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
UseCountTrailingZerosInstructionLOONGARCH64
#line 9321 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
        DFA_PRODUCTION__SET_VALID(MREGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, countTrailingZerosI_rule, c)
    }
}
void  State::_sub_Op_CountTrailingZerosL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) &&
        (
#line 12148 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
UseCountTrailingZerosInstructionLOONGARCH64
#line 9356 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+100;
        DFA_PRODUCTION__SET_VALID(MREGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, countTrailingZerosL_rule, c)
    }
}
void  State::_sub_Op_CreateEx(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(A0_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(MREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(S0_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(S1_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(S2_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(S3_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(S4_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(S5_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(S6_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(S7_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(T0_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(T1_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(T2_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(T3_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(A1_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(A2_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(A3_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(A4_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(A5_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(A6_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(A7_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(V0_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(V1_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(T8_REGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, CreateException_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, CreateException_rule, c+100)
    }
}
void  State::_sub_Op_DecodeN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGN) &&
        (
#line 10893 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->bottom_type()->is_ptr()->ptr() == TypePtr::NotNull ||
            n->bottom_type()->is_ptr()->ptr() == TypePtr::Constant
#line 9428 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGN]+100;
        DFA_PRODUCTION__SET_VALID(MREGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S0_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S1_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S2_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S3_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S4_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S5_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S6_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S7_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(T0_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(T1_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(T2_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(T3_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A0_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A1_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A2_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A3_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A4_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A5_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A6_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A7_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(V0_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(V1_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(T8_REGP, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, decodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, decodeHeapOop_not_null_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, decodeHeapOop_not_null_rule, c+100)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGN) &&
        (
#line 10879 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->bottom_type()->is_ptr()->ptr() != TypePtr::NotNull &&
            n->bottom_type()->is_ptr()->ptr() != TypePtr::Constant
#line 9471 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGN]+100;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(MREGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0_REGP) || _cost[S0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S0_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S1_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2_REGP) || _cost[S2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S2_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S3_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S4_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S5_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S6_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S7_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T0_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T1_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T2_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T3_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A0_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A1_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A2_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A3_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A4_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A5_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A6_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A7_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V0_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V1_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T8_REGP, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, decodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, decodeHeapOop_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, decodeHeapOop_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADN_MEMORY_) &&
        (
#line 5249 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
Universe::narrow_oop_base() == NULL && Universe::narrow_oop_shift() == 0
#line 9575 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADN_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(MREGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0_REGP) || _cost[S0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S0_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S1_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2_REGP) || _cost[S2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S2_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S3_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S4_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S5_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S6_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S7_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T0_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T1_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T2_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T3_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A0_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A1_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A2_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A3_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A4_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A5_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A6_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A7_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V0_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V1_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T8_REGP, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadN2P_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, loadN2P_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, loadN2P_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGN) &&
        
#line 4584 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
Universe::narrow_oop_shift() == 0
#line 9679 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[MREGN]+10;
        DFA_PRODUCTION__SET_VALID(INDIRECTNARROW, indirectNarrow_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirectNarrow_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGN) ) {
      unsigned int c = _kids[0]->_cost[MREGN];
        DFA_PRODUCTION__SET_VALID(_DECODEN_MREGN_, _DecodeN_mRegN__rule, c)
    }
}
void  State::_sub_Op_DecodeNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGN) ) {
      unsigned int c = _kids[0]->_cost[MREGN]+100;
        DFA_PRODUCTION__SET_VALID(MREGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S0_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S1_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S2_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S3_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S4_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S5_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S6_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S7_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(T0_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(T1_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(T2_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(T3_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A0_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A1_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A2_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A3_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A4_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A5_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A6_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A7_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(V0_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(V1_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(T8_REGP, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, decodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, decodeKlass_not_null_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, decodeKlass_not_null_rule, c+100)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADNKLASS_MEMORY_) &&
        (
#line 5291 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
Universe::narrow_klass_base() == NULL && Universe::narrow_klass_shift() == 0
#line 9734 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADNKLASS_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(MREGP) || _cost[MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(MREGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_T8_MREGP) || _cost[NO_T8_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0_REGP) || _cost[S0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S0_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGP) || _cost[S1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S1_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2_REGP) || _cost[S2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S2_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGP) || _cost[S3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S3_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGP) || _cost[S4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S4_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGP) || _cost[S5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S5_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGP) || _cost[S6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S6_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGP) || _cost[S7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(S7_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGP) || _cost[T0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T0_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGP) || _cost[T1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T1_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGP) || _cost[T2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T2_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGP) || _cost[T3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T3_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGP) || _cost[A0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A0_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGP) || _cost[A1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A1_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGP) || _cost[A2_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A2_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGP) || _cost[A3_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A3_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGP) || _cost[A4_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A4_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGP) || _cost[A5_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A5_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGP) || _cost[A6_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A6_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGP) || _cost[A7_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(A7_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(V0_REGP) || _cost[V0_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V0_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1_REGP) || _cost[V1_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(V1_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGP) || _cost[NO_AX_MREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGP) || _cost[T8_REGP] > c) {
        DFA_PRODUCTION__SET_VALID(T8_REGP, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadN2PKlass_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, loadN2PKlass_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, loadN2PKlass_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+100)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGN) ) {
      unsigned int c = _kids[0]->_cost[MREGN];
        DFA_PRODUCTION__SET_VALID(_DECODENKLASS_MREGN_, _DecodeNKlass_mRegN__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGN) &&
        
#line 4503 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
Universe::narrow_klass_shift() == 0
#line 9842 "../generated/adfiles/dfa_loongarch_64.cpp"
 ) {
      unsigned int c = _kids[0]->_cost[MREGN]+10;
        DFA_PRODUCTION__SET_VALID(INDIRECTNARROWKLASS, indirectNarrowKlass_rule, c)
    }
}
void  State::_sub_Op_DivD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+300;
        DFA_PRODUCTION__SET_VALID(REGD, divD_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_DivF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+300;
        DFA_PRODUCTION__SET_VALID(REGF, divF_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_DivI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+300;
        DFA_PRODUCTION__SET_VALID(MREGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, divI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, divI_Reg_Reg_rule, c)
    }
}
void  State::_sub_Op_DivL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGL]+100;
        DFA_PRODUCTION__SET_VALID(MREGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(V0REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(V1REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A0REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A1REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A2REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A3REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T0REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T1REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T2REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T3REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T8REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A4REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A5REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A6REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A7REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S0REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S1REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S2REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S3REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S4REGL, divL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S7REGL, divL_reg_reg_rule, c)
    }
}
void  State::_sub_Op_EncodeP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) &&
        (
#line 10869 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->bottom_type()->make_ptr()->ptr() == TypePtr::NotNull
#line 9925 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+100;
        DFA_PRODUCTION__SET_VALID(MREGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(T0_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(T1_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(T2_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(T3_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(T8_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A0_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A1_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A2_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A3_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A4_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A5_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A6_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A7_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S0_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S1_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S2_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S3_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S4_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S5_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S6_REGN, encodeHeapOop_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S7_REGN, encodeHeapOop_not_null_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) &&
        (
#line 10856 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->bottom_type()->make_ptr()->ptr() != TypePtr::NotNull
#line 9955 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+100;
      if (STATE__NOT_YET_VALID(MREGN) || _cost[MREGN] > c) {
        DFA_PRODUCTION__SET_VALID(MREGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0_REGN) || _cost[T0_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T0_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1_REGN) || _cost[T1_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T1_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2_REGN) || _cost[T2_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T2_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3_REGN) || _cost[T3_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T3_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8_REGN) || _cost[T8_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(T8_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0_REGN) || _cost[A0_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A0_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1_REGN) || _cost[A1_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A1_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2_REGN) || _cost[A2_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A2_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3_REGN) || _cost[A3_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A3_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4_REGN) || _cost[A4_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A4_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5_REGN) || _cost[A5_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A5_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6_REGN) || _cost[A6_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A6_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7_REGN) || _cost[A7_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(A7_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0_REGN) || _cost[S0_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S0_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1_REGN) || _cost[S1_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S1_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2_REGN) || _cost[S2_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S2_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3_REGN) || _cost[S3_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S3_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4_REGN) || _cost[S4_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S4_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S5_REGN) || _cost[S5_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S5_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S6_REGN) || _cost[S6_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S6_REGN, encodeHeapOop_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7_REGN) || _cost[S7_REGN] > c) {
        DFA_PRODUCTION__SET_VALID(S7_REGN, encodeHeapOop_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP];
        DFA_PRODUCTION__SET_VALID(_ENCODEP_MREGP_, _EncodeP_mRegP__rule, c)
    }
}
void  State::_sub_Op_EncodePKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+100;
        DFA_PRODUCTION__SET_VALID(MREGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(T0_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(T1_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(T2_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(T3_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(T8_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A0_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A1_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A2_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A3_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A4_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A5_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A6_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(A7_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S0_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S1_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S2_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S3_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S4_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S5_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S6_REGN, encodeKlass_not_null_rule, c)
        DFA_PRODUCTION__SET_VALID(S7_REGN, encodeKlass_not_null_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP];
        DFA_PRODUCTION__SET_VALID(_ENCODEPKLASS_MREGP_, _EncodePKlass_mRegP__rule, c)
    }
}
void  State::_sub_Op_FastLock(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], S0_REGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[S0_REGP]+300;
        DFA_PRODUCTION__SET_VALID(FLAGSREG, cmpFastLock_rule, c)
    }
}
void  State::_sub_Op_FastUnlock(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], S0_REGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[S0_REGP]+300;
        DFA_PRODUCTION__SET_VALID(FLAGSREG, cmpFastUnlock_rule, c)
    }
}
void  State::_sub_Op_Goto(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpDir_long_rule, c)
    }
}
void  State::_sub_Op_Halt(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, ShouldNotReachHere_rule, c)
    }
}
void  State::_sub_Op_If(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPD_REGD_REGD) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPD_REGD_REGD]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, branchConD_reg_reg_long_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPF_REGF_REGF) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPF_REGF_REGF]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, branchConF_reg_reg_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPL_MREGL_IMML) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPL_MREGL_IMML]+180;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, branchConL_regL_immL_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPL_MREGL_IMML_0) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPL_MREGL_IMML_0]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, branchConL_regL_immL_0_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPL_MREGL_MREGL) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPL_MREGL_MREGL]+250;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, branchConL_regL_regL_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPU_MREGI_IMMI_0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPU_MREGI_IMMI_0]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, branchConIU_reg_immI_0_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI_MREGI_IMMI) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI_MREGI_IMMI]+200;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, branchConI_reg_imm_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI_MREGI_IMMI_0) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI_MREGI_IMMI_0]+170;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, branchConI_reg_immI_0_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPI_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPI_MREGI_MREGI]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, branchConI_reg_reg_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPU_MREGI_IMMI) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPU_MREGI_IMMI]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, branchConIU_reg_imm_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPU_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPU_MREGI_MREGI]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, branchConIU_reg_reg_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPN_MREGN_MREGN) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPN_MREGN_MREGN]+180;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, cmpN_reg_branch_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], _CMPN_MREGN_IMMN_0) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[_CMPN_MREGN_IMMN_0]+180;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, cmpN_null_branch_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPP_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPP_MREGP_MREGP]+200;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, branchConP_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPP__DECODEN_MREGN__IMMP_0) &&
        (
#line 5997 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
Universe::narrow_oop_base() == NULL && Universe::narrow_oop_shift() == 0
#line 10172 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPP__DECODEN_MREGN__IMMP_0]+180;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, branchConN2P_0_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], _CMPP_MREGP_IMMP_0) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[_CMPP_MREGP_IMMP_0]+180;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, branchConP_0_long_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], FLAGSREG) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[FLAGSREG]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpCon_flags_long_rule, c)
      }
    }
}
void  State::_sub_Op_LShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_0_31) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_0_31];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_MREGI_IMMI_0_31, _LShiftI_mRegI_immI_0_31_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI_MREGI_IMMI_1) && STATE__VALID_CHILD(_kids[1], IMMI_0_31) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_MREGI_IMMI_1]+_kids[1]->_cost[IMMI_0_31];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__ANDI_MREGI_IMMI_1_IMMI_0_31, _LShiftI__AndI_mRegI_immI_1_immI_0_31_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+100;
        DFA_PRODUCTION__SET_VALID(MREGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, salI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, salI_Reg_Reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_MREGI_IMMI_24, _LShiftI_mRegI_immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ORI_MREGI_IMMI_0_32767) && STATE__VALID_CHILD(_kids[1], IMMI_16) ) {
      unsigned int c = _kids[0]->_cost[_ORI_MREGI_IMMI_0_32767]+_kids[1]->_cost[IMMI_16];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__ORI_MREGI_IMMI_0_32767_IMMI_16, _LShiftI__OrI_mRegI_immI_0_32767_immI_16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVL2I__ANDL_MREGL_IMML_7_) && STATE__VALID_CHILD(_kids[1], IMMI_16) ) {
      unsigned int c = _kids[0]->_cost[_CONVL2I__ANDL_MREGL_IMML_7_]+_kids[1]->_cost[IMMI_16];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__CONVL2I__ANDL_MREGL_IMML_7__IMMI_16, _LShiftI__ConvL2I__AndL_mRegL_immL_7__immI_16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_16) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_16];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_MREGI_IMMI_16, _LShiftI_mRegI_immI_16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVL2I_MREGL_) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_CONVL2I_MREGL_]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, salL2I_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, salL2I_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, salL2I_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, salL2I_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, salL2I_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, salL2I_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, salL2I_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, salL2I_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, salL2I_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, salL2I_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, salL2I_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, salL2I_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, salL2I_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, salL2I_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, salL2I_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, salL2I_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, salL2I_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, salL2I_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, salL2I_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, salL2I_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, salL2I_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, salL2I_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, salL2I_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, salL2I_Reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, salI_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, salI_Reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_1_4) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_1_4];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_MREGI_IMMI_1_4, _LShiftI_mRegI_immI_1_4_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADS_MEMORY__IMMI_24, _LShiftI__LoadS_memory__immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_16) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_16];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADI_MEMORY__IMMI_16, _LShiftI__LoadI_memory__immI_16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADI_MEMORY__IMMI_24, _LShiftI__LoadI_memory__immI_24_rule, c)
    }
}
void  State::_sub_Op_LShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_MREGI_) && STATE__VALID_CHILD(_kids[1], IMMI_32) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_MREGI_]+_kids[1]->_cost[IMMI_32];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL__CONVI2L_MREGI__IMMI_32, _LShiftL__ConvI2L_mRegI__immI_32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMMI_0_31) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMMI_0_31];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_MREGL_IMMI_0_31, _LShiftL_mRegL_immI_0_31_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMMI_32_63];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_MREGL_IMMI_32_63, _LShiftL_mRegL_immI_32_63_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGI]+100;
        DFA_PRODUCTION__SET_VALID(MREGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(V0REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(V1REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A0REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A1REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A2REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A3REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T0REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T1REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T2REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T3REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T8REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A4REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A5REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A6REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A7REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S0REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S1REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S2REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S3REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S4REGL, salL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S7REGL, salL_Reg_Reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_MREGI_) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_MREGI_]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, salL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, salL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, salL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, salL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, salL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, salL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, salL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, salL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, salL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, salL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, salL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, salL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, salL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, salL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, salL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, salL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, salL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, salL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, salL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, salL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, salL_RegI2L_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, salL_RegI2L_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, salL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, salL_Reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_MREGI_) && STATE__VALID_CHILD(_kids[1], IMMI_1_4) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_MREGI_]+_kids[1]->_cost[IMMI_1_4];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL__CONVI2L_MREGI__IMMI_1_4, _LShiftL__ConvI2L_mRegI__immI_1_4_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_MREGI_) && STATE__VALID_CHILD(_kids[1], IMMI_0_31) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_MREGI_]+_kids[1]->_cost[IMMI_0_31];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL__CONVI2L_MREGI__IMMI_0_31, _LShiftL__ConvI2L_mRegI__immI_0_31_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_MREGI_) && STATE__VALID_CHILD(_kids[1], IMMI_0_3) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_MREGI_]+_kids[1]->_cost[IMMI_0_3];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL__CONVI2L_MREGI__IMMI_0_3, _LShiftL__ConvI2L_mRegI__immI_0_3_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMMI_0_3) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMMI_0_3];
        DFA_PRODUCTION__SET_VALID(_LSHIFTL_MREGL_IMMI_0_3, _LShiftL_mRegL_immI_0_3_rule, c)
    }
}
void  State::_sub_Op_LoadB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADB_MEMORY_, _LoadB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(MREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, loadB_rule, c)
    }
}
void  State::_sub_Op_LoadUB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADUB_MEMORY_, _LoadUB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(MREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, loadUB_rule, c)
    }
}
void  State::_sub_Op_LoadUS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADUS_MEMORY_, _LoadUS_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(MREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, loadUS_rule, c)
    }
}
void  State::_sub_Op_LoadD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+150;
        DFA_PRODUCTION__SET_VALID(REGD, loadD_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_LoadD_unaligned(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+250;
        DFA_PRODUCTION__SET_VALID(REGD, loadD_unaligned_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_LoadF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+150;
        DFA_PRODUCTION__SET_VALID(REGF, loadF_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_LoadI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADI_MEMORY_, _LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(MREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, loadI_rule, c)
    }
}
void  State::_sub_Op_LoadKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(MREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(S0_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(S1_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(S2_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(S3_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(S4_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(S5_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(S6_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(S7_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(T0_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(T1_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(T2_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(T3_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(A0_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(A1_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(A2_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(A3_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(A4_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(A5_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(A6_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(A7_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(V0_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(V1_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(T8_REGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, loadKlass_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, loadKlass_rule, c+100)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+100)
      }
    }
}
void  State::_sub_Op_LoadNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADNKLASS_MEMORY_, _LoadNKlass_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(MREGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(T0_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(T1_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(T2_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(T3_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(T8_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(A0_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(A1_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(A2_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(A3_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(A4_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(A5_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(A6_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(A7_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(S0_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(S1_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(S2_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(S3_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(S4_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(S5_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(S6_REGN, loadNKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(S7_REGN, loadNKlass_rule, c)
    }
}
void  State::_sub_Op_LoadL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+250;
        DFA_PRODUCTION__SET_VALID(MREGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(V0REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(V1REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(A0REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(A1REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(A2REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(A3REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(T0REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(T1REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(T2REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(T3REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(T8REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(A4REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(A5REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(A6REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(A7REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(S0REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(S1REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(S2REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(S3REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(S4REGL, loadL_rule, c)
        DFA_PRODUCTION__SET_VALID(S7REGL, loadL_rule, c)
    }
}
void  State::_sub_Op_LoadL_unaligned(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+450;
        DFA_PRODUCTION__SET_VALID(MREGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(V0REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION__SET_VALID(V1REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION__SET_VALID(A0REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION__SET_VALID(A1REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION__SET_VALID(A2REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION__SET_VALID(A3REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION__SET_VALID(T0REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION__SET_VALID(T1REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION__SET_VALID(T2REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION__SET_VALID(T3REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION__SET_VALID(T8REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION__SET_VALID(A4REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION__SET_VALID(A5REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION__SET_VALID(A6REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION__SET_VALID(A7REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION__SET_VALID(S0REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION__SET_VALID(S1REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION__SET_VALID(S2REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION__SET_VALID(S3REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION__SET_VALID(S4REGL, loadL_unaligned_rule, c)
        DFA_PRODUCTION__SET_VALID(S7REGL, loadL_unaligned_rule, c)
    }
}
void  State::_sub_Op_LoadPLocked(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY] + MEMORY_REF_COST;
        DFA_PRODUCTION__SET_VALID(MREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(S0_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(S1_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(S2_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(S3_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(S4_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(S5_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(S6_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(S7_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(T0_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(T1_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(T2_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(T3_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(A0_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(A1_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(A2_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(A3_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(A4_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(A5_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(A6_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(A7_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(V0_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(V1_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(T8_REGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, loadPLocked_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, loadPLocked_rule, c+100)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+100)
      }
    }
}
void  State::_sub_Op_LoadP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(MREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(S0_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(S1_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(S2_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(S3_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(S4_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(S5_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(S6_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(S7_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(T0_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(T1_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(T2_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(T3_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(A0_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(A1_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(A2_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(A3_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(A4_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(A5_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(A6_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(A7_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(V0_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(V1_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(T8_REGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, loadP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, loadP_rule, c+100)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+100)
      }
    }
}
void  State::_sub_Op_LoadN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADN_MEMORY_, _LoadN_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(MREGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(T0_REGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(T1_REGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(T2_REGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(T3_REGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(T8_REGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(A0_REGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(A1_REGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(A2_REGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(A3_REGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(A4_REGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(A5_REGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(A6_REGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(A7_REGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(S0_REGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(S1_REGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(S2_REGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(S3_REGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(S4_REGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(S5_REGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(S6_REGN, loadN_rule, c)
        DFA_PRODUCTION__SET_VALID(S7_REGN, loadN_rule, c)
    }
}
void  State::_sub_Op_LoadRange(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(MREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, loadRange_rule, c)
    }
}
void  State::_sub_Op_LoadS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADS_MEMORY_, _LoadS_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(MREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, loadS_rule, c)
    }
}
void  State::_sub_Op_MaxI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_0) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_0]+50;
        DFA_PRODUCTION__SET_VALID(MREGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, maxI_Reg_zero_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, maxI_Reg_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+80;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, maxI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, maxI_Reg_Reg_rule, c)
      }
    }
}
void  State::_sub_Op_MemBarAcquire(const Node *n){
    {
      unsigned int c = 400;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_acquire_rule, c)
    }
}
void  State::_sub_Op_LoadFence(const Node *n){
    {
      unsigned int c = 400;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, load_fence_rule, c)
    }
}
void  State::_sub_Op_MemBarAcquireLock(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_acquire_lock_rule, c)
    }
}
void  State::_sub_Op_MemBarRelease(const Node *n){
    {
      unsigned int c = 400;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_release_rule, c)
    }
}
void  State::_sub_Op_StoreFence(const Node *n){
    {
      unsigned int c = 400;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, store_fence_rule, c)
    }
}
void  State::_sub_Op_MemBarReleaseLock(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_release_lock_rule, c)
    }
}
void  State::_sub_Op_MemBarVolatile(const Node *n){
    if(         (
#line 7808 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
Matcher::post_store_load_barrier(n)
#line 11222 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, unnecessary_membar_volatile_rule, c)
    }
    {
      unsigned int c = 400;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_volatile_rule, c)
      }
    }
}
void  State::_sub_Op_MemBarStoreStore(const Node *n){
    {
      unsigned int c = 400;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_storestore_rule, c)
    }
}
void  State::_sub_Op_MinI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+80;
        DFA_PRODUCTION__SET_VALID(MREGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, minI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, minI_Reg_Reg_rule, c)
    }
}
void  State::_sub_Op_ModI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+300;
        DFA_PRODUCTION__SET_VALID(MREGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, modI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, modI_Reg_Reg_rule, c)
    }
}
void  State::_sub_Op_ModL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGL]+100;
        DFA_PRODUCTION__SET_VALID(MREGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(V0REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(V1REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A0REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A1REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A2REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A3REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T0REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T1REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T2REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T3REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T8REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A4REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A5REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A6REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A7REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S0REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S1REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S2REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S3REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S4REGL, modL_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S7REGL, modL_reg_reg_rule, c)
    }
}
void  State::_sub_Op_MoveI2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+85;
        DFA_PRODUCTION__SET_VALID(REGF, MoveI2F_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_MoveF2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+85;
        DFA_PRODUCTION__SET_VALID(MREGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, MoveF2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, MoveF2I_reg_reg_rule, c)
    }
}
void  State::_sub_Op_MoveL2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+85;
        DFA_PRODUCTION__SET_VALID(REGD, MoveL2D_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_MoveD2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+85;
        DFA_PRODUCTION__SET_VALID(MREGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(V0REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(V1REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A0REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A1REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A2REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A3REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T0REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T1REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T2REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T3REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T8REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A4REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A5REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A6REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A7REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S0REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S1REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S2REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S3REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S4REGL, MoveD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S7REGL, MoveD2L_reg_reg_rule, c)
    }
}
void  State::_sub_Op_MulD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD];
        DFA_PRODUCTION__SET_VALID(_MULD_REGD_REGD, _MulD_regD_regD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(REGD, mulD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_MulF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF];
        DFA_PRODUCTION__SET_VALID(_MULF_REGF_REGF, _MulF_regF_regF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+100;
        DFA_PRODUCTION__SET_VALID(REGF, mulF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_MulI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI];
        DFA_PRODUCTION__SET_VALID(_MULI_MREGI_MREGI, _MulI_mRegI_mRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+300;
        DFA_PRODUCTION__SET_VALID(MREGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, mulI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, mulI_Reg_Reg_rule, c)
    }
}
void  State::_sub_Op_MulL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_MREGI_) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_MREGI_]+_kids[1]->_cost[MREGL]+100;
        DFA_PRODUCTION__SET_VALID(MREGL, mulL_reg_regI2L_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(V0REGL, mulL_reg_regI2L_0_rule, c)
        DFA_PRODUCTION__SET_VALID(V1REGL, mulL_reg_regI2L_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A0REGL, mulL_reg_regI2L_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A1REGL, mulL_reg_regI2L_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A2REGL, mulL_reg_regI2L_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A3REGL, mulL_reg_regI2L_0_rule, c)
        DFA_PRODUCTION__SET_VALID(T0REGL, mulL_reg_regI2L_0_rule, c)
        DFA_PRODUCTION__SET_VALID(T1REGL, mulL_reg_regI2L_0_rule, c)
        DFA_PRODUCTION__SET_VALID(T2REGL, mulL_reg_regI2L_0_rule, c)
        DFA_PRODUCTION__SET_VALID(T3REGL, mulL_reg_regI2L_0_rule, c)
        DFA_PRODUCTION__SET_VALID(T8REGL, mulL_reg_regI2L_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A4REGL, mulL_reg_regI2L_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A5REGL, mulL_reg_regI2L_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A6REGL, mulL_reg_regI2L_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A7REGL, mulL_reg_regI2L_0_rule, c)
        DFA_PRODUCTION__SET_VALID(S0REGL, mulL_reg_regI2L_0_rule, c)
        DFA_PRODUCTION__SET_VALID(S1REGL, mulL_reg_regI2L_0_rule, c)
        DFA_PRODUCTION__SET_VALID(S2REGL, mulL_reg_regI2L_0_rule, c)
        DFA_PRODUCTION__SET_VALID(S3REGL, mulL_reg_regI2L_0_rule, c)
        DFA_PRODUCTION__SET_VALID(S4REGL, mulL_reg_regI2L_0_rule, c)
        DFA_PRODUCTION__SET_VALID(S7REGL, mulL_reg_regI2L_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], _CONVI2L_MREGI_) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[_CONVI2L_MREGI_]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, mulL_reg_regI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, mulL_reg_regI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, mulL_reg_regI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, mulL_reg_regI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, mulL_reg_regI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, mulL_reg_regI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, mulL_reg_regI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, mulL_reg_regI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, mulL_reg_regI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, mulL_reg_regI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, mulL_reg_regI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, mulL_reg_regI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, mulL_reg_regI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, mulL_reg_regI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, mulL_reg_regI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, mulL_reg_regI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, mulL_reg_regI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, mulL_reg_regI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, mulL_reg_regI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, mulL_reg_regI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, mulL_reg_regI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, mulL_reg_regI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGL]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, mulL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, mulL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, mulL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, mulL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, mulL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, mulL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, mulL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, mulL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, mulL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, mulL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, mulL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, mulL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, mulL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, mulL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, mulL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, mulL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, mulL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, mulL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, mulL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, mulL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, mulL_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, mulL_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_NegD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(REGD, negD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_NegF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION__SET_VALID(REGF, negF_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_OrI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_MREGI_IMMI_0_31) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_MREGI_IMMI_0_31) &&
        (
#line 10240 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x1f)
#line 11647 "../generated/adfiles/dfa_loongarch_64.cpp"
) && /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_MREGI_IMMI_0_31]+_kids[1]->_cost[_LSHIFTI_MREGI_IMMI_0_31]+100;
        DFA_PRODUCTION__SET_VALID(MREGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, rolI_Reg_immI_0_31_0_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, rolI_Reg_immI_0_31_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_MREGI_IMMI_0_31) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_MREGI_IMMI_0_31) &&
        (
#line 10240 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x1f)
#line 11680 "../generated/adfiles/dfa_loongarch_64.cpp"
) && /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_MREGI_IMMI_0_31]+_kids[1]->_cost[_URSHIFTI_MREGI_IMMI_0_31]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, rolI_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, rolI_Reg_immI_0_31_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_MREGP_) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_MREGP_]+_kids[1]->_cost[MREGL]+100;
        DFA_PRODUCTION__SET_VALID(MREGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(V0REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION__SET_VALID(V1REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A0REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A1REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A2REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A3REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION__SET_VALID(T0REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION__SET_VALID(T1REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION__SET_VALID(T2REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION__SET_VALID(T3REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION__SET_VALID(T8REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A4REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A5REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A6REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A7REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION__SET_VALID(S0REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION__SET_VALID(S1REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION__SET_VALID(S2REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION__SET_VALID(S3REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION__SET_VALID(S4REGL, orI_Reg_castP2X_0_rule, c)
        DFA_PRODUCTION__SET_VALID(S7REGL, orI_Reg_castP2X_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], _CASTP2X_MREGP_) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[_CASTP2X_MREGP_]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, orI_Reg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, orI_Reg_castP2X_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__ANDI_MREGI_IMMI_1_IMMI_0_31) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_MREGI_IMMI_0_31) &&
        (
#line 10175 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
32 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()))
#line 11861 "../generated/adfiles/dfa_loongarch_64.cpp"
) && /*src*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__ANDI_MREGI_IMMI_1_IMMI_0_31]+_kids[1]->_cost[_URSHIFTI_MREGI_IMMI_0_31]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, rotI_shr_logical_Reg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, rotI_shr_logical_Reg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_MREGI_IMMI_0_31) && STATE__VALID_CHILD(_kids[1], _LSHIFTI__ANDI_MREGI_IMMI_1_IMMI_0_31) &&
        (
#line 10175 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
32 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()))
#line 11944 "../generated/adfiles/dfa_loongarch_64.cpp"
) && /*src*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_MREGI_IMMI_0_31]+_kids[1]->_cost[_LSHIFTI__ANDI_MREGI_IMMI_1_IMMI_0_31]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, rotI_shr_logical_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, rotI_shr_logical_Reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, orI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, orI_Reg_Reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_0_32767) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_0_32767];
        DFA_PRODUCTION__SET_VALID(_ORI_MREGI_IMMI_0_32767, _OrI_mRegI_immI_0_32767_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _XORI_MREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[_XORI_MREGI_IMMI_M1]+_kids[1]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, ornI_Reg_nReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, ornI_Reg_nReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], _XORI_MREGI_IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[_XORI_MREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, ornI_Reg_nReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, ornI_Reg_nReg_rule, c)
      }
    }
}
void  State::_sub_Op_OrL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL__CONVI2L_MREGI__IMMI_32) && STATE__VALID_CHILD(_kids[1], _ANDL__CONVI2L_MREGI__IMML_MAXUI) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL__CONVI2L_MREGI__IMMI_32]+_kids[1]->_cost[_ANDL__CONVI2L_MREGI__IMML_MAXUI]+100;
        DFA_PRODUCTION__SET_VALID(MREGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(V0REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION__SET_VALID(V1REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A0REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A1REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A2REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A3REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION__SET_VALID(T0REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION__SET_VALID(T1REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION__SET_VALID(T2REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION__SET_VALID(T3REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION__SET_VALID(T8REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A4REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A5REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A6REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION__SET_VALID(A7REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION__SET_VALID(S0REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION__SET_VALID(S1REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION__SET_VALID(S2REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION__SET_VALID(S3REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION__SET_VALID(S4REGL, combine_i2l_0_rule, c)
        DFA_PRODUCTION__SET_VALID(S7REGL, combine_i2l_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDL__CONVI2L_MREGI__IMML_MAXUI) && STATE__VALID_CHILD(_kids[1], _LSHIFTL__CONVI2L_MREGI__IMMI_32) ) {
      unsigned int c = _kids[0]->_cost[_ANDL__CONVI2L_MREGI__IMML_MAXUI]+_kids[1]->_cost[_LSHIFTL__CONVI2L_MREGI__IMMI_32]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, combine_i2l_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, combine_i2l_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_MREGL_IMMI_32_63) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_MREGL_IMMI_0_31) &&
        (
#line 10272 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x3f)
#line 12365 "../generated/adfiles/dfa_loongarch_64.cpp"
) && /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_MREGL_IMMI_32_63]+_kids[1]->_cost[_LSHIFTL_MREGL_IMMI_0_31]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, rolL_Reg_immI_32_63_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_MREGL_IMMI_0_31) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_MREGL_IMMI_32_63) &&
        (
#line 10272 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x3f)
#line 12442 "../generated/adfiles/dfa_loongarch_64.cpp"
) && /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_MREGL_IMMI_0_31]+_kids[1]->_cost[_URSHIFTL_MREGL_IMMI_32_63]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, rolL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, rolL_Reg_immI_32_63_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTL_MREGL_IMMI_0_31) && STATE__VALID_CHILD(_kids[1], _LSHIFTL_MREGL_IMMI_32_63) &&
        (
#line 10256 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x3f)
#line 12519 "../generated/adfiles/dfa_loongarch_64.cpp"
) && /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTL_MREGL_IMMI_0_31]+_kids[1]->_cost[_LSHIFTL_MREGL_IMMI_32_63]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, rolL_Reg_immI_0_31_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTL_MREGL_IMMI_32_63) && STATE__VALID_CHILD(_kids[1], _URSHIFTL_MREGL_IMMI_0_31) &&
        (
#line 10256 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x3f)
#line 12596 "../generated/adfiles/dfa_loongarch_64.cpp"
) && /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTL_MREGL_IMMI_32_63]+_kids[1]->_cost[_URSHIFTL_MREGL_IMMI_0_31]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, rolL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, rolL_Reg_immI_0_31_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], _CASTP2X_MREGP_) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[_CASTP2X_MREGP_]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, orL_Reg_P2XReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, orL_Reg_P2XReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_MREGP_) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_MREGP_]+_kids[1]->_cost[MREGL]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, orL_Reg_P2XReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, orL_Reg_P2XReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGL]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, orL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, orL_Reg_Reg_rule, c)
      }
    }
}
void  State::_sub_Op_PartialSubtypeCheck(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NO_T8_MREGP) && STATE__VALID_CHILD(_kids[1], NO_T8_MREGP) ) {
      unsigned int c = _kids[0]->_cost[NO_T8_MREGP]+_kids[1]->_cost[NO_T8_MREGP]+1100;
        DFA_PRODUCTION__SET_VALID(MREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(S0_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(S1_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(S2_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(S3_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(S4_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(S5_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(S6_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(S7_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(T0_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(T1_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(T2_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(T3_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(A0_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(A1_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(A2_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(A3_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(A4_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(A5_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(A6_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(A7_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(V0_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(V1_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(T8_REGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, partialSubtypeCheck_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, partialSubtypeCheck_rule, c+100)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(MEMORY, load_long_indirect_rule, c+100)
      }
    }
}
void  State::_sub_Op_PrefetchAllocation(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAlloc_rule, c)
    }
}
void  State::_sub_Op_PrefetchRead(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchr_rule, c)
    }
}
void  State::_sub_Op_PrefetchWrite(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchw_rule, c)
    }
}
void  State::_sub_Op_RShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+100;
        DFA_PRODUCTION__SET_VALID(MREGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, shr_arith_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, shr_arith_Reg_Reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, shr_arith_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, shr_arith_Reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_MREGI_IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_MREGI_IMMI_24]+_kids[1]->_cost[IMMI_24]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, i2b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_MREGI_IMMI_16) && STATE__VALID_CHILD(_kids[1], IMMI_16) &&
        /*sixteen*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_MREGI_IMMI_16]+_kids[1]->_cost[IMMI_16]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, i2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, i2s_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__ORI_MREGI_IMMI_0_32767_IMMI_16) && STATE__VALID_CHILD(_kids[1], IMMI_16) &&
        /*sixteen*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__ORI_MREGI_IMMI_0_32767_IMMI_16]+_kids[1]->_cost[IMMI_16]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, ori2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, ori2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, ori2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, ori2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, ori2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, ori2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, ori2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, ori2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, ori2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, ori2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, ori2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, ori2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, ori2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, ori2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, ori2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, ori2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, ori2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, ori2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, ori2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, ori2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, ori2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, ori2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, ori2s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, ori2s_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__CONVL2I__ANDL_MREGL_IMML_7__IMMI_16) && STATE__VALID_CHILD(_kids[1], IMMI_16) &&
        /*sixteen*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__CONVL2I__ANDL_MREGL_IMML_7__IMMI_16]+_kids[1]->_cost[IMMI_16]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, land7_2_s_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, land7_2_s_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADS_MEMORY__IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADS_MEMORY__IMMI_24]+_kids[1]->_cost[IMMI_24]+125;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, loadS2B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADI_MEMORY__IMMI_16) && STATE__VALID_CHILD(_kids[1], IMMI_16) &&
        /*sixteen*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADI_MEMORY__IMMI_16]+_kids[1]->_cost[IMMI_16]+125;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, loadI2S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADI_MEMORY__IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADI_MEMORY__IMMI_24]+_kids[1]->_cost[IMMI_24]+125;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, loadI2B_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGI]+100;
        DFA_PRODUCTION__SET_VALID(MREGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(V0REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(V1REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A0REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A1REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A2REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A3REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T0REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T1REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T2REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T3REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T8REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A4REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A5REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A6REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A7REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S0REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S1REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S2REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S3REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S4REGL, sarL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S7REGL, sarL_Reg_Reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMMI_32_63];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL_MREGL_IMMI_32_63, _RShiftL_mRegL_immI_32_63_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, sarL_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, sarL_Reg_imm_rule, c)
      }
    }
}
void  State::_sub_Op_Rethrow(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, RethrowException_rule, c)
    }
}
void  State::_sub_Op_Return(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, Ret_rule, c)
    }
}
void  State::_sub_Op_RoundDouble(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD];
        DFA_PRODUCTION__SET_VALID(REGD, roundDouble_nop_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_RoundFloat(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF];
        DFA_PRODUCTION__SET_VALID(REGF, roundFloat_nop_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_SafePoint(const Node *n){
    {
      unsigned int c = 105;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, safePoint_poll_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGP) &&
        (
#line 12058 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
false
#line 13743 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+125;
    }
}
void  State::_sub_Op_SqrtD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _CONVF2D_REGF_) ) {
      unsigned int c = _kids[0]->_cost[_CONVF2D_REGF_];
        DFA_PRODUCTION__SET_VALID(_SQRTD__CONVF2D_REGF__, _SqrtD__ConvF2D_regF___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(REGD, sqrtD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_StoreB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _CONVL2I_MREGL_) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_CONVL2I_MREGL_]+125;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeB_convL2I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[MREGI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeB_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI8]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmB_rule, c)
      }
    }
}
void  State::_sub_Op_StoreC(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI_0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI_0]+125;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeC_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[MREGI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeC_rule, c)
      }
    }
}
void  State::_sub_Op_StoreCM(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI8]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmCM_rule, c)
    }
}
void  State::_sub_Op_StorePConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGP_MREGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_MREGP_MREGP]+100;
        DFA_PRODUCTION__SET_VALID(FLAGSREG, storePConditional_rule, c)
    }
}
void  State::_sub_Op_StoreIConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_MREGI_MREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_MREGI_MREGI]+100;
        DFA_PRODUCTION__SET_VALID(FLAGSREG, storeIConditional_rule, c)
    }
}
void  State::_sub_Op_StoreLConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_T2REGL_MREGL) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_T2REGL_MREGL]+100;
        DFA_PRODUCTION__SET_VALID(FLAGSREG, storeLConditional_rule, c)
    }
}
void  State::_sub_Op_StoreD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMD_0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMD_0]+40;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeD_immD_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGD]+50;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeD_reg_rule, c)
      }
    }
}
void  State::_sub_Op_StoreF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMF_0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMF_0]+40;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeF_immF_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGF]+50;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeF_reg_rule, c)
      }
    }
}
void  State::_sub_Op_StoreI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _CONVL2I_MREGL_) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_CONVL2I_MREGL_]+125;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeI_convL2I_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[MREGI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmI_rule, c)
      }
    }
}
void  State::_sub_Op_StoreL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMML]+200;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeL_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMML_0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMML_0]+180;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeL_immL_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[MREGL]+200;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeL_reg_rule, c)
      }
    }
}
void  State::_sub_Op_StoreP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMP_0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMP_0]+125;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmP_immP_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[MREGP]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeP_rule, c)
      }
    }
}
void  State::_sub_Op_StoreN(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMN_0) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMN_0]+125;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmN_immN_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ENCODEP_MREGP_) &&
        (
#line 5403 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
Universe::narrow_oop_base() == NULL && Universe::narrow_oop_shift() == 0
#line 13894 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ENCODEP_MREGP_]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeP2N_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], MREGN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[MREGN]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeN_rule, c)
      }
    }
}
void  State::_sub_Op_StoreNKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ENCODEPKLASS_MREGP_) &&
        (
#line 5424 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
Universe::narrow_klass_base() == NULL && Universe::narrow_klass_shift() == 0
#line 13913 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ENCODEPKLASS_MREGP_]+125;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeP2NKlass_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], MREGN) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[MREGN]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeNKlass_rule, c)
      }
    }
}
void  State::_sub_Op_StrComp(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_A4_REGP_MA5REGI) && STATE__VALID_CHILD(_kids[1], _BINARY_A6_REGP_MA7REGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_A4_REGP_MA5REGI]+_kids[1]->_cost[_BINARY_A6_REGP_MA7REGI]+100;
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, string_compare_rule, c)
    }
}
void  State::_sub_Op_StrEquals(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_A4_REGP_A5_REGP) && STATE__VALID_CHILD(_kids[1], MA6REGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_A4_REGP_A5_REGP]+_kids[1]->_cost[MA6REGI]+100;
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, string_equals_rule, c)
    }
}
void  State::_sub_Op_SubD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(REGD, subD_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, storeSSD_rule, c+100)
    }
}
void  State::_sub_Op_SubF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+100;
        DFA_PRODUCTION__SET_VALID(REGF, subF_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, storeSSF_rule, c+100)
    }
}
void  State::_sub_Op_SubI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI_0) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI_0]+_kids[1]->_cost[MREGI]+80;
        DFA_PRODUCTION__SET_VALID(MREGI, negI_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, negI_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, negI_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, negI_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, negI_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, negI_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, negI_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, negI_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, negI_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, negI_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, negI_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, negI_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, negI_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, negI_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, negI_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, negI_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, negI_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, negI_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, negI_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, negI_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, negI_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, negI_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, negI_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, negI_Reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M2047_2048) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_M2047_2048]+80;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, subI_Reg_immI_M2047_2048_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, subI_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, subI_Reg_Reg_rule, c)
      }
    }
}
void  State::_sub_Op_SubL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_MREGI_) && STATE__VALID_CHILD(_kids[1], _CONVI2L_MREGI_) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_MREGI_]+_kids[1]->_cost[_CONVI2L_MREGI_]+200;
        DFA_PRODUCTION__SET_VALID(MREGL, subL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(V0REGL, subL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(V1REGL, subL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A0REGL, subL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A1REGL, subL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A2REGL, subL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A3REGL, subL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(T0REGL, subL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(T1REGL, subL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(T2REGL, subL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(T3REGL, subL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(T8REGL, subL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A4REGL, subL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A5REGL, subL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A6REGL, subL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(A7REGL, subL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(S0REGL, subL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(S1REGL, subL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(S2REGL, subL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(S3REGL, subL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(S4REGL, subL_RegI2L_RegI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(S7REGL, subL_RegI2L_RegI2L_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_MREGI_) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_MREGI_]+_kids[1]->_cost[MREGL]+200;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, subL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, subL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, subL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, subL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, subL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, subL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, subL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, subL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, subL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, subL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, subL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, subL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, subL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, subL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, subL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, subL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, subL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, subL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, subL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, subL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, subL_RegI2L_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, subL_RegI2L_Reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], _CONVI2L_MREGI_) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[_CONVI2L_MREGI_]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, subL_Reg_RegI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, subL_Reg_RegI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, subL_Reg_RegI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, subL_Reg_RegI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, subL_Reg_RegI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, subL_Reg_RegI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, subL_Reg_RegI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, subL_Reg_RegI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, subL_Reg_RegI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, subL_Reg_RegI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, subL_Reg_RegI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, subL_Reg_RegI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, subL_Reg_RegI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, subL_Reg_RegI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, subL_Reg_RegI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, subL_Reg_RegI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, subL_Reg_RegI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, subL_Reg_RegI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, subL_Reg_RegI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, subL_Reg_RegI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, subL_Reg_RegI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, subL_Reg_RegI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGL]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, subL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, subL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, subL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, subL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, subL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, subL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, subL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, subL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, subL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, subL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, subL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, subL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, subL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, subL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, subL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, subL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, subL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, subL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, subL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, subL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, subL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, subL_Reg_Reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_M2047_2048) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_M2047_2048]+80;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, subL_Reg_immL_M2047_2048_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMML_0) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[IMML_0]+_kids[1]->_cost[MREGL]+80;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, negL_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, negL_Reg_rule, c)
      }
    }
}
void  State::_sub_Op_TailCall(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGP) && STATE__VALID_CHILD(_kids[1], MREGP) ) {
      unsigned int c = _kids[0]->_cost[MREGP]+_kids[1]->_cost[MREGP]+300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, TailCalljmpInd_rule, c)
    }
}
void  State::_sub_Op_TailJump(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NO_AX_MREGP) && STATE__VALID_CHILD(_kids[1], MREGP) ) {
      unsigned int c = _kids[0]->_cost[NO_AX_MREGP]+_kids[1]->_cost[MREGP]+200;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, tailjmpInd_rule, c)
    }
}
void  State::_sub_Op_ThreadLocal(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(MREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_T8_MREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(S0_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(S1_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(S2_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(S3_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(S4_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(S5_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(S6_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(S7_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(T0_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(T1_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(T2_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(T3_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(A0_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(A1_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(A2_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(A3_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(A4_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(A5_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(A6_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(A7_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(V0_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(V1_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(T8_REGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, tlsLoadP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, tlsLoadP_rule, c+100)
    }
}
void  State::_sub_Op_URShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+100;
        DFA_PRODUCTION__SET_VALID(MREGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, shr_logical_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, shr_logical_Reg_Reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, shr_logical_Reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, shr_logical_Reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_0_31) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_0_31];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_MREGI_IMMI_0_31, _URShiftI_mRegI_immI_0_31_rule, c)
    }
}
void  State::_sub_Op_URShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_MREGP_) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_MREGP_]+_kids[1]->_cost[IMMI_32_63]+80;
        DFA_PRODUCTION__SET_VALID(MREGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(V0REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION__SET_VALID(V1REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION__SET_VALID(A0REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION__SET_VALID(A1REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION__SET_VALID(A2REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION__SET_VALID(A3REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION__SET_VALID(T0REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION__SET_VALID(T1REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION__SET_VALID(T2REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION__SET_VALID(T3REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION__SET_VALID(T8REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION__SET_VALID(A4REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION__SET_VALID(A5REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION__SET_VALID(A6REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION__SET_VALID(A7REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION__SET_VALID(S0REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION__SET_VALID(S1REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION__SET_VALID(S2REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION__SET_VALID(S3REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION__SET_VALID(S4REGL, slrL_P2XReg_immI_32_63_rule, c)
        DFA_PRODUCTION__SET_VALID(S7REGL, slrL_P2XReg_immI_32_63_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMMI_32_63];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL_MREGL_IMMI_32_63, _URShiftL_mRegL_immI_32_63_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMMI_32_63]+80;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, slrL_Reg_immI_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, slrL_Reg_immI_32_63_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_MREGP_) && STATE__VALID_CHILD(_kids[1], IMMI_0_31) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_MREGP_]+_kids[1]->_cost[IMMI_0_31]+80;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, slrL_P2XReg_immI_0_31_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMMI_0_31) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMMI_0_31];
        DFA_PRODUCTION__SET_VALID(_URSHIFTL_MREGL_IMMI_0_31, _URShiftL_mRegL_immI_0_31_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMMI_0_31) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMMI_0_31]+80;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, slrL_Reg_immI_0_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, slrL_Reg_immI_0_31_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, slrL_Reg_Reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, slrL_Reg_Reg_rule, c)
      }
    }
}
void  State::_sub_Op_XorI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], MREGI) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[MREGI]+100;
        DFA_PRODUCTION__SET_VALID(MREGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS0REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS1REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS2REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS3REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS4REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS5REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS6REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MS7REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT0REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT1REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT2REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT3REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT8REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MT4REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA0REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA1REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA2REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA3REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA4REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA5REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA6REGI, xorI_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(MA7REGI, xorI_Reg_Reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_XORI_MREGI_IMMI_M1, _XorI_mRegI_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVL2I_MREGL_) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[_CONVL2I_MREGL_]+_kids[1]->_cost[IMMI_M1]+60;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, xorL2I_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, xorL2I_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, xorL2I_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, xorL2I_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, xorL2I_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, xorL2I_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, xorL2I_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, xorL2I_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, xorL2I_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, xorL2I_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, xorL2I_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, xorL2I_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, xorL2I_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, xorL2I_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, xorL2I_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, xorL2I_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, xorL2I_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, xorL2I_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, xorL2I_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, xorL2I_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, xorL2I_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, xorL2I_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, xorL2I_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, xorL2I_Reg_immI_M1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_M1]+60;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, xorI_Reg_immI_M1_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, xorI_Reg_immI_M1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) && STATE__VALID_CHILD(_kids[1], IMMI_0_4095) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+_kids[1]->_cost[IMMI_0_4095]+60;
      if (STATE__NOT_YET_VALID(MREGI) || _cost[MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(MREGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NO_AX_MREGI) || _cost[NO_AX_MREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NO_AX_MREGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS0REGI) || _cost[MS0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS0REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS1REGI) || _cost[MS1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS1REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS2REGI) || _cost[MS2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS2REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS3REGI) || _cost[MS3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS3REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS4REGI) || _cost[MS4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS4REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS5REGI) || _cost[MS5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS5REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS6REGI) || _cost[MS6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS6REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MS7REGI) || _cost[MS7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MS7REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT0REGI) || _cost[MT0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT0REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT1REGI) || _cost[MT1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT1REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT2REGI) || _cost[MT2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT2REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT3REGI) || _cost[MT3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT3REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT8REGI) || _cost[MT8REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT8REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MT4REGI) || _cost[MT4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MT4REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA0REGI) || _cost[MA0REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA0REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA1REGI) || _cost[MA1REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA1REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA2REGI) || _cost[MA2REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA2REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA3REGI) || _cost[MA3REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA3REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA4REGI) || _cost[MA4REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA4REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA5REGI) || _cost[MA5REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA5REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA6REGI) || _cost[MA6REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA6REGI, xorI_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(MA7REGI) || _cost[MA7REGI] > c) {
        DFA_PRODUCTION__SET_VALID(MA7REGI, xorI_Reg_imm_0_4095_rule, c)
      }
    }
}
void  State::_sub_Op_XorL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], MREGL) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[MREGL]+100;
        DFA_PRODUCTION__SET_VALID(MREGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
        DFA_PRODUCTION__SET_VALID(V0REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(V1REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A0REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A1REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A2REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A3REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T0REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T1REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T2REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T3REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(T8REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A4REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A5REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A6REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(A7REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S0REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S1REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S2REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S3REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S4REGL, xorL_Reg_Reg_rule, c)
        DFA_PRODUCTION__SET_VALID(S7REGL, xorL_Reg_Reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MREGL) && STATE__VALID_CHILD(_kids[1], IMML_0_4095) ) {
      unsigned int c = _kids[0]->_cost[MREGL]+_kids[1]->_cost[IMML_0_4095]+60;
      if (STATE__NOT_YET_VALID(MREGL) || _cost[MREGL] > c) {
        DFA_PRODUCTION__SET_VALID(MREGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(V0REGL) || _cost[V0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V0REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(V1REGL) || _cost[V1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(V1REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A0REGL) || _cost[A0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A0REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A1REGL) || _cost[A1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A1REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A2REGL) || _cost[A2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A2REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A3REGL) || _cost[A3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A3REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(T0REGL) || _cost[T0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T0REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(T1REGL) || _cost[T1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T1REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(T2REGL) || _cost[T2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T2REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(T3REGL) || _cost[T3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T3REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(T8REGL) || _cost[T8REGL] > c) {
        DFA_PRODUCTION__SET_VALID(T8REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A4REGL) || _cost[A4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A4REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A5REGL) || _cost[A5REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A5REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A6REGL) || _cost[A6REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A6REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(A7REGL) || _cost[A7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(A7REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(S0REGL) || _cost[S0REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S0REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(S1REGL) || _cost[S1REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S1REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(S2REGL) || _cost[S2REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S2REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(S3REGL) || _cost[S3REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S3REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(S4REGL) || _cost[S4REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S4REGL, xorL_Reg_imm_0_4095_rule, c)
      }
      if (STATE__NOT_YET_VALID(S7REGL) || _cost[S7REGL] > c) {
        DFA_PRODUCTION__SET_VALID(S7REGL, xorL_Reg_imm_0_4095_rule, c)
      }
    }
}
void  State::_sub_Op_AddVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 12434 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->as_Vector()->length() == 2
#line 15382 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vadd2F_rule, c)
    }
}
void  State::_sub_Op_SubVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 12459 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->as_Vector()->length() == 2
#line 15393 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vsub2F_rule, c)
    }
}
void  State::_sub_Op_MulVF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], VECD) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 12473 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->as_Vector()->length() == 2
#line 15404 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[VECD]+_kids[1]->_cost[VECD]+100;
        DFA_PRODUCTION__SET_VALID(VECD, vmul2F_rule, c)
    }
}
void  State::_sub_Op_LoadVector(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 12162 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->as_LoadVector()->memory_size() == 8
#line 15415 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(VECD, loadV8_rule, c)
    }
}
void  State::_sub_Op_StoreVector(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], VECD) &&
        (
#line 12172 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->as_StoreVector()->memory_size() == 8
#line 15426 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[VECD]+145;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeV8_rule, c)
    }
}
void  State::_sub_Op_ReplicateB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI_M1) &&
        (
#line 12254 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->as_Vector()->length() == 8
#line 15437 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI_M1]+80;
        DFA_PRODUCTION__SET_VALID(VECD, Repl8B_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_0) &&
        (
#line 12243 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->as_Vector()->length() == 8
#line 15446 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI_0]+90;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl8B_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 12212 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->as_Vector()->length() == 8
#line 15457 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+110;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl8B_imm_DSP_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) &&
        (
#line 12181 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->as_Vector()->length() == 8
#line 15468 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl8B_DSP_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI_M1) &&
        (
#line 12336 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->as_Vector()->length() == 4
#line 15481 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI_M1]+100;
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_0) &&
        (
#line 12326 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->as_Vector()->length() == 4
#line 15490 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI_0]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 12296 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->as_Vector()->length() == 4
#line 15501 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_imm_DSP_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) &&
        (
#line 12266 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->as_Vector()->length() == 4
#line 15512 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl4S_DSP_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI_M1) &&
        (
#line 12391 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->as_Vector()->length() == 2
#line 15525 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI_M1]+100;
        DFA_PRODUCTION__SET_VALID(VECD, Repl2I_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_0) &&
        (
#line 12380 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->as_Vector()->length() == 2
#line 15534 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI_0]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2I_zero_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI) &&
        (
#line 12363 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->as_Vector()->length() == 2
#line 15545 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2I_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MREGI) &&
        (
#line 12348 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->as_Vector()->length() == 2
#line 15556 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MREGI]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2I_rule, c)
      }
    }
}
void  State::_sub_Op_ReplicateF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMF_0) &&
        (
#line 12417 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->as_Vector()->length() == 2
#line 15569 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF_0]+100;
        DFA_PRODUCTION__SET_VALID(VECD, Repl2F_zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 12405 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.282.b08/hotspot/src/cpu/loongarch/vm/loongarch_64.ad"
n->as_Vector()->length() == 2
#line 15578 "../generated/adfiles/dfa_loongarch_64.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
      if (STATE__NOT_YET_VALID(VECD) || _cost[VECD] > c) {
        DFA_PRODUCTION__SET_VALID(VECD, Repl2F_rule, c)
      }
    }
}
bool State::DFA(int opcode, const Node *n) {
  switch(opcode) {
  case Op_RegN: { _sub_Op_RegN(n);
    break;
  }
  case Op_RegI: { _sub_Op_RegI(n);
    break;
  }
  case Op_RegP: { _sub_Op_RegP(n);
    break;
  }
  case Op_RegF: { _sub_Op_RegF(n);
    break;
  }
  case Op_RegD: { _sub_Op_RegD(n);
    break;
  }
  case Op_RegL: { _sub_Op_RegL(n);
    break;
  }
  case Op_RegFlags: { _sub_Op_RegFlags(n);
    break;
  }
  case Op_VecD: { _sub_Op_VecD(n);
    break;
  }
  case Op_AbsD: { _sub_Op_AbsD(n);
    break;
  }
  case Op_AbsF: { _sub_Op_AbsF(n);
    break;
  }
  case Op_AddD: { _sub_Op_AddD(n);
    break;
  }
  case Op_AddF: { _sub_Op_AddF(n);
    break;
  }
  case Op_AddI: { _sub_Op_AddI(n);
    break;
  }
  case Op_AddL: { _sub_Op_AddL(n);
    break;
  }
  case Op_AddP: { _sub_Op_AddP(n);
    break;
  }
  case Op_AndI: { _sub_Op_AndI(n);
    break;
  }
  case Op_AndL: { _sub_Op_AndL(n);
    break;
  }
  case Op_Binary: { _sub_Op_Binary(n);
    break;
  }
  case Op_Bool: { _sub_Op_Bool(n);
    break;
  }
  case Op_CallDynamicJava: { _sub_Op_CallDynamicJava(n);
    break;
  }
  case Op_CallLeaf: { _sub_Op_CallLeaf(n);
    break;
  }
  case Op_CallLeafNoFP: { _sub_Op_CallLeafNoFP(n);
    break;
  }
  case Op_CallRuntime: { _sub_Op_CallRuntime(n);
    break;
  }
  case Op_CallStaticJava: { _sub_Op_CallStaticJava(n);
    break;
  }
  case Op_CastII: { _sub_Op_CastII(n);
    break;
  }
  case Op_CastX2P: { _sub_Op_CastX2P(n);
    break;
  }
  case Op_CastP2X: { _sub_Op_CastP2X(n);
    break;
  }
  case Op_CastPP: { _sub_Op_CastPP(n);
    break;
  }
  case Op_CheckCastPP: { _sub_Op_CheckCastPP(n);
    break;
  }
  case Op_ClearArray: { _sub_Op_ClearArray(n);
    break;
  }
  case Op_CMoveD: { _sub_Op_CMoveD(n);
    break;
  }
  case Op_CMoveF: { _sub_Op_CMoveF(n);
    break;
  }
  case Op_CMoveI: { _sub_Op_CMoveI(n);
    break;
  }
  case Op_CMoveL: { _sub_Op_CMoveL(n);
    break;
  }
  case Op_CMoveP: { _sub_Op_CMoveP(n);
    break;
  }
  case Op_CMoveN: { _sub_Op_CMoveN(n);
    break;
  }
  case Op_CmpN: { _sub_Op_CmpN(n);
    break;
  }
  case Op_CmpD: { _sub_Op_CmpD(n);
    break;
  }
  case Op_CmpD3: { _sub_Op_CmpD3(n);
    break;
  }
  case Op_CmpF: { _sub_Op_CmpF(n);
    break;
  }
  case Op_CmpF3: { _sub_Op_CmpF3(n);
    break;
  }
  case Op_CmpI: { _sub_Op_CmpI(n);
    break;
  }
  case Op_CmpL: { _sub_Op_CmpL(n);
    break;
  }
  case Op_CmpL3: { _sub_Op_CmpL3(n);
    break;
  }
  case Op_CmpLTMask: { _sub_Op_CmpLTMask(n);
    break;
  }
  case Op_CmpP: { _sub_Op_CmpP(n);
    break;
  }
  case Op_CmpU: { _sub_Op_CmpU(n);
    break;
  }
  case Op_CompareAndSwapI: { _sub_Op_CompareAndSwapI(n);
    break;
  }
  case Op_CompareAndSwapL: { _sub_Op_CompareAndSwapL(n);
    break;
  }
  case Op_CompareAndSwapP: { _sub_Op_CompareAndSwapP(n);
    break;
  }
  case Op_CompareAndSwapN: { _sub_Op_CompareAndSwapN(n);
    break;
  }
  case Op_ConN: { _sub_Op_ConN(n);
    break;
  }
  case Op_ConNKlass: { _sub_Op_ConNKlass(n);
    break;
  }
  case Op_ConD: { _sub_Op_ConD(n);
    break;
  }
  case Op_ConF: { _sub_Op_ConF(n);
    break;
  }
  case Op_ConI: { _sub_Op_ConI(n);
    break;
  }
  case Op_ConL: { _sub_Op_ConL(n);
    break;
  }
  case Op_ConP: { _sub_Op_ConP(n);
    break;
  }
  case Op_Conv2B: { _sub_Op_Conv2B(n);
    break;
  }
  case Op_ConvD2F: { _sub_Op_ConvD2F(n);
    break;
  }
  case Op_ConvD2I: { _sub_Op_ConvD2I(n);
    break;
  }
  case Op_ConvD2L: { _sub_Op_ConvD2L(n);
    break;
  }
  case Op_ConvF2D: { _sub_Op_ConvF2D(n);
    break;
  }
  case Op_ConvF2I: { _sub_Op_ConvF2I(n);
    break;
  }
  case Op_ConvF2L: { _sub_Op_ConvF2L(n);
    break;
  }
  case Op_ConvI2D: { _sub_Op_ConvI2D(n);
    break;
  }
  case Op_ConvI2F: { _sub_Op_ConvI2F(n);
    break;
  }
  case Op_ConvI2L: { _sub_Op_ConvI2L(n);
    break;
  }
  case Op_ConvL2D: { _sub_Op_ConvL2D(n);
    break;
  }
  case Op_ConvL2F: { _sub_Op_ConvL2F(n);
    break;
  }
  case Op_ConvL2I: { _sub_Op_ConvL2I(n);
    break;
  }
  case Op_CountedLoopEnd: { _sub_Op_CountedLoopEnd(n);
    break;
  }
  case Op_CountLeadingZerosI: { _sub_Op_CountLeadingZerosI(n);
    break;
  }
  case Op_CountLeadingZerosL: { _sub_Op_CountLeadingZerosL(n);
    break;
  }
  case Op_CountTrailingZerosI: { _sub_Op_CountTrailingZerosI(n);
    break;
  }
  case Op_CountTrailingZerosL: { _sub_Op_CountTrailingZerosL(n);
    break;
  }
  case Op_CreateEx: { _sub_Op_CreateEx(n);
    break;
  }
  case Op_DecodeN: { _sub_Op_DecodeN(n);
    break;
  }
  case Op_DecodeNKlass: { _sub_Op_DecodeNKlass(n);
    break;
  }
  case Op_DivD: { _sub_Op_DivD(n);
    break;
  }
  case Op_DivF: { _sub_Op_DivF(n);
    break;
  }
  case Op_DivI: { _sub_Op_DivI(n);
    break;
  }
  case Op_DivL: { _sub_Op_DivL(n);
    break;
  }
  case Op_EncodeP: { _sub_Op_EncodeP(n);
    break;
  }
  case Op_EncodePKlass: { _sub_Op_EncodePKlass(n);
    break;
  }
  case Op_FastLock: { _sub_Op_FastLock(n);
    break;
  }
  case Op_FastUnlock: { _sub_Op_FastUnlock(n);
    break;
  }
  case Op_Goto: { _sub_Op_Goto(n);
    break;
  }
  case Op_Halt: { _sub_Op_Halt(n);
    break;
  }
  case Op_If: { _sub_Op_If(n);
    break;
  }
  case Op_LShiftI: { _sub_Op_LShiftI(n);
    break;
  }
  case Op_LShiftL: { _sub_Op_LShiftL(n);
    break;
  }
  case Op_LoadB: { _sub_Op_LoadB(n);
    break;
  }
  case Op_LoadUB: { _sub_Op_LoadUB(n);
    break;
  }
  case Op_LoadUS: { _sub_Op_LoadUS(n);
    break;
  }
  case Op_LoadD: { _sub_Op_LoadD(n);
    break;
  }
  case Op_LoadD_unaligned: { _sub_Op_LoadD_unaligned(n);
    break;
  }
  case Op_LoadF: { _sub_Op_LoadF(n);
    break;
  }
  case Op_LoadI: { _sub_Op_LoadI(n);
    break;
  }
  case Op_LoadKlass: { _sub_Op_LoadKlass(n);
    break;
  }
  case Op_LoadNKlass: { _sub_Op_LoadNKlass(n);
    break;
  }
  case Op_LoadL: { _sub_Op_LoadL(n);
    break;
  }
  case Op_LoadL_unaligned: { _sub_Op_LoadL_unaligned(n);
    break;
  }
  case Op_LoadPLocked: { _sub_Op_LoadPLocked(n);
    break;
  }
  case Op_LoadP: { _sub_Op_LoadP(n);
    break;
  }
  case Op_LoadN: { _sub_Op_LoadN(n);
    break;
  }
  case Op_LoadRange: { _sub_Op_LoadRange(n);
    break;
  }
  case Op_LoadS: { _sub_Op_LoadS(n);
    break;
  }
  case Op_MaxI: { _sub_Op_MaxI(n);
    break;
  }
  case Op_MemBarAcquire: { _sub_Op_MemBarAcquire(n);
    break;
  }
  case Op_LoadFence: { _sub_Op_LoadFence(n);
    break;
  }
  case Op_MemBarAcquireLock: { _sub_Op_MemBarAcquireLock(n);
    break;
  }
  case Op_MemBarRelease: { _sub_Op_MemBarRelease(n);
    break;
  }
  case Op_StoreFence: { _sub_Op_StoreFence(n);
    break;
  }
  case Op_MemBarReleaseLock: { _sub_Op_MemBarReleaseLock(n);
    break;
  }
  case Op_MemBarVolatile: { _sub_Op_MemBarVolatile(n);
    break;
  }
  case Op_MemBarStoreStore: { _sub_Op_MemBarStoreStore(n);
    break;
  }
  case Op_MinI: { _sub_Op_MinI(n);
    break;
  }
  case Op_ModI: { _sub_Op_ModI(n);
    break;
  }
  case Op_ModL: { _sub_Op_ModL(n);
    break;
  }
  case Op_MoveI2F: { _sub_Op_MoveI2F(n);
    break;
  }
  case Op_MoveF2I: { _sub_Op_MoveF2I(n);
    break;
  }
  case Op_MoveL2D: { _sub_Op_MoveL2D(n);
    break;
  }
  case Op_MoveD2L: { _sub_Op_MoveD2L(n);
    break;
  }
  case Op_MulD: { _sub_Op_MulD(n);
    break;
  }
  case Op_MulF: { _sub_Op_MulF(n);
    break;
  }
  case Op_MulI: { _sub_Op_MulI(n);
    break;
  }
  case Op_MulL: { _sub_Op_MulL(n);
    break;
  }
  case Op_NegD: { _sub_Op_NegD(n);
    break;
  }
  case Op_NegF: { _sub_Op_NegF(n);
    break;
  }
  case Op_OrI: { _sub_Op_OrI(n);
    break;
  }
  case Op_OrL: { _sub_Op_OrL(n);
    break;
  }
  case Op_PartialSubtypeCheck: { _sub_Op_PartialSubtypeCheck(n);
    break;
  }
  case Op_PrefetchAllocation: { _sub_Op_PrefetchAllocation(n);
    break;
  }
  case Op_PrefetchRead: { _sub_Op_PrefetchRead(n);
    break;
  }
  case Op_PrefetchWrite: { _sub_Op_PrefetchWrite(n);
    break;
  }
  case Op_RShiftI: { _sub_Op_RShiftI(n);
    break;
  }
  case Op_RShiftL: { _sub_Op_RShiftL(n);
    break;
  }
  case Op_Rethrow: { _sub_Op_Rethrow(n);
    break;
  }
  case Op_Return: { _sub_Op_Return(n);
    break;
  }
  case Op_RoundDouble: { _sub_Op_RoundDouble(n);
    break;
  }
  case Op_RoundFloat: { _sub_Op_RoundFloat(n);
    break;
  }
  case Op_SafePoint: { _sub_Op_SafePoint(n);
    break;
  }
  case Op_SqrtD: { _sub_Op_SqrtD(n);
    break;
  }
  case Op_StoreB: { _sub_Op_StoreB(n);
    break;
  }
  case Op_StoreC: { _sub_Op_StoreC(n);
    break;
  }
  case Op_StoreCM: { _sub_Op_StoreCM(n);
    break;
  }
  case Op_StorePConditional: { _sub_Op_StorePConditional(n);
    break;
  }
  case Op_StoreIConditional: { _sub_Op_StoreIConditional(n);
    break;
  }
  case Op_StoreLConditional: { _sub_Op_StoreLConditional(n);
    break;
  }
  case Op_StoreD: { _sub_Op_StoreD(n);
    break;
  }
  case Op_StoreF: { _sub_Op_StoreF(n);
    break;
  }
  case Op_StoreI: { _sub_Op_StoreI(n);
    break;
  }
  case Op_StoreL: { _sub_Op_StoreL(n);
    break;
  }
  case Op_StoreP: { _sub_Op_StoreP(n);
    break;
  }
  case Op_StoreN: { _sub_Op_StoreN(n);
    break;
  }
  case Op_StoreNKlass: { _sub_Op_StoreNKlass(n);
    break;
  }
  case Op_StrComp: { _sub_Op_StrComp(n);
    break;
  }
  case Op_StrEquals: { _sub_Op_StrEquals(n);
    break;
  }
  case Op_SubD: { _sub_Op_SubD(n);
    break;
  }
  case Op_SubF: { _sub_Op_SubF(n);
    break;
  }
  case Op_SubI: { _sub_Op_SubI(n);
    break;
  }
  case Op_SubL: { _sub_Op_SubL(n);
    break;
  }
  case Op_TailCall: { _sub_Op_TailCall(n);
    break;
  }
  case Op_TailJump: { _sub_Op_TailJump(n);
    break;
  }
  case Op_ThreadLocal: { _sub_Op_ThreadLocal(n);
    break;
  }
  case Op_URShiftI: { _sub_Op_URShiftI(n);
    break;
  }
  case Op_URShiftL: { _sub_Op_URShiftL(n);
    break;
  }
  case Op_XorI: { _sub_Op_XorI(n);
    break;
  }
  case Op_XorL: { _sub_Op_XorL(n);
    break;
  }
  case Op_AddVF: { _sub_Op_AddVF(n);
    break;
  }
  case Op_SubVF: { _sub_Op_SubVF(n);
    break;
  }
  case Op_MulVF: { _sub_Op_MulVF(n);
    break;
  }
  case Op_LoadVector: { _sub_Op_LoadVector(n);
    break;
  }
  case Op_StoreVector: { _sub_Op_StoreVector(n);
    break;
  }
  case Op_ReplicateB: { _sub_Op_ReplicateB(n);
    break;
  }
  case Op_ReplicateS: { _sub_Op_ReplicateS(n);
    break;
  }
  case Op_ReplicateI: { _sub_Op_ReplicateI(n);
    break;
  }
  case Op_ReplicateF: { _sub_Op_ReplicateF(n);
    break;
  }
  
  default:
    tty->print("Default case invoked for: \n");
    tty->print("   opcode  = %d, \"%s\"\n", opcode, NodeClassNames[opcode]);
    return false;
  }
  return true;
}
